<?PHP
$TITLE = "The Craft of Text Editing";
$META = "";
$META_DESCRIPTION = "";
$META_KEYWORDS = "craft,emacs,text editing,how to";
$LASTMOD = getlastmod();
$BODY = "";
include("../include/fin-top.inc");
?>

<h1>
--or--<br>
Emacs for the Modern World
</h1>

<h2>
-by-<br>
Craig A. Finseth
</h2>

<p>Copyright 1999 by Craig A. Finseth.  Contact the author with
questions about distribution rights.</p>

<img src="craft-cover.png" alt="craft cover" width="432" height="648">

<p>This web site contains the full text of the book &quot;The Craft of
Text Editing.&quot; That book was published in 1991 by Springer-Verlag
&amp; Co.  By arrangement between the author and the publisher, the book
version is now out of print and all rights have been returned to the
author.  Note that there may be some slight differences in typograhic
corrections between this version and the printed one.</p>

<p>If you wish to cite this work, please use the following URL:</p>

<blockquote>
<a href="http://www.finseth.com/craft">http://www.finseth.com/craft</a>
</blockquote>

<p>This book is also available in print form.  It has ISBN
<tt>978-1-4116-8297-9</tt> (10-digit: <tt>1-4116-8297-1</tt>).
It is available from Lulu and from Amazon.com:</p>

<ul>

<li><a href="http://people.lulu.com/users/index.php?fHomepage=370764">Lulu storefront</a>

<li><a href="http://www.amazon.com/gp/product/1411682971">Amazon page</a>

</ul>

<p>If you should notice typos or formatting problems, please let me
know.  I am not, however, planning on revising or updating the book
anytime soon.  Typo corrections and minor changes will continue to be
made indefinitely.</p>

<p>Here is a <a href="craft.tar"><tt>.tar</tt> file</a> that contains
the complete work and here is a <a href="craft.tar.gz">gzip'd
version</a> of the <tt>.tar</tt> file.</p>

<p>Here is a <tt>.gz</tt> file that contains a <a
href="other/the-craft-of-text-editing.ps.gz">PostScript version</a> of
the complete work.  <i>This version is frozen as of June 2000 and will
not reflect any corrections made after that time.</i> Thanks to <a
href="mailto:fekete.krisztian@freemail.hu">Fekete Krisztian</a> for
the conversion.</p>

<p>Here is a <tt>.gz</tt> file that contains a tar file of a <a
href="other/the-craft-of-text-editing.tar.gz">LaTeX version</a>
version of the complete work.  <i>This version is frozen as of June
2000 and will not reflect any corrections made after that time.</i>
Thanks to <a href="mailto:fekete.krisztian@freemail.hu">Fekete
Krisztian</a> for the conversion.</p>

<br>
<hr>
<br>

<h3>Quick Contents:</h3>

<table width="100%" border="0">
<colgroup>
<col width="5%">
<col width="5%">
<col width="5%">
<col width="75%">
<col width="10%">
</colgroup>

<tr><td colspan="4"><a href="#preface">Preface</a></td><td>&nbsp;</td></tr>

<tr><td colspan="4"><a href="#intro">Introduction</a>: What Is Text Editing All About?</td><td>&nbsp;</td></tr>

<tr><td colspan="4"><a href="#c1">One</a>: Users</td><td>&nbsp;</td></tr>

<tr><td colspan="4"><a href="#c2">Two</a>: User Interface Hardware</td><td>&nbsp;</td></tr>

<tr><td colspan="4"><a href="#c3">Three: Implementation Languages</td><td>&nbsp;</td></tr>

<tr><td colspan="4"><a href="#c4">Four: Editing Models</td><td>&nbsp;</td></tr>

<tr><td colspan="4"><a href="#c5">Five: File Formats</td><td>&nbsp;</td></tr>

<tr><td colspan="4"><a href="#c6">Six</a>: The Internal Sub-Editor</td><td>&nbsp;</td></tr>

<tr><td colspan="4"><a href="#c7">Seven</a>: Redisplay</td><td>&nbsp;</td></tr>

<tr><td colspan="4"><a href="#c8">Eight</a>: User-Oriented Commands: The Command Loop</td><td>&nbsp;</td></tr>

<tr><td colspan="4"><a href="#c9">Nine</a>:</a> Command Set Design</td><td>&nbsp;</td></tr>

<tr><td colspan="4"><a href="#c10">Ten</a>: Emacs-Type Editors</td><td>&nbsp;</td></tr>

<tr><td colspan="4"><a href="#epilogue">Epilogue</a></td><td>&nbsp;</td></tr>

<tr><td colspan="4"><a href="#aA">Appendix A</a>: A Five-Minute Introduction to C</td><td>&nbsp;</td></tr>

<tr><td colspan="4"><a href="#aB">Appendix B</a>: Emacs Implementations</td><td>&nbsp;</td></tr>

<tr><td colspan="4"><a href="#aC">Appendix C</a>: The Emacs Command Set</td><td>&nbsp;</td></tr>

<tr><td colspan="4"><a href="#aD">Appendix D</a>: The TECO Command Set</td><td>&nbsp;</td></tr>

<tr><td colspan="4"><a href="#aE">Appendix E</a>: ASCII Chart</td><td>&nbsp;</td></tr>

<tr><td colspan="4"><a href="#bibliog">Bibliography</a></td><td>&nbsp;</td></tr>

<tr><td colspan="4"><a href="#index">Book Index</a></td><td>&nbsp;</td></tr>

</table>

<br>
<hr>
<br>

<h3>Credits</h3>

<p>The chapter quotes comprise the verse &quot;Jabberwocky&quot; by
Lewis Carroll, from the work <i>Through the Looking Glass.</i></p>

<h3>Trademarks</h3>

<p>Annex is a registered trademark of Xylogics.</p>

<p>CP/M is a registered trademark of Digital Research.</p>

<p>DEC, Tops-20, VT52, VT100, VT200 and VAX/VMS are registered
trademarks of Digital Equipment Corp.</p>

<p>FinalWord and MINCE are registered trademarks of Mark of the Unicorn.</p>

<p>IBM and IBM PC are registered trademarks of IBM Corp.</p>

<p>Apple ][ is a registered trademark of Apple Computer, Inc.</p>

<p>Macintosh is a trademark licensed to Apple Computer, Inc.</p>

<p>MS/DOS is a registered trademark of Microsoft Corp.</p>

<p>TTY is a registered trademark of Teletype Corp.</p>

<p>UNIX is a registered trademark of AT&amp;T</p>

<br>
<hr>
<br>

<a name="contents"> </a>
<h2>Table of Contents</h2>

<table width="100%" border="0">
<colgroup>
<col width="5%">
<col width="5%">
<col width="5%">
<col width="75%">
<col width="10%">
</colgroup>

<tr><td colspan="4"><a href="#preface">Preface</a></td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#preface.q">Questions</a> to Probe Your Understanding</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#preface.ack">Acknowledgements</a></td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="4"><a href="#intro">Introduction</a>: What Is Text Editing All About?</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#intro.1">1</a> The Basic Get_Line</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#intro.1.1">1.1</a> Version One</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#intro.1.2">1.2</a> Version Two</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#intro.1.3">1.3</a> Version Three</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#intro.1.4">1.4</a> Version Four</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#intro.2">2</a> The Forest</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#intro.q">Questions</a> to Probe Your Understanding</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="4"><a href="#c1">One</a>: Users</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#c1.1">1.1</a> User Categories</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c1.1.1">1.1.1</a> Amount of Experience</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c1.1.2">1.1.2</a> Type of Experience</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#c1.2">1.2</a> &quot;Religion&quot;</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c1.3">1.3</a> User Goals</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c1.4">1.4</a> Physiological Constraints</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c1.5">1.5</a> Applying These Physiological Constraints</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c1.6">1.6</a> Users Who Have Handicaps</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c1.q">Questions</a> to Probe Your Understanding</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="4"><a href="#c2">Two</a>: User Interface Hardware</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#c2.1">2.1</a> Display Types</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c2.1.1">2.1.1</a> TTY and Glass TTY</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c2.1.2">2.1.2</a> Basic Displays</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c2.1.3">2.1.3</a> Advanced Displays</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c2.1.4">2.1.4</a> &quot;Memory Mapped&quot; Displays</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c2.1.5">2.1.5</a> Graphics Displays</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#c2.2">2.2</a> Keyboards</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c2.2.1">2.2.1</a> Special Function Keys</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c2.2.2">2.2.2</a> Extra Shift Keys</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c2.2.3">2.2.3</a> Key Placement</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c2.2.4">2.2.4</a> Example Keyboards</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#c2.3">2.3</a> Graphical Input</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c2.3.1">2.3.1</a> Touch Sensitive Display</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c2.3.2">2.3.2</a> Tablet</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c2.3.3">2.3.3</a> Mouse</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c2.3.4">2.3.4</a> Trackball</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c2.3.5">2.3.5</a> Joystick</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c2.3.6">2.3.6</a> A Different Mouse</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c2.3.7">2.3.7</a> Other Devices</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c2.3.8">2.3.8</a> Conclusion</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#c2.4">2.4</a> Communications Path Issues</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c2.4.1">2.4.1</a> Speed and Character Format</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c2.4.2">2.4.2</a> Flow Control</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c2.4.3">2.4.3</a> Echo Negotiation</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c2.4.4">2.4.4</a> Fancy Modems</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#c2.q">Questions</a> to Probe Your Understanding</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="4"><a href="#c3">Three: Implementation Languages</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#c3.1">3.1</a> General Considerations</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c3.1.1">3.1.1</a> Availability and Implementation Quality</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c3.1.2">3.1.2</a> Text Handling Power</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c3.1.3">3.1.3</a> Support for Extensibility</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c3.1.4">3.1.4</a> Large Project Support</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c3.1.5">3.1.5</a> Efficiency</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#c3.2">3.2</a> Specific Language Notes</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c3.2.1">3.2.1</a> TECO</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c3.2.2">3.2.2</a> Lisp</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c3.2.3">3.2.3</a> C</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c3.2.4">3.2.4</a> PL/1</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c3.2.5">3.2.5</a> Other Systems Languages</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c3.2.6">3.2.6</a> Fortran</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c3.2.7">3.2.7</a> Pascal</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c3.2.8">3.2.8</a> Basic</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c3.2.9">3.2.9</a> Ada</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c3.2.10">3.2.10</a> Sine</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c3.2.11">3.2.11</a> Custom Editor Languages</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#c3.q">Questions</a> to Probe Your Understanding</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="4"><a href="#c4">Four: Editing Models</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#c4.1">4.1</a> One-Dimensional Array of Bytes</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c4.2">4.2</a> Two-Dimensional Array of Bytes</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c4.3">4.3</a> List of Lines</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c4.4">4.4</a> Paged Models</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c4.5">4.5</a> Objects</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c4.6">4.6</a> Dealing with Real Text</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c4.q">Questions</a> to Probe Your Understanding</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="4"><a href="#c5">Five: File Formats</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#c5.1">5.1</a> Text Files</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c5.1.1">5.1.1</a> Line Boundaries</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c5.1.2">5.1.2</a> Line Contents</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c5.1.3">5.1.3</a> End of File</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#c5.2">5.2</a> Binary Files</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c5.3">5.3</a> Structured Files</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c5.4">5.4</a> Where to Store the &quot;Extra&quot; Information</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c5.4.1">5.4.1</a> In-Band</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c5.4.2">5.4.2</a> Out-of-Band</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c5.4.3">5.4.3</a> Conclusion</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#c5.5">5.5</a> The Additional Information</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c5.5.1">5.5.1</a> Fonts, Sizes, Attributes</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c5.5.2">5.5.2</a> Line, Paragraph, Page, and Other Formats</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c5.5.3">5.5.3</a> Non-Text Objects</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#c5.6">5.6</a> Internationalization</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c5.q">Questions</a> to Probe Your Understanding</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="4"><a href="#c6">Six</a>: The Internal Sub-Editor</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#c6.1">6.1</a> Basic Concepts and Definitions</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c6.2">6.2</a> Internal Data Structures</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c6.3">6.3</a> Procedure Interface Definitions</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c6.4">6.4</a> Characteristics of Implementation Methods</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c6.4.1">6.4.1</a> No Management</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c6.4.2">6.4.2</a> Extra Space at the End</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c6.4.3">6.4.3</a> Buffer Gap</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="3">&nbsp;</td><td><a href="#c6.4.3.1">6.4.3.1</a> Multiple Gaps and Why They Don't Work</td><td>&nbsp;</td></tr>
<tr><td colspan="3">&nbsp;</td><td><a href="#c6.4.3.2">6.4.3.2</a> The Hidden Second Gap</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#c6.5">6.5</a> Implementation Method Overview</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c6.6">6.6</a> Buffer Gap</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c6.7">6.7</a> Linked Line</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c6.8">6.8</a> Paged Buffer Gap</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c6.9">6.9</a> Other Methods</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c6.10">6.10</a> Method Comparisons</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c6.10.1">6.10.1</a> Storage</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c6.10.2">6.10.2</a> Crash Recovery</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c6.10.3">6.10.3</a> Efficiency of Editing</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c6.10.4">6.10.4</a> Efficiency of Buffer/File I/O</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c6.10.5">6.10.5</a> Efficiency of Searching</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c6.10.6">6.10.6</a> Multiple Buffers</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c6.10.7">6.10.7</a> Paged Virtual Memory</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c6.10.8">6.10.8</a> Conclusions</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#c6.11">6.11</a> Editing Extremely Large Files</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c6.12">6.12</a> Difference Files</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c6.q">Questions</a> to Probe Your Understanding</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="4"><a href="#c7">Seven</a>: Redisplay</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#c7.1">7.1</a> Constraints</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c7.2">7.2</a> Procedure Interface Definitions</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c7.2.1">7.2.1</a> Editor Procedures</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c7.2.2">7.2.2</a> Display Independent Procedures</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#c7.3">7.3</a> Considerations</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c7.3.1">7.3.1</a> Status Line</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c7.3.2">7.3.2</a> End of the Buffer</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c7.3.3">7.3.3</a> Horizontal Scrolling</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c7.3.4">7.3.4</a> Line Wrap</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c7.3.5">7.3.5</a> Word Wrap</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c7.3.6">7.3.6</a> Tabs</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c7.3.7">7.3.7</a> Control Characters</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c7.3.8">7.3.8</a> Proportionally Spaced Text</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c7.3.9">7.3.9</a> Attributes, Fonts, and Scripts</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c7.3.10">7.3.10</a> Breaking Out Between Lines</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c7.3.11">7.3.11</a> Multiple Windows</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#c7.4">7.4</a> Redisplay Itself</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c7.4.1">7.4.1</a> The Framer</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c7.4.2">7.4.2</a> The Basic Algorithm</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c7.4.3">7.4.3</a> Sub-Editor Interaction</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c7.4.4">7.4.4</a> The Advanced Algorithm</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c7.4.5">7.4.5</a> Redisplay for Memory-Mapped Displays</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#c7.q">Questions</a> to Probe Your Understanding</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="4"><a href="#c8">Eight</a>: User-Oriented Commands: The Command Loop</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#c8.1">8.1</a> The Core Loop: Read, Evaluate, Print</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c8.1.1">8.1.1</a> The Evaluate Procedure</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c8.1.2">8.1.2</a> Move by a Character</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c8.1.3">8.1.3</a> Insert a Character</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c8.1.4">8.1.4</a> Second-Level Dispatch</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c8.1.5">8.1.5</a> Accept an Argument</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c8.1.6">8.1.6</a> Philosophy</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c8.1.7">8.1.7</a> A Minimalist Command Set Design</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#c8.2">8.2</a> Errors</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c8.2.1">8.2.1</a> Internal Errors</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c8.2.2">8.2.2</a> External Errors</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c8.2.3">8.2.3</a> Exiting</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#c8.3">8.3</a> Arguments</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c8.3.1">8.3.1</a> Numeric (Prefix) Arguments</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c8.3.2">8.3.2</a> String (Suffix) Arguments</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c8.3.3">8.3.3</a> Positional Arguments</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c8.3.4">8.3.4</a> Selection Arguments</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#c8.4">8.4</a> Rebinding</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c8.4.1">8.4.1</a> Rebinding Keys</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c8.4.2">8.4.2</a> Rebinding Functions</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#c8.5">8.5</a> Modes</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c8.5.1">8.5.1</a> Modes and Dynamic Rebinding</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c8.5.2">8.5.2</a> Implementing Modes</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#c8.6">8.6</a> Changing Your Mind</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c8.6.1">8.6.1</a> Command Set Design</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c8.6.2">8.6.2</a> Kill Ring</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c8.6.3">8.6.3</a> Undo</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c8.6.4">8.6.4</a> An Undo Heresy</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c8.6.5">8.6.5</a> Redo</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#c8.7">8.7</a> Macros</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c8.7.1">8.7.1</a> Again</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c8.7.2">8.7.2</a> Keystroke Recording</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c8.7.3">8.7.3</a> Macro Languages</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c8.7.4">8.7.4</a> Redisplay Interaction</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#c8.q">Questions</a> to Probe Your Understanding</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="4"><a href="#c9">Nine</a>:</a> Command Set Design</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#c9.1">9.1 Responsiveness</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c9.2">9.2</a> Consistency</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c9.3">9.3</a> Permissiveness</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c9.4">9.4</a> Progress</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c9.5">9.5</a> Simplicity</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c9.6">9.6</a> Uniformity</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c9.7">9.7</a> Extensibility</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c9.8">9.8</a> Modes</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c9.9">9.9</a> Use of Language</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c9.10">9.10</a> Guideline Summary</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c9.10.1">9.10.1</a> Overall</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c9.10.2">9.10.2</a> Modes</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c9.10.3">9.10.3</a> Use of Language</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#c9.11">9.11</a> Structure Editors</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c9.12">9.12</a> Programing Assistance</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c9.13">9.13</a> Command Behavior</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c9.13.1">9.13.1</a> Does Down Move the Point or the Text?</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c9.13.2">9.13.2</a> Scrolling vs. Paging</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c9.13.3">9.13.3</a> Page Breaks</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c9.13.4">9.13.4</a> How Many Ways Can You Move by a Word?</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="3">&nbsp;</td><td><a href="#c9.13.4.1">9.13.4.1</a> Moving by Words</td><td>&nbsp;</td></tr>
<tr><td colspan="3">&nbsp;</td><td><a href="#c9.13.4.2">9.13.4.2</a> Deleting by Words</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c9.13.5">9.13.5</a> Where Do Sentences and Paragraphs End?</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c9.13.6">9.13.6</a> How to Search</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#c9.13.7">9.13.7</a> Commands to Handle Typos</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="3">&nbsp;</td><td><a href="#c9.13.7.1">9.13.7.1</a> Capitalization Commands</td><td>&nbsp;</td></tr>
<tr><td colspan="3">&nbsp;</td><td><a href="#c9.13.7.2">9.13.7.2</a> Twiddling</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#c9.q">Questions</a> to Probe Your Understanding</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="4"><a href="#c10">Ten</a>: Emacs-Type Editors</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#c10.1">10.1</a> &quot;What Do You Mean, 'Emacs-type?' &quot;</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c10.2">10.2</a> The Command Set</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c10.3">10.3</a> The Extended Environment</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c10.4">10.4</a> Extensibility</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#c10.q">Questions</a> to Probe Your Understanding</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="4"><a href="#epilogue">Epilogue</a></td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#epilogue.q">Questions</a> to Probe Your Understanding</td><td>&nbsp;</td></tr>


<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="4"><a href="#aA">Appendix A</a>: A Five-Minute Introduction to C</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#aA.1">A.1</a> Case Conventions</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#aA.2">A.2</a> Data Types and Declarations</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#aA.3">A.3</a> Constants</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#aA.4">A.4</a> Pre-defined Constants</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#aA.5">A.5</a> Procedure Structure</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#aA.6">A.6</a> Statements</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#aA.7">A.7</a> Operators</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#aA.8">A.8</a> Standard Library Functions Used in This Book</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#aA.9">A.9</a> Non-Standard Library Functions Used in This Book</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="4"><a href="#aB">Appendix B</a>: Emacs Implementations</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="4"><a href="#aC">Appendix C</a>: The Emacs Command Set</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#aC.1">C.1</a> Notation</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#aC.2">C.2</a> Default GNU-Emacs Command List</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#aC.2.1">C.2.1</a> Base Commands</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#aC.2.2">C.2.2</a> Help Commands</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#aC.2.3">C.2.3</a> Control-X (^X) Commands</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#aC.2.4">C.2.4</a> Control-X 4 Commands</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#aC.2.5">C.2.5</a> Meta (^[) Commands</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#aC.3">C.3</a> The Author's Command Set</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="4"><a href="#aD">Appendix D</a>: The TECO Command Set</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#aD.1">D.1</a> General notation:</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#aD.2">D.2</a> Commands</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#aD.3">D.3</a> E-Commands (most file commands are here)</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#aD.4">D.4</a> F-Commands</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#aD.5">D.5</a> Special Q-registers, names are of the form &quot;..x&quot;</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#aD.6">D.6</a> FS Variables</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="4"><a href="#aE">Appendix E</a>: ASCII Chart</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="4"><a href="#bibliog">Bibliography</a></td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td>&nbsp;</td><td colspan="3"><a href="#bibliog.1">1</a> Current</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td colspan="3"><a href="#bibliog.2">2</a> Thesis</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#bibliog.2.1">2.1</a> Emacs-Type Editors</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="3">&nbsp;</td><td><a href="#bibliog.2.1.1">2.1.1</a> ITS EMACS</td><td>&nbsp;</td></tr>
<tr><td colspan="3">&nbsp;</td><td><a href="#bibliog.2.1.2">2.1.2</a> Lisp Machine Zwei</td><td>&nbsp;</td></tr>
<tr><td colspan="3">&nbsp;</td><td><a href="#bibliog.2.1.3">2.1.3</a> Multics Emacs</td><td>&nbsp;</td></tr>
<tr><td colspan="3">&nbsp;</td><td><a href="#bibliog.2.1.4">2.1.4</a> MagicSix TVMacs</td><td>&nbsp;</td></tr>
<tr><td colspan="3">&nbsp;</td><td><a href="#bibliog.2.1.5">2.1.5</a> Other Emacs-Type Text Editors</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#bibliog.2.2">2.2</a> Non-Emacs Display Editors</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#bibliog.2.3">2.3</a> Structure Editors</td><td>&nbsp;</td></tr>
<tr><td colspan="2">&nbsp;</td><td colspan="2"><a href="#bibliog.2.4">2.4</a> Other Editors</td><td>&nbsp;</td></tr>

<tr><td colspan="5">&nbsp;</td></tr>

<tr><td colspan="4"><a href="#index">Book Index</a></td><td>&nbsp;</td></tr>

</table>

<p><a href="#contents">Back to Contents</a>.</p>
<hr>
<a name="preface"></a><h1>Preface</h1>

<p>Just over eleven years ago I was faced with selecting a topic for
my thesis.  At the time, I was a student at the Massachusetts
Institute of Technology and was working on my bachelor's degree in
Computer Science and Engineering.  One of the degree requirements was
a thesis, and you can't have a thesis without a topic.</p>

<p>During my four years at M.I.T., a new type of text editor had come
into being and widespread use.  This type of text editor was called
&quot;Emacs,&quot; and it was a major step forward in many ways.
Implementations of this type of editor were appearing on many computer
systems.  Some people even used an implementation as the basis for
their thesis.  I took a different tack.  The idea that I settled on
for my thesis was a description of the technology that underlies all
text editors, but with a special emphasis on Emacs-type editors.  The
thesis was written and published as a technical memo (Finseth
1980).</p>

<p style="text-align: center;">* * *</p>

<p>Ten years later, I was reading the USENET News news group
Comp.editors, one of the many facets of that worldwide electronic
bulletin board.  A discussion thread had started up in which
<i>both</i> sides of the discussion were citing my thesis as the
authority in the field.  Further inquiries (not by me: I was just
reading along) showed that no one in that group was aware of any other
document that described general text-editing technology.</p>

<p>My thesis was ten years old: it predated most personal computers
and workstations.  There had even been a chapter in an early draft
that attempted to prove that it was not possible to implement an
Emacs-type text editor on a small computer.  (I invented a way, threw
out the chapter, and with some friends started a software company to
market such an editor.  Oh well.)  It was clearly time for a complete
rewrite, and that rewrite is what you are reading now.</p>

<p>If you don't have a copy of my thesis (or the <i>Technical Memo</i>:
the two have identical content), you won't miss anything.  This book
has all of the information from the earlier document, and is now
updated.  It also has a whole lot more.  Every part has been
completely rewritten and expanded, and major sections have been
added.</p>

<p>As with my thesis, this book is written in an informal, almost
chatty style.  It is addressed directly to &quot;you,&quot; who are
assumed to care about how text editors are implemented.  Be warned,
however, that it also contains opinions about the &quot;right&quot;
and &quot;wrong&quot; way of doing things and that these opinions hold
that many of the current directions and trends are -- shall we say? --
not the &quot;right&quot; way.  You should keep in mind that you
should not accept everything said in here as the gospel truth, but
understand why I say what I say and make your own informed
judgment.</p>

<p>This book is addressed to anyone who implements large software
systems or who wants to know the considerations that go into such
systems.  It focuses around text editors.  Although not required, an
understanding of programming will be helpful.</p>

<a name="preface.q"></a><h2>Questions to Probe Your Understanding</h2>

<p>Each chapter ends with a set of questions and problems designed to
probe your understanding of the material that was just presented.
And, true to the Socratic method, some of these questions also
introduce new material.  The level of difficulty of the questions
ranges from very easy to quite difficult, and each question is
labelled to help you gauge how much effort is required.  Just as with
most programming issues, most questions have no single correct
answer.</p>

<a name="preface.ack"></a><h2>Acknowledgements</h2>

<p>I would like to thank those people who helped me in various
ways:</p>

<ul>
<li>Owen &quot;Ted&quot; Anderson
<li>Joe Austin
<li>Jeff Brown
<li>Bernard Greenberg
<li>Brian Hess
<li>Mike Kazar
<li>Richard Kovalcik
<li>Scott Layson
<li>Jason Linhart
<li>David Moon
<li>Robert Nathaniel
<li>Lee Parks
<li>Jeffrey Schiller
<li>Richard Stallman
<li>Seth Steinberg
<li>Peter Steinmetz
<li>Liba Svobodova
<li>Daniel Weinreb
</ul>

<p>Plus, of course, all of those people that I have left out.  Special
thanks to my wife Ann and daughter Kari, who put up with my typing
away all the time.</p>

<blockquote>
Craig A. Finseth<br>
St. Paul, Minnesota<br>
February 1991<br>
</blockquote>

<p>Copyright 1999 by Craig A. Finseth.</p>

<p><a href="#contents">Back to Contents</a>.</p>
<hr>
<a name="intro"></a><h1>Introduction: What Is Text Editing All About?</h1>

<blockquote><i>
'Twas brillig, and the slithy toves<br>
&nbsp;&nbsp;Did gyre and gimble in the wabe:<br>
All mimsy were the borogoves,<br>
&nbsp;&nbsp;And the mome raths outgrabe.
</i></blockquote>

<p>In its most general form, text editing is the process of taking
some input, changing it, and producing some output.  Ideally, the
desired changes would be made immediately and with no effort required
beyond the mere thought of the change.  Unfortunately, the ideal case
is not yet achievable.  We are thus consigned to using tools such as
computers to effect our desired changes.</p>

<p>Computers have physical limitations.  These limitations include the
nature of user-interface devices; CPU performance; memory constraints,
both physical and virtual; and disk capacity and transfer speed.
Computer programs that perform text editing must operate within these
limitations.  This book examines those limitations, explores tradeoffs
among them and the algorithms that implement specific tradeoffs, and
provides general guidance to anyone who wants to understand how to
implement a text editor or how to perform editing in general.</p>

<p>I do not present the complete source code to an editor, nor is the
source code available on disk (at least from me: see Appendix B).  For
that matter, you won't even see a completely worked out algorithm.
Rather, this book teaches the craft of text editing so that you can
understand how to construct your own editor.</p>

<p>The first chapters discuss external constraints: human mental
processes, file formats, and interface devices.  Later chapters
describe memory management, redisplay algorithms, and command set
structure in detail.  The last chapter explores the Emacs-type of
editor.  The Emacs-type of editor will also be used whenever a
reference to a specific editor is required.</p>

<p>This range of topics is quite broad, and it is easy to lose sight
of the forest with all of those trees.  The remainder of this
introduction will sketch the outlines of the forest by examining an
editor-in-miniature: a get-line-of-input routine.  We will start with
a basic version of the routine, then make it more elaborate in a
series of steps. By the end, you will see where the complexity of a
text editor arises from.</p>

<p>The program examples are written in the ANSI version of the C
language.  Appendix A provides a brief introduction to the C language
and explains all of the features used in examples.</p>

<a name="intro.1"></a><h2>1 The Basic Get_Line</h2>

<p>The <b>Get_Line</b> routine accepts these inputs:</p>

<ul>
<li>a prompt string
<li>a buffer to accept the input; this buffer must be at least two
characters long
<li>an indication of the buffer length
</ul>

<p>and produces these outputs:</p>

<ul>
<li>a success/fail status
<li>if the status is &quot;success,&quot; the input is stored in the
supplied buffer; the end of the input is marked with the NUL (^@, 0
decimal) character
<li>if the status is &quot;fail,&quot; the buffer may have been
modified but will not contain valid input
</ul>

<p>The editing performed by this routine is on the input buffer.  This
first version assumes that you are creating a new item from scratch
each time.</p>

<a name="intro.1.1"></a><h3>1.1 Version One</h3>

<pre>
FLAG Get_Line(char *prompt, char *buffer, int len)
	{
	char *cptr = buffer;
	int key;

	if (len &lt; 2) return(FALSE);		/* safety check */
	printf(&quot;%s: &quot;, prompt);
	for (;;) {
		key = KeyGet();
		if (isprint(key)) {
			if (cptr - buffer &gt;= len - 1) Beep();
			else	{
				*cptr++ = key;
				printf(&quot;%c&quot;, key);
				}
			}
		else if (key == KEYENTER) {
			*cptr = NUL;
			printf(&quot;\n&quot;);
			return(TRUE);
			}
		else	Beep();
		}
	}
</pre>

<p>Version One accepts input until the user presses the Enter key.  If
a user's input will overflow the input buffer, the input is discarded
and the program will sound an error beep.  Once the Enter key has been
pressed, the program appends a NUL character to terminate the string
and returns True.  Non-printing characters other than Enter also cause
the program to sound an error beep.  Simple, straightforward, and
useless, as there is no way for the user to correct any typing
mistakes.</p>

<a name="intro.1.2"></a><h3>1.2 Version Two</h3>

<p>Here is version Two.  It adds editing:</p>

<pre>
FLAG Get_Line(char *prompt, char *buffer, int len)
	{
	char *cptr = buffer;
	int key;

	if (len &lt; 2) return(FALSE);		/* safety check */
	printf(&quot;%s: &quot;, prompt);
	for (;;) {
		key = KeyGet();
		if (isprint(key)) {
			if (cptr - buffer &gt;= len - 1) Beep();
			else	{
				*cptr++ = key;
				printf(&quot;%c&quot;, key);
				}
			}
		else	{
			switch (key) {

			case KEYBACK:
				if (cptr &gt; buffer) {
					cptr--;
					printf(&quot;\b \b&quot;);
					}
				break;

			case KEYENTER:
				*cptr = NUL;
				printf(&quot;\n&quot;);
				return(TRUE);
				/*break;*/

			default:
				Beep();
				break;
				}
			}
		}
	}
</pre>

<p>Version Two starts developing problems that can no longer be swept
under the rug.</p>

<p>Version One glossed over exactly what is meant by the Enter key.
That's sort of okay.  Most keyboards have only one key labelled
&quot;Enter&quot; or &quot;Return&quot; or something similar.  It
almost always sends a Carriage Return character.  The program can
compare against just that character and almost always operate
&quot;correctly,&quot; <i>i.e.</i>, as the user expects.  However,
most keyboards have at least <i>two</i> keys for erasing: Back Space
and Delete. Some people and computer systems use one of these.  Other
people and computer systems user the other.  (We will ignore any extra
&quot;erase&quot; or &quot;delete character&quot; keys that you might
find.  For now.)  The program can handle this problem in several
ways:</p>

<ul>
<li>accept only one or the other
<li>accept both
<li>if the operating system supports some sort of &quot;terminal
parameter configuration,&quot; ask the operating system what character
to use
<li>provide a configuration option in your program to let the user
set his or her preferred character; the option will most likely
default to the operating system configuration setting if one is
available
</ul>

<p>If you picked the first option, just over half of your users will
be upset with you.  The second option is much better: almost all users
will like you, and this part of your program need not be operating
system specific at all.  (I often select this option when writing
small programs that should have a minimum of operating
system-dependant code.)  The third option is a fine solution.  Most
users will like you, and you are building on other work (<i>i.e.</i>,
the operating system) instead of reinventing the wheel.</p>

<p>If you picked the fourth option, you have already learned what an
Emacs-type editor is about.  Implicit in this option is recognizing
that users should be able to control their environment as much as
possible. Yes, it is more work to write such programs and, yes, it
sometimes overlaps the existing operating system, but it can be well
worth the effort.</p>

<p>Another problem appears in the statement:</p>

<pre>
					printf(&quot;\b \b&quot;);
</pre>

<p>This statement is a crude attempt at erasing a character.  As it
turns out, there are pretty powerful conventions regarding how
printing characters and newlines are handled by operating systems and
output devices.  These characters all move the cursor to the right or
to the start of the next line.  However, when you want the cursor to
back up in any way or you wish to control it in any other way, you are
on your own: there are no industry-wide conventions for specifying
these operations.  And, with no conventions to rely upon, your program
has to implement a method of coping with the range of output
devices.</p>

<a name="intro.1.3"></a><h3>1.3 Version Three</h3>

<p>Version Three assumes that the input buffer contains some text.
This text is used for the response if the user just presses Enter
(<i>i.e.</i>, the text is the default value):</p>

<pre>
FLAG Get_Line(char *prompt, char *buffer, int len)
	{
	char *cptr = buffer;
	FLAG waskey = FALSE;
	int key;

	if (len &lt; 2) return(FALSE);		/* safety check */

	for (;;) {
		ToStartOfLine();
		ClearLine();
		printf(&quot;%s: %s&quot;, prompt, buffer);
		key = KeyGet();
		if (isprint(key)) {
			if (!waskey) {
				*buffer = NUL;
				waskey = TRUE;
				}
			if (cptr - buffer &gt;= len - 1) Beep();
			else	{
				*cptr++ = key;
				*cptr = NUL;
				}
			}
		else	{
			switch (key) {

			case KEYBACK:
				if (!waskey) {
					*buffer = NUL;
					waskey = TRUE;
					}
				if (cptr &gt; buffer) {
					--cptr;
					*cptr = NUL;
					printf(&quot;\b \b&quot;);
					}
				break;

			case KEYENTER:
				printf(&quot;\n&quot;);
				return(TRUE);
				/*break;*/

			default:
				Beep();
				break;
				}
			}
		}
	}
</pre>

<p>Version Three returns the supplied response if the user just
presses the Enter key.  Otherwise, the supplied response is erased
completely the first time a printing key or Back Space is pressed.
The only other changes worth noting are that the prompt has been moved
to the inside of the loop and a few terminal interface routines have
been added.  The first one moves the &quot;cursor&quot; to the
beginning of the line.  The next clears the line.</p>

<a name="intro.1.4"></a><h3>1.4 Version Four</h3>

<p>This version adds a number of features:</p>

<ul>
<li>commands to move the cursor left and right
<li>insert/replace editing
<li>a command to delete the character to the right of the cursor
<li>commands to move to the beginning and end of the response
<li>a command to clear the response
<li>a command to clear the changes and restore the default
<li>a way to insert arbitrary characters, including command
characters, into the response
<li>a cancel key
<li>a redisplay key
</ul>

<p>This version of the routine also has a slight change to the
interface: the addition of a separate default value parameter.</p>

<pre>
FLAG Get_Line(char *prompt, char *buffer, int len, char *default)
	{
	char *cptr = buffer;
	FLAG isinsert = TRUE;
	FLAG waskey = TRUE;
	int key;

	if (len &lt; 2) return(FALSE);		/* safety check */

	strcpy(buffer, default);
	for (;;) {
		ToStartOfLine();
		ClearLine();
		printf(&quot;%s: %s&quot;, prompt, buffer);
		PositionCursor(strlen(prompt) + 2 + (cptr - buffer));

		key = KeyGet();
		if (isprint(key)) {
			if (!waskey) {
				cptr = buffer;
				*cptr = NUL;
				waskey = TRUE;
				}
			if (isinsert) {
				if (buffer + strlen(buffer) &gt;= len - 1) Beep();
				else	{	/* move rest of line and insert */
					memmove(cptr + 1, cptr, strlen(cptr) + 1);
					*cptr++ = key;
					*cptr = NUL;
					}
				}
			else	{
				if (*cptr == NUL) {
						/* end of input, so append to buffer */
					if (buffer + strlen(buffer) &gt;= len - 1)
						Beep();
					else	{
						*cptr++ = key;
						*cptr = NUL;
						}
					}
				else *cptr++ = key;	/* replace */
				}
			}
		else	{
			switch (key) {

			case KEYBACK:
				if (!waskey) {
					cptr = buffer;
					*cptr = NUL;
					waskey = TRUE;
					}
				if (cptr &gt; buffer) {
					xstrcpy(cptr - 1, cptr);
					cptr--;
					*cptr = NUL;
					}
				break;

			case KEYDEL:		/* delete the following char */
				if (cptr &lt; buffer + strlen(buffer))
					xstrcpy(cptr, cptr + 1);
				else	Beep();
				break;

			case KEYENTER:
				printf(&quot;\n&quot;);
				return(TRUE);
				/*break;*/

			case KEYLEFT:
				if (cptr &gt; buffer) cptr--;
				waskey = TRUE;
				break;

			case KEYRIGHT:
				if (cptr &lt; buffer + strlen(buffer)) cptr++;
				waskey = TRUE;
				break;

			case KEYSTART:		/* move to start of response */
				cptr = buffer;
				waskey = TRUE;
				break;

			case KEYEND:		/* move to end of response */
				cptr = buffer + strlen(buffer);
				waskey = TRUE;
				break;

			case KEYQUOTE:		/* insert the next character,
							even if it is a control char */
				if (!waskey) {
					cptr = buffer;
					*cptr = NUL;
					waskey = TRUE;
					}
				key = KeyGet();
				if (isinsert) {
					if (buffer + strlen(buffer) &gt;= len - 1)
						Beep();
					else	{	/* move rest of line and insert */
						memmove(cptr + 1, cptr,
							strlen(cptr) + 1);	
						*cptr++ = key;
						*cptr = NUL;
						}
					}
				else	{
					if (*cptr == NUL) {
							/* end of input, so append */	
						if (buffer + strlen(buffer) &gt;= len - 1)
							Beep();
						else	{
							*cptr++ = key;
							*cptr = NUL;
							}
						}
					else *cptr++ = key;	/* replace */
					}
				break;

			case KEYCLEAR:		/* erase response */
				cptr = buffer;
				*cptr = NUL;
				waskey = TRUE;
				break;

			case KEYDEFAULT:	/* restore default response */
				strcpy(buffer, default);
				cptr = buffer;
				waskey = FALSE;
				break;

			case KEYCANCEL:	/* abort out of editing */
				return(FALSE);
				/*break;*/

			case KEYREDISPLAY:	/* redisplay the prompt and resp */
				break;

			case KEYINSERT:	/* set insert mode */
				isinsert = TRUE;
				break;

			case KEYREPLACE:	/* set replace mode */
				isinsert = FALSE;
				break;
				
			default:
				Beep();
				break;
				}
			}
		}
	}
</pre>

<p>Version Four does all that was claimed for it, but not as well as
one would like.  In particular:</p>

<ul>
<li>it did not check to ensure that the default response fits within the buffer
<li>there was no way for the user to determine whether the program is
in insert or replace mode except by typing a character and finding out
what happens
<li>it assumes that all characters are the same width when displayed
<li>it did not address the question of what the commands are nor how
the user supposed to remember them all
</ul>

<a name="intro.2"></a><h2>2 The Forest</h2>

<p>The examples presented in this chapter bumped into these
problems:</p>

<ul>
<li>What characteristics of the display and keyboard affect text editing?
<li>How should the program cope with presenting output on different displays?
<li>What view of the text should be presented to the user?
<li>How should the text be managed so that large amounts of text could
be edited efficiently?
<li>How should display updating occur so that editing changes are
efficiently presented to the user?
<li>How should the command set be designed? What should the meanings
of the various commands be?
<li>How should the program be designed so that the user can change how
it operates?
</ul>

<p>These and other questions will be addressed in the remainder of
this book.</p>

<a name="intro.q"></a><h2>Questions to Probe Your Understanding</h2>

<p>Modify the latest version of <b>Get_Line</b> to accept only numeric
responses.  What sort of error messages should be given?  (Easy)</p>

<p>Modify the latest version of <b>Get_Line</b> to accept only
responses from a list that is passed in as a parameter.  What sort of
error messages should be given? (Easy)</p>

<p>What are two good formats for such a list (Easy for those familiar
with C, Medium otherwise)</p>

<p>What is the appropriate degree of control (key definitions, enable
/ disable features, etc.) that the calling program should have over
the input editing?  (Medium)</p>

<p><a href="#contents">Back to Contents</a>.</p>
<hr>
<a name="c1"></a><h1>One: Users</h1>

<blockquote><i>
&quot;Beware the Jabberwock, my son!<br>
&nbsp;&nbsp;The jaws that bite, the claws that catch!
</i></blockquote>

<p>The saying goes: &quot;Business would be great if it weren't for
customers.&quot; Well, programming would be easy if it weren't for
users.  In the simple case, there would be exactly one user for your
program, - yourself - and you would use it only once.  Most programs,
however, are used many times by many people.  You must take those
users into account when designing your program.</p>

<p>This chapter will only review those aspects of users that are most
relevant to text editing: full discussions of users and design can and
do fill many books in themselves, some of which are listed in the
Bibliography.  This chapter (and this book) does not address the
question of non-people users.</p>

<a name="c1.1"></a><h2>1.1 User Categories</h2>

<p>Each user can be placed in a category.  Each category is described
in terms of the <i>amount</i> and the <i>type</i> of experience.  It
is important to understand users: each user creates a model of how a
new program works based on his or her experience with other programs
combined with the &quot;hints&quot; that your program's user interface
gives to him or her.  It is up to you to either match your program's
behavior to your users' model(s) or to give them enough information so
that they generate a model that is well-matched to your program.</p>

<a name="c1.1.1"></a><h3>1.1.1 Amount of Experience</h3>

<p>The amount of experience that a user has is a point on a continuous
scale.  All users start with no experience and accumulate experience
as they learn.  Although the scale is continuous, I have divided it
into five regions in order to simplify discussion.  Also, this list is
not intended as a self-rating scale: most of you who are reading this
book will be programmers.</p>

<p><b>Neophyte</b> users barely know what a computer is.  They lack
understanding of such &quot;basic&quot; terms as &quot;file&quot; and
&quot;file name&quot; (the concepts behind these terms are actually
quite sophisticated).  This lack of understanding does <i>not</i> mean
that they are unintelligent people, only that they have never had a
reason to learn these concepts.  If you are designing a program for
this type of user, you may feel both blessed and cursed.  Cursed
because it can be so difficult, and blessed because this area of
program design has such a pressing need for good designs.</p>

<p>Experience from the field of artificial intelligence can shed more
light on this issue.  AI researchers found it (comparatively) easy to
write programs that can handle advanced mathematics such as freshman
calculus.  However, as the researchers pushed on to handle such easy
(to most people) areas as filling in coloring books, the programming
problems got harder and harder.  Some of this difficulty is due to the
fact that the task of teaching college-level courses is well
understood--especially by college professors--but teaching coloring is
not.  For example, how many textbooks have you seen on &quot;how to
color&quot;?  More to the point, computers have been designed to
process information in a certain way, one that is mathematically
elegant, but not necessarily related to how people's minds work.  As
people write programs for more and more &quot;basic&quot; tasks, this
difference becomes increasingly apparent.</p>

<p>Many programs have been (mis-)designed for neophyte users.  They
often offer a few simple commands, yet leave intact such difficult
concepts such as that of a &quot;file.&quot; They solve the wrong
problem, sort of like travelling to a place where a foreign language
is spoken, and trying to communicate by speaking your native language
slowly and distinctly.  As a program designer, you must understand the
thought structure of your users, and design programs that match that
structure.  The blessing comes from designing programs that are very
different from &quot;conventional&quot; programs and which are
well-matched to their users.</p>

<p><b>Novice</b> users have used a computer before, perhaps for text
editing, word processing, spread sheet, or database applications.  In
any event, novice users have some familiarity with the idea of typing
things into a box and seeing a response that somehow reflects their
typing.  They understand how a shift key works, that a lowercase
letter 'l' is not the same as a digit '1', and so forth.  They even
have some understanding of the idea of &quot;context:&quot; that keys
do different things at different times.  Users with this amount of
experience are able to operate almost any program that has a good
design and a decent manual.</p>

<p><b>Basic</b> users are like novice users, only more so.  They
understand such programming concepts as thread of control, variables,
and statements like &quot;A = A + 1&quot; (in fact, many people call
such users &quot;programmers&quot;).  These users can operate any
program, even one with a poor design.  Given source code to the
program they are able to customize and extend it, albeit in what might
be an awkward fashion.</p>

<p><b>Power</b> users know one or more application programs
thoroughly.  They understand not only how to use those programs fully,
but can often go beyond the bounds of what the original designers
intended.  They may write large programs often in the form of
application macros, but do not <i>design</i> these programs.  These
users understand the fine points of the programs that they use.</p>

<p><b>Programmer-level</b> users understand the theory of programming.
When writing a large program, they design the program before
implementing it.  They generalize, applying their experience and their
knowledge of one program to guess how another program will
operate.</p>

<a name="c1.1.2"></a><h3>1.1.2 Type of Experience</h3>

<p>The amount-of-experience scale is one-dimensional: people start at
the beginning and proceed along the scale as they gain experience.
This type of experience scale is more like a collection of baseball
cards.  A user can collect the experience types (cards) in any order,
and two people with the same number of experience types (cards) may
have no experience types (cards) in common.</p>

<p>The experience types do not necessarily carry over: experience
gained on one type of system may or may not prove useful on another.
Actually, experience gained on one system may make it more difficult
to learn another.  And, if users grow to like one type of system, they
may then dislike another one, thus making any experience transfer
problematic.</p>

<p>These experience types can have a major effect on the design of
your programs, as it is usually important for new programs to appear
and operate in a manner similar to existing programs.  Thus, the
(possibly bad) designs of those existing programs may have to be
carried into the design of your program.</p>

<a name="c1.2"></a><h2>1.2 &quot;Religion&quot;</h2>

<p>This section might also be titled &quot;religious preference.&quot;
In the computer field, &quot;religion&quot; is a technical term that
refers to the usually irrational and extreme preference of one
program, style, or method to another.  Although you cannot really do
anything about this phenomenon, you can keep it in mind when analyzing
comments on your design.</p>

<p>It has been observed that people often &quot;get religion&quot;
over the first application (for example, a word processor) that they
use.  I can't recall the number of people who have tried to convince
me that the program that they just discovered (<i>i.e.</i>, the first
one they used) is the best one in the world.  This form of
&quot;religion&quot; is normal and derives from the facts that (1) the
move from manual to automated methods (<i>e.g.</i>, from typewriters
to word processors) involves a major increase in capabilities: even
the simplest word processor provides vastly more capabilities than
does a typewriter, and (2) new users do not have the experience to
realize that all programs (<i>e.g.</i>, word processors) are not
equal.  This form of religion usually fades away over time as new
users gain experience.</p>

<p>In a hauntingly close parallel to the &quot;second system
effect&quot; (Brooks 1982), the &quot;second program users&quot; are
the ones to watch out for.  These people started using one program,
then gave that program up in favor of a second one.  The problem is
that they think that since the second program is better than the first
one (which it usually is), it must therefore be better than all the
rest.</p>

<p>There is nothing in particular that you can do about users that
feel religious about a program: rational arguments are in general
ignored.  You can, however, be aware that such users exist, and
recognize when you are dealing with one.</p>

<a name="c1.3"></a><h2>1.3 User Goals</h2>

<p>Knowing your user's experience is essential, but a program design
must incorporate knowledge of what task or tasks the user is trying to
accomplish.  For text editors, he or she might want to create:</p>

<ul>
<li>some jottings, format not important;
<li>some jottings, format important;
<li>some jottings within a structure (<i>e.g.</i>, outliners);
<li>something with a specialized format (<i>e.g.</i>, a business
letter or a poem);
<li>a short narrative document (<i>e.g.</i>, a school paper or short story);
<li>a longer document (<i>e.g.</i>, a long paper or book);
<li>a long document with complex formatting (<i>e.g.</i>, a
mathematics textbook);
<li>a computer program;
<li>data for a program; or
<li>something else.
</ul>

<p>The frequency of doing these tasks can range from occasionally to
continuously.  Different tasks can be performed by the same user with
different frequencies.</p>

<p>The style of doing these tasks can also vary.  One person may do
all of one task, then start on the next.  Another person may be
frequently switching among two or more tasks.</p>

<a name="c1.4"></a><h2>1.4 Physiological Constraints</h2>

<p>Users are people.  There are limits to what people can do.  These
limits must be considered when designing a program.</p>

<p><b>Hands</b> have a limited reach.  The very act of reaching for
one key draws a hand away from other keys.  Thus, commands that you
expect to follow one another should be assigned with that constraint
in mind.  Function keys are often difficult to find and awkward to
press.  While there are almost always two shift keys, most keyboards
only have one control (or equivalent) key and may only have one of
other types of shift keys.  Thus, it is difficult to press some
shifted keys (such as control-P) with just one hand.</p>

<p>Non-keyboard devices such as mice draw a hand far away from the
keyboard -- and you don't in general know whether it is the left or
right hand that is drawn away.  A sequence such as control-mouse
button may be very difficult for some (<i>i.e.</i>, left-handed) users
to type.</p>

<p><b>Eyes</b> can focus on a limited area of high resolution
surrounded by a large area of lower resolution.  However, areas of
strong contrast such as reverse video are still visible in
low-resolution areas.  Blinking items are not only visible, but will
draw the eye to them.  &quot;Status&quot; displays should therefore
change as quietly as possible so as not to draw the eye away from the
text under edit.  For example, it may make sense to place such status
areas on the top part of the display if insert/delete line operations
cause visible motion of the bottom part.</p>

<p><b>The mind</b> (or brain), however, places the greatest
constraints on editor design.  It is only capable of processing a few
thoughts (&quot;instructions&quot;) per second.  In order for users to
be productive, it is important that these thoughts be directed as much
as possible to useful editing operations.  There are several things to
consider regarding these thoughts.</p>

<p>First, mental effort (thought) is required to translate between the
display representation of the text being edited and the user's
internal representation.  The WYSIWYG (&quot;what you see is what you
get&quot;) principle reduces this effort by reducing the amount of
thought required.  Note that in general WYSIWYG does <i>not</i> mean
&quot;fancy output on a graphics display.&quot; Rather, it means
&quot;it is what it appears to be, no more and no less.&quot;</p>

<p>Second, the mind has expectations: it sees (and in general senses)
what it <i>expects</i> to see.  In extreme cases, if something totally
unexpected happens, it can take many seconds for the mind to even
recognize that there is an unexpected image, in addition to the time
required to process the image and make a decision.  Thus, it is
important for the program to anticipate what the mind will expect to
see and to arrange the display accordingly.</p>

<p>Third, it takes mental effort to handle special cases.  For
example, if the delete operation deletes everything except for
newlines, it takes effort to remember that difference and to monitor
each command that is being given to ensure that it conforms to the
restriction.  Fourth, it takes mental effort to plan ahead.  The
design of the editor should make it easy for the user to change his or
her mind.</p>

<p>Last, it takes mental effort to track modes.  (Chapter 9 goes into
modes in detail.) Each time a new mode is introduced, it takes mental
effort to track the state of the mode and adds effort to the process
of switching modes.</p>

<p>The mind's short-memory can hold from five to seven
&quot;chunks&quot; of information (Norman 1990). These chunks are
organized in a cache-like form.  When the chunk cache fills up, chunks
must be stored in &quot;main memory,&quot; a process that takes time.
Considering that some of these chunks are used to remember what is
being edited, why the editing is being done, and other such context,
it becomes clear that the editor should be designed to use as few of
these &quot;chunks&quot; as possible.</p>

<p>The mind is poor at thinking numerically.  It is much easier to
think in terms of &quot;put that there&quot; than &quot;put object
12856 at location 83456.&quot; These last two points mean that the
computer should do as much remembering as possible for the user.</p>

<a name="c1.5"></a><h2>1.5 Applying These Physiological Constraints</h2>

<p>Let us examine how these principles apply to a particular user: me.
I select myself as the example for the simple reason that I understand
how my mind works better than I understand anyone else's.</p>

<p>First, I almost always work with plain ASCII files.  Hence, I can
take advantage of WYSIWYG on even a simple ASCII terminal.</p>

<p>Second, the program/computer combination that I use can (mostly)
keep up with my typing in real time.</p>

<p>Third, the Emacs command set that I use is very regular, so my mind
need only keep track of a few special cases.</p>

<p>Fourth, the basic paradigm behind the Emacs command set is
&quot;move to desired position, make desired change.&quot; This
paradigm applies <i>even in the case where I made a mistake</i>, as I
simply add the mistake to the list of changes to be made and continue
to apply the pardigm.  I never have to change mental gears.  The
penalty for making a mistake is thus minimized.</p>

<p>Fifth, the program minimizes what I need to remember: the text
being edited is there to be seen, exactly as is, and there are very
few state variables to track.  In addition, the Emacs command set is
defined mainly in terms of objects (character, word, sentence, etc.)
and has a convenient way of saying &quot;some,&quot; &quot;a
lot,&quot; &quot;a whole lot,&quot; and &quot;a huge amount.&quot;
(Various aspects fo Emacs command set are discussed in later
chapters.)</p>

<p>Going beyond these principles, I have used the Emacs command set so
long (thirteen years) that I quip that most of my editing is performed
by my spinal cord and not my brain.  Although this quip is not true
since the spinal cord can only handle purely reflex actions, we will
look closely at how my mind functions when editing text.  The mind of
any other experienced user should operate in a similar fashion.</p>

<p>As I write this text, part of my mind is articulating the point
that I am trying to make, while another part is expanding those words
into their component characters.  Call these parts the &quot;source
process.&quot; Another part of my mind is translating those characters
into finger motions.  Call this part the &quot;keystroke
process.&quot; Other parts of my mind are reading the text as it
appears on the screen, turning it back into words, and matching these
words against the original word stream.  Call this the &quot;feedback
process.&quot;</p>

<p>These three processes work in any sort of writing: using a
computer, typewriter, or pen.  All people who write use them.
However, if the resulting text is to have few errors, one of two
things must have happened: either the user made very few mistakes
(thus minimizing the number of errors to be corrected) or the user
must have written slowly, giving the feedback loop enough time to
recognize an error before too much time has elapsed and the error
becomes difficult to correct (such as an omitted character on the
previous line or page).</p>

<p>With the advent of computers, and their ability to make seamless
corrections, a third option appeared: a new, fast feedback loop.  This
loop operates by giving the keystroke process the ability to recognize
that it made a mistake.  This extra ability is not useful without
seamless editing, as it takes a long time to use the eraser or
correction tape.  However, with (a lot of) practice, a fourth process
can be &quot;running:&quot; the &quot;editing process.&quot;</p>

<p>The editing process takes the feedback from the keystroke process
and inserts editing commands into the character stream created by the
source process.  Here is an example of how this editing might operate
to correct an error when writing the text &quot;the quick red
fox.&quot;</p>

<ul>
<li>The source process generates the appropriate character string.

<li>An error occurs.  What is actually typed on the keyboard is the
string &quot;teh&quot;.

<li>The keystroke process recognizes the error just after the
&quot;h&quot; was typed.

<li>The editing process takes time to run.  In this time, let us
suppose that the characters &quot; quick&quot; (that is a space,
followed by &quot;quick&quot;) were placed in the &quot;output
queue.&quot; It is reasonable to suppose that all of the characters
for each word will be placed on the queue in one operation.

<li>The editing process then places its own string of characters on
the output queue.  This string will correct the error.  For the Emacs
command set, the sequence might be &quot;^[b^B^T^E&quot;.  This
sequence means &quot;move back a word (&quot;^[b&quot;), move back one
more character (&quot;^B&quot;), interchange the two switched
characters (&quot;^T&quot;: swaps &quot;eh&quot; to &quot;he&quot;),
return to the end of the line (&quot;^E&quot;).

<li>The rest of the line is then processed as usual, with the
characters &quot; red fox&quot; placed on the queue in two chunks and
eventually typed correctly. At some later time, the feedback process
confirms that the phrase was typed correctly.
</ul>

<p>(Other users may have variations on this process.  For example,
they may always delete all of any word with an error and retype the
word.)  With the extra fast feedback loop, the fingers were kept
typing at full speed all the time.  Granted, an extra five characters
were typed, but consider what would happen without the extra loop.  It
could well be that the entire phrase would have been typed before the
error was noticed.  The source process would have already started on
the next phrase.  When the feedback process notices the error, the
smooth typing of characters would stop as the user's mind determines
exactly which corrections are required and how to perform them.  It
must then start the pipeline going again.  The stopping, correcting,
and starting again takes several seconds.  A fifty word-per-minute
typist is typing about five characters per second.  The Emacs
correction string would take one second to type.  There is thus a
direct saving of some seconds and an indirect saving due to not having
interrupted the smooth flow of thinking.</p>

<p>Note that the design of the command set played an important part in
making this loop usable.  For example, if no &quot;go backward
word&quot; operation were available, the editing process would have to
compute how many characters were in the &quot;output buffer,&quot; an
operation that is quite time-consuming (quick: how many letters in
&quot;brown&quot;?) as well as not well matched to how the mind
works.</p>

<p>Some recent industry trends illustrate how some &quot;user
friendly&quot; designs clash with this editing process.  Consider a
typical, modern window system.  In some ways, it acts to frustrate an
experienced user.  For example, when a user closes a modified file,
the computer may put up a dialog box that says &quot;Discard changes?
Yes, No, Cancel&quot; (or words to the same effect).  This prompt will
be displayed in a beautiful dialog box, neatly centered on the screen.
Each response will have its own button.  Unfortunately, even if the
user is expecting the dialog box, he or she may have wait for the
system to catch up for these reasons:</p>

<ul>
<li>The operating system does not know about the dialog box until the
program has informed it of the box.  Hence, if the mouse button is
pressed too early, the button-press event will be sent to the main
window and not the dialog box.

<li>While the user knows that the dialog box will appear in the center
of the screen, it is in general too difficult to predict precisely
where the (dialog box) button will show up to be able to &quot;mouse
ahead.&quot; Hence, the mouse button cannot be pressed until the box
is drawn.
</ul>

<p>For these reasons, an experienced user's editing process may be
interrupted.  These interrupts no doubt contribute to the feeling of
sluggishness that many experienced users still feel when using such
systems.  The challenge is to design your program so that experienced
users can productively use your program.  The steps that you can take
to faciliate this use include:</p>

<ul>
<li>keep dialog box choices consistent
<li>provide keyboard responses for all choices
<li>provide for typeahead
<li>be prepared to handle mis-direcdted events
</ul>

<p>In general, the goal is for an experienced user to be able to
accurately predict which responses will be required, and to reliably
supply those reponses in advance of the prompts.  In this way,
experienced users can continue to do their work, without being slowed
down by the system.</p>

<a name="c1.6"></a><h2>1.6 Users Who Have Handicaps</h2>

<p>When someone has a significantly reduced ability to do something,
that person is considered to be handicapped in that area.  The reduced
ability might be physical, such as reduced hand motion or poor
eyesight, or it might be mental, such as a reduced ability to remember
things.</p>

<p>While the number of people who have severe handicaps in many areas
is small, a large number of users have at least limited handicaps in a
few areas.  As it is important for programs to accommodate as wide a
range of users as possible, programs must accommodate users with
handicaps.</p>

<p>It is also important to keep in mind that those users that have
severe and/or multiple handicaps can benefit greatly from the use of
computers. </p>

<p>Sometimes, even users without a handicap benefit from designs
intended to aid users with handicaps.  For example, adding a
wheelchair ramp to an old building also allows other people to roll
heavy objects up the ramp instead of having to use stairs.</p>

<p>The main design principles to follow to take into account users
with handicaps are:</p>

<ul>
<li>Reduce mental complexity: have the user deal with only one object
or concept at a time.

<li>Reduce visual complexity: keep displays clean and to the point and
avoid clutter.

<li>Reduce manual complexity: allow the user to do everything with
just one finger (this does <i>not</i> mean to <i>force</i> the user to
do everything with one finger).  Keep commands simple.  Allow
shortcuts and shorthand where applicable.

<li>Provide for customization. If you are lucky, the operating system
will do this for you.
</ul>

<p>It is not surprising that these are also good design rules for
users without handicaps.</p>

<a name="c1.q"></a><h2>Questions to Probe Your Understanding</h2>

<p>(Some of these questions refer to marketing decisions. A designer
must also take into account those people who are not yet users.
Remember that purchasers are &quot;users&quot; too.)</p>

<p>Consider the case where the higher you go in an organization, the
less computer experience people have.  Assume that product purchase
decisions are made at a higher level than the product user.  How does
this inversion affect product design?  Product marketing?
(Medium)</p>

<p>Many product reviews include &quot;feature checklists&quot; or
&quot;scoreboards.&quot; These checklists in general include all
features found in all related products.  What are the pros and cons of
these checklists for manufacturers?  For users?  (Medium)</p>

<p>I have observed that, all other things being equal, people will buy
the <i>more</i> expensive of two application programs.  Why?
(Easy)</p>

<p>Productivity falls off as computer response time increases.
However, the fall-off is not linear, but happens in a series of
thresholds, where slight increases in response time cause large drops
in productivity.  Why do these thresholds exist?  What information do
you need about human physiology in order to calculate where the
thresholds are?  (Hard)</p>

<p>How would you design a <i>program</i> to best be used by someone
with dyslexia?  What about the entire computer system?  It is okay to
be extreme and to make it less usable by other people.  (Medium)</p>

<p><a href="#contents">Back to Contents</a>.</p>
<hr>
<a name="c2"></a><h1>Two: User Interface Hardware</h1>

<blockquote><i>
Beware the Jubjub bird, and shun<br>
&nbsp;&nbsp;The frumious Bandersnatch!&quot;
</i></blockquote>

<p>User interface hardware is the collection of devices you use when
interacting with the computer.  The currently available user interface
hardware usually consists of a display screen for output and a
keyboard and perhaps a mouse or other graphical input device for
input.  This chapter will first discuss the output side: the
screen. It will then discuss the input side: the keyboard.  Finally,
it will discuss the communications paths that tie the two parts
together.</p>

<a name="c2.1"></a><h2>2.1 Display Types</h2>

<p>In the old days (<i>i.e.</i>, the early 1980s), almost all displays
were part of character-based terminals.  Differences in capabilities
among the terminals were often crucial.  These differences play an
important part in the types of redisplay schemes that are workable
(redisplay is discussed in Chapter 7).  Thus, it is worth reviewing
the old display types.</p>

<a name="c2.1.1"></a><h3>2.1.1 TTY and Glass TTY</h3>

<p>A TTY is the canonical printing terminal.  Printing terminals have
the property that what is once written can never be unwritten.  A
glass TTY is the same as a TTY except that it uses a screen instead of
paper. It has no random cursor positioning, no way of backing up, and
no way of changing what was displayed.  They are quieter than printing
terminals, though.</p>

<p>When a text editor is used on one of these displays, it usually
maintains a <i>very</i> small window (<i>e.g.</i>, one line) and
either echos only newly typed text or else constantly redisplays
(<i>i.e.</i>, reprints) that small window.  Once a user is familiar
with a display editor, however, it is possible -- in a crunch -- to
edit from a terminal of this type, but this is not generally a
pleasant way to work.</p>

<p>Although one would hope that this type of display was gone for
good, it does crop up from time to time in poorly implemented window
schemes.  Some window schemes offer window interfaces that resemble
printing terminals -- all too well.</p>

<p>You may encounter one other type of &quot;write only&quot; scheme:
a Unix-style output stream.  As an editor writer, you may want to
check for this and either:</p>

<ul>
<li>alter your output accordingly, or
<li><i>don't</i> alter your output
</ul>

<p>You may want to alter your output if you feel that the user wants
to create some sort of &quot;audit trail&quot; type file.  On the
other hand, you would not want to alter your output if the user is
attempting to diagnose problems by recording the data that is sent to
the display.</p>

<a name="c2.1.2"></a><h3>2.1.2 Basic Displays</h3>

<p>A basic display has, as a bare minimum, some sort of cursor
positioning.  It will generally also have &quot;clear to end of
line&quot; operation (put blanks on the screen from the current cursor
position to the end of the line that the cursor is on) and &quot;clear
to end of screen&quot; (ditto, but to the end of the screen)
functions.  These functions can be simulated, if necessary, by sending
spaces and newlines.  A typical basic terminal is (was) the DEC
VT52.</p>

<p>Such displays are quite usable at higher speeds (for example, over
a 9600 bps connection) but usability deteriorates rapidly as the speed
decreases.  It requires patience to use basic displays over a 1200 bps
connection, and a dedication bordering on insanity to use them at 300
bps.</p>

<a name="c2.1.3"></a><h3>2.1.3 Advanced Displays</h3>

<p>Advanced displays have all of the features of the basic displays,
along with editing features such as &quot;insert&quot; and
&quot;delete line and/or character.&quot; These features can
significantly reduce the amount of data sent to the display for common
operations.  A typical advanced (<i>circa</i> 1980) terminal is the
DEC VT100.  Most terminals currently manufactured are at least as
powerful as this one.</p>

<p>There is a subtle difference among some of the advanced terminals.
An &quot;insert line&quot; operation adds one or more blank lines at
the cursor: the lines that &quot;drop off&quot; the bottom of the
screen are lost.  A &quot;delete line&quot; operation deletes one or
more lines at the cursor: blank lines are inserted at the bottom.  A
&quot;scroll window&quot; operation (move lines <i>x</i> through
<i>y</i> up/down <i>n</i> lines) affects only the specified lines: the
other ones remain stationary.</p>

<p>The &quot;scroll window&quot; operation is more pleasing than the
others to see when there is some stationary text being displayed at
the bottom of the screen.  With &quot;insert/delete line,&quot; the
appropriate number of lines must be deleted and then inserted; the
text at the bottom thus moves within the display's memory.  Such jumps
are often visible to the user.  With &quot;scroll window,&quot; the
whole thing is performed as one operation and the lines at the bottom
do not jump.</p>

<a name="c2.1.4"></a><h3>2.1.4 &quot;Memory Mapped&quot; Displays</h3>

<p>This designation covers a wide range of displays.  Their common
characteristic is that display memory can be read or written at
near-bus speeds.  The display is usually built into the computer that
is running the text editor.  Many personal computers and workstations
follow this design.  But be warned: some computers have very fast
display <i>hardware</i>, but the <i>software</i> that is used to
interact with the display is very slow.  It is probably better for a
redisplay scheme to consider such displays to be &quot;advanced&quot;
or even &quot;basic.&quot; Examples of such displays are the ROM BIOS
calls on the IBM PC and Sun workstations.  In both cases, third-party
drivers operate many times faster than the manufacturer-supplied
ones. </p>

<p>The use of such fast displays has several implications for the
redisplay process.  First, many of the advanced features are typically
not available.  However, it may be possible to emulate the missing
features quickly enough that the lack of advanced features is almost
always not significant.  Second, it may be possible to use the display
memory as the only copy of the data on the screen.  (This optimization
is discussed in Chapter 7.)  Third, if reading from the screen does
not cause flicker but writing does, the screen can be read and the
incremental redisplay process will run and compare the buffer against
it, changing it only when necessary.  Finally, if you can write to the
screen without flicker, the redisplay process merely boils down to
copying the buffer onto the screen, as copying is generally faster
than comparing.</p>

<a name="c2.1.5"></a><h3>2.1.5 Graphics Displays</h3>

<p>Most personal computer and workstation displays are actually
bitmap-oriented graphics displays.  Software is used to make them
appear to display characters.  With a graphics display -- and the
appropriate software -- a program can not only display text, but
display text using proportional spacing (where different letters take
up different amounts of space), take advantage of different sizes,
styles, and display fonts, and even incorporate graphical
elements.</p>

<a name="c2.2"></a><h2>2.2 Keyboards</h2>

<p>This section presents a review of salient keyboard features.
Although most of us won't ever get the chance to design a keyboard, we
all purchase keyboards, and more importantly we design programs with
existing keyboards in mind.</p>

<p>The keyboard is the main way of telling the computer what to do.
In some cases, it is the only way of doing so.  Many thousands of
characters will be entered in the course of a normal working session.
Someone who types for a living (such as a typist, writer, or computer
programmer) can easily type <i>ten million</i> characters each
year.</p>

<p>The keyboard should thus be tailored for the ease of typing
characters.  While this statement might seem trite, there are a large
number of keyboards on the market (<i>i.e.</i>, most) which are pretty
poor for entering characters.  Below is a discussion of the various
keyboard features and why they are or are not desirable.</p>

<p><i>N</i><b>-KEY ROLL-OVER</b> is a highly desirable feature.
Having it means that you don't have to let go of one key before
striking the next.  The codes for the keys that you did strike will be
sent out only once and in the proper order.  (The <i>n</i> means that
this roll-over operation will occur even though every key on the
keyboard has been pressed before the first one is released.)  The
basic premise behind <i>n</i>-key roll-over is that you will not hit
the same key twice in a row.  Instead, you will hit a different key
first and the reach for that key will naturally pull your finger off
the initial one.  <i>N</i>-key roll-over loosens the timing
requirements regarding exactly when your finger has to come off the
first key.  Thus, typing errors are reduced.  Note that <i>n</i>-key
roll-over is of no help in typing double letters.  Note also that
shift keys are handled specially and are not subject to roll-over.</p>

<p>Some keyboards implement &quot;2-key roll-over/<i>n</i>-key
lockout.&quot; This means that only the first two keys of a continuous
sequence will be sent and the rest ignored (until all keys are
released).  This &quot;feature&quot; is actually a way of turning the
statement &quot;we don't offer <i>n</i>-key roll-over&quot; into a
positive-sounding statement &quot;we offer 2-key ...&quot;</p>

<p><b>AUTO-REPEAT</b> means that if a key is pressed and held down,
the code for that key is sent repeatedly.  It is a very desirable
feature.  It can cause problems (say, if you put something down on the
keyboard), but such problems are worth living with.  Older terminals
sometimes followed typewriter design in that only certain keys would
repeat (such as space, 'x', and dash).  Repeating just these few keys
is not useful.  Other terminals repeat the printing characters but not
the control characters.  This is also not useful.  As we will see
later, it is the control characters that we are most likely to want to
repeat.</p>

<p>There are three parameters associated with auto-repeat: the initial
delay to the first repeat, the rate at which a key will repeat, and
the acceleration of the repeat.  Ideally, the user should be able to
set these parameters.  If they cannot be set, the values selected by
the manufacturer become an additional consideration.</p>

<p>&quot;<b>TYPEABILITY</b>&quot; (I trust that the English language
has not sunk to the point where this is considered to be a valid word)
is the single most critical feature.  It is simply the ability to type
the useful characters without moving your fingers from the standard
touch-typing position (the &quot;asdf&quot; and &quot;jkl;&quot;
keys).  As more and more people who use (computer) keyboards are touch
typists and can thus type reasonably fast, they should not be slowed
down by having to move their hands out of the basic position.  It can
take one or two <i>seconds</i> to locate and type an out-of-the-way
key.  The row above the digits is out of the way, as are numeric key
pads and cursor control keys. One second is from three to ten
characters of time (at 30 - 100 words per minute).  Thus, it takes
less time in general to type a four- or five-character command from
the basic keyboard than to type one &quot;special&quot; key.</p>

<p>Because of the desire for typeability, it is worth at least
considering doing away with such keys as Shift Lock or Caps Lock.
They are rarely, if ever, used, and the keyboard space that they
occupy is in high demand.  (Yes, I realize that my anti-uppercase bias
is showing here.)</p>

<p>Keyboard manufacturers have done other things that reduce
typeability. Two examples are illustrative.  First, the timing on the
shift keys can be blown.  The result of doing so is that when
&quot;Foo&quot; is desired, &quot;FOo,&quot; &quot;fOo,&quot; and
&quot;foo&quot; are as likely to result.  The other example is having
a small &quot;sweet spot&quot; on each key. Missing this &quot;sweet
spot&quot; will cause both the desired and the adjoining key to fire
or not.  Thus, striking &quot;i&quot; could cause either
&quot;io&quot; or nothing to be sent.</p>

<p><b>PACKAGING</b> or physical keyboard design is also very
important. Sharp edges near the keyboard or too tightly packed keys
can cause errors and fatigue.  Can the keyboard be positioned so as to
be comfortable?  Is there a palm ledge (this may be either good or
bad)?  Does the keyboard meet &quot;ergonometric&quot; standards?  (In
my experience, &quot;ergonomic&quot; standards equate to &quot;hard to
use.&quot;)</p>

<a name="c2.2.1"></a><h3>2.2.1 Special Function Keys</h3>

<p>Keyboard manufacturers seem to have decided that a plethora of
special keys is more useful than adding shift keys.  Thus, you can get
keyboards with Insert Line or &quot;cursor up&quot; or -- gasp -- PF1
(if not LF1, F1, <i>and</i> RF1).  These keys, when pressed, will
either do the function that they name, do something totally random, or
send a (usually pre-defined and unchangeable) sequence of characters
to the program.</p>

<p>With the advent of windowing systems, manufacturers have realized
that the keyboard/display combination simply does not have the
information required to properly perform the function locally.  They
have also decided that random operations don't sell devices well.
This is actually a change from the terminals made a few years ago.</p>

<p>That leaves us with character sequences.  Ideally, the sequences
would be programmable.  Thus, the editor could save the current set of
programmed sequences (if any), load a set that would not interfere
with any editing commands, then restore the user's settings upon
exit. However, this is the real world and it is often the case that
the sequences are not programmable.</p>

<p>Given this, the keys may or may not be useful.  For example, the
&quot;cursor up&quot; key might send Escape 'E'.  You may wish this
particular sequence to perform a &quot;move to end of sentence&quot;
operation (I do).  Thus, pressing the &quot;cursor up&quot; key will
move you to the end of the sentence!</p>

<p>Okay, you say, I won't use Escape 'E' to move to the end of the
sentence.  You then look up all of the sequences that may be sent by
function keys and design your command set around them.  All is well
and good until you try to use a different keyboard.  Your new keyboard
will in general use different sequences than the old one.  The
sequences may even conflict: for example, the &quot;cursor down&quot;
key on the new terminal might send Escape 'E'.</p>

<p>We got into this situation for two reasons: a major one and a minor
one.  The minor one is easy to deal with.  All that we have to do is
tell the editor which keyboard we are using and have the editor
perform any required adjustments.  On UNIX systems, for example, the
required information can be found in the <i>/etc/termcap</i> or
<i>terminfo</i> facilities.</p>

<p>The major reason why we are in this situation is that the program
cannot tell when we are pressing a function key and when we are typing
the same sequence of characters explicitly.  After all, there are only
128 or 256 possible characters, and they must be shared by regular
keys and function keys.</p>

<p>Some systems that support directly attached terminals use timing
information to make this determination.  If a string of characters
comes in with no delays between them, they assume (usually correctly)
that it is a single function-key press.  This timing approach does not
work if the terminal (or other computer) is coming in via a
network.</p>

<p>The problem could best be solved by standardizing the character
sequences sent by function keys so as to (1) have a single, obscure
prefix (say, Escape, control-_) and (2) have a consistent syntax so
that all devices can easily determine when the sequence is over.
Command set designers would just have to live with the hole in the
command set, but that would be a small price to pay.</p>

<p>Aside from the problems of compatibility with whatever software is
being run, the placement of the function keys is also a problem.  As
was mentioned before, keys that are off to one side take a long time
to hit.  Thus, typing is slowed down considerably.  The keys are best
used for infrequently used functions or functions where the extra time
is not a significant factor (<i>e.g.</i>, Help).</p>

<p>There is yet one more problem.  Additional keys are not free and so
the number of them that you'll want to pay for is limited. However, it
is desirable to have the ability to specify a large number of
functions (<i>i.e.</i>, have a large number of codes that can be
specified by the user).  The number of function keys required grows
linearly with the number of codes.</p>

<a name="c2.2.2"></a><h3>2.2.2 Extra Shift Keys</h3>

<p>The other way to increase the number of codes available to the user
is to provide extra shift keys.  Shift keys are keys that modify the
actions of the other keys.  Shift and Control are the two most common
examples of such keys.  The IBM PC has an Alt key, the Apple Macintosh
has its &quot;cloverleaf&quot; key, and some terminals have a Meta key
option.</p>

<p>As an example, a Meta key would set the top (value 128 decimal) bit
of the character that is typed.  Thus, while typing shift-A would send
the code for uppercase A (65 decimal), meta-shift-A (often abbreviated
as simply meta-A or ~A) would send the code 128 + 65 or 193 decimal. A
user can thus specify 256 codes instead of the usual 128 from a full
ASCII keyboard.</p>

<p>The number of possible codes grows exponentially with the number of
extra shift keys.  Thus, 512, 1024, and even 2048 code keyboards (with
2, 3, or 4 extra shift keys) are conceivable.  You will have to use
system-dependent techniques to take advantage of this extra
information.</p>

<p>Finding room on the basic keyboard for these extra shift keys is
not easy.  That is one reason why the removal of the Shift Lock key
was suggested earlier.  These keys must be on the basic keyboard in
order to preserve touch-typeability.</p>

<a name="c2.2.3"></a><h3>2.2.3 Key Placement</h3>

<p>A computer is not a typewriter.  There are things that you do with
a computer that simply do not apply to typewriters.  Hence, a computer
keyboard should have more keys than a typewriter, and yet these keys
must be conveniently placed.</p>

<p>Several computer manufacturers have achieved good keyboard designs.
Unfortunately, most of them have retired their good designs in favor
of poor ones.  (See the next section for examples.)  Here are some of
my criteria for good key placement:</p>

<ul>
<li>Basic QWERTY keyboard (Dvorak keyboards are discussed later)

<li>top row has: Escape, 1/!, 2/@, 3/#, 4/$, 5/%, 6/^, 7/&amp;, 8/*,
9/(, 0/), -/_, =/+

<li>second row has: Tab, QWERTYUIOP, [/{, ]/}

<li>third row has: Control, ASDFGHJKL, ;/:, '/&quot;

<li>fourth row has: Shift, ZXCVBNM, ,/&lt;, ./&gt;, //?, Shift

<li>extra shift keys (Alt, Meta, etc.) should be immediately below the
shift keys

<li>the Back Space and/or Delete keys should be on the upper right, as
close in as possible

<li>the keys `/~ and \/| should fit into the right somewhere

<li>the Return (Enter, etc.) key should be on the right, as close in
as possible, in the third or second and third rows

<li>the Break key should be on the far upper right
</ul>

<p>These are the positions that have come to be accepted as standard
for computer keyboards.  However, some manufacturers have gotten
scared that their computers might actually resemble computers.  Thus,
necessary keys such as Escape and Control get moved out to the far
reaches of the keyboard, and &quot;&lt;&quot; and &quot;&gt;&quot;
characters get moved from their convenient, traditional positions
above &quot;,&quot; and &quot;.&quot; to who knows where.</p>

<p>Dvorak keyboards are an underground fad.  Their proponents swear by
them and claim significant performance improvements (<i>i.e.</i>, you
can type faster on them).  As the story goes, the standard QWERTY
layout was designed to slow typing on the early typewriters in order
to keep the mechanism from jamming.  And, since jamming is no longer a
consideration, one can (and Dvorak did) design a layout that is
&quot;better.&quot; Regardless of the truth of the story (and I
believe it to be true), all keyboard layouts can take advantage of the
improvements in technology.  For example, modern keyboards are
actually a grid of switches.  These switches are scanned
electronically.  Their travel, feel, and other characteristics can be
adjusted as desired.  They have been adjusted so that both key travel
and effort are much reduced from old, manual typewriters.  Hence, hand
and finger motions are reduced overall and the benefits to be gained
from switching layouts are thereby reduced.</p>

<p>Considering that there are hundreds of millions of existing
keyboards that use the QWERTY layout, and that there are billions of
people trained to use it, it becomes clear that only an enormous gain
in productivity (<i>e.g.</i>, greater than 100%) would be able to
justify a switch to another layout.  And while there are a number of
isolated success stories, not even the proponents of Dvorak layouts
offer any controlled studies that show the requisite gains (Norman
1990).  Hence, these keyboards are not being adopted on a large
scale.</p>

<a name="c2.2.4"></a><h3>2.2.4 Example Keyboards</h3>

<p>This section will briefly review a number of widely available
keyboards.  The keyboards reviewed are the ones actually named: the
review does not transfer to &quot;clones.&quot; The comments are, of
course, my personal opinions.</p>

<p><b>DEC VT100</b> terminal: The keyboard layout is excellent.  The
feel is klunky.  The control keys don't repeat.</p>

<p><b>DEC VT200</b> terminal: The keyboard layout is poor (badly
placed Escape key and &quot;&lt;&quot; and &quot;&gt;&quot; keys).
The feel is pretty good.</p>

<p><b>IBM PC 83-key</b> keyboard: This is the one sold with the
original IBM PC.  Its layout is almost excellent (the
&quot;\&quot;/&quot;|&quot; key placement is a little weird).  It
makes a clacking sound which I happen to like although many people do
not.  The feel is excellent.  If only they didn't try to
&quot;improve&quot; it with...</p>

<p><b>IBM PC 101-key</b> keyboard: This is the only one that you can
get from IBM now, and it is enough in itself to keep me from buying a
new IBM PC.  The Escape and control keys are very poorly placed.  The
feel is excellent.</p>

<p><b>Apple Macintosh original &quot;slab&quot;</b> keyboard: The
layout isn't too bad you consider that Apple intended this machine to
be its own universe, and not try to incorporate outside software.  On
the whole, however, it suffers from not having quite enough keys
(especially Escape), so that terminal emulator programs are awkward to
use.  The feel is fair. </p>

<p><b>Apple Macintosh &quot;Standard&quot;</b> keyboard: Perfect
layout, enough keys, great feel.</p>

<p><b>Apple Macintosh &quot;Enhanced&quot;</b> keyboard: This keyboard
is for people who like the IBM PC 101-key keyboard.  Enough said.</p>

<p><b>Sun Microsystems SPARCstation</b> keyboard: Excellent layout,
poor feel, too many function keys.</p>

<a name="c2.3"></a><h2>2.3 Graphical Input</h2>

<p>Another way of interacting with a computer is by means of a
graphical input device.  The advantage of a graphical input device is
that it can reduce the number of commands needed.  Such a device is
used for pointing at sections of the screen.  It is possible to
specify items (<i>i.e.</i>, &quot;operate on that&quot;) without
having to specify the numerical address of the location or a command
string to move there.</p>

<p>When a graphical input device is used, the screen is treated as one
menu with the device pointing to one entry.  A cursor is used to
provide feedback to the user about which menu &quot;item&quot; is
currently selected.  There are usually one or more flags that can be
specified conveniently from the device.  These flags provide control
information and are analogous to shift keys.</p>

<p>The basic way to use these devices is to track the position implied
by the graphical input device with the cursor.  When a signal is
given, the action implied by the current position is performed. The
screen is logically broken up into two or more sections.  One section
has the text that is being edited.  Moving the cursor here provides a
convenient way to move the point around; typing a character could
cause it to be inserted wherever the cursor is. Other portions of the
screen can specify menus of possible actions to select from.
Graphical input is thus a very sophisticated way of specifying a
position as an argument to a function.</p>

<p>The following sections discuss the advantages and disadvantages of
a variety of graphical input devices.  Bear in mind that the comments
are generalizations: there are exceptions to each of the advantages
and disadvantages mentioned.</p>

<a name="c2.3.1"></a><h3>2.3.1 Touch Sensitive Display</h3>

<p>A Touch Sensitive Display (TSD) is just what it sounds like.  The
screen is covered with a special transparent material (or a grid of
LEDs and receptors or other devices) that you touch with your finger:
the absolute (<i>x</i>,<i>y</i>) coordinates of where you touched are
then reported.  The only available flag is the &quot;touch/no
touch&quot; flag.  (Actually, experimental pressure-sensitive displays
exist that report all three positions and three pressure axes.)  The
well-engineered touch-sensitive displays are quite pleasant to use for
low-usage applications.  For high-usage purposes such as text editing,
it is tiresome to keep raising your hand to the screen, and your
finger tends to cover the most interesting part of the display
(<i>i.e.</i>, the part that you are about to edit).</p>

<a name="c2.3.2"></a><h3>2.3.2 Tablet</h3>

<p>A tablet is a special surface that reports the position of the
input device as an (<i>x</i>,<i>y</i>) coordinate.  The input device
can be a &quot;puck&quot; (a small box) or a special pen.  At least
one flag (&quot;touch/no touch&quot;) is always available: some pucks
have four, sixteen or even more extra flags.  Tablets are very handy
for converting paper documents such as maps into computer form.  They
are less useful for text editing, as they tend to be large and
therefore require a long reach and a lot of uncluttered desk
space.</p>

<a name="c2.3.3"></a><h3>2.3.3 Mouse</h3>

<p>A mouse is a small box on wheels (or, in some cases, on felt pads
over a special pad).  As you move it around on the floor, desk, books,
a leg, or most anything else, it reports the relative movement of the
mouse (<i>i.e.</i>, &quot;I was just moved <i>n</i> units up and
<i>m</i> units left&quot;).  It can have several flags (buttons),
although the correct number is one, as having extra buttons means that
program designers will try to put extra functions on them.  And, while
the functions themselves are not a problem (I do advocate extra shift
keys, after all), the presence of these functions usually implies a
poor program design.  Fortunately, if the mouse has extra buttons, the
software can easily correct this &quot;defect&quot; just by making
them all do the same thing.</p>

<a name="c2.3.4"></a><h3>2.3.4 Trackball</h3>

<p>A trackball is an upside-down (&quot;dead&quot;) mouse.  Instead of
moving the wheels by moving the box, you spin the slightly larger
wheel directly.</p>

<a name="c2.3.5"></a><h3>2.3.5 Joystick</h3>

<p>A joystick is a small stick mounted on a couple of potentiometers.
They typically can report either absolute position, first derivative
(relative movement) or second derivative (acceleration).  As the stick
is moved only over a small distance, it is difficult to construct one
with good resolution and that avoids &quot;stickiness&quot; and
&quot;jumpiness.&quot; It is generally not as nice to use as a mouse
or trackball.  Flags are simulated by regular keyboard keys.</p>

<a name="c2.3.6"></a><h3>2.3.6 A Different Mouse</h3>

<p>Finally, an imaginary but useful device should be considered. That
device is a foot-operated mouse (perhaps called a &quot;rat?&quot;).
Using your feet rather than your hand to operate the mouse solves one
of the most nagging problems of any of these devices, which is that
your hands must leave the keyboard with the usual, aforementioned
results.  Of course, this device makes it harder to edit with your
feet up on your desk...</p>

<a name="c2.3.7"></a><h3>2.3.7 Other Devices</h3>

<p>New types of input devices appear all the time.  Thus, no listing
of such devices can ever remain complete.  An example of a recent such
device is &quot;pen&quot; input.  The points to remember are that each
device should be judged on its own strengths and weaknesses and that
the devices should be judged on how they help your users: not whether
the devices are &quot;neat&quot; or &quot;new.&quot;</p>

<a name="c2.3.8"></a><h3>2.3.8 Conclusion</h3>

<p>These devices all assume a reasonably high bandwidth connection to
the computer (say, 2400 bps or faster).  If you have a slow-speed
connection, the cursor tracking must be performed in the local display
device, which must somehow be programmed with the knowledge of when to
report events and what to do with the cursor (sometimes the cursor
changes shape as it crosses from one part of the screen to another).
In this way, it is possible to supply the necessary immediate
feedback.  A slow-speed connection would be quite satisfactory for
communicating the significant events, but probably not satisfactory
for the screen refresh that would follow, say, the selection of a
menu.</p>

<a name="c2.4"></a><h2>2.4 Communications Path Issues</h2>

<p>This section covers a number of miscellaneous issues concerning the
communications path between the computer and the display/keyboard
device.</p>

<a name="c2.4.1"></a><h3>2.4.1 Speed and Character Format</h3>

<p>It almost goes without saying that the faster the communications
path, the better.  Consider it said.</p>

<p>It also almost goes without saying that a full-duplex
communications path is necessary.  Fortunately, we are long past the
days when users were forced to wait until the computer let them type.
Except on automated teller machines.</p>

<p>If the communications are over an asynchronous serial path,
character format is an issue.  The considerations are:</p>

<ul>
<li>Seven or eight data bits?  Pick eight if possible.  In this way,
you at least have the potential to use extra key codes.  The choice of
eight data bits also lets you use international character sets.

<li>Even, odd, or no parity?  Pick one to go with the data bits, as
this field has no effect on the data that the editor sees. The
combinations that you will tend to find all over the place are seven
data bits and even parity (older systems) and eight data bits and no
parity (newer systems).

<li>Number of stop bits?  One, unless your system wants a different
number.
</ul>

<p>Operating system designers make the quite valid and reasonable
assumption that they should be doing some processing of the input
characters.  Fortunately, they usually also offer the ability to turn
such processing off.  A text editor should follow these steps:</p>

<p>On entry to the editor:</p>

<ul>
<li>Record the current processing parameters.
<li>Turn off all character processing.
</ul>

<p>On exit:</p>

<ul>
<li>Restore the saved processing parameters.
</ul>

<p>In this way, the text editor has complete control over what happens
with the input characters.  This places an extra burden on you as the
writer of the editor, as you must replace the operating system
handlers with versions of your own that mimic the existing functions.
On the other hand, your versions will probably differ from the
operating system versions in a number of crucial ways.  For example,
if the operating system lets you suspend your process (for example,
under a Unix that supports job control), you need to restore the
terminal and input processing parameters before you turn control back
to the operating system.  When resumed, you need to return the
settings back to those used by the editor (noting any changes such as
a new window size) and probably refresh the display.  If you hadn't
replaced the normal handlers, the user would find yours to be a very
unfriendly program to use.</p>

<a name="c2.4.2"></a><h3>2.4.2 Flow Control</h3>

<p>The faster the communications path, the less time the display has
to process each character.  As the speed of the communications path is
increased, a point will be reached when the display can no longer keep
up in real time.  This is the point at which flow control is required.
There are three methods currently in use to implement flow
control.</p>

<p>The first is in-band control.  Two characters are reserved for flow
control purposes, typically the control-S and the control-Q
characters.  The first is used to mean &quot;hold on, I can't keep up
and my buffer is almost full.&quot; The second means &quot;okay, I've
caught up and you can proceed.&quot; This method works for the most
part, but has the annoying property of using up two valuable control
characters.  Using any control characters causes problems for some
programs.  For example, there exist some communications protocols that
use all 256 characters and allow no characters to be reserved.</p>

<p>The second method is out-of-band control.  This method uses a
variety of mechanisms, none of which interfere with sending data.
Examples of such methods are hardware &quot;handshake&quot; lines and
network protocol mechansims.  This method is clearly superior to
in-band.</p>

<p>The final method is flow control avoidance.  This method takes
advantage of the facts that displays take different amounts of time to
process different characters and that some characters (called padding
characters) take very little time to process.  The program send the
data as a mix of useful characters and padding characters.  The
specific mix is computed so that the average time required to process
each character is less than the time taken to send a character over
the communications path and that the terminal's input buffer does not
overflow.</p>

<p>For example, let's say that we have these (fairly typical)
figures:</p>

<ul>
<li>communications path speed is one character per msec

<li>time to process a printing character is .6 msec

<li>time to process a line feed character is 17 msec

<li>time to process a pad character is .1 msec
</ul>

<p>If we were just sending full lines of text to the display, we would
send 81 characters in 81 msec.  These 81 characters would take 80 * .6
msec + 17 msec = 65 msec to process.  Hence, no padding would be
required.</p>

<p>On the other hand, if we were just sending single-character lines
of text to the display, we would send 2 characters in 2 msec.  These 2
characters would take 1 * .6 msec + 17 msec = 17.6 msec to process.
Padding would be required as the 17.6 msec processing time is greater
than the 2 msec transmission time.  As it turns out, 18 padding
characters will be sufficient (1 * .6 msec + 17 msec + 18 * .1 msec =
19.4 msec, which is less than the 20 msec of transmission time).  It
is not difficult to calculate the correct number of padding characters
required, given the character mix and the communications path
speed.</p>

<p>This third method is the preferred method for text editors, as it
works on any communications path (<i>i.e.</i>, even those with no
out-of-band flow control) and it allows full use of all input
characters.  If used over a network, it has the disadvantage of
creating a modest additional amount of network traffic.</p>

<p>The ideal method would be for the editor to determine whether
out-of-band flow control is used along the entire communications path.
If such control is in use, no padding characters need to be sent.
Unfortunately, it is usually not possible to reliably determine the
type of flow control in use.</p>

<a name="c2.4.3"></a><h3>2.4.3 Echo Negotiation</h3>

<p>Echo negotiation was devised for the Multics computer system.  It
is a protocol for use by computer networks which can cut down on
response time by reducing communications overhead.  It is potentially
useful in an environment where the user's terminal is at one node and
the computer which is running the text editor is at another.  In such
an environment, it can take a long time to send a character back and
forth, and yet it takes little more time to send many characters.</p>

<p>Echo negotiation requires that it be easy to describe exactly what
is to be done with each character to a communications
processor/terminal combination and that the combination be capable of
doing enough of the editing to make it worthwhile.</p>

<p>Typically, echo negotiation can only be used when the editing point
(&quot;cursor&quot;) is at the end of a line.  The text editor sends a
list of approved characters to the terminal or other nearby
processor. As long as the user types only those characters and does
not reach the end of a screen line (thus necessitating a wrap), the
terminal can safely echo the input characters to the display and hold
onto the input text.  When any non-approved character is typed (or the
line fills up), the terminal reports all of the held input characters
and the reason why the input was sent on (<i>i.e.</i>, non-approved
character or line wrap) to the text editor.  The editor then processes
the input data and the cycle repeats.</p>

<p>The Xylogics Annex terminal server incorporates an advanced version
of echo negotiation called the LEAP Protocol.  It incorporates all of
the above design.</p>

<p>Both standard echo negotiation and the LEAP protocol suffer from
the same problem.  This problem is severe enough to call into question
the desirability of using them at all: Echo negotiation is only
potentially useful when the terminal is separate from the computer
that is running the text editor <i>and</i> when the computer is
overloaded.  The principle behind echo negotiation is that waking up
the text editor process for each character is inefficient.  In extreme
cases, the wake-up may take so long that input echoing is
significantly delayed.  The fix that echo negotiation offers is to
perform the updates in batches, thus waking up the text editor process
fewer times and thereby reducing overhead.</p>

<p>The problem with the fix is inherent in its own success.  With no
echo negotiation, input is echoed slowly but evenly (user typing is in
general much slower than process-switching times) and the text-editing
process tends to stay in memory. With echo negotiation, input is
echoed quickly until the non-approved character is typed, then a
(comparatively) long pause is encountered while the text-editing
process must be woken up and possibly even swapped in (we are talking
about a situation where resources are tight, after all).  Even though
the <i>average</i> per-character processing time might be lower, the
<i>variance</i> in per-character times is much larger with echo
negotiation.  It is usually the case that the variance is so high that
the system as a whole becomes unpleasant if not impossible to use.  In
one extreme test that I performed, I found the variance of times to be
so great that editing was all but impossible: until you stopped typing
for many seconds, you could never tell whether the computer had
processed all of your input and hence couldn't safely continue typing
(editing commands -- not new text to be inserted). In conclusion, echo
negotiation is not a good feature to include.</p>

<a name="c2.4.4"></a><h3>2.4.4 Fancy Modems</h3>

<p>High-speed modems (9600 bps and higher) are starting to become
quite common.  The main problem with them is that the advertising for
them is focused around file-transfer protocols and dumping large
quantities of text through them.  The manufacturers add a variety of
compression techniques to improve their modems' throughput in these
areas.</p>

<p>However, text editing is interactive.  Low response time is more
important than high throughput.  This is where the compression schemes
implemented by the modems can cause problems.  The simple solution is
to turn off all such compression.  Do not forget to turn off control-S
/ control-Q flow control while you're at it.</p>

<a name="c2.q"></a><h2>Questions to Probe Your Understanding</h2>

<p>Devise at least three different ways of encoding cursor positioning
coordinates.  Which is the most extensible?  (Easy)</p>

<p>Why can character-oriented displays handle blinking text more
easily than graphics displays?  Does it matter?  (Easy)</p>

<p>If you could change one physical attribute of the display
(<i>e.g.</i>, size, phosphor) that you use most, what would it be?
(Easy)</p>

<p>Give an example of an application that can make effective use of
function keys.  (Easy)</p>

<p>Devise an efficient, extensible encoding scheme for function keys.
(Easy)</p>

<p>Some keyboards (such as that used by the IBM PC and compatible
computers) assign a priority to shift keys and only pay attention to
the highest priority key pressed.  For example, pressing both Control
and Shift gives the same code as does just pressing Control.  Is this
better or worse than giving a different code to the combination key
presses?  Why?  (Easy)</p>

<p>How does the amount of buffering affect the need for padding?  Does
it matter where in the system additional buffering is placed?
(Medium)</p>

<p>A fourth way to handle flow control used to be common practice but
is no longer.  It is called &quot;ETX / ACK&quot; after the codes for
the characters that were used to implement it.  In this method, the
sender sends a block of text followed by an ETX character.  It then
waited for the receiver to return an ACK character.  Why has this
scheme dropped from favor?  How does it interact with terminals on
computer networks?  (Medium)</p>

<p><a href="#contents">Back to Contents</a>.</p>
<hr>
<a name="c3"></a><h1>Three: Implementation Languages</h1>

<blockquote><i>
He took his vorpal sword in hand:<br>
&nbsp;&nbsp;Long time the manxome foe he sought --
</i></blockquote>

<p>The choice of implementation language has a major effect on the
design of a text editor.  In some environments, only one language is
available.  In such environments, you do the best that you can and
your editor may end up different from what it would be if the ideal
language was available. However, most environments offer at least two
languages.  You thus have a choice, and this chapter offers guidance
in making that choice.  Of course, this may be a choice between Scylla
and Charybdis...</p>

<a name="c3.1"></a><h2>3.1 General Considerations</h2>

<p>The general considerations in selecting a language to use for
implementing a text editor are:</p>

<ul>
<li>availability and implementation quality
<li>text handling power
<li>support for extensibility
<li>support for large projects
<li>efficiency
</ul>

<p>Each of these considerations will be explored in detail.</p>

<a name="c3.1.1"></a><h3>3.1.1 Availability and Implementation Quality</h3>

<p>You can only use those languages that are supported on the system
that your text editor is first implemented upon.  Nonetheless, you
should be thinking about the second, third, and later systems that
your text editor will be ported to, and which languages all of those
systems support in common.</p>

<p>In addition to the mere presence of a language processor on a
system, you should take into consideration the quality of
implementation of such systems.  An implementation's speed of
operation, quality of diagnostics, quality of code produced, and other
such factors can make a large difference in the usability of the
language on a particular system.</p>

<a name="c3.1.2"></a><h3>3.1.2 Text Handling Power</h3>

<p>It may appear redundant to say that a text editor must handle text,
but consider a spread sheet program: most of its work is in handling
control flow, figuring redisplay, and setting up to execute commands.
Only a small fraction of its time is spent in the floating point
instructions that most users think is the program's &quot;real
work.&quot;</p>

<p>At any given moment, a text editor -- or most any other similar
interactive program -- is mainly doing all of the following:</p>

<ul>
<li>waiting for user input
<li>parsing that input
<li>setting up to execute the commands
<li>executing the commands
<li>determining the effect of those commands on the screen
<li>updating the screen
</ul>

<p>Most of these operations involve processing text in some way or
other.  Text editors differ from other applications only in that the
&quot;executing the commands&quot; item also involves manipulating
text.</p>

<p>It is important to note that &quot;text handling&quot; does not
necessarily mean &quot;string handling.&quot; In many cases, the
language's native string operations are not sufficient, and you must
write your own string primitives.  For example:</p>

<ul>
<li>Fortran does not support strings with dynamically varying lengths.
<li>C does not support strings that contain the NUL (0 decimal)
character.
<li>Many implementations of Pascal do not support arbitrarily long
strings (the leading byte count is often only 8 or 16 bits wide).
</ul>

<a name="c3.1.3"></a><h3>3.1.3 Support for Extensibility</h3>

<p>If they do nothing else, text editors change.  The language should
make it easy to make and maintain changes.  In some cases, the source
code must be changed and the editor recompiled.  However, it is very
desirable to allow users to change some of the editor to suit their
tastes.  The language should offer such support.</p>

<p>This support can take many forms:</p>

<ul>
<li>late binding of names to procedures through indirect calls,
dynamic linking, or other techniques
<li>retaining and using the symbol table information at run time so
that the user can think of changes in terms of names, not addresses
<li>internal error and consistency checking under program control so
that users can be protected from their mistakes
<li>the ability to add code to the executing editor
</ul>

<p>Not all languages offer these features.  You will have to simulate
the missing features when using those languages that lack them.</p>

<a name="c3.1.4"></a><h3>3.1.4 Large Project Support</h3>

<p>Text editors are apt to grow quite large.  All of the techniques
useful for any large project are useful here.  Examples of these
techniques are:</p>

<ul>
<li>division of the program into separate modules
<li>division of the program into separate files
<li>separate compilation
<li>a way to organize the global name space
<li>a way to keep objects out of the global name space
<li>automatic verification of procedure call/declaration compatibility
<li>conditional compilation
<li>compilation constants
<li>a way of constructing &quot;data abstractions&quot; that package
procedures and private state information
<li>a way of dynamically allocating memory
</ul>

<p>Add your own favorites to the list.</p>

<a name="c3.1.5"></a><h3>3.1.5 Efficiency</h3>

<p>Programs spend most of their time doing simple operations such
as:</p>

<pre>
	A = B
	A = B +/- 1
	A = B +/- C
</pre>

<p>No other expressions occur often enough to matter (Knuth 1971).
Thus, the language should support these common operations well.
Control structure implementations -- in particular, a procedure call
-- should be kept efficient.  Most languages do all right in this
respect: the main thing is to ensure that they keep simple things
simple.</p>

<a name="c3.2"></a><h2>3.2 Specific Language Notes</h2>

<p>This section briefly examines a number of popular and/or
interesting language choices.  It is important to keep in mind that at
some level, all languages are equivalent: anything that you can do in
one, you can do in any other, given sufficient CPU time, memory, and
programmer elbow grease.  However, each language is intended to make
solving one type of problem easy, and in most cases that type of
problem is not text editing.</p>

<a name="c3.2.1"></a><h3>3.2.1 TECO</h3>

<p>TECO (Text Editor and COrrector) was developed at the Massachusetts
Institute of Technology.  It was one of the first text editors ever
written.  It grew over the years, gaining both popularity and
features.  During one of its more stable periods, Digital Equipment
Corporation took a &quot;snapshot&quot; of its commands and produced
(subset) versions for all of DEC's computers.</p>

<p>But TECO kept growing.  Along the way, it turned into a
Turing-complete programming language.  Several sets of editor macros
were developed and used.  Sometime around 1975, Richard Stallman
organized these Editor MACroS into the first Emacs-type text
editor.</p>

<p>TECO is clearly a language capable of supporting text editing.
However, unless you have a DECSYSTEM 20 computer to run it on, you're
out of luck: M.I.T.'s version of TECO is written in assembly language
and only runs on such systems.</p>

<p>The TECO command set is described in Appendix D.  There are two
reasons why it is not a good choice as an implementation language:</p>

<ul>

<li>As has been mentioned, its only implementation is on the
PDP-10/DEC 20 series of computers.  Implementations on other machines
involve answering the question of what you write the TECO in -- the
very question that this chapter discusses.

<li>It is the only language less readable than APL.  A listing of a
TECO program has a more than passing resemblance to transmission line
noise.  Writing and maintaining TECO programs is a definite problem.
</ul>

<a name="c3.2.2"></a><h3>3.2.2 Lisp</h3>

<p>Lisp -- especially Common Lisp -- is an excellent choice.  It is
readily extensible, as even compiled Lisp code usually has provisions
for evaluating new expressions.  It thus provides an interpretive
language that can be readily used to write even complex editing
macros.  Modern implementations usually have excellent string support.
The language has features such as macros and packages that support
large projects well, and Lisp programs are fairly readable (if you
don't mind lots of parentheses (like these (and these))).  Compiled
Lisp code is usually as efficient as that of any other language.</p>

<p>Its view of memory management makes it well suited to the linked
line form of buffer management (described in Chapter 7).</p>

<a name="c3.2.3"></a><h3>3.2.3 C</h3>

<p>C was designed by people who wrote operating systems and utilities.
Since text editors are among those utilities, it is not surprising
that C would be a good choice.</p>

<p>C supports extensibility as well as any other compiled language,
and better than most. For example, it provides the ability to call
procedures through a pointer.</p>

<p>C lacks a built-in string type, but this lack is not a hindrance,
as you would probably need to re-implement strings anyway.  There is a
strong tradition in C of creating new data types, so the requirement
is well supported.</p>

<p>C supports many of the features needed for large projects.  In
addition, as the language was designed by its users, and only came
into widespread use after it was stable, there is a large existing
base of compatible implementations.  Due to this heritage, you don't
need &quot;improvements&quot; in the language in order to get useful
work done.</p>

<p>C's basic data types are focused around characters, integers, and
pointers.  These are exactly the core data types needed by text
editors.  C allows the ready manipulation of complicated data
structures and yet remains generally readable.</p>

<p>C++ is a variant of C that provides much improved support for
object-oriented programming.  It, too, is a good choice.</p>

<a name="c3.2.4"></a><h3>3.2.4 PL/1</h3>

<p>PL/1 is another example of a &quot;systems language.&quot; Thus,
most of the comments regarding C also apply to PL/1.  However, its
main failing is a lack of multiple implementations: the only vendor
that seriously supports it is IBM Corp.</p>

<a name="c3.2.5"></a><h3>3.2.5 Other Systems Languages</h3>

<p>There are a number of other systems languages (<i>e.g.</i>,
Modula).  However, like PL/1, they have only a limited availability.
Many were designed as research projects.  None of them even distantly
approach C in the number of implementations or trained
programmers.</p>

<a name="c3.2.6"></a><h3>3.2.6 Fortran</h3>

<p>Well, some people think that it's a great language for writing
astronomy programs.  I have even written a text editor in it.  Not by
choice.</p>

<a name="c3.2.7"></a><h3>3.2.7 Pascal</h3>

<p>Many people consider this language to be a good alternative (read
&quot;better&quot;) to C.  It is worth reviewing Pascal's history: it
was originally intended as a language to present (relatively small)
algorithms in an academic setting.  It was also targeted to
introductory programming courses.  For those purposes it is an
excellent choice.</p>

<p>However, the standard language is not targeted towards developing
large projects and does not provide the features that make developing
a large project practical.  On the other hand, each Pascal vendor has
supplied those features.  Unfortunately, they have in general chosen
different ways to provide the features.  Thus leading to incompatible
implementations that make porting code difficult.</p>

<a name="c3.2.8"></a><h3>3.2.8 Basic</h3>

<p>Basic has Pascal's problems, only more so: the core version is not
even standardized (by the industry: there is an ANSI standard which is
honored in the breach).  Implementations range from &quot;Tiny
Basic,&quot; which can be run in only a few Kilobytes of memory to
&quot;True Basic,&quot; as defined by Kemeny &amp; Kurtz (Kemeny
1985), which offers all the advanced features that you could want and
all but omits line numbers.  But &quot;True Basic&quot; bears little
resemblance to what most programmers think of as the Basic
language.</p>

<a name="c3.2.9"></a><h3>3.2.9 Ada</h3>

<p>Ada was designed as a language to support embedded, real-time
systems.  It has many features which allow compilers to validate code
and use external information to produce small, reliable object
modules.  However, these features do not mesh well with the need for
extensiblity (for example, there is rarely a need to reprogram an
altimeter while in flight).  Further, the general computing
environment that is the home for most text editors is simply outside
the scope of what Ada is intended for.  However, it should be
seriously examined as a choice if the text editor is to execute in an
embedded, real-time system.</p>

<a name="c3.2.10"></a><h3>3.2.10 Sine</h3>

<p>Sine (Anderson 1979) was a Lisp-like language tailored for text
applications.  Its only implementation to date is on Interdata 7/32
(or Perkin-Elmer 3200) minicomputers running the MagicSix operating
system developed at M.I.T.'s Architecture Machine Group.  It is
interesting because it is a language tailored for implementing
editors.  It is an example of an &quot;ideal&quot; implementation
language.  </p>

<p>Sine is composed of two parts.  Sine source code is assembled into
a compact format.  This object code is then interpreted.  It allows
function rebinding and other such niceties.  In addition, the
interpreter implements such things as memory management and screen
redisplay.  Thus, the resulting editor is nicely structured, with
&quot;irrelevant&quot; details hidden away. This mention of Sine leads
nicely into...</p>

<a name="c3.2.11"></a><h3>3.2.11 Custom Editor Languages</h3>

<p>No traditional language (except perhaps for Common Lisp) offers
complete support for text editing.  The solution, used by virtually
every implementation of Emacs-type text editors, as well as many
implementations of other editors, is the creation of a custom editor
language.</p>

<p>An existing language -- very often C -- is selected.  This language
is used to write an interpreter for the custom editor language.  The
interpreter manages memory, handles display refresh, and in general
provides all of the necessary utility functions.  The editor language
is then used to write the logic of all the user-visible commands.</p>

<p>As the editor language is implemented using an interpreter, the
command set is readily extensible.  Also, because the editor language
is designed around text editing, it can offer excellent text-handling
power.</p>

<p>The division of the programming tasks into two components provides
an excellent base for supporting large projects.  And, since the
interpreter is usually implemented in a language such as C, the
interpreter can be quite efficient.</p>

<p>For these reasons, custom editor languages are the preferred method
for implementing text editors.</p>

<a name="c3.q"></a><h2>Questions to Probe Your Understanding</h2>

<p>What is a good way of implementing a command dispatch table in C?
Fortran?  Pascal?  Ada?  (Easy)</p>

<p>Why is a string-oriented language such as SNOBOL not a good choice?
(Easy)</p>

<p>How much compilation is appropriate for the custom editor language
(none, just interpret the text; tokenization; full)?  (Medium)</p>

<p>Following on the previous question, how would an opcode-oriented
interpreter compare to a threaded-code interpreter? (Medium)</p>

<p><a href="#contents">Back to Contents</a>.</p>
<hr>
<a name="c4"></a><h1>Four: Editing Models</h1>

<blockquote><i>
So rested he by the Tumtum tree,<br>
&nbsp;&nbsp;And stood a while in thought.
</i></blockquote>

<p>An editing model is the view of the file that the editor presents
to the user.  This chapter describes several editing models.  You can
build other models by varying and combining these models.</p>

<p>The following discussions review the models themselves, not the
commands available to the user.  You should assume that essentially
the same commands are available in all models.</p>

<a name="c4.1"></a><h2>4.1 One-Dimensional Array of Bytes</h2>

<p>The most general form of a data file is a one-dimensional array of
bytes.  The one-dimensional editing model presents this form of a data
file directly to the user.  In it, the bytes of the file are displayed
uninterpreted for the user to see.  The basic editing operations are
&quot;insert&quot; and &quot;delete bytes.&quot;</p>

<p>This model is very pure, but it is a little difficult for most
users to deal with.  Text editors that appear to use this model
actually use a slightly modified form of the model where some
characters -- in particular, the tab and newline characters -- are
interpreted during the display process.  Thus, text files appear as a
series of lines.</p>

<p>In this model, line breaks may or may not require special handling.
Whether they do depends on how they are represented.  Various
representations are described in detail in the next chapter.</p>

<p>This model supports both insertion and replacement editing equally
well.  Replacement editing is probably best implemented as a hybrid
scheme where it automatically switches to insert mode to prevent
replacing a line break.</p>

<a name="c4.2"></a><h2>4.2 Two-Dimensional Array of Bytes</h2>

<p>This model is the basic two-dimensional form.  Instead of editing a
line, the user is editing in a quarter-plane, with the origin usually
in the upper-left corner.  Conceptually, the user can move freely in
the two-dimensional quadrant.  In practice, the editor usually only
stores the non-blank portions, as storing an infinite-quadrant's worth
of data can be prohibitively expensive.  Some systems may impose fixed
upper bounds on the width or length of the quadrant.</p>

<p>Line breaks are implicit in the editing model itself.  Hence,
implementations usually provide explicit commands to split and join
lines.</p>

<p>Both insertion and replacement editing are possible, although the
model lends itself to replacement editing in a natural manner.
Editors that use this model often have explicit commands to insert
(and delete) both rows and characters within a row.</p>

<p>While the pure form of this model arranges the text into a
rectangle, most implementations actually impart a left-to-right, then
top-to-bottom (or one of the other seven combinations) bias.  This
bias affects all of the editing operations.  For example, it is often
the case that implementations offer many commands for editing within a
line, but only a few commands for editing entire lines.</p>

<a name="c4.3"></a><h2>4.3 List of Lines</h2>

<p>This model is halfway between the first two.  It consists of a
one-dimensional array of lines.  Each line is then a one-dimensional
array of bytes.  From the user's viewpoint, this model differs from
the two-dimensional model in that text exists only where it has been
entered.  If the user wants to extend a line to the right, he or she
must go into insert mode and type space characters.</p>

<p>In the two-dimensional model, on the other hand, the quadrant is
assumed to be filled with blanks.  Hence, there is no concept of
extending the line to the right, as the line is assumed to extend
infinitely far.  To add text to the right, the user simply moves to
the desired position.</p>

<p>Implementations that use this model usually make a very sharp
distinction between editing within a line and editing lines.  For
example, lines may have a maximum length or cut and paste operations
may only operate on line boundaries.</p>

<a name="c4.4"></a><h2>4.4 Paged Models</h2>

<p>It once was popular to divide the text into a series of pages.
Editing was performed within a page, and explicit commands were
required to move to another page or to re-paginate the text.  Any of
the models could be used for editing within a page.  This division was
thought to be natural: not coincidentally, it just
&quot;happened&quot; to make it easier to write editors on systems
that had very limited amounts of memory.</p>

<p>Most modern editors show page breaks as a &quot;framework&quot;
that &quot;floats&quot; over the underlying text.  This framework can
be placed over any of the other underlying editing models.</p>

<a name="c4.5"></a><h2>4.5 Objects</h2>

<p>Editing is a very general concept: there is no reason to limit the
basic objects being edited to characters (or bytes) and lines.  It may
make sense in some cases to provide ways of editing such objects as
words, sentences, paragraphs, sections, chapters, and other
&quot;natural&quot; objects as explicit objects.  Most editors provide
commands to manipulate these objects without having them affect the
fundamental editing model.</p>

<p>Other objects cannot be readily simulated.  Examples of these
objects are links to other documents, &quot;opaque&quot; objects
included from other objects (<i>e.g.</i>, bitmaps), and graphical
objects (lines, boxes, circles, etc.).</p>

<p>In addition, text can be viewed in more than two dimensions.  For
example, multiple files can be &quot;stacked&quot; into a third
dimension, multiple versions of a single file can be combined into a
time-like dimension, or portions of a file can be viewed and
manipulated as a tree or list structure.  The possibilities are
endless.</p>

<a name="c4.6"></a><h2>4.6 Dealing with Real Text</h2>

<p>The models just listed are more or less pure forms.  Each model has
its advantages and disadvantages because text has a more complex
structure than is represented by any of the models.</p>

<p>On the one hand, text is composed of a hierarchy of lexical
units:</p>

<ul>
<li>characters
<li>words
<li>phrases
<li>sentences
<li>paragraphs
<li>subsections
<li>sections
<li>chapters
<li>documents
</ul>

<p>These units reflect the <i>meaning</i> of the text.  When the user
is thinking in terms of meaning, the editor should provide an editing
model -- and commands -- that reflect these units.  Since text is read
sequentially, the one-dimensional model is well-matched to this
mode.</p>

<p>On the other hand, the printed page is composed of:</p>

<ul>
<li>characters, which are arranged into
<li>words, which are arranged into
<li>lines, which are arranged into
<li>pages, which are arranged into
<li>documents
</ul>

<p>These units reflect the <i>layout</i> of the text.  When the user
is thinking in terms of appearance, the editor should provide an
editing model -- and commands -- that reflect these units.  As a page
is a two-dimensional object, the two-dimensional model fits this mode
well.</p>

<p>Many &quot;simple&quot; editors and word processors support this
mode of thinking.  This mode is attractive for new users.  After all,
isn't the whole purpose of a word processor to put characters on a
page?  So doesn't it follow that users should be thinking in terms of
placing each character on the page, one after the other?  If taken to
extreme, the user is forced to make every placement decision, a
situation that doesn't leave the user with much time or energy left to
decide what to write.</p>

<p>While layout is important, it does not directly relate to the
meaning of the text.  And while meaning is important, the user sees
the text in a particular layout, so layout-oriented editing is also
important.  The challenge, then, is to design an editing model -- and
an editor -- that allows the user to select the most appropriate
features of each model with minimal effort.  Thus, it can take
advantage of the best of both models while avoiding the
disadvantages.</p>

<a name="c4.q"></a><h2>Questions to Probe Your Understanding</h2>

<p>Explore the ramifications of a two-dimensional editing model where
the origin is in the center of the document instead of the upper-left
corner.  What additional commands might be required?  What operations
(if any) does such a model make easier?  Harder? (Easy)</p>

<p>Provide an algorithm for transforming between the one-dimensional
and two-dimensional models. (Medium)</p>

<p>What is a good way to support proportionally spaced text in the
<i>pure</i> two-dimensional array of bytes model? (Hard)</p>

<p>What problems are encountered when trying to support more than one
model at the same time? (Easy) What is a good solution to these
problems? (Hard)</p>

<p><a href="#contents">Back to Contents</a>.</p>
<hr>
<a name="c5"></a><h1>Five: File Formats</h1>

<blockquote><i>
And, as in uffish thought he stood,<br>
&nbsp;&nbsp;The Jabberwock, with eyes of flame,
</i></blockquote>

<p>This chapter surveys the range of file formats that a text editor
might encounter.</p>

<a name="c5.1"></a><h2>5.1 Text Files</h2>

<p>Each operating system has a standard way of storing text
files. Text editors must be able to edit these standard system text
files.  From the user's point of view, such files consist of a series
of reasonable-length lines of &quot;reasonable&quot; characters.</p>

<a name="c5.1.1"></a><h3>5.1.1 Line Boundaries</h3>

<p>From the program's point of view, system text files consist of a
sequence of characters, divided into lines in a variety of ways.  Each
of the most popular methods will be described.</p>

<p><b>Card and Print Images</b>: These files are a series of lines,
all exactly the same length (typically 80, 132, or 133 characters
long).  They may also include another form of line divisor
(<i>e.g.</i>, 80 characters, then a CR/LF sequence).  These files will
mostly be found on older systems.</p>

<p><b>Newline Character</b>: Marker bytes are used to signal the end
of one line and the start of another.  Popular choices are:</p>

<ul>
<li>Line Feed: Used by UNIX systems.

<li>Carriage Return: Used by Apple computers and some DEC computers.

<li>Carriage Return/Line Feed combination: Used by CP/M and MS/DOS
computers.  The two-character sequence can be awkward to use when
editing.  You can usually get away with dropping the CR (but only when
it appears as part of a CR/LF sequence), use the LF as a newline
character, and put the CR back when the file is written out.  When
editing an existing file, record whether you found CRs to remove, so
that you don't put extra CRs in when writing out binary files.
</ul>

<p><b>Character Count</b>: Some systems use an initial count of
characters (typically the count is one or two bytes long), followed by
that many characters.  There may or may not be padding between lines
in order to align their start on a word boundary.</p>

<p><b>Record Markers</b>: Some operating systems store one line per
record, and store the record markers &quot;out of band.&quot; In this
case, you must read and write one line at a time, and record the line
break information somehow.  (If the operating system lets you read
multiple lines at once, it must have some method of indicating what
the line boundaries are, which leads us to one of the earlier
methods.)</p>

<a name="c5.1.2"></a><h3>5.1.2 Line Contents</h3>

<p>Some systems place restrictions on the contents of each line.  The
most frequently encountered restrictions are:</p>

<p><b>Long Lines</b>: Some systems have no limit on the length of a
line.  Others place a fixed limit.  Typical limits are 80, 127 or 128,
255/6, 511/2, 32,767/8, and 65,535 characters.  If a program attempts
to write lines that exceed the system limit, some systems return an
error, others split the line, and still others will silently truncate
the line.</p>

<p><b>Short Lines</b>: Most systems support zero-length (empty) lines
quite well. However, some systems do not allow such lines while others
allow them in theory but not in practice.  For example, the
system-supplied text editor may not allow the entry of empty lines.
Because of this limitation, no files will be created that have such
lines.  Hence, the code to handle such lines may not be tested well,
and some programs may not behave properly when such lines are
encountered.</p>

<p><b>Partial Last Line</b>: This problem can only occur in systems
that use a newline character.  As with short lines, the
system-supplied text editor may not allow the entry of partial last
lines (<i>i.e.</i>, a missing newline character) and some programs may
not behave properly when such lines are encountered.</p>

<p><b>Non-Printing Characters</b>: All systems generally allow all
printing characters and the Space character to appear in text files.
These character have codes that range from 32 to 126 decimal in ASCII
or the equivalent characters in EBCDIC.  Difficulties arise in how
programs handle other characters.  For example, are Tab characters
treated as one character or the appropriate number of spaces, and if
the latter, what is the appropriate width?  Limitations on
non-printing characters usually fall into the following groups:</p>

<ul>
<li>Tab
<li>Form Feed
<li>Back Space
<li>Carriage Return (this is a &quot;bare CR&quot;)
<li>other control characters (in the range 0 to 31 decimal and 127
decimal)
<li>meta characters (128 to 255 decimal)
</ul>

<p>Typically, systems that allow a given group allow all preceding
groups.  Given that the characters are allowed, the next question is
how should the character be displayed.  Typical methods are:</p>

<ul>
<li>Just send the character as is without translation.
<li>Expand into caret notation (see Appendix E).
<li>Expand into octal or hexadecimal notation.
</ul>

<a name="c5.1.3"></a><h3>5.1.3 End of File</h3>

<p>Most systems record the exact file length and make this information
available to the program.  However, there are two special cases to be
considered:</p>

<p><b>CP/M systems</b> only record the file length to the next
multiple of 128 bytes.  By convention, a control-Z (^Z) character is
used to mark the end of the file.  Data after the first Z character is
ignored.  Note that if the file ends exactly on a 128-byte boundary,
some programs do not add the trailing ^Z character.  Some programs
filled the entire remainder of the block with the ^Z character: other
programs relied on this convention and only removed trailing ^Z
characters.</p>

<p><b>MS/DOS systems</b> started off following the CP/M convention but
later changed to omit the ^Z character.  The safest algorithm to use
on these systems is:</p>

<ul>
<li>If you are editing an existing file, record whether the file
originally ended with ^Z. When the new version is written, add a ^Z if
the file had one.
<li>Otherwise, do not add a ^Z.
</ul>

<p>As always, the user should have a way of selecting both
methods.</p>

<a name="c5.2"></a><h2>5.2 Binary Files</h2>

<p>From a text editor's point of view, a <i>binary file</i> is any
file that is not a text file.  These files have none of the following
restrictions found in text files:</p>

<ul>
<li>Files may not be divided into lines at all.
<li>Lines may be any length.
<li>Lines may contain any character.
</ul>

<p>As a general rule, it is a nice feature to be able to edit a binary
file.  The rules to be followed are these:</p>

<ul>
<li>You should be able to read a file in and write the identical file
back out.
<li>It should be possible to move to and usefully view any portion of
the file.
<li>It should be possible to insert any character.
<li>It should be possible to precisely control any deletions
(<i>e.g.</i>, &quot;delete the following three characters&quot;).
</ul>

<a name="c5.3"></a><h2>5.3 Structured Files</h2>

<p>If your editor will only encounter standard system-text files and
binary files, you can skip the rest of this chapter which describes
considerations for designing file formats for holding information in
addition to pure ASCII text.</p>

<p>Basic text files use 94 printing characters and a Space
character. They also need some way to indicate line breaks.  Often,
users will want to include the Bell, Back Space, Tab, and Form Feed
characters in their text files.  Thus, a total of 99 characters are
reserved for representing themselves.  This leaves 29 codes (with 7
bit characters) or 157 codes (with 8 bit characters) available for
other uses.</p>

<p>If all computer manufacturers used only the ASCII character set,
the analysis could stop here.  However, IBM Corp., Apple Computer
Corp., Hewlett-Packard, and other vendors all support
&quot;extended&quot; character sets that make use of many of these
other codes.  (Not to worry, though, the world is still safe: all of
the manufacturers support <i>different</i> extended character sets.)
What were previously unused codes are now in use to the extent that
your users wish to be able to make use of the extended characters.</p>

<p>(Actually, as this book is being written, many vendors are jointly
developing a 16-bit character set that is intended to encompass most
characters and glyphs in use, although not doing a complete job on
Chinese, Japanese, and Korean.)</p>

<a name="c5.4"></a><h2>5.4 Where to Store the &quot;Extra&quot; Information</h2>

<p>Whether or not &quot;extended&quot; character sets are supported,
it is likely that you will want to store more information than can fit
into the unused character codes.  This leads us to the basic choice
that will affect many other aspects of the implementation: is the
extra information stored in-band or out-of-band?</p>

<a name="c5.4.1"></a><h3>5.4.1 In-Band</h3>

<p>Storing information <i>in-band</i> means that some of the character
codes are used to signal the presence of this additional
information. Once the presence of this information is indicated, all
character codes can potentially be used to represent the
information.</p>

<p>The use of these character codes for non-character purposes has two
ramifications.  First, those codes are not available for representing
characters.  Second, if those characters are present, redisplay must
know how to display them (and their associated information) and the
user commands must know how to process them.</p>

<p>Depending upon the purpose of the extra information and your users'
expectations, it may be appropriate to allow this in-band information
to be visible to the user, at least in some display modes.  Further,
it may be appropriate to allow the user to edit the information
directly.  On the other hand, the best choice might be to hide this
information from the user and allow only indirect manipulation.</p>

<p>Note that programs should be able to parse in-band information in
either direction (<i>i.e.</i>, both when working forwards through the
buffer and when working backwards).  It is also important in this
representation that it be reasonably easy to determine how to display
a file when starting from an arbitrary point in the middle of the
file.  In particular, the program shouldn't have to examine the entire
previous contents of the file in order to figure out how to display
something.</p>

<a name="c5.4.2"></a><h3>5.4.2 Out-of-Band</h3>

<p>Storing information <i>out-of-band</i> means that none of the
character codes are used for any special purpose.  Rather, the
additional information is stored somewhere else and is tied back to
the text by means of pointers and offsets.</p>

<p>The disadvantage of choosing the out-of-band method is that you
must find some place to put the information.  While a file is being
edited, the information can (and probably should) be stored in special
purpose structures within the editor.  However, when the file is
stored, the additional information must be put somewhere.  This place
can be a separate file or a separate part of the same file (either a
different file &quot;fork,&quot; or at the file's beginning or
end).</p>

<a name="c5.4.3"></a><h3>5.4.3 Conclusion</h3>

<p>There may be enough additional information that manipulating it can
itself require significant overhead.  The techniques described in the
next chapter can apply to the additional information as to the text
itself.</p>

<p>There is no preferred choice: both in-band and out-of-band have
their good points and their bad.  The choice must be made on a
case-by-case basis.</p>

<p>Actually, they are almost two ends of a continuous scale.  The
difference between them could also be considered like this:</p>

<ul>
<li><i>in-band</i> data is parsed at each use
<li><i>out-of-band</i> data is parsed at file load
</ul>

<a name="c5.5"></a><h2>5.5 The Additional Information</h2>

<p>This section describes some of the categories of additional
information that you may wish to store in files.  These categories are
illustrative examples only: you will probably want to store other
types of information or the same types in different ways.</p>

<a name="c5.5.1"></a><h3>5.5.1 Fonts, Sizes, Attributes</h3>

<p>A <i>font</i> describes the shapes of the characters.  <i>Size</i>
information describes how large a character should be.
<i>Attributes</i> are variations on a font such as boldface, italics,
or underscoring. Together, these are used in word processors to
provide character formatting.</p>

<p>These three share common qualities such as the ability to change at
a character boundary, and the ability to change one without changing
the others.  The representation that you select needs to take these
qualities into account.</p>

<a name="c5.5.2"></a><h3>5.5.2 Line, Paragraph, Page, and Other Formats</h3>

<p>This information determines such things as line margins,
justification types, tab stops, page headings and footings, page
length, and so forth.  This information has a major effect on the
redisplay code described in Chapter 7.</p>

<a name="c5.5.3"></a><h3>5.5.3 Non-Text Objects</h3>

<p>These can be arbitrary non-text objects such as graphical bitmaps
or object, spread sheets, database excerpts, or other information used
by non-editor applications.  The editor needs to know such things
as:</p>

<ul>
<li>how to display them
<li>how much space they occupy
<li>how to invoke the application that defines them
<li>how to obtain current or updated versions of them
</ul>

<a name="c5.6"></a><h2>5.6 Internationalization</h2>

<p>This section lists some of the U.S. and English language biases
that might be encountered in text files.  Techniques for removing
these biases from the program are outside the scope of this book.  By
their nature, these biases are hard to sort out: my apologies if I
have missed some.</p>

<p>Except for this section, this book contains U.S. and English
language biases.  However, the programming and design techniques
described in the rest of this book are applied in pretty much the same
way in non-U.S. and non-English language editors.</p>

<p>The first bias is the character set used to represent information.
There are many different international character sets and, while they
tend to incorporate the U.S. ASCII character set (presented in
Appendix E) in them, they all differ in the other characters.</p>

<p>The second bias is the character size (<i>i.e.</i>, the number of
bits required to represent the number of distinct characters that can
be stored in the document).  If you are limiting your users to ASCII,
7-bit characters are sufficient.  However, international character
sets may require 8, 16, or even 32 bits per character.  In the case of
the larger character sizes, it may make sense to store most characters
as 8-bit codes and to have multiple-byte characters for the others.
So long as your implementation handles them consistently and can
interchange data with the other programs on your system, the exact
representation does not matter.</p>

<p>The third bias is the language direction.  English uses
left-to-right, then top-to-bottom.  Other languages use different
patterns.  You must also properly handle cases where you mix languages
(say, English and Arabic).</p>

<p>The fourth bias is the general conventions for handling such things
as character case (some languages do not have English's
upper/lowercase distinction), characters changing representation
depending upon their position within a word (contextual forms), and so
forth.</p>

<p>The fifth bias is in handling numbers.  For example, in the U.S.,
numbers are written as &quot;1,000.5&quot;.  In Europe, they are
written as &quot;1.000,5&quot;.  In addition, languages differ in the
order that digits are entered (left to right vs. right to left) and
the placement of the most significant digit.</p>

<p>The sixth bias is in handling dates: day - month - year, month -
day - year, and year - month - day are all popular, as are differing
punctuation characters between them.</p>

<p>The seventh bias is in handling calendars.  Gregorian and Julian
are both in use and quite similar, but there are lunar and other
calendars also in use.</p>

<p>The eigth bias is how punctuation characters are handled.  For
example, in Spanish, questions are introduced with an inverted
&quot;?&quot; character and terminated with &quot;?&quot;.</p>

<p>The last bias is how hyphenation is handled.  In English, it is
often difficult or impossible to determine how a word should be
hyphenated.  In Portuguese, for example, it is very easy to determine
how to hyphenate a word and is considered mandatory to handle
hyphenation properly.</p>

<a name="c5.q"></a><h2>Questions to Probe Your Understanding</h2>

<p>How visible should the representation of line boundaries in
standard system-text files be to the user? (Easy)</p>

<p>Why is the ability to edit binary files useful? (Easy)</p>

<p>Is it reasonable to require that font, size, and attribute
definitions always be properly nested? (Medium: note that the program
can automatically make non-nested change requests into nested
ones)</p>

<p>Define a representation for fonts, sizes, and attributes.
(Medium)</p>

<p>Define a <i>good</i> representation for fonts, sizes, and
attributes.  (Hard)</p>

<p>Identify a bias that I missed. (Easy for non-U.S. readers, probably
Hard for U.S. readers)</p>

<p><a href="#contents">Back to Contents</a>.</p>
<hr>
<a name="c6"></a><h1>Six: The Internal Sub-Editor</h1>

<blockquote><i>
Came whiffling through the tulgey wood,<br>
&nbsp;&nbsp;And burbled as it came!
</i></blockquote>

<p>There are many ways to decompose the implementation of a text
editor into smaller pieces.  This book analyzes one particular
decomposition: that into a sub-editor to manage the text being edited,
redisplay, and the user-oriented commands.  (There are no other
pieces: when these have been assembled, the editor is complete.)  This
particular decomposition was chosen for two reasons.  First, it is a
natural one with relatively simple interfaces between the parts.
Second, it has been chosen for many different implementations: it is
thus known to be a decomposition that works well.  This chapter covers
the internal sub-editor.  The following chapters describe the other
parts.</p>

<p>The purpose of the internal sub-editor is to hide all of the
details of how the text is stored from the redisplay and the
user-oriented commands.  This chapter will begin by presenting some
basic concePpts and definitions.  It will then list internal data needs
and describe a procedural interface.  Finally, it will present a
number of ways to implement the actual sub-editor and discuss the
trade-offs between them.</p>

<a name="c6.1"></a><h2>6.1 Basic Concepts and Definitions</h2>

<p>A <i>buffer</i> is the basic unit of text being edited.  It can be
any size, from zero characters to the largest item that can be
manipulated on the computer system.  This limit on size is usually set
by such factors as address space, amount of real and/or virtual
memory, and mass storage capacity.  A buffer can exist by itself, or
it can be associated with at most one file.  When associated with a
file, the buffer is a copy of the contents of the file at a specific
time.  A file, on the other hand, can be associated with any number of
buffers, each one being a copy of that file's contents at the same or
at different times.</p>

<p>A <i>write</i> operation replaces the contents of a file with the
contents of a buffer.  Thus, the two have identical contents for at
least one moment.  A <i>read</i> operation replaces the buffer with
the contents of a file.  Again, the two have identical contents for at
least one moment.  An <i>insert</i> operation adds the contents of the
file to the buffer: the two will not have identical contents unless
the buffer was empty just before the insertion.</p>

<p>The buffer interface presented here follows the
&quot;one-dimensional array of characters&quot; model as described in
Chapter 5.  As will be seen, however, the implementation need not
follow that model.  When stored as text in the buffer, line breaks
will be represented by a single character, called <i>newline</i>.</p>

<p>At any one time there is one and only one special position within
the buffer.  This position is called the <i>point</i>.  All operations
that change the contents of the buffer occur at this position.  There
are also operations whose sole purpose is to move the point.  The
point can exist only <i>between</i> two characters: it is never on a
character.  On those displays that can only position a cursor on a
character, the convention is to place the point at the left edge of
the cursor.</p>

<p>The start of the buffer (which corresponds to the first location in
the file) is considered <i>before</i> or <i>backward from</i> the
point.  The end of the buffer is considered to be <i>after</i> or
<i>forward from</i> the point.</p>

<p>From time to time, it is useful to be able to remember positions
within a buffer.  A <i>mark</i> is an object that can remember a
position.  There can be any number of marks within a buffer, and more
than one mark can remember the same position.  As with the point, a
mark is always located between two characters.</p>

<p>When there is exactly one mark, the range of characters between the
point and the mark is called the <i>region</i>.  It does not matter
which order the point and mark are in.</p>

<p>Here are two examples of how marks are used:</p>

<ul>
<li>A mark may remember a specific location for future reference.  For
example, a command might paginate a file.  In this case, a mark would
remember where the point was when the command was invoked.  Thus, the
point could be moved during the re-pagination and returned to its
initial starting place.

<li>A mark can serve as bounds for iteration.  For example, the
&quot;fill paragraph&quot; command might place a mark at its starting
place, move to the end of the paragraph and place a mark there, then
move to the beginning of the paragraph.  It then performs a &quot;fill
region&quot; operation, filling from the point to the location of the
second mark.
</ul>

<p>There are two types of marks.  They differ only in how they behave
in the case that an insertion is made at the location of the mark.
<i>Normal marks</i> move with the insertion.  Thus, the newly inserted
character will be just before the mark.  <i>Fixed marks</i> remain in
place: the newly inserted character will be just after the mark.  An
example of the difference is in the case where a command is to
identify the characters that are inserted.  The command merely needs
to create both a fixed and a normal mark at the same place.  After the
insertion, the two marks will bracket the new characters.</p>

<p>A <i>mode</i> is a set of alterations to the user-oriented command
set.  For example, &quot;C mode&quot; might alter the definitions of
the word-, sentence-, and paragraph-oriented commands to apply to
tokens, language statements, and block structure.  Modes are described
in more detail in Chapter 8.</p>

<p>Finally, the term <i>character</i> denotes the basic unit of change
within a buffer.  While characters can be any size, they are most
often eight bits long.  In such a case, the term <i>byte</i> may be
used interchangeably with <i>character</i>.</p>

<a name="c6.2"></a><h2>6.2 Internal Data Structures</h2>

<p>This section discusses the sub-editor's data structures.  All of
the sub-editor's state information is defined in this chapter. Thus,
if your implementation retains this information across invocations,
you can offer the user the ability to resume editing where he or she
left off, thus reducing the amount of work required to edit a
file.</p>

<p>The other place where state information is kept is in the screen
manager which is described in the following chapter.  The screen
manager is that part of the software which knows what was displayed on
the user's screen.  If that knowledge is not retained across
invocations, the information displayed on the user's screen may change
when the user exits and re-enters the editor.  If that knowledge is
retained, the information can be recreated exactly.</p>

<p>All of the specifics of the data structures listed here are
examples only.  You will undoubtedly wish to change some or all of
them.</p>

<p>The <i>world</i> contains all of the buffers in use by the editor.
It is a circular list of buffer descriptors and a variable that
indicates which is the current buffer.  In C syntax:</p>

<pre>
	struct {
		struct buffer *buffer_chain;
		struct buffer *current_buffer;
		} world;
</pre>

<p>Each buffer descriptor has this internal information:</p>

<pre>
	struct buffer {
		struct buffer *next_chain_entry;
		char buffer_name[BUFFERNAMEMAX];

		location point;
		int cur_line;
		int num_chars;
		int num_lines;

		struct mark *mark_list;

		struct storage *contents;

		char file_name[FILENAMEMAX];
		time file_time;
		FLAG is_modified;

		struct mode *mode_list;
		};
</pre>

<p><b>Next_chain_entry</b> is the mechanism used for implementing the
circular list of buffers.  The list is circular because there is no
preferred (or &quot;origin&quot;) buffer and it should be possible to
get to any buffer with equal ease.</p>

<p><b>Buffer_name</b> is a character string that allows the user to be
able to refer to the buffer.</p>

<p><b>Point</b> is the current location where editing operations are
taking place.  It is defined in terms of a private data type, since
different implementations will use different representations.  As it
turns out, there is never a need for any code outside of the
sub-editor to ever be aware of the representation of this data
type.</p>

<p><b>Cur_line</b> is optional.  If implemented, it provides a
high-speed way to track the current line number.</p>

<p><b>Num_chars</b> is optional.  If implemented, it provides a
high-speed way to track the total number of characters in the buffer
(its length).</p>

<p><b>Num_lines</b> is optional.  If implemented, it provides a
high-speed way to track the total number of lines in the buffer.</p>

<p><b>Mark_list</b> is the list of marks defined for this buffer.  The
mark structure is defined later.</p>

<p><b>Contents</b> indicates the actual buffer contents.  As with the
location data type, its specifics will vary with the
implementation.</p>

<p><b>File_name</b> is the name of the file associated with the
buffer, or the empty string if there is no associated file.</p>

<p><b>File_time</b> is the last time at which the contents of the file
and buffer were identical (<i>i.e.</i>, the time of the last read or
write).  On multi-process systems, this value can be used to determine
whether the contents of the file have been changed by another process,
and thus whether the copy being edited is in synchronization with the
actual file.</p>

<p><b>Is_modified</b> indicates whether the buffer has been modified
since it was last written out or read in.</p>

<p><b>Mode_list</b> is the list of modes in effect for the buffer. The
mode structure is defined next.</p>

<pre>
	struct mark {
		struct mark *next_mark;
		mark_name name;
		location where_it_is;
		FLAG is_fixed;
		};
</pre>

<p>This structure is a linked list and is repeated for every mark. The
chain is not circular.  It probably is a good idea to keep the list
sorted in the order that the marks appear in the buffer.</p>

<p><b>Next_mark</b> is a pointer to the next mark in the chain.  A
NULL pointer indicates the end of the chain.</p>

<p><b>Name</b> is the name of the mark.  This name is returned by the
mark creation routine and provides a way for the user to refer to
specific marks.  If your implementation permits, you can just return a
pointer to the mark structure instead of making up names.</p>

<p><b>Where_it_is</b> is the mark's location.</p>

<p><b>Is_fixed</b> indicates whether the mark is a fixed mark.</p>

<pre>
	struct mode {
		struct mode *next_mode;
		char *mode_name;
		status (*add_proc)();
		};
</pre>

<p>This structure is a linked list and is repeated for every mode that
is in effect for the current buffer. The chain is not circular.  While
modes should be defined in such a way that it does not matter what
order they are invoked in, it is probably not possible to meet this
requirement in actual practice.  Thus, this list must be kept sorted
in invocation order.  Modes are discussed in more detail in Chapter
8.</p>

<p><b>Next_mode</b> is a pointer to the next mode in the chain.  A
NULL pointer indicates the end of the chain.</p>

<p><b>Mode_name</b>, if non-NULL, is the name added to the list of
names of modes in effect.  This list is ordinarily displayed somewhere
on the screen.  Note that there should be a mechanism for defining
modes that do not have displayed names.</p>

<p><b>Add_proc</b> is a pointer to a procedure to execute whenever the
command set for this buffer needs to be created or re-created.  The
procedure should make all required modifications to the global command
tables and return a success/fail status.</p>

<a name="c6.3"></a><h2>6.3 Procedure Interface Definitions</h2>

<p>This section defines the interface provided by the sub-editor.  The
procedures will be described in terms of their logical function only,
leaving out specific implementation details.  An example of such a
detail is a method of determining whether the operation succeeded.
(The undefined type &quot;status&quot; will be used to indicate places
where status information is especially desirable.)  All data types
mentioned (<i>e.g.</i>, string) are intended to be generic, and no
specific implementations are assumed.</p>

<p>One question that is important to your implementation but not
addressed in this definition is whether the caller or callee allocates
the data structures.  This chapter will assume that the callee
allocates all data.</p>

<p>The names are selected for their mnemonic value.  Actual
implementations may be forced to change them to conform to local
limits.  In addition, you may wish to add a unique prefix (such as
&quot;Buf&quot; or &quot;SE&quot;) to them all to prevent name
conflicts.</p>

<pre>
	status World_Init(void);
	status World_Fini(void);
	status World_Save(char *file_name);
	status World_Load(char *file_name);
</pre>

<p><b>World_Init</b> is the basic set-up-housekeeping call.  It is
called once, upon editor invocation.  It should perform all required
one-time initialization operations.  No other sub-editor procedure
except for <b>World_Fini</b> can be legally called unless
<b>World_Init</b> returns a successful status.  After this call, one
empty buffer exists (perhaps called &quot;scratch&quot; or something
similar).</p>

<p><b>World_Fini</b> terminates all sub-editor state information.
Once called, <b>World_Init</b> must be called again before other
sub-editor calls can be legally made.</p>

<p><b>World_Save</b> saves all editor state information in the
specified file.</p>

<p><b>World_Load</b> loads all editor state information from the
specified file.  These two routines implement state-saving across
editor invocations.  The possibility of retaining multiple saved
environments is interesting but, while it has been implemented, is not
a feature that receives much use.  It is perhaps too difficult for
users to keep track of multiple editing environments or users may
prefer to be able to switch among tasks without having to perform a
save and load.</p>

<p>If you are creating a &quot;stripped down&quot; editor, the
<b>World_Save</b> and <b>World_Load</b> routines would not do
anything.  They can be put in as stubs if there is a reasonable
possibility that the editor will be embellished later.</p>

<pre>
	status Buffer_Create(char *buffer_name);
	status Buffer_Clear(char *buffer_name);
	status Buffer_Delete(char *buffer_name);
	status Buffer_Set_Current(char *buffer_name)
	char *Buffer_Set_Next(void);
	status Buffer_Set_Name(char *buffer_name);
	char *Buffer_Get_Name(void);
</pre>

<p>These routines all manipulate buffer objects.  Their definitions
assume that character string names are used to specify buffer objects.
As with marks, pointers to buffer structures can also be used if your
implementation permits.</p>

<p>As with many other questions, it is an implementation choice as to
whether the sub-editor retains a &quot;current buffer&quot; or whether
a buffer is explicitly provided to all remaining sub-editor calls.
This definition chooses the former; as buffer changes are performed
only (comparatively) rarely, and hence it is probably helpful to the
sub-editor to be able to cache the information relating to the current
buffer.</p>

<p>Note that most of these calls are not useful for single buffer
implementations as might be found in very resource-limited
environments (<i>e.g.</i>, a toaster).  Such implementations should
only include the calls if there is a reasonable chance of expanding to
a multiple buffer editor in the future.</p>

<p><b>Buffer_Create</b> takes a name and creates an empty buffer with
that name.  Note that no two buffers may have the same name.</p>

<p><b>Buffer_Clear</b> removes all characters and marks from the
specified buffer.</p>

<p><b>Buffer_Delete</b> deletes the specified buffer.  If the
specified buffer is the current one, the next buffer in the chain
becomes the current one.  If no buffers are left, the initial
&quot;scratch&quot; buffer is automatically re-created.</p>

<p><b>Buffer_Set_Current</b> sets the current buffer to the one
specified.</p>

<p><b>Buffer_Set_Next</b> sets the current buffer to the next one in
the chain, and it returns the name of the new buffer.  This mechanism
allows for iterating through all buffers looking for one which meets
an arbitrary test.</p>

<p><b>Buffer_Set_Name</b> changes the name of the current buffer to
that specified.</p>

<p><b>Buffer_Get_Name</b> returns the name of the current buffer.</p>

<pre>
	status Point_Set(location loc);
	status Point_Move(int count);
	location Point_Get(void);
	int Point_Get_Line(void);
	location Buffer_Start(void);
	location Buffer_End(void);
</pre>

<p><b>Point_Set</b> sets the point to the specified location.</p>

<p><b>Point_Move</b> moves the point forward (if <i>count</i> is
positive) or backward (if negative) by <i>abs(count)</i>
characters.</p>

<p><b>Point_Get</b> returns the current location.</p>

<p><b>Point_Get_Line</b> returns the number of the line that the point
is on.  Note that while characters are numbered starting from zero,
lines are numbered starting from one.</p>

<p><b>Buffer_Start</b> returns the location of the start of the
buffer.</p>

<p><b>Buffer_End</b> returns the location of the end of the
buffer.</p>

<pre>
	int Compare_Locations(location loc1, location loc2);
	int Location_To_Count(location loc);
	location Count_To_Location(int count);
</pre>

<p>These are miscellaneous utility routines.</p>

<p><b>Compare_Location</b> returns 1 if location <i>loc1</i> is after
<i>loc2</i>, 0 if they are the same location, or -1 if <i>loc1</i> is
before <i>loc2</i>.</p>

<p><b>Location_To_Count</b> accepts a location and returns the number
of characters between the location and the beginning of the buffer.
The point's percentage position can be computed by:</p>

<pre>
	((float)Location_To_Count(Point_Get()) * 100.) / ((float)Get_Num_Chars())
</pre>

<p><b>Count_To_Location</b> accepts a non-negative count and converts
it to the corresponding location.  You can set the point to a position
specified by an absolute character count by:</p>

<pre>
	Point_Set(Count_To_Location(count));
</pre>

<pre>
	status Mark_Create(mark_name *name, FLAG is_fixed);
	void Mark_Delete(mark_name name);
	status Mark_To_Point(mark_name name);
	status Point_To_Mark(mark_name name);
	location Mark_Get(mark_name name);
	status Mark_Set(mark_name name, location loc);
	FLAG Is_Point_At_Mark(mark_name name);
	FLAG Is_Point_Before_Mark(mark_name name);
	FLAG Is_Point_After_Mark(mark_name name);
	status Swap_Point_And_Mark(mark_name name);
</pre>

<p>These routines manage marks.  They allow for creating both normal
and fixed marks, deleting marks, and otherwise manipulating them.
Except when creating them, there is no difference in usage with these
routines between normal marks and fixed marks (although their behavior
will differ).</p>

<p><b>Mark_Create</b> creates a new mark of the specified type and
returns its name.  The new mark is positioned at the point.</p>

<p><b>Mark_Delete</b> deletes the specified mark.</p>

<p><b>Mark_To_Point</b> sets the location of the specified mark to the
point.</p>

<p><b>Point_To_Mark</b> sets the point to the location of the
specified mark.</p>

<p><b>Mark_Get</b> returns the location for the mark.  This is not
actually used all that much, as the location value can change whenever
any sub-editor call is made.</p>

<p><b>Mark_Set</b> moves the specified mark to the specified
location.</p>

<p><b>Is_Point_At_Mark</b> returns True if the point is at the
specified mark.</p>

<p><b>Is_Point_Before_Mark</b> returns True if the point is before the
specified mark.</p>

<p><b>Is_Point_After_Mark</b> returns True if the point is after the
specified mark.</p>

<p><b>Swap_Point_And_Mark</b> swaps the locations of the point and the
specified mark.</p>

<p>With these definitions, the basic way of doing something over a
region would be like this:</p>

<pre>
	status Do_Something_Over_Region(mark_name name)
		{
		FLAG was_before = Is_Point_Before_Mark(name);
		mark_name saved;
		status stat = OK;

			/* ensure that the point is before the mark */
		if (!was_before) Swap_Point_And_Mark(name);

			/* remember where we started */
		if (Mark_Create(&amp;saved) != OK) {
			if (!was_before) Swap_Point_And_Mark(name);
			return(NOT_OK);
			}

			/* loop until you get to the mark */
		for ( ; !Is_Point_At_Mark(name); Point_Move(1)) {
			if (&lt;do something&gt; != OK) {
				stat = NOT_OK;
				break;
				}
			}

			/* all done, put the point back */
		Point_To_Mark(saved);
		Mark_Delete(saved);
			/* put the point and mark back where they started */
		if (!was_before) Swap_Point_And_Mark(name);
		return(stat);
		}
</pre>

<p>The way that this procedure records the initial positions of the
point and mark (a flag and a saved mark) is a little confusing.
Unfortunately, it is less confusing than the alternative of creating
two saved marks.</p>

<pre>
	char Get_Char(void);
	void Get_String(char *string, int count);
	int Get_Num_Chars(void);
	int Get_Num_Lines(void);
</pre>

<p>These routines return buffer-related information.</p>

<p><b>Get_Char</b> returns the character after the point.  Its results
are undefined if the point is at the end of the buffer.</p>

<p><b>Get_String</b> returns up to <i>count</i> characters starting
from the point.  It will return fewer than <i>count</i> characters if
the end of the buffer is encountered.</p>

<p><b>Get_Num_Chars</b> returns the number of characters in the buffer
(<i>i.e.</i>, the length of the buffer).</p>

<p><b>Get_Num_Lines</b> returns the number of lines in the buffer. It
is undefined whether or not one counts an incomplete last line.</p>

<pre>
	void Get_File_Name(char *file_name, int size);
	status Set_File_Name(char *file_name);
	status Buffer_Write(void);
	status Buffer_Read(void);
	status Buffer_Insert(char *file_name);
	FLAG Is_File_Changed(void);
	void Set_Modified(FLAG is_modified);
	FLAG Get_Modified(void);
</pre>

<p>These routines provide file-related operations.</p>

<p><b>Get_File_Name</b> returns the file name that is currently
associated with the current buffer.  <i>Size</i> is the size of the
buffer allocated for the returned file name.</p>

<p><b>Set_File_Name</b> sets the file name for the current buffer.</p>

<p><b>Buffer_Write</b> writes the buffer to the currently named file,
making any required conversions between the internal and external
representations.  The modified flag is cleared and the file time is
updated to the current time.</p>

<p><b>Buffer_Read</b> clears the buffer and reads the currently named
file into the buffer, making any required conversions between the
external and internal representations.  The modified flag is cleared
and the file time is updated to the current time.</p>

<p><b>Buffer_Insert</b> inserts the contents of the specified file
into the buffer at the point, making any required conversions between
the external and internal representations.  The modified flag is set
if the file was not empty.</p>

<p><b>Is_File_Changed</b> returns True if the file has been changed
since it was last read or written.</p>

<p><b>Set_Modified</b> sets the state of the modified flag to the
supplied value.  It is most often used manually to clear the
modification flag in the case where the user is sure that any changes
should be discarded.  This flag is set by any insertion, deletion, or
other change to the buffer.</p>

<p><b>Get_Modified</b> returns the modification flag.</p>

<pre>
	status Mode_Append(char *mode_name, status (*add_proc)(), FLAG is_front);
	status Mode_Delete(char *mode_name);
	status Mode_Invoke(void);
</pre>

<p>These routines manage the multiple mode capability.</p>

<p><b>Mode_Append</b> appends a mode with the supplied name and add
procedure to the mode list.  If <i>is_front</i> is True, the new mode
is added to the front of the mode list.  Otherwise, it is added at the
end.</p>

<p><b>Mode_Delete</b> removes the named mode from the mode list.</p>

<p><b>Mode_Invoke</b> invokes the &quot;add&quot; procedures on the
mode list to create a command set.</p>

<pre>
	void Insert_Char(char c);
	void Insert_String(char *string);
	void Replace_Char(char c);
	void Replace_String(char *string);
	status Delete(int count);
	status Delete_Region(mark_name name);
	status Copy_Region(char *buffer_name, mark_name name);
</pre>

<p>These routines manipulate the buffer.  All of them set the
modification flag.</p>

<p><b>Insert_Char</b> inserts one character at the point.  The point
is placed after the inserted character.</p>

<p><b>Insert_String</b> inserts a string of characters at the point.
The point is placed after the string.</p>

<p><b>Replace_Char</b> replaces one character with another.  This
routine is logically equivalent to:</p>

<pre>
	Insert_Char(c);
	Delete(1);
</pre>

<p>but is potentially more efficient.  If the point is at the end of
the buffer, the routine simply does an insert.</p>

<p><b>Replace_String</b> replaces a string as if <b>Replace_Char</b>
is called on each of its characters.</p>

<p><b>Delete</b> removes the specified number of characters from the
buffer.  The specified number of characters are removed after the
point if <i>count</i> is positive or before the point if <i>count</i>
negative.  If the specified count extends beyond the start or end of
the buffer, the excess is ignored.</p>

<p><b>Delete_Region</b> removes all characters between the point and
the mark.</p>

<p><b>Copy_Region</b> copies all characters between the point and the
mark to the specified buffer, inserting them at the point.  The basic
Emacs Wipe Region command is actually implemented as:</p>

<pre>
	Copy_Region(kill_buffer, mark);
	Delete_Region(mark);
</pre>

<p>This example also shows that even though an implementation presents
only a single buffer to the user, a multiple buffer implementation may
actually be required.</p>

<pre>
	status Search_Forward(char *string);
	status Search_Backward(char *string);
	FLAG Is_A_Match(char *string);
	status Find_First_In_Forward(char *string);
	status Find_First_In_Backward(char *string);
	status Find_First_Not_In_Forward(char *string);
	status Find_First_Not_In_Backward(char *string);
</pre>

<p>These routines handle searching and matching strings.  While it is
possible to implement these routines in terms of routines that have
already been defined, because of their repetitive nature, it helps
performance if they are built into the sub-editor.  (Actually, the
same can be said of several of the other routines that have been
defined such as <b>Insert_String</b>.)</p>

<p><b>Search_Forward</b> searches forward for the first occurance of
<i>string</i> after the point and, if found, leaves the point at the
end of the found string.  Successive searches will thus locate
successive instances of the string.  If not found, the point is not
moved.  Types of searches are discussed in Chapter 9.</p>

<p><b>Search_Backward</b> works like <b>Search_Forward</b>, except
that the search proceeds backward and the point is placed at the start
of the found string (<i>i.e.</i>, the end closest to the start of the
buffer).</p>

<p><b>Is_A_Match</b> returns True if the string matches the contents
of the buffer starting at the point.  In other words, it returns True
if <b>Search_Forward</b> would move the point <i>strlen(string)</i>
characters forward.</p>

<p><b>Find_First_In_Forward</b> searches the buffer starting from the
point for the first occurence of any character in the supplied string.
Thus, <i>Find_First_In_Forward(&quot;0123456789&quot;)</i> would leave
the point before the first digit found after the point.  Unlike the
<b>Search_*</b> routines, this routine leaves the point at the end of
the buffer if no characters in the string are found.  A typical use of
the <b>Find_*</b> routines is this sequence, which skips over the
first number after the point:</p>

<pre>
	Find_First_In_Forward(&quot;0123456789&quot;);
	Find_First_Not_In_Forward(&quot;0123456789&quot;);
</pre>

<p><b>Find_First_In_Backward</b> works in the obvious way.</p>

<p><b>Find_First_Not_In_Forward</b> searches for the first occurence
of any character <i>not</i> in the supplied string.  Thus,</p>

<p><i>Find_First_Not_In_Forward(&quot;0123456789&quot;)</i> would
leave the point before the first non-digit found after the point.
Unlike the <b>Search_*</b> routines, this routine leaves the point at
the end of the buffer if no characters in the string are found.</p>

<p><b>Find_First_Not_In_Backward</b> works in the obvious way.</p>

<p>Here are some examples of using the <b>Find_*</b> routines:</p>

<p>To move to the start of the next line:</p>

<pre>
	Find_First_In_Forward(NEWLINE);
</pre>

<p>To move to the start of the next word:</p>

<pre>
	Find_First_In_Forward(word_chars);
	Find_First_Not_In_Forward(word_chars);
</pre>

<pre>
	int Get_Column(void);
	void Set_Column(int column, FLAG round);
</pre>

<p><b>Get_Column</b> returns the zero-origin column that the point is
in, after taking into account tab stops, variable-width characters,
and other special cases, but <i>not</i> taking into account the screen
width.  (After all, the width of the display that the user happens to
be using should not affect the actions of an editing command.)</p>

<p><b>Set_Column</b> moves the point to the desired column, stopping
at the end of a line if the line is not long enough.  If the specified
column cannot be reached exactly (due to tab stops or other special
cases), it uses the <i>round</i> flag.  If the flag is set, the point
is &quot;rounded&quot; to the nearest available column position.  If
the flag is clear, the point is moved to the next highest available
column position.</p>

<a name="c6.4"></a><h2>6.4 Characteristics of Implementation Methods</h2>

<p>This section describes how implementation methods may be
characterized, and then describes three of those methods in detail.
All of those methods are assumed to store the buffers in the
equivalent of main memory.  Depending upon the physical
characteristics of the computer, &quot;main memory&quot; can be actual
memory, in virtual memory, or readily mappable into virtual memory.  A
later section describes methods for dealing with files that do not fit
into main memory.</p>

<p>The implementation methods discussed here use two-level
&quot;divide and conquer&quot; strategies.  The first level divides
the buffer into pieces.  The size ranges for each piece are:</p>

<ul>
<li>one character
<li>a small number of characters (<i>e.g.</i>, 16 to 64)
<li>a line
<li>a large number of characters (<i>e.g.</i>, 512 to 4,096)
<li>the entire buffer
</ul>

<p>The pieces can be kept in an array, a linked list, or some other
structure. The second level describes how the pieces are managed:</p>

<ul>
<li>no management
<li>extra space at the end
<li>buffer gap
</ul>

<p>Each of these second-level techniques will be described in
detail.</p>

<a name="c6.4.1"></a><h3>6.4.1 No Management</h3>

<p>In this technique, the piece is allocated exactly enough memory to
hold it.  The length of the piece is the only &quot;overhead&quot;
information.  A deletion is done by allocating a new piece of the
desired (smaller) size, then copying the non-deleted portions from the
old piece to the new one.  An insertion is done by allocating a new
piece of the desired (larger) size, then copying the old piece to the
new one, inserting the new characters on the way.  In code:</p>

<pre>
	struct piece {
		int length;
		char data[1];	/* length characters */
		}

		/* delete LEN characters starting from START */
	struct piece *Delete_From_Piece(struct piece *pptr, int start, int len)
		{
		struct piece *newptr;
		int newlen = pptr-&gt;length - len;

			/* allocate new piece */
		newptr = (struct piece *)malloc(sizeof(struct piece) +
			newlen - 1);
		if (newptr == NULL) return(NULL);

			/* copy non-deleted parts */
		memmove(&amp;newptr-&gt;data[0], &amp;pptr-&gt;data[0], start);

		memmove(&amp;newptr-&gt;data[start],
			&amp;pptr-&gt;data[start + len],
			pptr-&gt;length - (start + len));

		newptr-&gt;length = newlen;

		free(pptr);
		return(newptr);
		}

		/* insert LEN characters starting at START */
	struct piece *Insert_Into_Piece(struct piece *pptr, int start,
			int len, char *chrs)
		{
		struct piece *newptr;
		int newlen = pptr-&gt;length + len;

			/* allocate new piece */
		newptr = (struct piece *)malloc(sizeof(struct piece) +
			newlen - 1);
		if (newptr == NULL) return(NULL);

			/* copy existing parts */
		memmove(&amp;newptr-&gt;data[0], &amp;pptr-&gt;data[0], start);
		memmove(&amp;newptr-&gt;data[start + len], &amp;pptr-&gt;data[start],
			pptr-&gt;length - start);
		newptr-&gt;length = newlen;

			/* copy new part */
		memmove(&amp;newptr-&gt;data[start], chrs, len);

		free(pptr);
		return(newptr);
		}
</pre>

<a name="c6.4.2"></a><h3>6.4.2 Extra Space at the End</h3>

<p>In this technique, the piece is allocated enough memory to contain
it, and possibly additional memory as well.  The length of the piece
and the amount of the piece currently in use are kept as overhead
information. A deletion never requires a re-allocation.  An insertion
will require a re-allocation only when the free space is used up.  As
the bulk of insertions are one character at a time (<i>i.e.</i>, as
the user types), insertions will only require a re-allocation at
relatively infrequent intervals.  In code:</p>

<pre>
	struct piece {
		int length;
		int used;
		char data[1];	/* length characters */
		}

		/* delete LEN characters starting from START */
	struct piece *Delete_From_Piece(struct piece *pptr, int start, int len)
		{
		memmove(&amp;pptr-&gt;data[start], &amp;pptr-&gt;data[start + len],
			pptr-&gt;used - (start + len));
		pptr-&gt;used -= len;
		return(pptr);
		}

		/* insert LEN characters starting at START */
	struct piece *Insert_Into_Piece(struct piece *pptr, int start,
			int len, char *chrs)
		{
		struct piece *newptr;
		int newlen;
		int amt = min(pptr-&gt;length - pptr-&gt;used, len);

			/* do as much as will fit */
		memmove(&amp;pptr-&gt;data[start + amt], &amp;pptr-&gt;data[start],
			pptr-&gt;used - (start + amt));
		memmove(&amp;pptr-&gt;data[start], chrs, amt);
		pptr-&gt;used += amt;
		len -= amt;
		if (len &lt;= 0) return(pptr);	/* done */

		start += amt
		chrs += amt;
		newlen = Round_Up_To_Block_Size(pptr-&gt;length + len);

			/* allocate new piece */
		newptr = (struct piece *)malloc(sizeof(struct piece) +
			newlen - 1);
		if (newptr == NULL) return(NULL);

			/* construct new contents */
		memmove(&amp;newptr-&gt;data[0], pptr-&gt;data[0], start);
		memmove(&amp;newptr-&gt;data[start], chrs, len);
		memmove(&amp;newptr-&gt;data[start + len],
			pptr-&gt;data[start],
			pptr-&gt;length - start);

		newptr-&gt;length = newlen;
		newptr-&gt;used = pptr-&gt;used + len;

		free(pptr);
		return(newptr);
		}
</pre>

<p>When this version of the delete routine is compared to the &quot;no
management&quot; version, it is simpler and will run faster.  The
insert routine is more complex, but most of the complexity will be
executed only rarely.  The path most often followed is again simpler
and faster than before.</p>

<p>This technique has an additional benefit.  In the &quot;no
management&quot; version, memory is allocated in character-size units
ranging from one character to the entire piece.  In the &quot;extra
space&quot; technique, memory is allocated in (typically) sixteen byte
chunks.  Typical allocation units will range from eight bytes to the
piece-size limit (if any), in steps of sixteen bytes.  (Actually, you
probably never want to allocate a piece that is not a multiple of
sixteen bytes).  In any event, the dynamic range of the size of
allocated units will be much smaller than in the &quot;no
management&quot; technique.  Thus, memory management will consume less
overhead, and less memory will be lost to allocation
fragmentation.</p>

<a name="c6.4.3"></a><h3>6.4.3 Buffer Gap</h3>

<p>The buffer gap technique system stores the text as two contiguous
sequences of characters with a (possibly null) gap between them.
Changes are made to the buffer by first moving the gap to the location
to be changed and then inserting or deleting characters by changing
pointers.  It thus uses memory efficiently, as the gap can be kept
small and so a very high percentage of memory can be devoted to
actually storing text.  The overhead information includes the length
of the piece, the location of the start of the gap, and the location
of the end of the gap.</p>

<p>Here is an example buffer which contains the word
&quot;Minneapolis&quot;.</p>

<pre>
0   1   2   3   4   5   6   7   8                       9  10  11
| M | i | n | n | e | a | p | o |   |   |   |   |   | l | i | s |
-----------------------------------------------------------------
0   1   2   3   4   5   6   7   8   9  10  11  12  13  14  15  16
 30  31  32  33  34  35  36  37  38  39  40  41  42  43  44  45
                P              GS                  GE
</pre>

<p>In this example, the buffer is 11 characters long and it contains
no spaces.  The blanks between the &quot;o&quot; and the &quot;l&quot;
show where the gap is and do not indicate that the memory has spaces
stored in it.  The point is between the &quot;n&quot; and the
&quot;e&quot; at location 4 and is labeled with a &quot;P&quot; in the
bottom line (legal values for the point are the numbers from zero to
the length of the buffer, 11 in this case). There are also three
different sets of numbers (coordinate systems) for referring to the
contents of the buffer.</p>

<p>First is the user coordinate system.  It is displayed above the
buffer.  The values for it run from 0 to the length of the buffer
(11).  As you will note, the gap is &quot;invisible&quot; in this
system. The coordinates label the positions between the characters and
not the characters themselves.  Thought of in this way, the arithmetic
is easy.  Thought of as labeling the characters, the arithmetic
becomes fraught with special cases and ripe for fencepost errors.</p>

<p>Second is the gap coordinate system.  It is displayed immediately
under the line.  The values for it run from 0 to the amount of storage
that is available and it, too, labels the positions between the
characters.  The internal arithmetic of the buffer manager is done in
this coordinate system.  The start of the gap (labeled &quot;GS&quot;
in the bottom line) is at position 8 and the end of the gap (labeled
&quot;GE&quot;) is at position 13.</p>

<p>Conversion from the user coordinate system to the gap coordinate
system is quite easy.  If a location (in the user coordinate system)
is before the start of the gap, the values are the same. If a location
is after the start of the gap (<i>not</i> the end of the gap!), its
corresponding location in the gap coordinate system is (GapEnd -
GapStart) + the location in the user coordinate system.  It is a good
idea to isolate this calculation either in a macro or a subroutine in
order to enhance readability.  Most routines (<i>e.g.</i>, the search
routines) will then use the user coordinate system even though those
routines are essentially internal.</p>

<p>The third coordinate system is the storage coordinate system.  It
is the bottom row of numbers in the diagram.  It is the means whereby
the underlying memory locations are referenced.  It is labeled from X
to X + the amount of memory that is available. The origin (the value
of X) was chosen here to be 30 to help distinguish between the various
coordinate systems.  Its absolute value makes no difference.  Note
that it labels the memory locations themselves and so caution must be
taken to avoid fencepost errors.</p>

<p>This technique has a very low overhead for examining the buffer.
The user coordinate location is first converted to the gap coordinate
system.  The memory location is then looked up and its contents
returned. Essentially, one comparison and a few additions are
required.  The purpose of the conversion is to make the gap invisible.
Note that the contents of the buffer are not moved.</p>

<p>However, there is further overhead associated with inserting or
deleting, since the gap may have to be moved so that it is at the
point.  There are three cases:</p>

<ul>
<li>The gap is at the point already.  No motion is necessary.

<li>The gap is before the point.  The gap must be moved to the
point. The characters after the gap but before the point must be moved
before the insertion or deletion can take place. The quantity
ConvertUserToGap(point) - GapEnd characters must be moved. This
quantity is numerically point - GapStart.

<li>The gap is after the point.  The gap must be moved to the
point. The characters after the point but before the gap must be moved
before the insertion or deletion can take place.  The quantity
GapStart - ConvertUserToGap(point) characters must be moved.  This
quantity is numerically GapStart - point.
</ul>

<p>After the gap has been moved to the point, insertions or deletions
are performed by moving the GapStart pointer (or the GapEnd pointer --
it makes no difference).  A deletion is a decrementing of the GapStart
pointer.  An insertion is an incrementing of the GapStart pointer
followed by placing the inserted character in the memory location that
was just incremented over.</p>

<p>Note that after the first insertion or deletion the gap is already
in the correct place.  Thus, the insertions or deletions that follow
can take place without moving the gap .  Further, the point can be
moved away and back again with no motion of the gap taking
place. Thus, the gap is only moved when an insertion or deletion is
about to take place and the last modification was at a different
location.</p>

<p>This scheme has a penalty associated with it.  The gap does not
move very often, but potentially very large amounts of text may have
to be shuffled.  If a modification is made at the end of a buffer and
then one is made at the beginning, the entire contents of the buffer
must be moved.  (Note, on the other hand, that if a modification is
made at the end of a buffer, the beginning is examined, and another
modification is made at the end, then no motion takes place.)  The key
question that must be asked when considering this scheme is, when a
modification is about to be made, how far has the point moved since
the last modification?</p>

<p>How far can the point be moved before the shuffling delay becomes
noticeable?  Assume that an interval of 1/10 second is noticeable and
that the editor is running on a dedicated system.  Assume 250
nanosecond, 16-bit wide memory.  Assume also that ten memory cycles
are required for every two bytes moved (load, store, and eight
overhead cycles for instructions).  Then, 80,000 bytes can be moved
with a just noticeable delay.</p>

<p>Because of the locality principle and because most files that are
edited are less than 80,000 bytes in size, it seems reasonable to
conclude that the average distance moved will be less than 80,000
bytes and so the shuffling delay will not be noticeable. Note that the
size of the gap does not affect how long the shuffling will take and
so the gap should be as large as possible.  </p>

<a name="c6.4.3.1"></a><h4>6.4.3.1 Multiple Gaps and Why They Don't Work</h4>

<p>Assume that we were still uncomfortable with the shuffling delay
and a possible fix was put forth.  This fix would have, say, ten
different gaps spread throughout the buffer.  What would the effects
be?  The idea behind this discussion is to help one understand the
buffer gap system by seeing how it changes to the scheme fail.</p>

<p>First, the conversion from the user to the gap coordinate system
would be more complex and take longer.  Thus, some ground would be
lost.  However, this is a small loss on every memory reference in
order to smooth out some large bumps, so it might still be a
reasonable thing to do.</p>

<p>Second, the average amount of shuffling will go down, but not by
anywhere near a factor of ten.  Because of the locality principle,
most shuffling occurs over short distances and so cutting out the
&quot;long shots&quot; will not have a large effect.</p>

<p>Third, unless the writer is very careful, the gaps will tend to
lump together into a smaller number of &quot;larger&quot; gaps.  In
other words, two or more gaps will meet with the GapEnd pointer for
one gap the same as the GapStart pointer for the next gap.  There is
just as much overhead in referencing them, but the average amount of
shuffling will increase (or, more precisely, not be decreased).</p>

<p>On the whole, the extra complexity does not seem to return
proportional benefits and so this scheme is not used.</p>

<a name="c6.4.3.2"></a><h4>6.4.3.2 The Hidden Second Gap</h4>

<p>On some computers, for example the two-dimensional memory system
used by Multics, a second gap at the end of the buffer is provided
with almost no extra overhead.  The key to this gain is that the
buffer is not stored in a fixed-size place.  Rather, the size of the
memory (or address space, to be more precise) that is holding the
buffer can also increase.</p>

<p>The extra overhead is a check to see whether a modification is
taking place at the end of the buffer.  If so, the modification can be
made directly with no motion of the gap.</p>

<p>The second gap has a greater effect than one might think because a
disproportionately high percentage of modifications take place at the
end of the buffer.  This distortion is due to the fact that most
documents, programs, etc., are written from beginning to end and so
the new text is inserted (or changed) at the end of the buffer.</p>

<p>The increased overhead due to the second gap method is low because
the check for the end of the buffer is already there (in the system
hardware).  There is no problem of the gaps coalescing because one of
them is pegged into place.  The gains are not all that great, but
neither are the costs and so it should be used where supported by the
operating system.</p>

<a name="c6.5"></a><h2>6.5 Implementation Method Overview</h2>

<p>We started by not internally managing the pieces at all.  We then
added some slack space at the end of each piece.  We moved to the
buffer gap technique, which allowed that slack space (now called a
gap) to move within the piece.  Finally, we reviewed an optimization
of the buffer gap technique that in some cases added the slack space
at the end again.</p>

<p>This table presents a summary of the implementation methods.  A
&quot;-&quot; means that the combination makes no sense.  An
&quot;=&quot; means that the combination tends to be very inefficient
to implement.  A &quot;*&quot; indicates those combinations that are
plausible.</p>

<table border="0" width="100%">
<colgroup>
<col width="25%">
<col width="25%">
<col width="25%">
<col width="25%">
</colgroup>

<tr><td valign="top">size of separately managed piece</td><td valign="top">no management</td><td valign="top">at the end</td><td valign="top">extra space buffer gap</td></tr>
<tr><td valign="top">character</td><td valign="top">*</td><td valign="top">-</td><td valign="top">-</td></tr>
<tr><td valign="top">16-64 chars</td><td valign="top">*</td><td valign="top">*</td><td valign="top">*</td></tr>
<tr><td valign="top">line</td><td valign="top">=</td><td valign="top">*[2]</td><td valign="top">*</td></tr>
<tr><td valign="top">1/2-4K chars</td><td valign="top">=</td><td valign="top">=</td><td valign="top">*[3]</td></tr>
<tr><td valign="top">buffer</td><td valign="top">=</td><td valign="top">=</td><td valign="top">*[1]</td></tr>
</table>

<p>Combination [1] is the standard buffer gap management method.
Combination [2] is the &quot;linked line&quot; management method.
Combination [3] is the &quot;paged buffer gap&quot; management method.
The following sections will describe each of these methods.  Later
sections will compare and contrast them.</p>

<a name="c6.6"></a><h2>6.6 Buffer Gap</h2>

<p>This method was first used by TECO.  This method treats the entire
buffer as a single object.  The buffer gap technique is used to handle
insertions and deletions.  It is simple and straightforward, easy to
implement and easy to debug.  As the text is contiguous, the buffer
can be transferred to or from a file with just one or two system
calls.  It also translates easily to the modern world of workstations
with large virtual address spaces.</p>

<a name="c6.7"></a><h2>6.7 Linked Line</h2>

<p>This method came into common use for Emacs-type editors when they
began to be implemented on top of Lisp environments.  In this method,
the buffer is stored as a doubly linked list of lines.  The following
information might be stored for each line:</p>

<pre>
	struct line {
		struct line *next;
		struct line *previous;
		struct piece *theline;
		int version;			/* optional */
		struct marks *mark_lists;	/* optional */
		};
</pre>

<p>The <b>next</b> and <b>previous</b> fields implement the
doubly-linked list.  They point to the following and preceding lines,
respectively.</p>

<p>The <b>line</b> field is managed using one of the management
techniques described in the earlier characteristics of implementations
section.  Typically, the &quot;leave space at the end&quot; technique
is used.</p>

<p>The <b>version</b> field is optional.  If implemented, it is for
use by the redisplay code and will be discussed in Chapter 7.</p>

<p>The <b>mark_lists</b> fies is optional.  If implemented, it records
which marks are located on this line.</p>

<p>A buffer <i>location</i> in this method is typically represented as
a (line pointer, offset) pair.  It follows from this representation
that marks are always associated with a line (think about it).  Marks
can thus be efficiently implemented by a per-line mark list.  By doing
so, less time is required to update the marks after insertions or
deletions because only those that are on the affected line can
possibly be changed.</p>

<p>The operation of this method is straightforward. New lines, when
created, are simply spliced into the list at the appropriate place.
Note that no characters are stored to indicate line breaks.  If the
new line is inserted into the middle of an existing line, some
movement of the text on the end of the old line to the newly allocated
line is all that is required.</p>

<p>The line itself is typically stored by the &quot;extra space at
end&quot; technique.  However the buffer gap technique could also be
used. Regardless of the technique used, it is important to ensure that
no limits are placed on the length of a line.</p>

<p>If your implementation includes automatic word wrap, do <i>not</i>
split lines on &quot;soft&quot; newlines, because the overhead of
shuffling the line allocations while the user types will be large.
Instead, use a buffer gap technique within a line and only split lines
on hard newlines (<i>i.e.</i>, paragraphs).</p>

<a name="c6.8"></a><h2>6.8 Paged Buffer Gap</h2>

<p>In this method, the buffer is divided into &quot;pages&quot; of one
to two Kilobytes each while the file is read in.  Each page is then
managed with the buffer gap technique.  The pages are organized into
an array or linked list.  This method has two points in its favor:</p>

<ul>
<li>Since each page is small, the gap need never be moved very far.
<li>Since all pages are the same size, memory management is kept simple.
</ul>

<p>These points are very important in resource-limited environments.
For example, this method was used in the Mince text editor that
initially ran on CP/M systems with 48 Kilobytes of memory and small
floppy disks.  That editor implemented a complete paged, virtual
memory environment for its buffers.  (The implementation included all
of the then-current optimizations found in virtual memory operating
systems.)  The size of the buffer was limited only to the amount of
available disk space.</p>

<p>Since main memory was so limited (in some systems, only three or
four pages could be kept in memory at once), the excess pages were
swapped to disk.  A descendant of the Mince editor called The
FinalWord used the disk storage to even greater advantage: the control
information was written to disk as well, thus allowing the complete
editing state to be saved between invocations as well as being
recoverable in the event of a system crash.</p>

<a name="c6.9"></a><h2>6.9 Other Methods</h2>

<p>The other methods involve tracking small chunks of characters or
even individual characters.  While they are in principle do-able,
their small object size serves to increase the amount of memory and
CPU overhead, unfortunately without offering any compensating
advantages.  Thus, they remain largely unused.</p>

<a name="c6.10"></a><h2>6.10 Method Comparisons</h2>

<p>This section compares the three main methods in a variety of
ways.</p>

<a name="c6.10.1"></a><h3>6.10.1 Storage</h3>

<p>These comparisons are on a per-buffer basis.  They also assume
eight-bit characters.  Our sample buffer will consist of 150,
60-character lines.</p>

<p>A buffer gap implementation requires a fixed-size header (say,
eight bytes) plus one byte per character of text.  Total size is 9,008
bytes.</p>

<p>A linked line implementation requires a fixed-size header (say,
eight bytes), plus a fixed-size header per line (say, twelve bytes)
plus one byte per character of text, plus on the average eight bytes
of fragmentation per line.  Total size is 8 + 150 * 12 + 9,000 - 150
(don't store newline characters) + 8 * 150 = 11,858 bytes.</p>

<p>A paged buffer gap implementation requires a fixed-size header
(say, eight bytes), plus a fixed-size header per page (say, twelve
bytes), plus the pages (say, two Kilobytes each).  Total size is 8 +
12 * 5 + 2,048 * 5 = 10,308 bytes.</p>

<p>The linked line method pays a large storage price because of its
relatively high per-line overhead.  In this example, the per-line
overhead was about 33 percent.</p>

<p>The paged buffer gap method pays a large price in this example
because of the mismatch between the page size and the buffer.  If
memory is tight, a smaller page size can be selected.  However, the
extra overhead is paid only once per buffer, since it occurs only at
the end.</p>

<a name="c6.10.2"></a><h3>6.10.2 Crash Recovery</h3>

<p>These comparisons assume that a recovery program is examining the
core image of an edit session that was interrupted.</p>

<p>In the buffer gap method, crash recovery is relatively easy and
fail safe.  In general, the start and end of the buffer can be found
if a marker is left around the buffer (say, a string of sixteen
strange (value 255) bytes) and the buffer is everything between
them. The gap can be recovered and manually deleted by the user or, if
it too is filled with a special marker, can be automatically
deleted.</p>

<p>In the linked line method, crash recovery is harder.  Recovery is
greatly aided by erasing freed memory.  Basically, you perform the
recovery by picking a block at random and examining it.  If it can be
parsed into a line header (<i>i.e.</i>, the pointer values, etc., are
reasonable), continue (a careful selection of header formats will
help).  Otherwise, pick a different block.  You can then follow the
next and previous pointers and parse them.  If this works three or
four times in a row, you can be confident that you have a handle on
the contents. If a header doesn't parse, it is because it is either a
part of a line (either pick again at random or go back one chunk and
try again) or a header that was being modified (in which case you are
blocked from continuing down that end of the chain).  In the latter
case, go in the other direction as far as possible.  You now have one
half of the buffer.  Repeat the random guess, but don't pick from
memory that you have already identified as part of the buffer.  You
should get the other half of the buffer.  Leave it to the user to put
the two halves together again.  If the freed blocks are not erased,
the chance of finding a valid-looking header that points to erroneous
data is very high.</p>

<p>In the paged buffer gap method, crash recovery is easier than with
linked line, but harder than with buffer gap.  As with buffer gap,
marker bytes can help you locate the buffer pages, and the gap can be
recovered either manually or automatically.  The pages are strung
together just like lines were: it is just that there are fewer pages
to work with.</p>

<a name="c6.10.3"></a><h3>6.10.3 Efficiency of Editing</h3>

<p>These comparisons examine the typical types of effort required to
insert a character or line.</p>

<table border="0" width="100%">
<colgroup>
<col width="25%">
<col width="25%">
<col width="25%">
<col width="25%">
</colgroup>

<tr><td valign="top"><b>operation:</b></td><td valign="top"><b>insert character</b></td><td valign="top"><b>insert line</b></td><td valign="top"><b>maximum motion</b></td></tr>

<tr><td valign="top">buffer gap</td><td valign="top">move gap<br>
pointer update
</td><td valign="top">same as insert character</td><td valign="top">buffer</td></tr>

<tr><td valign="top">linked line</td><td valign="top">move/scroll line<br>
pointer update</td><td valign="top">allocate header line<br>
splice into line</td><td valign="top">none</td></tr>

<tr><td valign="top">paged buffer gap</td><td valign="top">if full, split page<br>
move gap<br>
pointer update
</td><td valign="top">same as insert character</td><td valign="top">page</td></tr>
</table>

<p>As might be expected, the buffer gap scheme is the most efficient,
although you will occasionally encounter a comparatively long pause.
The linked line scheme adds lots of overhead to the simple operations
and cuts out the occasional comparatively long pauses.  But you will
often be hit badly if, for example, you insert in the middle of a
4,000-character line.  The paged buffer gap method removes the pauses
at the price of a moderate increase in complexity.</p>

<a name="c6.10.4"></a><h3>6.10.4 Efficiency of Buffer/File I/O</h3>

<p>This section compares the way that the methods handle buffer/file
I/O.</p>

<p>The buffer gap method is extremely efficient.  Reading a file into
a buffer consists of these operations:</p>

<ul>
<li>Determine the file's length.
<li>Allocate enough memory to hold the file, plus some extra for growth.
<li>Read the file in.
</ul>

<p>On some systems, even this can actually be improved.  For example,
on many systems you can just map the file into the address space of
your process.  No actual data motion takes place until you modify one
of the pages.  At that time, the page is copied and the modifications
are written to the new copy (this is sometimes called
&quot;copy-on-write&quot;).  Writing the file out can take two calls
(one to cover the text in front of the gap and the other to cover the
text after the gap).</p>

<p>The linked line method has a very obvious but poor algorithm to
read the file in.  This code fragment illustrates the algorithm:</p>

<pre>
	if (fd = fopen(FILE, &quot;r&quot;)) == NULL) {
		...error...
		}
	while (fgets(buf, sizeof(buf), fd) != NULL) {
		if (!Allocate_Line(strlen(buf)) {
			...error...
			}
		Build_Line(buf);
		}
	fclose(fd);
</pre>

<p>This algorithm has a system call (in the <i>fgets</i>) and
allocation for every line in the buffer.  An improved algorithm would
read the whole file into memory (or at least read in large chunks),
then allocate lines out of that memory.  This improvement at least
reduces switching between the system and program contexts.  (A
sufficiently good <i>fgets</i> implementation would effectively do
this.  Unfortunately, the libraries that come with many C compilers
are not sufficiently good...)</p>

<p>The paged buffer gap method could be just as efficient at reading
as the buffer gap method.  It would operate by reading the entire file
in as a block, then dividing that block up without moving any data.
The first insert on each page will cause a page split, though.
Writing would have a worst case number of system calls equal to twice
the number of pages in use.</p>

<a name="c6.10.5"></a><h3>6.10.5 Efficiency of Searching</h3>

<p>This section compares the way that the three methods handle
searching.</p>

<p>If your implementation is such that the search time dominates the
setup time, all three methods are equivalent.  In the case where the
setup time dominates the search time, the methods do perform
differently, and that is the case that will be examined.</p>

<p>This comparison assumes that the search routines are &quot;built
in&quot; to the buffer management code for performance reasons.  While
they could call <b>Get_Char</b> for every character, doing so would
probably not be very efficient.  Given equivalent implementations of
the actual search code, the main difference among the methods is the
number of times that the inner search loop is called.  In other words,
it is the number of distinct pieces that must be searched.</p>

<p>The buffer gap method calls the inner loop twice: once for the text
in front of the gap and once for the text after the gap.  While an
implementation could move the gap so that the search routine only
needs to be called once, doing so goes against the reason for having
the gap in the first place.  Keep in mind that searching happens a
lot.  For example, two searches are done whenever the &quot;forward
word&quot; command is given.  The whole point of the buffer gap method
is to avoid moving the gap until it is necessary.  An even worse way
to go astray is to move the gap as you search.  This replaces one
large, efficient gap move with many smaller ones.  We have already
observed that even fairly large gap moves are not very noticeable, so
&quot;optimizing&quot; them out is not a wise move.  In conclusion,
invoking the search loop twice is quite efficient.</p>

<p>The linked line method invokes the inner search loop once for every
line in the buffer.  In our earlier example, this means that it would
be invoked 150 times.  What's worse, the linked line method does not
store newline characters.  Rather, they are implied by the line
structure.  Hence, whenever a newline character is in the search
string, that character must be handled in a special manner.  While
some optimizations can (and should) be made (for example, searching
for &quot;x&lt;newline&gt;&quot; means that you only have to look at
the last character of each line), the code complexity required to make
these optimizations adds its own performance penalty.</p>

<p>The paged buffer gap method lies somewhere between the other two.
In the earlier example, the search routine would have to be invoked
ten times.  This is not enough to incur a significant performance
penalty, but it is one more reason not to use this method if buffer
gap will work.</p>

<a name="c6.10.6"></a><h3>6.10.6 Multiple Buffers</h3>

<p>This section compares the way that the methods handle multiple
buffers.</p>

<p>The buffer gap method offers no choice: the buffers must follow one
another in memory (where else could they be?).  This arrangement
becomes bad when the total size of all buffers becomes large enough
that an objectionable pause occurs when switching buffers.  The
arrangement can be improved by leaving extra &quot;gaps&quot; between
buffers.</p>

<p>The linked line method has two choices.  First, all lines can be
allocated out of a common pool.  Thus, over time, the buffers tend to
&quot;intertwine&quot; (<i>i.e.</i>, the lines of one buffer are mixed
in with the lines from other buffers in physical memory).  This choice
tends to maximize the density of text and thus makes the most
efficient use of memory. (See also the discussion in the next section
about paged environments.)  The other choice is to allocate memory
among buffers, then allocate all lines for a buffer from within each
buffer's allocation.  There must, of course, be some way to change the
buffer allocations.</p>

<p>The paged buffer gap method has the same two choices as linked
line.</p>

<a name="c6.10.7"></a><h3>6.10.7 Paged Virtual Memory</h3>

<p>This section compares the way that the methods perform in paged,
virtual memory environments.  It concentrates on the effects that
occur when main memory is full and paging is going on (&quot;tight
memory&quot;).</p>

<p>Some operations, such as searching the entire buffer, require that
the buffer be accessed sequentially.  In situations where the entire
buffer does not fit into memory, no management method can avoid some
page swapping.  That type of situation is not analyzed here.</p>

<p>The buffer gap method generally works well in this environment.
Its highly compact format allows for accessing large portions of the
buffer with only a few pages in memory.  Its sequential organization
also implies that it has a very good locality of reference and so the
nearby pages are heavily referenced and likely to be around.</p>

<p>Its major problem is, as usual, the worst case situation of a large
gap movement.  In tight memory situations, moving the whole buffer
implies that all of the buffer's pages must be swapped in and -- most
likely -- swapped out again.  Overall, the buffer gap method does as
well as can be expected.  The nearby portions of the buffer will tend
to be in memory because of locality of reference, but distant portions
may in general have to be paged in.</p>

<p>The linked line method has many disadvantages and no real
advantages in tight memory situations.  First, if an intertwining
multiple buffer scheme is used, over time the effective page size is
reduced by a factor that tends to increase over time to equal the
number of buffers.  This reduction is due to the random nature of the
buffer memory allocations, the fact that many lines tend to fit into
one virtual memory page, and the consequence that over time a virtual
memory page tends to hold lines from as many buffers as possible.
However, when a given buffer is in use, the storage used by the other
buffers is consuming memory.</p>

<p>Even separating the buffer memory does not resolve this problem.
When buffers get large, different parts of the same buffer may act in
the same fashion as the separate buffers to decrease the effective
page size.  In extreme cases, a desired &quot;target&quot; line may be
in memory, but in the process of following the linked list, the target
line may be swapped out!</p>

<p>Notwithstanding the above, this method does not pack data as
tightly as the others.  An earlier example showed that the overhead
for the linked line method is about 33 percent.  Thus, the page size
is effectively reduced by 25 percent.</p>

<p>When all factors are combined, a typical linked line system is
probably reducing its effective page size by about 50 percent.  The
result is that, for example, if a computer has one Megabyte of memory
in 512, two Kilobyte pages, the linked line method would effectively
treat this as 512 Kilobytes of memory (512, one Kilobyte pages).</p>

<p>The paged buffer gap method is essentially the buffer gap method,
modified to improve performance in tight memory situations.  It
removes the lengthy gap moves and consequently lowers the probability
of thrashing.  When designing such a system, the buffer page size
should be set the same or as a multiple of the virtual memory page
size.  Thus, in even the tightest memory situations an insert or
delete of one character will only affect at most two pages of buffer
memory.</p>

<a name="c6.10.8"></a><h3>6.10.8 Conclusions</h3>

<p>Use the buffer gap method if at all possible.</p>

<p>Only use the linked line method if you are implementing in an
environment that likes to manipulate lists of small objects; for
example, Lisp environments.</p>

<p>Only use the paged buffer gap method if resources are tight.</p>

<a name="c6.11"></a><h2>6.11 Editing Extremely Large Files</h2>

<p>This section examines techniques for editing extremely large files.
The first type of extremely large file is those files that are so
large that reasonable assumptions based on current workstation and
mainframe architectures are no longer valid.  Given the current
generation of computing hardware, this starts happening around 512
Megabytes (ten years ago, I had set this number at 64 Megabytes).  At
that size, even simple operations such as a string search can take
several minutes to run on a fast processor with the whole file in
memory.</p>

<p>Although there are one or two interesting hacks you can do to stay
alive, life is simply not bearable when trying to edit such a large
unstructured file.  The alternative which large data base implementors
have known about for years, is to structure the file.  This
alternative is palatable because an unstructured editor can still be
used to edit the pieces of a structured file.  The other reason why
this limitation is not bothersome is that there aren't all that many
such files to edit.  (For example, the largest file on a computer
system that I often use is only about 33 Megabytes.)  The vast
majority of files are much smaller.  Gigantic files call for special
tools.</p>

<p>The other type of &quot;extremely large&quot; file is encountered
on resource-limited systems.  In these cases, files that would
otherwise be handled easily can now cause the system to bog down. For
example, in the first generation of microprocessor systems, an
extremely large file might have been 100 Kilobytes. There are several
ways of dealing with such files.</p>

<p>One way is to divide the file into chunks, each of which fits into
memory.  You read in the first chunk, edit it, write it out, read in
the second chunk, and continue until you are done.  While arbitrary
editing can be done within a chunk, in general you cannot back up to a
previous chunk without finishing the file and starting over.  This
method was used by the original TECO editor.</p>

<p>Another way is to use a three-file system.  As the user moves down
in the file, the &quot;from&quot; file is read and a &quot;to&quot;
file is written.  When the user wants to back up, the &quot;to&quot;
file is read and a &quot;holding&quot; file is written (the chunks
will appear in reverse order in this file).  When the user moves
forward again, the &quot;hold&quot; file is read (backwards) until
exhausted, then the &quot;from&quot; file is read from again.</p>

<p>The best method to use if main memory is tight is paged buffer gap.
If disk storage is also tight, serial chunking is best.</p>

<a name="c6.12"></a><h2>6.12 Difference Files</h2>

<p>There is another type of buffer management that has been used to
good advantage in several cases.  It is called the <i>difference
file</i> method.  It works best when recording relatively few changes,
and those changes are small when compared to the size of the buffer.
In this method, the buffer is not kept in memory at all.  Instead,
only a list of differences between the buffer and the
&quot;original&quot; file is kept. When information is being retrieved
from the buffer, it is read from the file as needed and the
differences applied.</p>

<p>This method has much promise.  For example, in many cases, a file
will be read into a buffer, looked at by the user, and the buffer
deleted.  In this example, the difference file method essentially acts
as a file viewer.  This is particularly encouraging when you realize
that the larger a file is, the less likely it is to be dramatically
changed.</p>

<p>On the other hand, this method does not scale well.  For example, I
have been editing this chapter continuously for several hours.  As it
turns out, the current version bears little resemblance to the
original.  The <i>best</i> description of the changes is &quot;throw
out everything and insert X,&quot; where &quot;X&quot; is the entire
chapter.  I would expect most &quot;reasonable&quot; descriptions of
this chapter to wind up being several times as large as the chapter
itself.  Hence, you now have to address the question of how to edit
the description of the differences.  Let's see, we can use buffer gap,
linked line, or paged buffer gap...</p>

<p>In addition, this method does not work well in tight memory
situations.  As I write this chapter, it occupies about 60 Kilobyes of
the roughly 100 Kilobytes of free RAM disk space on my lap-top
computer.  I simply don't have the room to store what amounts to both
the &quot;old&quot; and &quot;new&quot; versions at once.</p>

<p>But, one might argue, you don't have to store the &quot;old&quot;
version as it appears on disk.  Well, that's true, but the disk is
sitting on the table by my side, not in the floppy drive.  So how can
it be read?</p>

<p>In conclusion, this method works well when one is essentially
viewing files.  However, it breaks down badly as changes to the file
accumulate.  It can easily end up taking several times as much memory
to track all the changes as to simply store the modified version.
Finally, the changes can easily become so large that either a
&quot;real&quot; buffer management method must be implemented to
simply track the changes or &quot;snapshot&quot; files must be created
so that changes can be tracked from a new base.  Hence, why bother
with the extra overhead?</p>

<a name="c6.q"></a><h2>Questions to Probe Your Understanding</h2>

<p>Rectangular regions include only those characters between the point
and mark that are also in columns between those of the point and the
mark. Define a set of interface procedures to handle rectangular
regions.  (Easy)</p>

<p>Come up with a situation where it would be a good idea to implement
the buffer as a linked list of characters.  (Medium)</p>

<p>The first buffer gap editor was TECO, which was also among the
first text editors ever written.  It was written in the early 1960s.
Explain why many people spent the next fifteen years reinventing
hard-to-use, limited-functionality line editors.  (Medium, but if you
succeed I would like to hear your explanation)</p>

<p>Devise a buffer management scheme better than buffer gap.  (Hard,
but if you succeed, you can probably get a Ph.D. thesis out of it)</p>

<p><a href="#contents">Back to Contents</a>.</p>
<hr>
<a name="c7"></a><h1>Seven: Redisplay</h1>

<blockquote><i>
One, two!  One, two!  And through and through<br>
&nbsp;&nbsp;The vorpal blade went snicker-snack!
</i></blockquote>

<p>The previous chapter described a way of dividing the implementation
into parts and covered one of those parts, the internal sub-editor.
This chapter describes the redisplay part.</p>

<p>This chapter will start by discussing the general constraints that
affect redisplay.  It will then describe the external interface and
some of the internal interfaces used by redisplay (the &quot;procedure
interface&quot; definitions).  It goes on to discuss many of the
considerations that affect implementations of the algorithms.
Finally, it describes the redisplay algorithms.</p>

<a name="c7.1"></a><h2>7.1 Constraints</h2>

<p>Redisplay, or incremental redisplay, to give it its full name, is
that part of the implementation that is responsible for ensuring that
all changes to the buffer are promptly reflected on the user's
display. As is evident from the definition, there are two parts to
redisplay's job.</p>

<p>The first part is to ensure that all changes are indeed tracked.
In the absence of the second part, this part would be quite easy.</p>

<p>The second part of the job is to ensure that the changes are made
&quot;promptly.&quot; In this context, &quot;promptly&quot; means that
the amount of clock time required to make the updates visible is
minimized.  Clock time is the combination of transmission time, CPU
time, and disk access time that is perceived by the user as the delay
from when a command has been entered to when the display has been
updated.</p>

<p>In general, the buffer's contents will change only a small amount
during any one command.  The screen will thus only have to be changed
by a small amount in order to reflect the changed buffer contents.
Hence, the algorithms concentrate on incrementally redisplaying the
buffer; the entire process is thus referred to as incremental
redisplay.  Fortunately, it turns out that in cases where the buffer
is changed drastically, the increment-oriented approach to redisplay
works quite well and so there is no need for multiple algorithms.</p>

<p>This discussion of incremental redisplay assumes a model of the
system where the editing is done on a main processor which
communicates with a display.  If the main processor is the same as the
display, the bandwidth of the CPU to display communications channel
can be very high.  However, the considerations remain unchanged: only
the relative weights change.  Incremental redisplay is an optimization
between CPU time, display-processing time, and communications-channel
time, with a few memory considerations thrown in.</p>

<p>The first major constraint is the speed of the communications
channel.  Typical speeds that are available are 300, 1200, 2400, and
9600 bps.  Memory-mapped and other built-in displays run at bus
speeds: communications speed is essentially infinite.</p>

<p>A typical video display has a 24 x 80 character screen.  At 300
bps, it takes three seconds to reprint a line and over a minute to
refresh the whole screen.  At 1200 bps, less than one second is
required to reprint a line and about sixteen seconds to refresh the
screen.  At 9600 bps, it will take one to two seconds to refresh the
screen.  The speed of the communication thus greatly affects the
amount of optimization that is desired.  At 300 bps, the user may
notice even one extra transmitted character, while at 9600 bps,
reprinting entire lines does not take an appreciable amount of time.
One dimension of the optimization is thus clear: the importance of
optimizing the number of characters sent increases in proportion to
the slowness of the communication line.</p>

<p>The second major constraint is the speed of the display device.  It
takes time for the display to handle each command, and this time can
affect the choice of commands sent to the display.  For example, if a
line ending in:</p>

<pre>
	whale
</pre>

<p>was changed to:</p>

<pre>
	narwhale
</pre>

<p>the redisplay code could elect to position the cursor just before
the &quot;w&quot;, insert three characters, then send &quot;nar&quot;.
Alternatively, it could position to the same place and just send
&quot;narwhale&quot;.  The latter would be more efficient unless the
display could accept and perform the &quot;insert three
characters&quot; command in less than five character times (possible).
As has been mentioned before, some memory-mapped displays actually
process commands very slowly.  As the effective display speed is so
low, it is important to use good redisplay algorithms on those
displays.</p>

<p>User interface considerations also affect which command sequences
should be sent.  For example, while it might be acceptable from a pure
clock-time point of view to reprint an entire line, users do not like
to see text which has not changed in the buffer &quot;change&quot; by
being reprinted.  The flickering that is generated by the reprinting
process attracts the user's attention to that text, which is
undesirable as the text has not, after all, changed.  Thus, avoiding
extraneous flickering and movement of text is good.  The amount of
perceived flicker will vary from display to display, being highly
dependent upon such factors as display command set, display speed,
internal display data-structures, timing, and phosphor.</p>

<p>The third major constraint is the CPU speed.  On some computers,
computing an optimal redisplay sequence takes longer than is saved by
the optimizations (&quot;optimal&quot; considering only the
communications channel and display).  On those machines, the correct
optimization is to send the &quot;less-than-optimal&quot;
sequence.</p>

<p>CPU time must be spent in order to perform any optimizations. If
the CPU time spent exceeds some small amount of clock time, the user
will perceive response to be sluggish.  It is therefore desirable to
minimize the CPU time spent on optimizing the redisplay.  However, the
communications channel speed also makes a difference.  If the line is
slow, extra CPU time can and should be spent (at 300 bps, it is
worthwhile to spend up to 30 msec. of CPU time to eliminate one
character from being transmitted (which takes about 30
msec.)). However, at higher speeds it is generally not practical to
heavily optimize the number of characters sent, as it can easily take
longer to compute the optimizations than to transmit the extra data.
This relaxation of the optimization is subject to the user interface
constraint outlined above.</p>

<p>The fourth constraint is the memory size. For example, one
technique stores a copy of the entire screen, character by character.
This technique works quite well in general.  However, where memory is
tight this technique may not be feasible.</p>

<a name="c7.2"></a><h2>7.2 Procedure Interface Definitions</h2>

<p>This section describes two interfaces.  The first one is the
(external) interface that redisplay presents to the rest of the editor
implementation (<i>i.e.</i>, the sub-editor and the user-oriented
commands).  The second interface is the internal interface used by the
redisplay to isolate the display-specific portions of its internal
code.</p>

<p>In this section, the term <i>display</i> refers to the hardware
operated by the user.  A display has a keyboard, screen, and perhaps a
graphical input device.  The <i>screen</i> is the part of the display
that shows output.  A <i>window</i> is a logical screen.  One window
can occupy the entire screen, or more than one window can share the
screen, perhaps even overlapping.  A window can never be larger than
the screen.</p>

<a name="c7.2.1"></a><h3>7.2.1 Editor Procedures</h3>

<pre>
	status Window_Init(char *display);
	status Window_Fini(void);
	status Window_Save(FILE *fptr);
	status Window_Load(FILE *fptr);
</pre>

<p><b>Window_Init</b> is the basic set-up-housekeeping call.  It is
called once, upon editor invocation.  It should perform all required
one-time initialization, including keyboard and screen initialization.
No other editor interface call except for <b>Window_Fini</b> can be
legally called unless <b>Window_Init</b> returns a successful status.
The parameter indicates the display type.  Presumably, if the
parameter is null, the routine will determine a default display.</p>

<p><b>Window_Fini</b> terminates all state information.  Once called,
<b>Window_Init</b> must be called again before other editor interface
calls can be legally made.</p>

<p><b>Window_Save</b> saves the current redisplay state information in
the file opened on the specified file descriptor.  Presumably,
<b>World_Save</b> opened the file, then called this routine.</p>

<p><b>Window_Load</b> loads all redisplay state information from the
file opened on the specified file descriptor.</p>

<p>If you are creating a &quot;stripped down&quot; editor, then these
routines would not do anything.  They can be put in as stubs if there
is a reasonable possibility that the editor will be embellished
later.</p>

<pre>
	void Redisplay(void);
	void Recenter(void);
	void Refresh_Screen(void);
</pre>

<p><b>Redisplay</b> performs one incremental redisplay.  If it runs to
completion, the screen will accurately reflect the buffer.  However,
this routine also checks for type ahead.  If the user does type (or
use the graphical input device) before the redisplay has finished,
this routine will notice that event and abort the redisplay in a safe
manner.  Presumably, the user will quit typing ahead at some point and
redisplay can then complete.</p>

<p><b>Recenter</b> operates as does <b>Redisplay</b>, except that it
moves the point to the center of the window (technically, the
preferred percentage).  This procedure is needed because there is
typically a user-level command to perform this operation.</p>

<p><b>Refresh_Screen</b> operates as does <b>Recenter</b>, except that
it assumes that the screen has been corrupted.  Thus, this routine
ensures that the screen is correct no matter what else may have
happened.</p>

<pre>
	void Set_Pref_Pct(int percent);
	int Get_Point_Row(void);
	int Get_Point_Col(void);
</pre>

<p><b>Set_Pref_Pct</b> sets the preferred percentage.  After a
<b>Recenter</b> or other similar operation, the point will be on a
line approximately this percentage of the way through the window.  A
good default value is about forty percent.  With this default on a
22-line window, the point will be on line 9.</p>

<p><b>Get_Point_Row</b> returns the number of the row within the
window that the point is at.</p>

<p><b>Get_Point_Col</b> returns the number of the column within the
window that the point is at.  This may not be the same as the column
returned by <b>Get_Column</b>, as that routine does not take into
account line wrap.</p>

<pre>
	window_data Window_Create(window_data wind);
	status Window_Destroy(window_data wind);
	status Window_Grow(window_data wind, int amt);
	int Get_Window_Top_Line(window_data wind);
	int Get_Window_Bot_Line(window_data wind);
	location Get_Window_Top(window_data wind);
	location Get_Window_Bot(window_data wind);
</pre>

<p>These routines are used to manipulate multiple windows, if you
choose to offer that feature.  The definitions provided here only
allow for horizontal windows (<i>i.e.</i>, all windows occupy the full
width of the display).  Vertical windows and overlapping windows are
not covered, although they are often implemented.</p>

<p><b>Window_Create</b> creates a new window.  It operates by
splitting the supplied window in two.  Both windows initially show the
same data.  It returns a window descriptor for the second window.</p>

<p><b>Window_Destroy</b> destroys the supplied window.  The window
above this one expands to occupy the vacant screen space.  Note that
<i>Window_Destroy(Window_Create(wind))</i> results in no change.</p>

<p><b>Window_Grow</b> grows the specified window by the specified
number of lines.  The window is grown by moving the top line up.</p>

<p><b>Get_Window_Top_Line</b> returns the screen line that contains
the top line of the specified window.</p>

<p><b>Get_Window_Bot_Line</b> returns the screen line one after the
bottom of the specified window.  This is the same value as
<b>Get_Window_Top_Line</b> of the next lower window.</p>

<p><b>Get_Window_Top</b> returns the location in the buffer just
before the character that is at the top left part in the window.
Several of the user commands use this information.</p>

<p><b>Get_Window_Bot</b> returns the location in the buffer just after
the character that is at the bottom right part of the window (or as
close as you can get to it).  This is the same location that would be
returned by <b>Get_Window_Top</b> if the window were exactly one
window below its current position.  Several of the user commands use
this information.</p>

<a name="c7.2.2"></a><h3>7.2.2 Display Independent Procedures</h3>

<p>This section describes the display functions used by redisplay.
The routines that implement these functions are not part of redisplay
itself.  A full discussion of this topic is beyond the scope of this
book (but is covered in Linhart 1980). In essence, the problem is that
every display manufacturer has decided on a different set of features
and offers different ways of accessing those features.  To solve the
problem, a set of routines is needed which can isolate these
differences, as well as a way of selecting among different sets of
such routines as the display changes.</p>

<p>Although not recommended, it <i>is</i> possible to cover a lot of
displays by assuming that the display accepts the ANSI escape
sequences (<i>i.e.</i>, the display is a DEC VT100).  Most modern
displays accept these sequences.  However, many older displays do not.
In addition, not all displays take the same amount of time to process
a given command.  Thus, there is still per-display information to
consider.</p>

<p>There is one piece of existing technology to mention, and that is
exemplified by the <i>curses</i> package available on many UNIX
systems (similar packages are available under other names for other
systems).  It not only provides display independent functions, albeit
with a somewhat different interface, it also performs the redisplay
for you! However, as the purpose of this chapter is to explain how
redisplay works, that package will receive no further mention.</p>

<p>The following set of procedures will allow display-independent
operations for most displays.  The procedure interfaces isolate the
operations that are used by redisplay.</p>

<pre>
	status Key_Init(char *display);
	status Key_Fini(void);
	char Key_Get(void);
	FLAG Key_IsInput(void);
	private Key_FunctionKeys(void);
</pre>

<p><b>Key_Init</b> and <b>Key_Fini</b> operate in the by now familiar
fashion.  They will be called by the <b>Window_Init</b> and
<b>Window_Fini</b> routines.  In particular, though, these routines
make sure that all processing of input characters is turned off
(<i>i.e.</i>, set it for &quot;raw&quot; input) and all configuration
information is loaded.</p>

<p><b>Key_Get</b> waits for a key to be pressed and returns it.  Keys
that send multiple characters (<i>e.g.</i>, function keys) are
returned one character at a time.</p>

<p><b>Key_IsInput</b> returns True if input is available or False if
it is not.  It is used, for example, by <b>Redisplay</b> to determine
whether to abort.</p>

<p><b>Key_FunctionKeys</b> returns information about the function keys
available on this keyboard.  This information includes key placement,
key labelling, and the codes returned by the keys.  The information is
returned in an implementation-defined manner (<i>i.e.</i>, you get to
invent your own representation).</p>

<pre>
	status Screen_Init(char *screen);
	status Screen_Fini(void);
	int Screen_Rows(void);
	int Screen_Columns(void);
	private Screen_Atrributes(void);
</pre>

<p><b>Screen_Init</b> and <b>Screen_Fini</b> operate in the by now
familiar fashion.  They, too will be called by the <b>Window_Init</b>
and <b>Window_Fini</b> routines.  In particular, though, these
routines make sure that all processing of output characters is turned
off (<i>i.e.</i>, set it for &quot;raw&quot; output) and all
configuration information is loaded.</p>

<p><b>Screen_Rows</b> returns the number of rows in the screen.  In
this case, a row is the granularity of screen output.  On a graphics
screen, a row would be one pixel.</p>

<p><b>Screen_Columns</b> returns the number of columns in the screen.
In this case, a column is the granularity of screen output.  On a
graphics screen, a column would be one pixel.</p>

<p><b>Screen_Attributes</b> returns information about the attributes
(<i>e.g.</i>, boldface, reverse video, blinking, etc.) that the screen
supports.  The information is returned in an implementation-defined
manner (<i>i.e.</i>, you get to invent your own representation
again).</p>

<pre>
	void Set_Cursor(int row, int column);
	void Set_Row(int row);
	void Set_Column(int column);
	void Set_Attr(private attributes);
	int Get_Row(void);
	int Get_Column(void);
	private Get_Attr(void);
	void Put_Char(char c);
	void Put_String(char *str);
	void Beep(void);
</pre>

<p><b>Set_Cursor</b> sets the cursor to the specified row and column.
It is assumed that the optimal (<i>i.e.</i>, least cost) command
sequence will be selected.</p>

<p><b>Set_Row</b> sets the cursor to the specified row, without
affecting the column.  Instead of a separate routine, this could be
multiplexed onto <b>Set_Cursor</b>, say by one of the following:</p>

<pre>
	Set_Cursor(row, -1);
	Set_Cursor(row, Get_Column());
</pre>

<p><b>Set_Column</b> sets the cursor to the specified column without
affecting the row.  The functionality provided by this routine could
also be multiplexed onto <b>Set_Cursor</b>.</p>

<p><b>Set_Attr</b> sets the current attributes to those specified.</p>

<p><b>Get_Row</b> returns the row that the cursor is on.</p>

<p><b>Get_Column</b> returns the column that the cursor is on.</p>

<p><b>Get_Attr</b> returns the current attributes.</p>

<p><b>Put_Char</b> outputs the supplied character to the screen,
updating the cursor position.  The character is always displayed: it
is never part or all of a command sequence.</p>

<p><b>Put_String</b> outputs the supplied string and leaves the cursor
after the string.  It otherwise works as per <b>Put_Char</b>.  These
strings are always displayed, even if they appear to contain screen
commands.  Commands may be sent to the screen only by means of the
supplied procedures.</p>

<p><b>Beep</b> rings the screen's bell or flashes the screen.</p>

<pre>
	CLEOL(void);
	Clear_Line(void);
	CLEOS(void);
	Clear_Screen(void);
</pre>

<p><b>CLEOL</b> sends the command sequence that optimally clears from
the current cursor position to the end of the current line.  The
cursor does not move.</p>

<p><b>Clear_Line</b> sends the command sequence that optimally clears
the entire current line, and leaves the cursor in column 0 (you are
assuming a zero-origin on all of these numbers, aren't you?).</p>

<p><b>CLEOS</b> sends the command sequence that optimally clears from
the current cursor position to the end of the screen.  Lines after the
current one are completely cleared.  The cursor does not move.</p>

<p><b>Clear_Screen</b> sends the command sequence that optimally
clears the entire screen, and leaves the cursor at the upper-left
corner (row 0, column 0).</p>

<pre>
	void Insert_String(char *str);
	void Delete_Chars(int count);
	void Insert_Lines(int count);
	void Delete_Lines(int count);
	void Scroll_Lines(int from, int to, int count);
</pre>

<p>These commands are available on advanced displays only (by the
definition of an advanced display from Chapter 2), and each is assumed
to send the optimal command sequences to effect its purpose.</p>

<p><b>Insert_String</b> takes a string, determines the optimal command
sequence required to insert it, and inserts it starting at the current
cursor location.  Line wrap is not performed: excess characters are
dropped off the right edge of the screen.  This routine could have
been defined to accept a count instead of a string and to insert
blanks.  However, it is easier to optimize command sequences by having
the string to be inserted available.</p>

<p><b>Delete_Chars</b> accepts a count and deletes that many columns.
Line wrap is not performed.  Blank columns are inserted from the right
edge of the screen.</p>

<p><b>Insert_Lines</b> accepts a count and inserts that number of
blank lines, starting with the line that the cursor is on (thus, you
can insert lines at the very top of the screen).</p>

<p><b>Delete_Lines</b> accepts a count and deletes that number of
lines, starting with the line that the cursor is on (thus, the line at
the very top of the screen can be deleted).  Blank lines are scrolled
in from the bottom.</p>

<p><b>Scroll_Lines</b> accepts a <i>from</i> line, a <i>to</i> line,
and a <i>count</i>.  The lines starting with the <i>from</i> line, and
up to but not including the <i>to</i> line, are scrolled by
<i>count</i> lines (positive scrolls the lines up and negative scrolls
the lines down).</p>

<pre>
	private Screen_Timings(private goal);
</pre>

<p><b>Screen_Timings</b> accepts a description of a goal, and returns
timing information on the various choices of screen routines that
could be used to achieve that result.  The description takes into
account the current screen status.  The information is to help the
redisplay code select the best screen routine, not to help the screen
routines optimize their own performance (such optimizations are
assumed to be done anyway).  As with the other private data types, the
information is returned in an implementation-defined manner
(<i>i.e.</i>, you get to invent your own representation).  Note that
the two private data types in this procedure's definition (that for
<i>goal</i> and the procedure itself) refer to <i>different</i> data
types with different representations.</p>

<a name="c7.3"></a><h2>7.3 Considerations</h2>

<p>This section describes various considerations that go into the
redisplay algorithm.  In other words, these are the ways in which the
algorithm gets complicated.  While none of these ways are particularly
difficult to implement in themselves, collectively they would clutter
the redisplay algorithms presented later.  Hence, you should keep
these topics in mind when reviewing the algorithms.</p>

<p>The topics in this section are only vaguely related to each other
and are in no particular order.</p>

<a name="c7.3.1"></a><h3>7.3.1 Status Line</h3>

<p>In general, each buffer will have some lines of status information.
In addition, there may be general editor status information.  Finally,
there may be lines of separators between windows.  (One hopes that on
&quot;small&quot; screens (<i>i.e.</i>, those with less than, say,
fifty lines), the numbers for these are &quot;one,&quot;
&quot;none,&quot; and &quot;none: use the buffer status line as a
window separator&quot; in order to devote as many lines as possible to
showing the text being edited.)</p>

<p>In any event, this &quot;framework&quot; information must be
retained and displayed.  The user-oriented command routines and
redisplay must work together to provide this infrastructure.</p>

<p>Here are some sample types of per-buffer status information:</p>

<ul>

<li>the file name
<li>the buffer name (may be the same as the file name)
<li>the buffer status: unmodified, modified, read-only
<li>the current modes
<li>the point position in characters and/or buffer length
<li>the point position as a percentage
<li>the location of the top of the window as a percentage (or
&quot;top&quot;, &quot;bot&quot;, or &quot;all&quot; as appropriate)
<li>the point column
<li>the current attribute
<li>the current line and number of lines
</ul>

<p>Of course, any one editor implementation will only show some of
this information at a time.  This list is not definitive. </p>

<p>Here are some sample types of editor status information:</p>

<ul>
<li>the name and version number of the editor
<li>copyright information
<li>the current date and time
<li>the current system &quot;load average,&quot; or other system
information
</ul>

<p>Again, any one implementation may only show some of this
information, and this list is not definitive.</p>

<a name="c7.3.2"></a><h3>7.3.2 End of the Buffer</h3>

<p>There are two cases that must be handled.</p>

<p>First, if the entire buffer fits in the window, you will run out of
buffer before you run out of window.  The caveat here is to ensure
that this case is properly detected and that the entire buffer is
shown, with the start of the buffer at the upper-left corner.</p>

<p>Second, if the entire buffer does not fit in the window but the end
of the buffer appears, the end should be close to but not at the
bottom of the window.</p>

<p>Those portions of the window that follow the end of the buffer can
be left blank or marked in some fashion.  As a rule, Emacs-type
editors leave that part of the window blank.</p>

<a name="c7.3.3"></a><h3>7.3.3 Horizontal Scrolling</h3>

<p>A window has a finite width.  Some lines will not fit within that
width.  There are two popular ways of handling such a situation:
horizontal scrolling and line wrap.  Ideally, your editor should offer
the user a choice between them.  This section will describe the
first.</p>

<p>When performing horizontal scrolling, a line longer than the window
width will spill off the edge: the part of the line that does not fit
thus will not be visible to the user.  As the user types, the text
being displayed will adjust so that the text around the point is
always visible.  In addition, the user should be provided with
commands to move the window left or right (with a few characters of
overlap).  In addition, the status line should contain indicators that
show whether text is currently lost off of either the left or the
right sides (use separate indicators).</p>

<a name="c7.3.4"></a><h3>7.3.4 Line Wrap</h3>

<p>When performing line wrap, the window never moves left or right at
all.  Instead, the text that would have been clipped off of the right
edge of the window is wrapped to the next line.  If the line is
sufficiently long, it may wrap two or more times.</p>

<p>In this type of display, no window motion commands are required.
In addition, the status indicators are also not required, although you
may wish to mark the wrapped lines.</p>

<p>Line wrap introduces a new problem that must be handled properly:
that of single lines that, when wrapped, occupy the entire window.
Although rare, such lines do show up from time to time in non-text
files.</p>

<p>When horizontal scrolling and line wrap are compared, neither comes
out a clear winner and both offer valuable features, hence the
assertion that your implementation should support both line wrap and
horizontal scrolling.</p>

<p>The advantages to horizontal scrolling are that it is easy to
implement, and can be processed quickly.</p>

<p>One of the disadvantages is that it requires a fast display.
Consider the case when the user has a 160-column line displayed in an
80-column window.  On the average, the window will have to be shifted
twice per line of typing.  Another disadvantage is that clipped text
appears to have been deleted.  It can be rather disconcerting to the
user to have this text vanish and reappear.</p>

<p>One of the advantages of line wrap is that all of the text is
always visible.  In addition, when editing a very long line, the
entire window shows the immediate context.  In contrast, when editing
the end of a long line when using horizontal scrolling, most or all of
the remainder of the window will be blank, having been scrolled off
the left edge.</p>

<p>The main disadvantages to line wrap are the additional complexity
in the redisplay required to handle the line wrap, the very poor
presentation when lines are only slightly wider than the window, and
the disconcerting multi-line &quot;shifting&quot; that occurs when a
user is inserting or deleting near the start of a wrapped line.</p>

<a name="c7.3.5"></a><h3>7.3.5 Word Wrap</h3>

<p>Once you have line wrap, the next logical step is to break the line
on a word boundary instead of a character boundary.  You then offer
&quot;word wrap,&quot; a feature found in almost every word processor
available today.  Typically, a word processor will store each
paragraph of text as a single line and simply perform word wrap upon
it.  Ruler lines are used to adjust the margins and change the type of
justification.</p>

<p>This is a very nice feature to offer.  It does have some pitfalls
for the unwary implementor, however:</p>

<ul>
<li>Your redisplay now has to handle look-ahead.

<li>You are going to have to decide where to break the lines (white
space only, include dashes, include other punctuation?).

<li>Your users are going to want ruler lines, and so you must provide
all of that infrastructure.

<li>You will have to track where the word wrap actually occurs because
the user thinks (and hence the line-manipulating commands operate) in
terms of the lines as displayed.
</ul>

<p>If you do implement word wrap, you may as well go the whole way and
support flushing right, centering, and justification of text during
display.</p>

<a name="c7.3.6"></a><h3>7.3.6 Tabs</h3>

<p>Tab characters can be handled in two ways.  The first way is to not
handle them at all.  Instead, convert them to spaces upon entry.  In
this case, the redisplay code never sees those characters and hence
doesn't need to deal with them.</p>

<p>The second - and by far the most common method - is to treat the
tab as a &quot;cursor control command&quot; that in effect says
&quot;think of me as <i>n</i> blanks, where <i>n</i> is the number of
units to the next tab stop.&quot; Thus, when the redisplay code
encounters a tab, it computes <i>n</i>, then pretends that it is
displaying <i>n</i> consecutive blanks (or a single blank of width
<i>n</i>).  <i>N</i> can be computed in one of three ways.</p>

<p>First, tab stops can be set every <i>c</i> columns (or
characters). In a zero-origin numbering system, tabs set every
<i>c</i> columns are set at columns 0, C, 2*C, 3*C, ...  For example,
when <i>c</i> is 8, tabs are in columns 0, 8, 16, 24, ...  The
<i>C</i> language expression to compute <i>n</i> is:</p>

<pre>
	n = c - x % c;
</pre>

<p>where <i>x</i> is the current column.</p>

<p>The second way to set tab stops is to allow them to be set at
arbitrary column positions.  This way is often used in ruler lines in
simple word processors.  In this case, you must decide on a
representation such as a bit array or an array of the columns where
tabs are set.</p>

<p>The third way to set tab stops is to allow them to be set at
arbitrary positions, where the positions are measured in units such as
inches, millimeters, etc.  This way is most useful on graphics
screens.</p>

<p>So far, only &quot;traditional&quot; tabs have been described.
These might be termed &quot;left&quot; tabs because the left edge of
the text is placed at the tab stop.  Other types of tabs have become
popular (again) with the advent of word processors:</p>

<ul>
<li><b>Right tabs</b> adjust the position of the text to the left of
the tab stop so that its right edge is at the tab stop.  Typically,
all text back to the previous tab stop or the start of line is
adjusted.
<li><b>Decimal tabs</b> search for a decimal point (comma in Europe)
and place that character at the tab stop.  Again, typically, all text
back to the previous tab stop or the start of line is adjusted.  These
tabs act as right tabs if the text does not contain a decimal point.
<li><b>Centering tabs</b> center the preceding text between the
current and previous tab stop.
</ul>

<p>Again, other variations are possible.  Note that only the
(traditional) left tabs can be implemented without some sort of look
ahead.</p>

<a name="c7.3.7"></a><h3>7.3.7 Control Characters</h3>

<p>Control characters are those that are not printing characters, a
space, a newline, or a tab.  (&quot;Printing characters&quot; means
just that: if your system supported &quot;extended&quot; or
&quot;enhanced&quot; character sets, then those characters may not
count as control characters.)  In addition, a word processor may store
some information &quot;in band.&quot; That information would be either
interpreted or skipped on redisplay.</p>

<p>However, even in a word processor or on a system with an extended
character set, there should be a way to view (and edit) a
&quot;pure&quot; binary file.  In order to view such a file, there
must be a standard representation for non-printing characters.</p>

<p>One representation is to show such characters in octal
(&quot;\###&quot;) or hexadecimal (&quot;\x##&quot;).</p>

<p>However, the most common representation -- and possibly the most
useful one -- is to show such characters in caret notation (for a
complete list of the caret notation, see Appendix E).  The easiest way
to define this notation is with a code excerpt:</p>

<pre>
	void Caret(char c)
		{
		if (c == NL) {
			...handle newlines...
			return;
			}
		if (c == TAB) {
			...handle tabs...
			return;
			}
		if (c &amp; 0x80) {
			Put_Char('~');
			c &amp;= 0x7f;
			}
		if (c &lt; SP || c &gt; '~') {
			Put_Char('^');
			c ^= '@'
			}
		Put_Char(c);
		}
</pre>

<p>When handling these multiple-character characters, your
implementation must be consistent.  For example, be sure that your
cursor-positioning code takes the extra characters into account. Your
implementation must also properly handle the case where such a
character spans a line boundary.  It doesn't matter which choice is
made here (<i>i.e.</i>, the choice is between splitting the character
at the boundary and moving the whole character to the next line), only
that your implementation handle it consistently and correctly.</p>

<a name="c7.3.8"></a><h3>7.3.8 Proportionally Spaced Text</h3>

<p>Once you have tabs and control characters down, displaying text in
a proportionally spaced font is not too difficult.  The main variation
is that you no longer assume that all printing characters are the same
width.  Instead, you look up the width of each one as you display it.
Actually, you can even support <i>kerning</i> by looking up each
consecutive pair of characters to decide how to handle them.</p>

<p>The main &quot;gotcha&quot; in supporting proportionally spaced
text is that one character no longer always exactly overwrites another
on the screen.  Thus, if you change an &quot;m&quot; to an
&quot;i&quot;, you have to figure out what to do with the extra width.
Fortunately most displays that handle proportionally spaced text
(mainly graphics displays) offer a high-performance primitive to
scroll a region of the screen.</p>

<a name="c7.3.9"></a><h3>7.3.9 Attributes, Fonts, and Scripts</h3>

<p>The next level of generality is the support of attributes, fonts,
and scripts.  Attributes include such modifiers as boldface, italics,
underscoring, and superscripting.  Fonts include the different
typefaces such as Times Roman and Helvetica.  Scripts include language
families such as European and Japanese.</p>

<p>With these, your support can be as complex as you wish.  Especially
when it comes to scripts, your time and energy are going to give out
long before you can provide support for all languages.</p>

<p>However, each one is fairly simple to handle.  The first step is to
store the attribute, font, and script information somewhere (see
Chapter 5).  The second step is to interpret that information.</p>

<a name="c7.3.10"></a><h3>7.3.10 Breaking Out Between Lines</h3>

<p>As was mentioned in the procedure interface definitions, the
redisplay process does not have to run to completion before editing
resumes.  Instead, it can get to a convenient spot and check for any
user input.  If input has arrived, the redisplay can be aborted
(&quot;broken out of&quot;) and the input processed.  It is important
to keep in mind that the purpose of redisplay is to provide feedback
to the user.  If the user has already typed something, there is no
immediate need for the feedback.  Hence, redisplay can be broken out
of and then restarted after the user's input has been processed.</p>

<p>In order to keep the amount of state information to a minimum, it
may make sense to not abort instantly, but instead to finish a current
chunk of redisplay (say, a line) before checking for input.  At the
minimum, you must keep track of how far along you had proceeded, so
that you don't wind up redisplaying your redisplayed text.</p>

<p>The presence of between-line breakout can affect how your redisplay
is done.  For example, if resources are tight, it may make sense to
start by redisplaying the line that the point is on, then to go on to
the other lines as you have time.  In that way, the information that
is most important to the user is the first to get updated.</p>

<p>Lest there be any doubt: between-line breakout is a very important
feature and should only be left out of the very simplest
implementations or those implementations that can complete even the
most complex redisplay in under 100 msec.</p>

<a name="c7.3.11"></a><h3>7.3.11 Multiple Windows</h3>

<p>Supporting multiple windows implies that the screen is divided into
sections, with each section showing a possibly different buffer or
part of the buffer. There are several ways that multiple windows can
be supported:</p>

<ul>
<li>Don't support them.  Instead, rely on the (presumed) operating
system ability to run multiple instances of the editor.  This is not
desirable because the different instances may not be able to
communicate quickly with each other.  For example, you may not be able
to &quot;cut&quot; from one window and &quot;paste&quot; into another.

<li>Support horizontal windows only.  Horizontal windows occupy the
entire width of the screen.  This is a good and popular choice.  It is
not too difficult to implement, yet it provides a large chunk of the
required functionality.

<li>Support both vertical and horizontal windows (tiled).  (Better)

<li>Support arbitrary overlapped windows.  (Best, and supported by
many windowing packages)
</ul>

<p>The main thing to keep in mind when implementing multiple windows
is that, when two or more windows contain the same text, changes made
to one should be immediately reflected in the other.</p>

<p>If you do support multiple windows, you can implement status and
prompt lines as buffers in themselves and simply fit them in as
additional windows to be displayed.  In this way, you no longer have
to consider them as special cases.</p>

<a name="c7.4"></a><h2>7.4 Redisplay Itself</h2>

<p>The basic role of redisplay is to ensure that all changes to the
sub-editor are promptly reflected on the screen.  Two major approaches
are used by implementors to performing redisplay.</p>

<pre>
				   -----------------
				   | user commands |
				   -----------------
				     /		 \
				    /		  \
				   v		   v
			--------------		-------------
			| sub-editor |		| redisplay |
			--------------		-------------

				     First Approach
</pre>

<p>The first approach is for the routines which are invoked by the
user to tell the redisplay code exactly what they did (<i>e.g.</i>,
&quot;I deleted 5 characters from here&quot;).  This approach is not a
very clean one and it is prone to error, as the same information must
be given twice (once to the sub-editor and once to redisplay), and
hence an implementation must handle the situation where the two sets
of instructions are not consistent (<i>e.g.</i> the application tells
the sub-editor to delete a line but tells redisplay to insert a line).
This is an especially important consideration because we would like to
encourage novice users to write their own commands.  The extra effort
of getting the redisplay correct might discourage such efforts.</p>

<pre>
				   -----------------
				   | user commands |
				   -----------------
				     /
				    /
				   v
			--------------		-------------
			| sub-editor |&lt;--------&gt;| redisplay |
			--------------		-------------

				     Second Approach
</pre>

<p>The second -- and preferred -- approach is to have the redisplay
code communicate with the sub-editor to track the changes.  This
approach also has two methods of operation.</p>

<p>The first method (which might be called
&quot;sub-editor-driven&quot;) is to have the sub-editor calls
communicate directly with the redisplay.  For example,
<b>Insert_Char</b> would make a call to display saying, &quot;I
inserted this character at this place.&quot; The second method (which
might be called &quot;redisplay-driven&quot;) is to have the redisplay
operate on its own and ask the sub-editor for information.</p>

<p>The sub-editor-driven method appears to be simple to implement, but
upon closer examination turns out to be quite complex.  This
complexity arises for several reasons.</p>

<p>First, the desirable operations for a sub-editor to offer (as shown
in the sub-editor procedure interface definitions) do not match well
to the available operations on displays.  Hence, the redisplay code
will have to perform this conversion.  An example would be deleting a
line.  The code to perform the delete might be:</p>

<pre>
	void Delete_Line(void)
		{
		mark_name beg;

		Find_First_In_Backward(NEWLINE);/* to start of line */
		if (Mark_Create(&amp;beg) != OK) return;

		Find_First_In_Forward(NEWLINE);	/* to end of line */
		Point_Move(1);			/* skip over newline */

		Copy_Region(kills, beg);	/* save in kill buffer */
		Delete_Region(beg);		/* gone */

		Mark_Delete(beg);
		}
</pre>

<p>The sub-editor operation is &quot;delete a region&quot; and the
region just happens to contain a line.  <i>Somebody</i> has to examine
the region to determine that it contains a line and that a
&quot;delete line&quot; call to the display <i>might</i> be the
correct one to use.</p>

<p>Second, the redisplay code will have to filter the sub-editor
operations (and subsequent directives) that happen outside the
window.</p>

<p>Third, every change made in the buffer does not necessarily imply a
change in the display.  For example, if the buffer contains the
text:</p>

<pre>
	Here is a line.
	Here is a line.
	Here is a line.
	Here is a line.
</pre>

<p>and the first line is deleted, the following lines do not in fact
change.  That particular case may be rare, but the following happens
fairly often:</p>

<pre>
	Here is line 1.
	Here is line 2.
	Here is line 3.
	Here is line 4.
</pre>

<p>In this case, the &quot;Here is line &quot; strings should not be
redisplayed.</p>

<p>Fourth, the change might be no change at all.  For example, the
&quot;lower case region&quot; command applied to the text:</p>

<pre>
	Most people believe the Unicorn to be a mythical animal.
</pre>

<p>might have in its inner loop:</p>

<pre>
	Replace_Char(tolower(Get_Char()));
	Point_Move(1);
</pre>

<p>This would have the effect of telling redisplay 56 times that a
character had changed, when in fact only two of those characters were
changed.  One might argue that the <b>Replace_Char</b> routine could
check to see whether the new character was in fact different before
informing redisplay, however:</p>

<ul>
<li>You haven't gained anything, just changed who is doing the checking.
<li>The inner loop could have been written:
</ul>

<pre>
			c = Get_Char();
			Delete(1);
			Insert_Char(tolower(c));
</pre>

<p>The most telling reason for not using the sub-editor-driven method,
however, is more fundamental.  The sub-editor's responsibility is to
handle the buffer, not redisplay.  It is the redisplay's
responsibility to handle the redisplay function.</p>

<p>The algorithms presented in the remainder of this chapter
illustrate the basic algorithms.  They do not handle all possible
error cases, nor do they handle many of the options listed above, such
as variable width characters, line wrap, between-line breakout, and
others.</p>

<a name="c7.4.1"></a><h3>7.4.1 The Framer</h3>

<p>The framer is that part of the redisplay code that decides what
part of the buffer will appear in the window.  The redisplay code
maintains two marks, one at the top of the window and the other at the
bottom.  The algorithm is fairly simple.  Here it is:</p>

<pre>
	int num_lines_window;	/* the number of lines in the window */
	int point_pct;		/* the preferred percentage */

	void Framer(void)
		{
		mark_name saved;
		location new_start_loc;
		int cnt;

			/* remember where we started */
		if (Mark_Create(&amp;saved) != OK) {
			Fatal(&quot;can't create mark for redisplay&quot;);
			}

		Find_First_In_Backward(NEWLINE);
			/* count at most one window's worth of lines */
		for (cnt = 0; cnt &lt; num_lines_window; cnt++) {

				/* stop at the start of the window */
			if (Is_Point_At_Mark(top_of_window)) break;

				/* stop at the start of the buffer */
			if (Compare_Locations(Buffer_Start, Point_Get) &gt;= 0)
				break;

				/* record where a fresh screen would start,
				just in case we need it */
			if (cnt == point_pct * num_lines_window)
				new_start_loc = Point_Get();

			Point_Move(-1);
			Find_First_In_Backward(NEWLINE);
			}

			/* has the window moved? */
		if (cnt &gt;= num_lines_window)
			Mark_Set(top_of_screen, new_start_loc);

		Point_To_Mark(saved);
		Mark_Delete(saved);
		}
</pre>

<p>In essence, the algorithm followed by this routine is: &quot;so
long as the point would still wind up in the window, leave the start
of window unchanged.  If the point would not wind up in the window,
place it at the preferred percentage.&quot;</p>

<p>This version of the algorithm assumes that a buffer line will
always occupy exactly one window line and that all buffer lines are
the same height.</p>

<a name="c7.4.2"></a><h3>7.4.2 The Basic Algorithm</h3>

<p>The basic redisplay algorithm is as follows:</p>

<pre>
	int num_lines_window;	/* the number of lines in the window */
	int num_chars_window;	/* the number of characters in the
				window (its width) */
	char window[MAX_ROWS][MAX_COLS];	/* window contents */	

	void Redisplay(void)
		{
		mark_name saved;
		int row;
		int col;
		int i;
		int point_row;
		int point_col;
		char c;

			/* remember where we started */
		if (Mark_Create(&amp;saved) != OK) {
			Fatal(&quot;can't create mark for redisplay&quot;);
			}

		Framer();
		Point_To_Mark(top_of_window);

			/* loop over the whole window */
		for (row = 0; row &lt; num_lines_window; row++) {
			for (col = 1; col &lt; num_chars_window; col++) {

/* save the coordinates of the point so that we can put the cursor
there later */

				if (Is_Point_At_Mark(saved)) {
					point_row = row;
					point_col = col;
					}

				c = Get_Char();
				if (c == NL) {	/* at a newline? */

/* check whether the rest of the window line is blank.  if it is not, clear it */
					for (i = col; i &lt; num_chars_window; i++) {
						if (window[row][i] != SP) {
							Set_Cursor(row, i);
							CLEOL();
							memset(&amp;window[row][i], SP,
								num_chars_window - i);
							}
						}
					}

/* no newline, so has there been a change in the sub-editor? */

			else if (window[row][col] != c) {
				Set_Cursor(row, col);
				Put_Char(c);
				window[row][col] = c;
				}
			Point_Move(1);
			}
		}

/* clean up */

		Mark_To_Point(bottom_of_window);
		Set_Cursor(pointrow, pointcol);

		Point_To_Mark(saved);
		Mark_Delete(saved);
		}
</pre>

<p>The preceeding code shows your basic, garden variety redisplay
algorithm.  It will work on any screen that supports cursor
positioning (the <b>CLEOL</b> call can be simulated by sending Space
characters).  It will work quite well on communications channels
running at 4800 bps or over.  Its only memory requirements are an
array large enough to hold the window (typically 1920 characters).
There are no special redisplay &quot;hooks&quot; in the sub-editor
management code.</p>

<p>This algorithm is sufficient (and nearly optimal) in those cases
where CPU and memory are plentiful and the screen does not perform
insert/delete line or character operations.  If memory is tight, the
algorithm can be modified to only retain a complete copy of the
current line.  If you must be prepared to emulate the <b>CLEOL</b>
operation, it may be worthwhile to record the last non-blank column in
each screen line.  Doing so minimizes the number of Space characters
that must be sent.</p>

<a name="c7.4.3"></a><h3>7.4.3 Sub-Editor Interaction</h3>

<p>The basic algorithm can be sped up tremendously if some
redisplay-specific hooks are placed into the sub-editor.  There are a
number of different ways that the hooks can be introduced.  All of
these methods track the changes made to the buffer in one way or
another.</p>

<p>The first way is to keep a separate modification flag that tells
whether any changes were made to the buffer since the last redisplay.
If no changes were made, then redisplay will consist of either a
simple cursor motion or a complete screen regeneration.</p>

<p>The seond way, and much more useful, is to keep the modification
flag on a per-window-line basis.  A general interface to accomplish
this that works with all sub-editor implementation schemes is to
define a third type of mark, called a <i>window mark</i>.  This mark
has a flag associated with it.  There is one window mark for each line
in the window.  Just after a redisplay has been completed, all the
flags for all window marks are clear.  Each time the sub-editor
changes any of the buffers' contents, it sets the flag on the window
mark that is located before and closest to the change.  The redisplay
code can examine the flags.  Only window lines that have their
corresponding window marks set need to be examined closely during
redisplay.</p>

<p>Note that window marks need not be located at the start of a buffer
line.  If lines are being wrapped, one will be at each wrap point.  If
horizontal scrolling is being performed, one may be at the start of
the buffer line and another at the right edge of the window.  In this
way, changes made to the right of the window won't cause the redisplay
code to examine unchanged text.</p>

<p>This interaction is easy to define and implement in the sub-editor.
It is inexpensive to implement as the marks have to be examined for
updating anyway.  It is also highly effective at reducing CPU
overhead, as most commands change only a single line.  And, although
redisplay has to examine the flags for every line, most of the time
only one or two will show changes..</p>

<p>A third way is to associate a unique identifier with each window
mark instead of a flag.  This identifier would be changed by the
sub-editor whenever the associated text changes (<i>i.e.</i>, instead
of setting a flag it changes the unique identifier).  Typically, the
identifier will be a 32-bit integer.  Whenever an identifier is
required, the current value of the integer is used and the integer is
incremented.</p>

<p>The only problem that can arise with using unique identifiers is if
a unique identifier is not in fact unique.  This problem can arise if
all 2^32 unique identifiers are consumed before all lines in the
window have changed.</p>

<p>Some sub-editors that use the linked-line scheme use the addresses
of line structures as the unique identifiers.  While doing so is space
efficient, the sub-editor must ensure that if a line is freed, the
address is not re-used until all windows have been completely
redisplayed.</p>

<p>Finaly, there is one more flag that can help redisplay a great
deal.  This flag is only useful if the point is located at the end of
a buffer line.  The flag would say whether any buffer modification
other than &quot;insert one or more characters&quot; has been
performed.  If the flag says not, all that redisplay needs to do is to
output those characters.  As this situation is very common, it can
save a significant amount of computation.</p>

<a name="c7.4.4"></a><h3>7.4.4 The Advanced Algorithm</h3>

<p>The advanced-redisplay algorithm has two improvements over the
basic algorithm.  First, it provides a way of efficiently taking
advantage of the insert/delete line and character functions which are
supplied with many screens. Second, it provides a low CPU overhead way
of performing a redisplay on basic displays.</p>

<p>The basic idea used by this algorithm is to assign a unique
identifier to each window line.  (See the preceding section.)  When
the redisplay encounters a modified line (the unique identifiers don't
match), it performs a pattern match on the unique identifiers for the
remainder of the window.  It then uses the information derived from
that match to determine the best sequence of insert/delete line
commands to issue to the screen.</p>

<p>In more detail, this algorithm loops over the window lines,
checking each saved unique identifier against the current identifier
returned by the sub-editor.  If they match, no work needs to be done
and the algorithm proceeds to the next line.  If they don't match, it
can be for one of three reasons.</p>

<p>The first reason could be that an additional line or lines were
inserted between the two window lines.  This condition is detected by
comparing the window-line unique identifier against the rest of the
unique identifiers returned by the sub-editor and finding a
match. (Remember that the window-line unique identifiers are the
unique identifiers returned by the sub-editor one redisplay iteration
ago.)  The insertion case is where we once had lines:</p>

<pre>
	AB
</pre>

<p>and now have:</p>

<pre>
	ACB
</pre>

<p>We determine how many lines are in &quot;C&quot; (because we know
how far down we had to go to find a match) and tell the screen to
insert that many lines.  (If there is information after this window on
the screen, you will first have to delete that many lines from the end
of the window.)</p>

<p>The second reason could be that a line (or lines) was deleted.
This condition is detected by comparing the unique identifier returned
by the sub-editor for the next line against the unique identifiers of
the rest of the window lines and finding a match.  The deletion case
is where we once had lines:</p>

<pre>
	ABC
</pre>

<p>and now have:</p>

<pre>
	AC
</pre>

<p>We determine how many lines are in &quot;B&quot; (because we know
how far down we had to go to find a match) and tell the screen to
delete that many lines.  (If there is information after this window on
the screen, you will eventually have to insert that many lines at the
end of the window.)</p>

<p>The third reason could be that the line was changed.  This
condition is detected by comparing the unique identifiers of the
following window lines against the unique identifiers returned by the
sub-editor.  This case is either where we once had lines:</p>

<pre>
	ABC
</pre>

<p>and now have:</p>

<pre>
	ADC
</pre>

<p>or:</p>

<pre>
	ADE
</pre>

<p>In other words, neither the insertion condition nor deletion
condition was met. Knowing now that a line has been changed, the next
step is to determine exactly how the line has changed.</p>

<p>The algorithm starts by comparing the buffer line against the
window line and determining how many leading characters are in common.
(If the whole line is common, no changes need to be made to the screen
and the algorithm stops.)  For example, if the window line is:</p>

<pre>
	abcdef
</pre>

<p>and the buffer line is:</p>

<pre>
	abcxef
</pre>

<p>the two have three characters in common from the start.</p>

<p>The next step is to repeat the comparison, but work backwards
starting from the end.  The example strings have two characters in
common from the end.</p>

<p>The third step is to compare the line lengths.  If the two lines
are the same length, only the changed part in the middle needs to be
updated on the screen.  In the example strings, the lengths are the
same (six6).  This optimization can be done even on a basic
display.</p>

<p>If the two lines are not the same length (for example, the buffer
line is &quot;abcxyzef&quot;), the characters in the window line that
are replaced by characters in the buffer line can be rewritten (in the
example, the &quot;x&quot; replaces the &quot;d&quot;), then the
requisite number of characters can either be inserted or deleted and
the remainder of the changes written (insert two characters,
&quot;yz&quot;).  If there is no common text at the end of the line
and the buffer line is shorter than the window line, a <b>CLEOL</b>
call can be used instead of deleting characters.</p>

<p>Line wrap can pose a problem.  The window and buffer lines may have
no end text in common, and yet an insert or delete character operation
might be the appropriate one.  For example, consider the case where
the window width is six characters, the window line is
&quot;abcdef&quot;, and the buffer line is &quot;abcxdef&quot;.  Here,
the buffer line will ultimately become two window lines,
&quot;abcxde&quot; and &quot;f&quot;.  This case is detected by having
no common portion at the end and noticing that the line wraps.  A more
complicated matching process can detect the situation and appropriate
action can be taken.</p>

<p>This entire section considered only the (admittedly very common)
case where line and character insertions and deletions were only made
in one place.  It is very reasonable and appropriate to use more
general pattern-matching techniques to properly optimize multiple
insertions and deletions (Miller 1987).</p>

<a name="c7.4.5"></a><h3>7.4.5 Redisplay for Memory-Mapped Displays</h3>

<p>Redisplay for memory-mapped displays boils down to one of three
cases.  Each case is relatively simple.</p>

<p>First is the case where both reading from and writing to the screen
causes flicker.  The solution is to use the basic redisplay
algorithm.</p>

<p>Second is the case where reading does not cause flicker but writing
does.  The solution is to use the basic redisplay scheme, but change
it to use the actual window memory for storing the window array.</p>

<p>In the third case, neither reading nor writing causes flicker.  On
each redisplay cycle, merely copy the buffer text into window memory,
not forgetting to process new lines, etc., as needed.</p>

<a name="c7.q"></a><h2>Questions to Probe Your Understanding</h2>

<p>Define a set of editor procedures to handle vertical windows.
(Easy) Extend that set to handle overlapping windows. (Medium)</p>

<p>Implement the procedures that you just defined. (Hard)</p>

<p>Define a representations for the private data types mentioned here
(function keys, attributes, command times).  (one is Easy, all
together are Medium)</p>

<p>Identify the places where left-to-right, top-to-bottom biases are
built into the interface definitions.  English and European languages
have this bias. (Easy)</p>

<p>Rework the interface definitions to remove this bias and to be able
to handle all eight (yes, eight) combinations of
directions. (Medium)</p>

<p>Outlining is popular these days.  &quot;Outlining&quot; is the
ability to selectively skip over parts of the text during redisplay.
For example, one level might only display the chapter and section
titles.  Another level might include all titles and the first sentence
of each paragraph.  Identify how adding outlining would affect
redisplay.  (Medium)</p>

<p>Identify how the editor's redisplay algorithm changes when it makes
use of the UNIX <i>curses</i> library. (Hard)</p>

<p>How do the presence of ligatures and contextual forms used by
non-Roman languages affect cursor motion? (Medium)</p>

<p>What modifications to the redisplay algorithm are required to
handle ligatures or contextual forms used by non-Roman languages?
(Hard)</p>

<p><a href="#contents">Back to Contents</a>.</p>
<hr>
<a name="c8"></a><h1>Eight: User-Oriented Commands: The Command Loop</h1>

<blockquote><i>
He left it dead, and with its head<br>
&nbsp;&nbsp;He went galumphing back.
</i></blockquote>

<p>The previous two chapters described a way of dividing an
implementation into parts and covered the internal sub-editor and
redisplay.  This chapter describes the last part: the user-oriented
commands.  This last part is what gives the editor its
&quot;feel.&quot; It determines the overall command structure (the
syntax) and what each of the commands does (the semantics).</p>

<p>Command structure is a large enough topic to be divided into two
chapters.  This chapter describes <i>how</i> to implement the command
structure.  The next chapter covers command set design issues.  It
thus describes <i>what</i> commands should be implemented.</p>

<a name="c8.1"></a><h2>8.1 The Core Loop: Read, Evaluate, Print</h2>

<p>The command loop is built around a basic core.  This core reads in
commands, evaluates (or executes) them, and prints the results.</p>

<p><i>Reading commands</i> is the process of accepting user input and
determining what operations the user wishes to perform.</p>

<p><i>Evaluating commands</i> is the process of carrying out the
user's wishes.  In general, this is done by executing a series of
sub-editor calls.</p>

<p><i>Printing the results</i> is the redisplay.</p>

<p>The core loop looks like this:</p>

<pre>
	char c;

	while (1) {
		c = Key_Get();
		if (Evaluate(c)) break;
		Redisplay();
		}
</pre>

<p>This loop accepts user input (a single character), evaluates it,
exits (if the user has requested to quit the editor, causing
<b>Evaluate</b> to return True), and invokes <b>Redisplay</b>.  This,
like all program examples in this chapter, is a simplified version of
just one of the many ways you can implement these functions.  They are
meant as examples, not as limits.</p>

<a name="c8.1.1"></a><h3>8.1.1 The Evaluate Procedure</h3>

<pre>
	FLAG Evaluate(char c)
		{
		FLAG is_exit = FALSE;
		FLAG is_arg = FALSE;
		int arg = 1;

		while (!(*commands[c])(&amp;is_arg, &amp;arg, &amp;is_exit, c)) {
			c = Key_Get();
			Redisplay();
			}
		return(is_exit);
		}
</pre>			

<p>This is the core of the <b>Evaluate</b> routine.  The
<b>is_exit</b> flag records whether the command is one to exit the
editor.  The <b>is_arg</b> flag records whether the user has specified
a repeat-count argument.  The <b>arg</b> variable records the
repeat-count argument. </p>

<p>This routine -- and the editor implementation -- is built around a
set of command dispatch tables.  Each table is an array of pointers to
procedures, indexed by command characters.  Thus, the element:</p>

<pre>
	commands['a']
</pre>

<p>would specify the procedure to handle the command designated by the
&quot;a&quot; character.  These procedures all have the same
interface.  This interface is:</p>

<pre>
	FLAG Command_Procedure(FLAG *is_argptr, int *argptr,
		FLAG *is_exitptr, char c);
</pre>

<p>The first three arguments are <i>pointers</i> to the three state
variables.  They are pointers instead of the values so that the
command procedures can alter their values.  The fourth argument is the
character that is used to invoke the procedure.  The procedure returns
True if the command has completed, or False if the command is
incomplete.</p>

<p>The reasons for selecting this interface will be made clear through
four sample command procedures: &quot;move by character,&quot;
&quot;insert character,&quot; &quot;second-level dispatch,&quot; and
&quot;accept an argument.&quot;</p>

<a name="c8.1.2"></a><h3>8.1.2 Move by a Character</h3>

<p>This procedure moves forward by <i>arg</i> characters if <i>arg</i>
is positive or backward by <i>arg</i> characters if <i>arg</i> is
negative.  It looks like this:</p>

<pre>
	FLAG Move_by_Character(FLAG *is_argptr, int *argptr,
		 FLAG *is_exitptr, char c)
		{
		Point_Move(*argptr);
		return(TRUE);
		}
</pre>

<a name="c8.1.3"></a><h3>8.1.3 Insert a Character</h3>

<p>This procedure inserts <i>arg</i> copies of the character used to
invoke it.  If <i>arg</i> is negative, its absolute value is used.  It
looks like this:</p>

<pre>
	FLAG Insert_A_Character(FLAG *is_argptr, int *argptr,
		 FLAG *is_exitptr, char c)
		{
		int arg = *argptr;

		if (arg &lt; 0) arg = -arg;
		while (arg-- &gt; 0) Insert_Char(c);
		return(TRUE);
		}
</pre>

<a name="c8.1.4"></a><h3>8.1.4 Second-Level Dispatch</h3>

<p>This procedure doesn't implement a command itself.  Rather, it
accepts a second character and uses that to select a command from a
second dispatch table.  In this case, the &quot;^X&quot; character
will be used as the dispatch.</p>

<pre>
	FLAG Ctrl_X_Dispatch(FLAG *is_argptr, int *argptr,
		 FLAG *is_exitptr, char c)
		{
		char c;

		c = Delayed_Display(CTRL_X_DELAY, &quot;^X &quot;);
		return(*ctrl_x_commands[c])(is_argptr, argptr,
			is_exitptr, c));
		}
</pre>

<p>The <b>Delayed_Display</b> routine waits for a character and
returns it.  If more than a specified amount of time passes with no
input, the prompt string is displayed.</p>

<p>Note that this routine passes the arguments and exit status to and
from the second-level command routine.</p>

<a name="c8.1.5"></a><h3>8.1.5 Accept an Argument</h3>

<p>Again, this procedure doesn't implement a command itself.  Rather,
it performs one step of accepting a numeric argument.  For the
purposes of this example, we will assume that all digit characters
specify an argument and do not insert themselves.</p>

<pre>
	FLAG Argument(FLAG *is_argptr, int *argptr,
		 FLAG *is_exitptr, char c)
		{
		if (!*is_argptr) {	/* no arg yet */
			*is_argptr = TRUE;
			*argptr = 0;
			}
		*argptr = *argptr * 10 + c - '0';
		return(FALSE);
		}
</pre>

<p>This routine is the first one that does not completely execute the
command.  Rather, it modifies the state information that is passed to
the command procedure itself.</p>

<p>(Note: this routine does <i>not</i> implement the Emacs
&quot;universal argument&quot; command, but is a simplified version
for the purposes of this example only.  It actually performes
<i>vi</i>-style argument handling.)</p>

<a name="c8.1.6"></a><h3>8.1.6 Philosophy</h3>

<p>The loop as described puts few (theoretical) restrictions on the
command syntax.  Each character, in its raw form, is mapped to a
procedure which is in turn evaluated.  State information is passed to
and from this procedure, which can either update the state
information, perform an operation, or both.  Arbitrary syntax and
semantics can be implemented with this base.</p>

<p>In theory, a syntax of commands being words (<i>e.g.</i>,
&quot;delete,&quot; &quot;move,&quot; etc.) could be implemented in
this structure by having either a large number of dispatch tables (and
thus implementing a symbol-state table architecture) or a procedure
which parses the syntax of the command via conditional statements.  If
you really want to do one of these, you will want to invent your own
-- different -- internal structure.</p>

<a name="c8.1.7"></a><h3>8.1.7 A Minimalist Command Set Design</h3>

<p>Consider the thought that every character that is typed at the
keyboard causes a procedure to be executed.  The first conclusion that
results is that it is silly to type &quot;insert x&quot; or anything
like that when you want &quot;x&quot; to be inserted.  As this is a
very common operation, it makes more sense to bind the key
&quot;x&quot; to an &quot;InsertX&quot; function (or, more probably,
the <b>Insert_A_Character</b> procedure just defined).</p>

<p>This architecture binds all of the straight, printing ASCII
characters to commands that insert the character.  The remaining
things that can be entered from most keyboards are the control
characters, the delete key, and the break key.  These could be bound
to functions that implement a complex syntax, but why bother?  It is
not too difficult for users to learn even a large number of key
bindings, so let us bind the control keys directly to useful
functions.  For example, ^F could be &quot;move forward a
character,&quot; ^D could be &quot;delete the following
character,&quot; and so forth.  Note that the &quot;break&quot; key
does not have an ASCII value and is therefore difficult to use without
writing operating system-specific code.</p>

<p>Thirty-three functions (the 32 control characters plus the Delete
character) are not enough for even the commonly used functions. Thus,
some of the keys should be bound to functions which temporarily rebind
the dispatch table.  For each of these rebinding functions, 128 new
functions are made available (there is no reason for the printing
characters in those second-level tables to be bound to &quot;self
insert&quot;).</p>

<p>Thus, even though we began with a structure for the command loop
that did not impose any constraints on the syntax of commands (and
thus was as general as possible), we arrived at a specific syntax for
commands.  This syntax is to bind the printing characters to
&quot;self insert,&quot; bind the control characters to a mixture of
useful functions and second-level dispatch tables, and to have three
or four alternate dispatch tables (enough to supply many hundreds of
commands).  Thus, commands are rarely more than two keystrokes long.
The price that is paid for this brevity is a possibly longer time
learning to use the editor effectively.</p>

<p>Note that most of the increased time spent learning the editor is
<i>not</i> from the brevity of the commands, but because there are
more commands to learn.  Given a &quot;conventional&quot; editor of
some other command set design (<i>e.g.</i>, insert/replace modes or
command lines) and an equivalent subset of this &quot;minimalist&quot;
editor, learning times will probably be comparable when the same
number of commands from each are covered (assuming sensible command
assignments in both cases).</p>

<a name="c8.2"></a><h2>8.2 Errors</h2>

<p>There are two main types of errors: internal and external.
Internal errors are those that occur in the editor itself.  Examples
are a subscript being out of range and division by zero. External
errors are those that are caused by the user.  Examples of these are
an attempt to delete off the end of the buffer.  There are also
&quot;non-error&quot; errors, such as a normal exit condition.  Errors
can be detected both from within the editor and from outside the
editor (for example, by the operating system).</p>

<a name="c8.2.1"></a><h3>8.2.1 Internal Errors</h3>

<p>Internal errors will be considered first.  These errors cause an
immediate exit to the operating system with no questions asked and no
delays tolerated.  They will be internally generated by such things as
arithmetic overflows and bad subscripts. (While the editor might catch
and process some of these, it will not in general process them all.
This section only discusses the non-processed ones.)  These errors are
unpredictable and the state of the editor should remain intact.</p>

<p>The user should also be able to signal such an error to abort out
of the editor.  He or she might want to do this signaling because of a
problem with the editor itself (<i>e.g.</i>, infinite loop) or because
he or she wants to do something else (<i>e.g.</i>, suspend this
process and do another task).  This signaling is usually done with the
help of the operating system.  In any case, the precise state of the
editor should be retained so that it can be resumed exactly where it
left off.  Most operating systems have some facility for doing this;
they differ principally in the freedom of action that they allow
before losing the state.  This freedom ranges from nothing to doing
arbitrarily many other things.</p>

<p>At the user's discretion, the editor should be restartable either
from exactly where it left off or at a safe restart point.  This point
is ordinarily a portion of the editor which recovers the buffers and
other current state information and then resumes the command loop.
Note that in many implementations, the editor must perform actions
both on the process suspension and when it resumes.  These actions
must handle saving and restoring the state, restoring and saving the
display modes, and taking note of any changes in the environment, such
as a window resizing.</p>

<a name="c8.2.2"></a><h3>8.2.2 External Errors</h3>

<p>External errors are principally user errors.  The action ordinarily
taken is the display of an error message and a return to command
level.  The implementation of this level of recovery is built into the
procedures which implement the commands.</p>

<p>There is a variation of external errors which are generated
manually by the user.  Typically, these involve backing out of an
undesired state (<i>e.g.</i>, the unwanted invoking of a dispatch
table rebinding or aborting an undesired argument).  The ^G character
has often been used for this purpose.  In this case, the procedures
will know that this character has been typed and will implement the
back-out protocol.</p>

<a name="c8.2.3"></a><h3>8.2.3 Exiting</h3>

<p>Finally, provisions to exit the editor must be made.  These
provisions often take the form of a flag variable such as the
<i>is_exit</i> variable described earlier.</p>

<p>Note that various other uses might be multiplexed onto this flag,
signifying varying levels of &quot;exiting.&quot; For example, one
level could be used by buffer switching in order to rebind the
dispatch tables (see the section on modes later in this chapter).
Alternatively, the different functions could use multiple flag
variables.</p>

<p>Ordinary exiting involves several types of processing.  The editor
might ask the user what to do with buffers that have been modified but
not written out.  If, as is ordinarily assumed, the state of the
editor is preserved across invocations, the state must be saved.  If
not, it must be sure that all memory is deallocated.  Finally, the
user's environment should be restored as it was found.  This implies
such varied things as cleaning up the stack, closing files,
deallocating unneeded storage, and resetting terminal parameters.</p>

<a name="c8.3"></a><h2>8.3 Arguments</h2>

<p>Arguments are specified by the user to modify the behavior of a
function.  The Emacs argument mechanism will be described as an
example of three diverse ways in which arguments are obtained.</p>

<p>There are three standard argument types.  First are numeric
(prefix) arguments.  These are invoked by a string of functions (which
are in turn invoked by characters typed before the &quot;actual&quot;
command character) and are an example of using the key/function
binding to implement a more complicated syntax.  Next are string
(suffix) arguments.  When obtaining a string argument, the editor is
invoked recursively on an argument buffer, and upon return from the
recursive invocation the contents of that buffer are given to the
requesting procedure.  Last are positional arguments.  These are the
internal variables of the editor.</p>

<a name="c8.3.1"></a><h3>8.3.1 Numeric (Prefix) Arguments</h3>

<p>Prefix arguments are entered before the command whose behavior the
arguments are modifying, thus, their syntax does not depend upon the
command.  The interpretation of prefix arguments can vary from command
to command. Emac type editors limit these arguments to numeric
values.</p>

<p>Ordinarily, commands will have an internal variable available to
them named something like <i>arg</i>, and it will have a value of one.
Prefix arguments allow the user to change that value to any other
positive or negative integer.  It is useful to provide a mechanism for
command procedures to determine whether an argument has been given at
all.  This mechanism allows the procedures to handle the default case
where no arguments are supplied differently than the case where an
argument is supplied.</p>

<p>Each command uses arguments for different, but related,
purposes.</p>

<p>The first purpose is to specify a repeat count for a command.
Thus, specifying an argument of &quot;12&quot; to the &quot;forward
character&quot; command would cause the command to move forward 12
characters.</p>

<p>The second purpose is to tell a command to use a specific value.
For example, it doesn't make sense to say &quot;move to the end of the
buffer&quot; 12 times.  Instead, that command might interpret its
argument as a line number and move to the specified line of the
buffer.  In this case, the &quot;default&quot; value would be the (end
of the) last line.</p>

<p>An Emacs-type text editor uses the ^U character as the
&quot;universal argument&quot; function.  It can be used in either of
two ways.  ^U <i>command</i> means to supply an argument of
&quot;4&quot; to command.  Adding another ^U means to multiply the
current argument by four.  Thus, ^U ^U ^U <i>command</i> means to
supply an argument of 64 to the command.  The factor of 4 was selected
because 5 is too large (1, 5, 25, 125 goes up too fast) and, while 3
might have better spacing (1, 3, 9, 27, 81, 243), the powers of 4 are
known by all people who are likely to be around computers.  In
addition, on a 24 x 80 display, 64 is about the number of characters
per line and 16 is 2/3 of the screen height.</p>

<p>The other use is to specify a value exactly.  ^U <i>number</i>
<i>command</i> means to supply an argument of <i>number</i> to the
command.  For example, ^U - 1 4 7 <i>command</i> means to supply an
argument of -147 to the command.  The ^U in this case serves as an
&quot;escape&quot; to logically rebind the digit and &quot;-&quot;
keys.  If you want to supply an argument to the commands normally
invoked by the digit and '-' characters, you use the quote command,
located on ^Q.</p>

<p>On some terminals, there are two sets of numeric keys.  One set is
across the top row and always sends the ASCII code for the
corresponding digit character.  Another set may form a numeric pad and
its keys can be configured to send either the ASCII codes for the
digit characters or different codes.  In this case, these &quot;other
numbers&quot; can be bound directly to functions that set up the
implied arguments and the initial ^U is not needed.</p>

<a name="c8.3.2"></a><h3>8.3.2 String (Suffix) Arguments</h3>

<p>Numeric arguments are made available in the same way to all
commands.  Suffix arguments, however, must be explicitly requested by
the commands that use them.  A command may also request multiple
suffix arguments.  Most suffix arguments are for strings, not
numbers.</p>

<p>The program notifies the user of the string argument by displaying
a prompt.  This prompt indicates the type of argument that is
requested.  The user responds by entering the value up through and
including a terminating character.  The command then proceeds to
execute, using the value in whatever way is appropriate.</p>

<p>The following points should be taken into consideration regarding
string arguments.</p>

<p>First, the prompt should clearly state what is being asked for --
for example, &quot;Name of the file to be read.&quot;</p>

<p>Second, the key or key sequence used to terminate the end of the
string should be able to vary and should be indicated in the prompt --
for example, &quot;Name of the file to be read (Return): &quot; or
&quot;String to search for (ESC): &quot; There should be a way to
cleanly abort out of the prompt and its requesting command.  This
should be the same command used for the &quot;abort&quot; command
(<i>e.g.</i>, ^G).  </p>

<p>Third, in order to facilitate the abort process, the command should
<i>first</i> ask for all user input, and only <i>then</i> perform any
actions.  This organization means that any abort will result in no
effect rather than leave inconsistent state information.</p>

<p>Each command that requests a string prompt should provide a default
value for the prompt.  This value should be used if the user enters a
null response.  The value should be the program's best guess about
what value the user would most likely want to enter.  If no other
guess is available, the last value entered should be used.</p>

<p>Here are some examples of string arguments:</p>

<ul>
<li>Search string: Ask for a string and search for the next occurrence
of it in the buffer. If the user enters a null string, use the same
string that was last entered.

<li>Write file: Ask for a string and, using it as a file name, write
the contents of the buffer to the specified file.  If the user enters
a null string, use the current file name associated with the buffer.

<li>Change buffer: Ask for a string and switch to the buffer whose
name is the user's response.  If the user enters a null string, use
the buffer that was last the current one (<i>i.e.</i>, the one that
the user was in before the one that the user is in now).  Note that
this default may <i>not</i> be the one whose name was last entered.
</ul>

<p>Here are some example prompts:</p>

<ul>
<li>Name of the file to write to (Return, default /home/fin/test):
<li>String to search forward for (ESC):
<li>Name of the buffer to switch to (^M, default chapter5):
</ul>

<p>While these examples were requesting a character string, this need
not always be the case.  For example, to enter numeric values, the
requesting procedure merely has to convert the read-in character
string to a numeric value.  An example of such a command would be a
&quot;go to line&quot; command.</p>

<p>One way to implement the routine that accepts string arguments is
to use a variation of the <b>Get_Line</b> routine defined in the
Introduction.  However, a better way to implement this routine is to
create an argument buffer in a new window, display a prompt, and call
the editor recursively with that as the current buffer.  By following
this scheme, the full power of the editor is available to correct
typing mistakes or otherwise make the entry process easier.  It has
the additional advantage of not creating a new &quot;mode&quot;: the
user is free to continue editing while responding to the prompt.</p>

<p>Further, the full power of the editor can be brought to bear on a
problem.  For example, suppose that someone sends you a mail message
that says &quot;the answer is in file X.&quot; While reading the mail
message, you give the &quot;find file&quot; command.  This command
prompts you to enter a file name.  You switch buffers (from the prompt
buffer to the mail message buffer), copy the file name, switch back,
and paste it into the prompt, then type the prompter terminator.
<i>Voila</i>!  A fully integrated, modeless environment.</p>

<p>Finally, the prompts need not be &quot;lifeless&quot; and
&quot;passive.&quot; A passive prompt just accumulates the input until
complete, then passes it back as a block.  It has no interaction.  A
&quot;lively&quot; and &quot;active&quot; prompt offers interaction
with the user.  For example:</p>

<ul>
<li><b>Searching</b>: The search can be <i>incremental</i>, with the
search proceeding as the user types.
<li><b>File names</b>: The program can offer <i>file name
completion</i>, where the user can enter a prefix, press a key, and
the program fills in as much of the file name as possible.  A
different key might display a list of all file names that match what
has already been typed.
</ul>

<a name="c8.3.3"></a><h3>8.3.3 Positional Arguments</h3>

<p>Positional arguments are not directly specifiable by the user. They
are the editor's internal state variables. Such variables include both
those required by the editor (<i>e.g.</i>, the length of the buffer,
the locations of the point and the mark, etc.) and those which have a
specialized purpose (<i>e.g.</i>, the current value of the right-hand
margin, the tab spacing, etc.).</p>

<p>Often these values are used in unusual ways.  For example, the
horizontal position (column) of the point can often be a more pleasant
way of specifying a value than entering a number.  The user can
indicate that &quot;this is where I want the right margin to be&quot;
instead of having to count characters to get a number.</p>

<p>A specialized positional argument is the <i>region</i>.  This is
the range of text delimited by the point and the mark.  By convention,
it does not matter whether the point or the mark is placed earlier in
the buffer.</p>

<a name="c8.3.4"></a><h3>8.3.4 Selection Arguments</h3>

<p>The use of graphical input devices opens up new ways of issuing
commands and specifying arguments.  For example, the cursor can be
moved by a graphical input device as well as the more traditional
point-motion commands.  In addition, a region can be specified by a
&quot;click and drag&quot; operation (or whatever sequence is used by
the operating system).</p>

<a name="c8.4"></a><h2>8.4 Rebinding</h2>

<p><i>Binding</i> is the act of connecting a name and a meaning,
<i>rebinding</i> the act of changing the binding.  In the case of
editors, there are two different levels that binding (and rebinding)
can occur on.</p>

<p>The first is at the key level.  Binding in this case mean attaching
an operation to a key. These bindings are often implemented by means
of a dispatch table.</p>

<p>The second is at the function level.  Binding in this case means
attaching a procedure to an operation.  Again, these bindings are
often implemented by means of a dispatch table.</p>

<p>For example, the alphabetic keys may be bound to the
&quot;insert&quot; operation.  This operation, in turn, can be bound
to a variety of procedures:</p>

<ul>
<li>The basic &quot;insert a character&quot; procedure.
<li>The basic procedure, but one that saves a copy of the buffer every
so often.
<li>The basic procedure, but one that performs word wrap (by inserting
hard newlines, not in redisplay).  This is often called something like
&quot;fill mode.&quot;
<li>A different basic procedure, say one that performs replacement
(overwrite) instead of insertion.
</ul>

<p>Implementations can perform at one of two levels of rebinding:
static and dynamic.  Static rebinding is when the new procedure is
known about at the time that the editor is invoked.  All
implementations can perform this level of rebinding.  Dynamic
rebinding is possible when the new procedure can be defined after the
editor is invoked.  Unless otherwise stated, this discussion assumes
dynamic rebinding.</p>

<p>To a first approximation, editors that are written in compiled
languages (<i>e.g.</i>, C and Pascal) can only perform static
rebinding, and editors that are written in interpreted languages
(<i>e.g.</i>, Lisp) can also perform dynamic rebinding.  Dynamic
linking, however, allows compiled editors to include new procedures at
run time, and so this distinction is not always a proper one to make.
Dynamic bindings are also possible when a compiled language is used to
implement an interpreted language, which in turn implements at least
the user command portion of the editor.</p>

<a name="c8.4.1"></a><h3>8.4.1 Rebinding Keys</h3>

<p>The process of key rebinding is relatively simple and is done
essentially the same way in all implementations.  A set of dispatch
tables is used to map keys (represented by their ASCII values) to
their respective functions.</p>

<p>In languages such as C and Lisp, the table can contain the pointer
to the procedures themselves.  In less powerful languages such as
Fortran and Pascal, the dispatch table branches to a different part of
the same routine that contains the table.  There, the procedure call
is made.  In languages that supply it, a case statement can be used
instead of the n-way branch.</p>

<p>All of these command procedures have the same formal parameters,
and so they can all be invoked with the same calling sequence.  Thus,
the C and Lisp direct invocations can work properly.  Note also that
simple commands do not have to have a separate procedure assigned to
them, but the code to execute them can be placed in-line in place of a
call (where the case-statement equivalent is used).  Making this
substitution loses some potential flexibility.</p>

<a name="c8.4.2"></a><h3>8.4.2 Rebinding Functions</h3>

<p>Dynamic rebinding is ordinarily a language-supplied feature and so
it will not be discussed in depth.  Two comments will, however, be
made on how to simulate it.</p>

<p>If the underlying operating system has dynamic linking
(<i>e.g.</i>, Multics, OS/2, and some new UNIX systems), a procedure
may be rebound at run time.  Dynamic linking is a way of linking
procedures together in which the actual link is not made until the
procedure is about to be executed.  At that time, the procedure is
located in the file system and brought into memory.  The link may
either be left alone, in which case the next call will have the
procedure re-located (a relatively expensive process) or it may be
<i>snapped</i>. Snapping a link is the process of converting the
general call instruction (which is kept in a special, writeable part
of the program) into a call instruction to the appropriate address.
If a link is snapped, it must be explicitly unsnapped before any
rebinding is done.</p>

<p>If the operating system does not support dynamic linking, you might
choose to simulate it manually.  Such a process is complex, and some
thought will have to be given to the desirability of rebinding
functions.  The process is tantamount to explicit overlaying.</p>

<p>This all has a straightforward bearing on rebinding
functions. Rebinding a function involves changing the definition of
the procedure that is invoked by referencing it.  What has been
discussed are ways of changing such a procedure definition.  Note that
if the code to execute a function is inserted in-line in the basic
editor, it cannot be rebound by any of these methods.</p>

<p>If dynamic linking is not available and is not feasible to
simulate, there is still one way out.  This way will only provide
static rebinding.  Instead of just using one dispatch table which
indicates a procedure to be called directly, use two.  Use use the
first table to map from keys to the operation to be performed
(<i>e.g.</i>, ^F is mapped to &quot;moving forward one
character&quot;) and the second table to map from the operation to be
performed to a procedure that will perform it (<i>e.g.</i>,
&quot;moving forward one character&quot; is mapped to the
<b>Forward_Char</b> procedure).</p>

<a name="c8.5"></a><h2>8.5 Modes</h2>

<p>A <i>mode</i> is a collection of command rebindings. Modes can be
invoked implicitly, explicitly, or automatically.</p>

<p>An <i>implicitly</i> invoked mode is one that is not visible to the
user.  Implicit modes are used to support large, infrequently used
commands.  For example, suppose that you had an editor command that
played the game Adventure.  You probably wouldn't want the code for
that command to be occupying resources whenever you were using your
editor for editing. However, you might still want to make your
&quot;adventure&quot; command available at all times.  In this case,
you would use an implicit mode.  The &quot;adventure&quot; command
would then take these steps:</p>

<ul>
<li>Load the modules that implement the command.
<li>Rebind the key that invoked the &quot;adventure&quot; command to
run the new code.
<li>Run the code the first time.
</ul>

<p>From now on, whenever the user gives the &quot;adventure&quot;
command, the editor will directly execute that code.</p>

<p>An <i>explicitly</i> invoked mode is one that the user asks to use.
Examples of such modes are &quot;auto fill&quot; mode, &quot;auto
save&quot; mode, and alternate command sets.  The common element is
that the user gives a command, knowing that that command itself has no
function other than to persistently alter the key bindings.</p>

<p>An <i>automatically</i> invoked mode is one which the
implementation determines is appropriate to invoke, based on a command
given by the user that &quot;appeared&quot; to do something else.</p>

<p>One example of an automatically invoked mode is a language mode
(for example, a &quot;C&quot; mode). This mode will automatically be
invoked whenever the user edits a C source file (by convention, one
whose name ends in &quot;.c&quot; or &quot;.h&quot;).  Such a mode
might do the following:</p>

<ul>
<li>Rebind the internal variable that identifies which characters are
legal in tokens (<i>i.e.</i>, variable names) to also include the
&quot;_&quot; character, which can occur within C names.  This change
would make the <b>Forward_Word</b> function treat a C variable name as
a word.

<li>Similarly rebind the sentence and paragraph operations to operate
on statements and language blocks.

<li>Rebind the &quot;;&quot; key to be an &quot;electric&quot;
semicolon so that typing a &quot;;&quot; to finish one statement would
cause the editor to determine and insert the appropriate indentation.

<li>Similarly rebind the Tab, Return, and Line Feed keys.

<li>Replace the &quot;fill&quot; or &quot;reformat&quot; paragraph
command with one that &quot;prettyprints&quot; the current language
block.
</ul>

<p>And so forth.  Another example of an automatically invoked mode is
the specialized mode that the editor places you in when executing such
commands as &quot;help,&quot; &quot;read mail,&quot; and &quot;view a
directory.&quot; In these commands, the user is effectively placed in
a specialized application that shares as much as possible with the
regular editor commands, but does have its own extra commands.  For
example, in the &quot;view a directory&quot; application, the
&quot;d&quot; key might delete a file, the &quot;r&quot; key might
rename a file, and so forth.  However, the &quot;buffer&quot; or
&quot;window&quot; switch command should still be available so that
the user can perform other editing while the special application is
active.</p>

<a name="c8.5.1"></a><h3>8.5.1 Modes and Dynamic Rebinding</h3>

<p>The function rebindings that are commonly done by an editor are
known in advance and so they can be done by any implementation (see
the preceding section for a discussion of the difficulties involved in
function rebinding).  Fully dynamic rebinding (the new definition of
the procedure is not known until run time) is desirable for several
reasons:</p>

<ul>
<li>Debugging is greatly eased if the trial-and-error cycle time is
reduced by not having to compile and link the whole editor each time.
Instead, only one function has to be recompiled and linked.

<li>Space savings are achieved if unneeded modes and autoloaded single
functions are not brought into memory until called.

<li>If the editor is implemented in an interpreted language, users can
develop their own functions relatively easily.  Such
&quot;sideline&quot; development is advantageous because it allows
many people to develop useful programs.  Thus, the editor can be
specialized in many more ways than any reasonable support group could
ever implement on its own.  Implementation in an interpreted language
also encourages tailoring the editor to a user's own taste, enhancing
his or her productivity.
</ul>

<a name="c8.5.2"></a><h3>8.5.2 Implementing Modes</h3>

<p>Modes are defined on a per-buffer basis and so an implementation
must provide for changing these bindings as the current buffer is
switched.  The general technique for doing this is to have a set of
default bindings for the editor, a set of current bindings for each
buffer, and a set of procedures that can be invoked to change the
former into the latter.  When a buffer switch is made, the current
bindings are used to dispatch all commands.</p>

<p>Whenever a change to the mode list is made -- especially one that
removes a mode -- the editor must initialize the current bindings to
the default bindings, then invoke each mode procedure in turn to make
its changes.</p>

<a name="c8.6"></a><h2>8.6 Changing Your Mind</h2>

<p>This section discusses the methods used to help users who want to
change their minds about an editing command.</p>

<a name="c8.6.1"></a><h3>8.6.1 Command Set Design</h3>

<p>By far the most effective step that you can take is to design the
command set to minimize both state variables and changes of
perspective.  Such proper design is far more effective than any other
tool.  However, as these topics are covered in the next chapter and in
Chapter 1, they won't be discussed here.</p>

<a name="c8.6.2"></a><h3>8.6.2 Kill Ring</h3>

<p>The most basic way in which a user can change his or her mind is to
delete something, then say &quot;oops, I didn't want to delete
that.&quot; After all, if the user inserted extra text, deleting it is
easy and straightforward.  However, retyping accidentally deleted text
is in general neither easy nor straightforward.  Hence, an important
feature to provide is the ability to save that text for the user.
This feature can be added as a single-level save (referred to as the
<i>kill buffer</i>) or a multiple-level save (the <i>kill
ring</i>).</p>

<p>As an extra benefit, once the deleted text is saved, that feature
can be used for &quot;cut and paste&quot; operations.  In addition,
the saved text can be tied into the system &quot;clipboard&quot; or
similar facility.</p>

<p>An Emacs-type editor records multiple text-deletions in a
&quot;kill ring&quot; (for historical reasons, commands that save the
deleted text were called &quot;kill&quot; commands).  Some small but
fixed number of the successive deletions are stored together.  The
&quot;yank&quot; or &quot;paste&quot; command retrieves the last such
deletion (inserting it at the point).  Alternate &quot;yank&quot;
commands are available that cycle through the kill ring, re-deleting
the last-yanked text and replacing it with the next item.  (A ring is
better than a single kill buffer because it can store multiple
deletions.  It is superior to a stack of separate buffers because of
the ease with which various &quot;undeletions&quot; can be tried
out.)</p>

<p>It is easy to implement such a kill ring.  A buffer is designated
as the one to hold the deleted text and the commands that perform the
deletion simply copy the text that they are about to delete to that
buffer before performing the actual deletion.  There are two fine
points to the implementation.</p>

<p>First, successive deletion commands should add to the current
deletion, not create a new one.  Thus, the Emacs commands:</p>

<pre>
	^U ^[ d
</pre>

<p>which deletes the next four words, should have exactly the same
effect as:</p>

<pre>
	^[ d ^[ d ^[ d ^[ d
</pre>

<p><i>i.e.</i>, four successive &quot;delete word&quot; commands.  In
both cases, all four words should be part of the same deletion.</p>

<p>Second, your implementation must take care to delete properly.
Deleting <i>following</i> items (characters, words, sentences, etc.)
should add to the <i>end</i> of the deleted text.  Deleting
<i>previous</i> items should add to the <i>beginning</i> of the
deleted text.  Not coincidentally, all deletion commands in the
command set of Emacs-type editors are of the form &quot;delete
following...&quot; or &quot;delete previous...&quot; with the
exception of the &quot;delete current line&quot; command.  This
command must take the text from the point to the end of the line and
add it to the end of the deleted text, and take the text from the
point to the beginning of the line and add it to the start.</p>

<a name="c8.6.3"></a><h3>8.6.3 Undo</h3>

<p>The &quot;kill ring&quot; approach requires explicit support from
the user commands and provides considerable power, yet there are many
ways in which it does not make it easy for a user to change his or her
mind.  An &quot;undo&quot; facility is the most general way that you
help a user when he or she changes his or her mind.</p>

<p>In principle, an undo facility provides a mechanism for reversing
changes made by the user.  These effects can be as simple as moving
the point or inserting or deleting a character, or as complex as a
file write or global replace.</p>

<p>Note, however, that you may still want to provide the kill ring, as
it offers both one intuitive (if limited) type of undo, as well as
operations that undo cannot perform.  For example, you cannot
implement &quot;cut and paste&quot; with undo, except for the limited
case where you only want to paste the text exactly where you cut it
from!</p>

<p>Unlike the kill ring, which requires explicit support in the user
commands, the best place to provide support for undo is in the
sub-editor interface.  Note that this is in the interface, not the
sub-editor itself, although in general the undo facility will work
closely with the sub-editor.</p>

<p>The support works like this: each sub-editor procedure that makes
any change to a state variable or the buffer first makes a note of
what is to be changed, then records the pre-change value, then finally
makes the change.  For example, the <b>Point_Set</b> routine would
record &quot;the point is about to change,&quot; and the old (current)
location of the point.  It would then change the point's location.
Note that some procedures (such as the ones to delete a block of text)
must record arbitrarily large amounts of state information.</p>

<p>This type of recording allows you to back up as far as you like.
Since, in essence, each change to the state information is recorded,
all earlier states are recoverable by reversing each state change (in
reverse order, of course).</p>

<p>There is more to implementing undo than just recording state
changes, but the additional items are more icing than cake.</p>

<p>First, most undo commands operate on a user-command, not sub-editor
call, basis.  Thus you must also record when a new user command is
given.  Thus, each undo then undoes consecutive changes until it
reaches such a command marker.  In this way, even a complex global
replace can be undone.  Note that in general you will wish to have
repeated undo commands undo successively-earlier other commands.</p>

<p>Second, it probably makes sense to undo an entire consecutive set
of newly typed characters as a single command.</p>

<p>Third, the resources available to retain the undo information may
be limited.  This design minimizes that problem, as the
&quot;excess&quot; undo state can simply drop off the end.  The part
that is retained will still be consistent.</p>

<p>Fourth, the operating system may not support the undoing of
file-level operations or other commands.  In some cases, you can
simulate such undoing (say, by making a backup file), but in general
you will have to live with some limits to undo.  (Undoing a print
operation after the printing is complete is quite difficult.)</p>

<p>Fifth, state information is kept in places other than in the
sub-editor.  These other places must also be incorporated into the
undo facility.</p>

<a name="c8.6.4"></a><h3>8.6.4 An Undo Heresy</h3>

<p>Is undo a nice feature to offer?  Yes.  Is it vital to an editor?
Probably not.  Will adding it make a poorly designed editor into a
good one?  No.  Will it make such an editor acceptable?  Maybe.  As
was said earlier, the best way to help the user is with a good command
set design: it will minimize the need or desire for an undo.</p>

<p>While undo is a general-purpose facility that has good
applications, it is not clear that a text editor is one of them.  The
&quot;good design&quot; approach (using the Emacs command set as an
example) and the undo approach will now be compared in their approach
to moving around in text and deleting text.</p>

<p>Moving around in text is simply solving the problem &quot;I am at X
and I want to be at Y.&quot; The good design solution involves
translating this difference into a sequence of commands to move the
point from X to Y.  If a mistake is made in the process of
implementing the solution, the problem is merely restated to &quot;I
am at X' and I want to be at Y&quot; and it is re-solved.  The undo
solution differs by detecting the error (<i>i.e.</i>, deviation from
the intended solution), saying &quot;undo&quot; to put you back on the
original path, and proceeding.  Ordinarily this difference between the
two solutions is not very great.</p>

<p>If the user has accidentally moved a large distance (say, to the
start of the buffer), it becomes a little more difficult for the user
to recover his or her earlier position.  Emacs-type editors resolve
this issue by having the large-movement commands set the mark to where
you were. Thus, an interchange point and mark sequence will recover
from the error.  Keep in mind that almost all of the time, the user
does not care where the mark happens to be.</p>

<p>The two approaches are all but identical in the text deletion case.
On the one hand, accidentally-deleted text is recovered with a
&quot;yank&quot; command, and on the other hand, with an
&quot;undo&quot; command.</p>

<p>In conclusion, undo is a nice extra feature, but is no substitute
for a good design.</p>

<a name="c8.6.5"></a><h3>8.6.5 Redo</h3>

<p>Redo is the mechanism for undoing an undo.  Conceptually, the
record of undos is:</p>

<ol>
<li>most-recent command changes
<li>next-most-recent command changes
<li>next-next-most-recent command changes
<li>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;...
</ol>

<p>The first invocation of the &quot;undo&quot; command undoes #1.
The next invocation undoes #2, and so forth.  Redo redoes the most
recent undo, with repeated &quot;redo&quot; commands moving back up
the undo stack.  Let's look at an implementation:</p>

<pre>
	FLAG Undo(FLAG *is_argptr, int *argptr, FLAG *is_exitptr, char c)
		{
		if (undo_ptr == NULL) undo_ptr = last_command_undo;
		Undo_Command(undo_ptr);
		undo_ptr = Previous(undo_ptr);
		return(TRUE);
		}

	FLAG Redo(FLAG *is_argptr, int *argptr, FLAG *is_exitptr, char c)
		{
		if (undo_ptr == NULL)
			Error(&quot;No undo to redo&quot;);
		else {
			Redo_Command(undo_ptr);
			undo_ptr = Next(undo_ptr);
			}
		return(TRUE);
		}
</pre>

<p>and, in the main command loop:</p>

<pre>
	if (last_cmd != Undo &amp;&amp; last_cmd != Redo) undo_ptr = NULL;
</pre>

<p>The <b>Undo</b> procedure checks and, if it hasn't been called
&quot;recently,&quot; starts at the latest command.  It undoes the
command, then sets a pointer to point to the undo information for the
previous command.</p>

<p>The <b>Redo</b> procedure checks and, if <b>Undo</b> hasn't been
called &quot;recently,&quot; can't run, as there is no undo to redo.
Otherwise, it redoes the command and sets a pointer to point to the
undo information for the next command.</p>

<p>The main command loop determines whether the <b>Undo</b> or
<b>Redo</b> procedures have been called &quot;recently.&quot;
Basically, if the last command wasn't undo or redo, it resets the undo
pointer to null.</p>

<p>This implementation allows arbitrary undoing and redoing in any
combination, so long as the commands are given sequentially.  Bear in
mind that with the &quot;change in state&quot; recording of undo
information, it is only legal to apply those changes in the correct
order.</p>

<p>This implementation ignored the arguments to the undo and redo
commands.  Feel free to assign reasonable interpretations to the
arguments in your implementations.</p>

<a name="c8.7"></a><h2>8.7 Macros</h2>

<p>In a sense, macros allow a user to give commands by specifying them
implicitly instead of explicitly.  Macros fall into three general
levels.</p>

<a name="c8.7.1"></a><h3>8.7.1 Again</h3>

<p>The &quot;again&quot; facility allows a user to say &quot;do what I
just did again.&quot; For it to be most useful (<i>i.e.</i>, easier to
type than retyping the command), it should be assigned to a short key
sequence (<i>i.e.</i>, one shifted key).</p>

<p>The &quot;repeat count&quot; argument to the &quot;again&quot;
command should be used instead of the previous &quot;repeat
count&quot; argument to the command being repeated.</p>

<a name="c8.7.2"></a><h3>8.7.2 Keystroke Recording</h3>

<p>This facility allows the user to say &quot;start recording,&quot;
then give a series of commands (observing their effects as they are
typed), then say &quot;stop recording.&quot; Later, the entire
sequence of keystrokes can be replayed with a &quot;play
recording&quot; command.  A &quot;repeat count&quot; argument to the
&quot;play recording&quot; command will cause the recording to be
replayed the specified number of times.  Note that commands within the
recording can have repeat count arguments of their own.</p>

<a name="c8.7.3"></a><h3>8.7.3 Macro Languages</h3>

<p>Finally, the editor should provide the user full access to the
editor's macro language (if any).  This language will in general
provide a full programming language, thus allowing the user to specify
an arbitrary set of editing operations as well as a way of naming
these procedures for later invocation and key rebinding.</p>

<a name="c8.7.4"></a><h3>8.7.4 Redisplay Interaction</h3>

<p>The introduction of keystroke recording and macro languages only
servers to underscore the separation between the redisplay code and
the rest of the editor described in the previous chapter.  The
playback of recorded keystrokes will almost certainly complete with no
intervening redisplay.  Thus, if any of the code based its actions on
the current window contents, it would almost certainly execute
incorrectly.</p>

<a name="c8.q"></a><h2>Questions to Probe Your Understanding</h2>

<p>Expand the main command loop to include other types of input such
as mouse operations.  (Easy)</p>

<p>Generalize the main command loop and related code to use a general
event-driven mechanism. (Medium)</p>

<p>Write routines to move by a word and to delete a sentence, but be
sure to consider all of the punctuation and white space aspects of the
problem. (Medium)</p>

<p>What is a good memory management scheme to use for holding the undo
information? (Medium)</p>

<p>What fundamental support is required in the editor to best
implement the keystroke recorder?  (Easy)</p>

<p><a href="#contents">Back to Contents</a>.</p>
<hr>
<a name="c9"></a><h1>Nine: Command Set Design</h1>

<blockquote><i>
&quot;And hast thou slain the Jabberwock?<br>
&nbsp;&nbsp;Come to my arms, my beamish boy!
</i></blockquote>

<p>Previous chapters have discussed the external constraints on
implementations and the division of the editor into more manageable
pieces.  You now understand how to build an editor.  But which editor
should you build?  This chapter discusses various issues involved with
designing the editor's command set.</p>

<p>Your editor implementation will (you hope) be used by many people.
Regardless of the expertise of these people, there are some design
principles that should be followed.  A good design incorporates these
qualities:</p>

<ul>
<li>responsiveness
<li>consistency
<li>permissiveness
<li>progress
<li>simplicity
<li>uniformity
<li>extensibility
</ul>

<p>Each of these qualities will be discussed in turn.</p>

<a name="c9.1"></a><h2>9.1 Responsiveness</h2>

<p>Responsiveness means that each action taken by the user is handled
and confirmed immediately.  In other words, the application responds
well to the user.  This good response allows skilled users to work
fast.</p>

<p>A different name for responsiveness is <i>visible effect</i>, which
is to say that every action taken by the user has a visible effect on
the display.  This effect might be simple cursor motion, a change in
the text being shown, or a message.  Even if only an internal state
variable is changed, that state variable should have an indicator on
the display.  (Ringing the display's bell is considered to be a
&quot;visible&quot; effect for the purposes of this section.)  By
following this principle, the user is never in doubt whether the
application is keeping up with his or her typing or has received a
command: there is consequently never a need to issue a command because
of doubt or uncertainty.</p>

<p>On some displays, the desire for a visible effect can conflict with
other design goals such as minimizing display flicker.  One solution
to this problem is to delay the display of visible effect until the
user stops typing for a few seconds.  In this way, as long as a user
is typing, he or she is presumed to know what he or she is doing and
so the feedback is less important.  However, if the user should stop
typing, the application would quickly show the current state.</p>

<p>An important ramification of responsiveness is good error-checking.
User input should be checked as soon as logically possible after it
has been entered.  If the input passes the check, some sort of
confirmation is given (<i>e.g.</i>, a message or beep).  If the input
fails the check, an error indicator is displayed.  As a general rule,
no incorrect input should be accepted, unless it is infeasible to
perform the check.  Different checks will naturally be performed at
different times.  For example, if the user is being asked to enter a
number in a specified range, the individual characters can be checked
as they are typed to ensure that they are digits.  The number as a
whole cannot be range-checked until the user has indicated that it is
complete (say by pressing the Return key).</p>

<a name="c9.2"></a><h2>9.2 Consistency</h2>

<p>Consistency means that all parts of the application work the same
way.  This topic is covered in more detail in the section on
&quot;modes.&quot;</p>

<a name="c9.3"></a><h2>9.3 Permissiveness</h2>

<p>Permissiveness means that the user is in control of the application
and not vice versa.  While this might sound tautological at first, it
is a principle that is often honored only in the breach.  Think of the
applications that you have used that lead you through a step-by-step
process, with only limited choices at each step.  Often, these
applications do not allow you to review or change earlier decisions
short of aborting the whole application and starting over from
scratch.</p>

<p>Writing a permissive application is both easier and harder than
writing a non-permissive version of the same one. It is harder because
the implementation has to be able to handle any request at any time.
(An &quot;event - message - object&quot; design model makes it easy to
handle such unpredictable requests.)  If some process is multi-step,
the application must have interlocks to prohibit processing the steps
out of order (and of course these interlocks should have their state
variables displayed).  It is easier because you as a designer do not
have to anticipate all possible paths through the application and
decide in advance which ones are reasonable.</p>

<a name="c9.4"></a><h2>9.4 Progress</h2>

<p>Progress means that each command should meet some part of the
user's goals.  An example of a command that does not make progess
would be a command to &quot;show the current line.&quot; This command
does not contribute to making any of the changes that the user
(presumably) desires: it just wastes the user's time and effort.  It
is the elimination of such commands that makes screen-oriented text
editors such an improvement over the older ones.</p>

<p>In general, there should be no commands for the user to give that
merely tell the application to do something that it has enough
information to figure out on its own.  For example, if the user moves
to the end of the buffer, the application should display that part of
the buffer.  (Actually, as stated this principle is a bit harsh.  From
time to time, the application will not be able to guess correctly and
it is acceptable to have a way for the user to take control.  For
example, sometimes the user wants to position the window to include
two areas of particular interest.  The application in general cannot
detect this case.  But if that happens often, there is a design
problem.)</p>

<a name="c9.5"></a><h2>9.5 Simplicity</h2>

<p>Simplicity goes under the sobriquet of &quot;keep simple things
simple.&quot; Complicated things can be complicated (or simple if that
works out), but simple things should never be complicated.</p>

<p>This principle means that the basic editing operations (insert,
delete, move) should be as conceptually simple as possible.  For
example, inserting a character is a conceptually simple operation.
The simplest way of expressing that operation is to just type that
character.  Having input/edit (or &quot;input/overtype&quot; or
&quot;insert/replace&quot;) modes is an example of making a simple
thing complicated.  With the input/edit mode, inserting a character
becomes &quot;am I in insert mode? No. Then type the 'go into insert
mode' command, type the character, and maybe type the 'leave insert
mode' command.&quot; Hardly simple.</p>

<p>This principle is closely related to efficiency.  It is natural to
think that the command set that requires the fewest user operations is
the best one to use.  Unfortunately, that natural thought does not
remain valid when taken to extremes.  On an extreme basis, the set of
editing operations could be Huffman encoded into a command set.  While
the resulting command set would be optimally efficient, it would
probably not be usable.  For example, the command to insert the string
&quot;the &quot; might be ^X 7.  On the other hand, simple things tend
to be efficient if for no other reason than that they don't have the
baggage of being complicated.  Ideally, the most-often used commands
should be the shortest.</p>

<a name="c9.6"></a><h2>9.6 Uniformity</h2>

<p>Uniformity also goes under the names &quot;regularity,&quot;
&quot;predictability,&quot; and &quot;orthogonality.&quot; Basically,
a command set is uniform if, when a user knows some part of it, he or
she can predict the unknown parts.  Another way of looking at it is
that the command set fits into a pattern.</p>

<p>This principle is important in that the user is freed from learning
each command separately.  Instead, the user learns some of the
commands and a set of rules for generating the rest.  For example,
here are the basic Emacs character commands:</p>

<table border="0" width="100%">
<colgroup>
<col width="10%">
<col width="90%">
</colgroup>

<tr><td valign="top"><b>^F</b></td><td valign="top">move forward character</td></tr>
<tr><td valign="top"><b>^B</b></td><td valign="top">move backward character</td></tr>
<tr><td valign="top"><b>^D</b></td><td valign="top">delete the following character</td></tr>
<tr><td valign="top"><b>^H</b></td><td valign="top">delete the preceding character</td></tr>
</table>

<p>(Keep in mind that ^H is also the Back Space key.) Here are the
word commands:</p>

<table border="0" width="100%">
<colgroup>
<col width="10%">
<col width="90%">
</colgroup>

<tr><td valign="top"><b>^[ F</b></td><td valign="top">move forward word</td></tr>
<tr><td valign="top"><b>^[ B</b></td><td valign="top">move backward word</td></tr>
<tr><td valign="top"><b>^[ D</b></td><td valign="top">delete the following word</td></tr>
<tr><td valign="top"><b>^[ ^H</b></td><td valign="top">delete the preceding word</td></tr>
</table>

<p>A user learns these commands by learning this basic command
set:</p>

<table border="0" width="100%">
<colgroup>
<col width="10%">
<col width="90%">
</colgroup>

<tr><td valign="top"><b>F</b></td><td valign="top">move forward ...</td></tr>
<tr><td valign="top"><b>B</b></td><td valign="top">move backward ...</td></tr>
<tr><td valign="top"><b>D</b></td><td valign="top">delete the following ...</td></tr>
<tr><td valign="top"><b>^H</b></td><td valign="top">delete the preceding ...</td></tr>
</table>

<p>and these rules:</p>

<ul>
<li>control-shifted means &quot;character&quot;
<li>^[-prefixed means &quot;word&quot;
</ul>

<p>It is rare that a command set will ever be completely uniform.
However, it is important to take advantage of uniformity where
possible.</p>

<a name="c9.7"></a><h2>9.7 Extensibility</h2>

<p>Extensibility means the ability to accommodate changes.  This
principle has a number of aspects.  First, changes can be accommodated
by designing in &quot;holes&quot; or &quot;gaps&quot; where users can
install commands of their own.  Second, the command set can be made
rich (&quot;large&quot;) as the larger number of commands provides
more places for commands to be placed.  Third, a uniform command set
helps extensibility.  For example, if the command set has a set of
&quot;sentence&quot; operations (move by, delete by), these can be
converted as a set into &quot;statement&quot; operations for use in
programming languages.</p>

<a name="c9.8"></a><h2>9.8 Modes</h2>

<p>This chapter uses the word &quot;mode&quot; in a different way from
the command-set-oriented use of &quot;mode&quot; from earlier
chapters.  It is unfortunate that the same word is used by the
industry in different ways.</p>

<p>What are &quot;modes,&quot; and why should you care about them?
Simply put, a design has a mode when an end user has to do an
&quot;unnecessary&quot; action in order to do the desired action.  You
should care about modes because having modes can make a program harder
to use.  As a programmer, you are used to modes and deal with them
constantly without conscious thought.  Your end users, however, may be
confused by the presence of modes.  Their thinking might go something
like &quot;I pressed the 'f' key (at command level) and it showed me
an 'f', so why does pressing the 'f' key here move me forward by a
screen?&quot;</p>

<p>The definition just presented is a little abstract, so an example
is in order.  A piano is a device that has (almost) no modes.  If you
want a piano to make a sound, you just press a key.  Each key is
independent: it produces the same note regardless of which other keys
were pressed before.</p>

<p>A piano really does have modes.  You select the modes with the foot
pedals.  It is easy to learn to overlap the key presses with the foot
pedal ups and downs, so the modes, although present, do not interfere
with playing the piano.  Moreover, the modes have a great deal of
overlap with the basic keys.  In a manner of speaking, the piano's
&quot;command set&quot; is quite orthogonal.</p>

<p>A typical scientific calculator has many modes.  An example of such
a mode is the degrees/radians selection.  If you are in degrees mode
and want to compute the sine of an angle in radians, you must first
switch to radians mode and then compute the sine.  Switching to
radians is not part of your calculation.  Rather, it is something that
you have to do in order to perform your calculation.  Hence, the
calculator has a mode.  A similar -- but less useful -- mode in a text
editor would be an insert/overwrite (or replace) mode.</p>

<p>These examples are at the extremes of the range.  The piano is an
almost modeless device, while a calculator has many modes.</p>

<p>What does all this have to do with designing an editor's command
set?  These things:</p>

<ul>
<li>you should have as few modes as possible;
<li>modes should be aligned with the activity;
<li>if you must have a mode, make it visible.
</ul>

<p>Adding keys (or a mouse) can reduce the number of modes.  For
example, having both &quot;sine in degrees&quot; and &quot;sine in
radians&quot; keys would eliminate the degrees/radians mode.  However,
there is an upper limit to the number of keys that you can put on a
user input device, be it a calculator or a keyboard.</p>

<p>Rearranging the modes so that they coincide with natural breaks in
the activity also reduces confusion.  For example, it is not too
unreasonable to have a &quot;text editor mode&quot; and a &quot;spread
sheet&quot; mode, where the two modes correspond to completely
different applications.  Switching modes is less confusing because the
end user is mentally changing gears at the same time.  On the other
hand, with modern computers' ability to rapidly switch between
different application programs, it can be very valuable to have the
different applications present the same interface to the end user:
doing anything else is often not in the end-users' best interests.  Of
course, if you did provide additional functions within the text
editor, the differences in the modes whould be minimized.</p>

<p>Returning to the example of an insert/edit mode for an editor, we
can see how that mode is not aligned with a change in activity.  To
the user, &quot;editing&quot; is a single activity that comprises both
deletion and insertion.  Changing between insert and edit modes is
thus a mode change with no accompanying activity change.</p>

<p>Some text editors offer an insert/replace mode which affects how
newly typed text affects the existing text.  In insert mode, newly
typed text is inserted.  In replace mode, each newly typed character
usually replaces an existing character.  However, in many cases users
do not want to replace characters: they want to replace words,
sentences, or other higher-level objects.  In these cases, simple
replacement is not sufficient since it is unlikely that the new text
is exactly the same length as the old.  The correct effect can be
readily achieved when insert mode is combined with an operation that
defines a region or selection that identifies the old text.</p>

<p>Modes should be made visible.  For example, in older calculators,
the degrees/radians mode was hidden.  New calculators have an
indicator on the display that shows the current mode.  Although the
mode is still there, the indicator reminds the operator that the mode
exists and can even guide the operator's next input.</p>

<p>The best way to make the modes visible is to show all state
information on the display.  In this way, it is <i>possible</i> for a
knowledgeable end user to predict accurately the effect of the next
command by examining the current display.  Of course, not all end
users are &quot;knowledgeable,&quot; but how could a
<i>non</i>-knowledgeable user ever succeed if a knowledgeable one
cannot?</p>

<p>Note how the reasons for making modes visible dovetail with the
reasons mentioned earlier for commands having visible effects.</p>

<a name="c9.9"></a><h2>9.9 Use of Language</h2>

<p>DO NOT PRODUCE OUTPUT IN ALL UPPER CASE.  UPPER CASE IS MORE
DIFFICULT TO READ THAN lower case.  Proper capitalization and
punctuation are also important.  Would you rather read:</p>

<pre>
	ENTER CITY STATE AND ZIP CODE:
</pre>

<p>or:</p>

<pre>
	Enter city, state, and zip code:
</pre>

<p>Use full words and phrases: do not abbreviate.  Displays are large
enough and output fast enough so that abbreviations are no longer
required.</p>

<p>Prompts should have the form <i>verb object</i> (at least in
English). A prompt of:</p>

<pre>
	Username:
</pre>

<p>doesn't tell the user what to do.  However, a prompt of:</p>

<pre>
	Enter your username:
</pre>

<p>or even:</p>

<pre>
	Please enter your username:
</pre>

<p>is reasonably unambiguous.  In the first case, a user is apt to
feel confused and unsure of what to do next.  (What about a username?
Should he or she go get one?  Whose username?)  In the second case,
that confusion vanishes.</p>

<p>Error messages should state <i>whether</i> the operation was
performed, <i>why</i> something went wrong, and <i>what</i> to do
instead.  Instead of:</p>

<pre>
	File write error.
</pre>

<p>or (gasp!):</p>

<pre>
	SIO-FI-ERR-12
</pre>

<p>this:</p>

<pre>
	The file was not written because the disk was full.  Clear space
	on the existing disk and try again or write the file to a
	different disk.
</pre>

<p>Longer, but much better.</p>

<p>The application should do what computers do best: arithmetic,
checking, recording.  Users should do what they do best: direct the
application to solve a problem.  Don't make the user count things or
keep track of what was done in the past.</p>

<p>Be generous in what you accept.  If both Delete and Back Space are
used for erasing a character, accept both.  Unless there is a good
reason otherwise, don't distinguish between upper and lower-case
input.  In general, if there is a possible way to unambiguously
determine what the user wants, accept it.</p>

<a name="c9.10"></a><h2>9.10 Guideline Summary</h2>

<p>This section presents a brief summary of the guidelines already
presented.</p>

<a name="c9.10.1"></a><h3>9.10.1 Overall</h3>

<ul>
<li>Responsiveness: reflect all input immediately to the display.

<li>Consistency: the same input should always have the same result.

<li>Permissiveness: the user controls the application.

<li>Progress: the user input should achieve the user's goal, not be
for the application's benefit.

<li>Simplicity: keep simple things simple.

<li>Uniformity: make the commands easy to learn and to predict.

<li>Extensibility: plan for growth and change.
</ul>

<a name="c9.10.2"></a><h3>9.10.2 Modes</h3>

<ul>
<li>Avoid modes where possible.

<li>Where modes cannot be avoided, align mode changes with activity
changes.

<li>Remind the user what mode(s) are in effect.
</ul>

<a name="c9.10.3"></a><h3>9.10.3 Use of Language</h3>

<ul>
<li>Use mixed case, proper capitalization, and punctuation.

<li>Use full words and phrases: do not abbreviate.

<li>Prompts should tell the user what to do.

<li>Use full error messages.

<li>Have the program do what computers do best.

<li>Be generous in what you accept.
</ul>

<a name="c9.11"></a><h2>9.11 Structure Editors</h2>

<p>One idea that keeps recurring is that of a &quot;structure
editor.&quot; In general, a structure editor limits editing to valid
transformations on the object being edited.  They are often used as
programming language editors.  In those cases, there may be a command
to &quot;insert an `if' statement.&quot; The user then sees something
like this:</p>

<pre>
	if &lt;#&gt; then &lt;&gt;
	else &lt;&gt;
</pre>

<p>(This example does not use the C language.  In general, people
don't do structure editors for the C language.)  The point is
positioned at the &quot;#&quot; character and the user is then allowed
to make syntactically valid transformations to continue programming.
These editors are often found as the subject of research papers.  For
reasons that will be described, it is fortunate that they are not
often found anywhere else.</p>

<p>Of course, the user is in trouble if, for example, he or she
decides to negate the condition and make the &quot;else&quot; clause
into the &quot;then&quot; clause.  If the user is lucky, there will be
an editor command to do this operation.  If not, the user may have to
&quot;cut&quot; the else part and &quot;paste&quot; it into the then.
Or worse, the user may be forced to delete the else part and retype it
at the then.</p>

<p>It may well be possible to create a structure editor that is also a
good editor design.  However, in all my research I have never seen
one.  There are two reasons why creating such an editor is
difficult:</p>

<p>First, while the structure-oriented operations may be well suited
to the process of <i>writing</i> a program, they are not well suited
to the process of <i>editing</i> one.  The distinction is a subtle but
important one.  The examples (usually shown in the papers) all show
how easy it is to write programs this way.  After all, it is a nice
typing aid to be able to insert many characters of language statement
with a short command.  However, most of the work involved in
programming is in editing programs that are already written.  Editing
operations are often ugly and involve intermediate states that are not
valid language syntax.  It is just in those areas that the
structure-oriented operations start getting in the way.</p>

<p>Second, there is no carryover from one part of the editing task to
another.  Sure, it may be easier to write the program, <i>but the task
of editing text strings and comments to the program has not been
addressed by the programming-language editing commands</i>.  The user
still needs a full-feature editor to handle the strings constants, the
comments, and other documentation that are an integral part of any
programming project.  By adding the structure editor, either a
completely separate editor or a complicated new mode has been
introduced and consistency has been lost.  (I will completely skip
over the question of how to handle the programmer that is editing more
than one programming language.  I will point out that I have worked on
projects where I have been editing programs written in more than five
languages at the same time.)</p>

<p>Note that the arguments just presented address the concept of a
structure editor, not any one editor in particular.</p>

<a name="c9.12"></a><h2>9.12 Programing Assistance</h2>

<p>Even if the structure editor approach is not the best, there are
still techniques that can be used to help write and edit programs.  If
you like, it could be said that these techniques are adapted from
structure editors.  However, the origins of these techniques are lost
in the mists of history and no one knows which was developed first:
structure editors or the adaptations to general editors.</p>

<p><b>Typing aids</b>: The first technique is to have commands that
serve as typing aids.  These aids would insert statements or statement
parts by typing just a few characters (presumably fewer than the
statements or parts themselves!).  In this way, users gain the
&quot;express typing&quot; benefits of structure editors.</p>

<p><b>Language modes</b>: Further, a language mode can tailor the
effects of commands to suit the characteristics of the language.  For
example, the commands that move by or manipulate words would be
adjusted to use language tokens; those that use sentences would be
adjusted to use language statements; and those that use paragraphs
would be adjusted to use a statement block or procedure.  In addition,
commands that perform indentation can also be modified to handle
statement nesting.</p>

<p>However, these alterations change how commands work and so some
predictability is lost.  In addition, while the alterations would
presumably only be made for buffers that hold programs, these programs
include comments.  Hence, the commands need to &quot;know&quot;
whether they are operating in a comment and thus whether to use the
altered behavior.  Even so, not all users are happy with such changes.
Hence, there should be a way for users to turn them off.  (I, for
example, prefer to disable all language modes when editing.)</p>

<p><b>Syntax checking</b>: Structure editors offer good syntax
checking. Most even prevent you from creating a syntactically
incorrect program.  While possible to implement, syntax checking is
not clearly appropriate for an editor, given that a better alternative
may be available.  This better alternative is for users to be able to
invoke the compiler from within the editor, and to have the editor be
able to parse the compiler's error and warning messages.</p>

<p>Simple syntax checking is a feature that looks useful on the
surface, but turns out not to be very useful in practice, as good
programers tend to make relatively few syntax errors.  Syntax checking
can catch errors like:</p>

<pre>
	ovid Foo()		
		{
		return (a -+ b;
		}
</pre>

<p>This example has a misspelled keyword, a missing close parenthesis,
and an illegal operator combination.  Syntax checking can catch the
last two of these, but not the first: at the syntax level, there is no
way to tell whether &quot;ovid&quot; is a misspelled keyword or a
programmer-defined type.</p>

<p>Semantic checking can catch the &quot;ovid&quot; problem, as well
as missing declarations, mis-matched types, and other such problems.
With programs spread across multiple files, there is simply no way
that an editor would be able to assemble the information required to
perform the correct analysis.  It is up to the language compiler to
perform that function.</p>

<p><b>Compiler invocation</b>: And so we bring up the best way for an
editor to help in program development.  That is for the user to
quickly and easily be able to invoke the compiler and work with the
results.  The commands might be &quot;compile this file,&quot;
&quot;move to the place indicated by the next error message,&quot; and
so forth.  The lesser features such as syntax checking would only be
used on systems where invoking the compiler is expensive (in user
time, not computer power) to do from within the editor.</p>

<a name="c9.13"></a><h2>9.13 Command Behavior</h2>

<p>This section describes some of the considerations involved with
designing some of the commands.  As with other parts of the book, the
purpose of this section is not to say merely &quot;do it this
way,&quot; but to review why different approaches should be
considered.</p>

<a name="c9.13.1"></a><h3>9.13.1 Does Down Move the Point or the Text?</h3>

<p>Let's say that the point is somewhere in the middle of a large
buffer, large enough that neither the top or bottom is on the display.
The user gives the &quot;move down a line&quot; command (say, by
pressing the down-arrow key).  What happens?</p>

<p>First, the point (and cursor) could both move down one line.  The
user is thinking &quot;I want to move down&quot; and lo, the point
moves down.</p>

<p>A variant on this choice is to move the point down one line, but to
move the text of the buffer <i>up</i> in the window.  This variant has
the unfortunate property that the cursor is always kept in the center
of the window.</p>

<p>There is a another choice.  The cursor could stay in the same
place, and the <i>text of the buffer</i> move down.  In effect, this
moves the point <i>up</i> one line.</p>

<p>A moment's thought shows that both choices are indeed valid
interpretations of &quot;down.&quot; In fact, both have been
implemented many times.  All modern editors now use the first
interpretation.  In fact, you might be wondering why anyone would
select the second interpretation.</p>

<p>The descriptions just given do not reveal why the two
interpretations arose.  For that information, we have to step from the
world of text editing into the world of computer graphics.</p>

<p>Consider the following picture:</p>

<pre>
		 o		|\		The quick
		---		| \		red fox
		 |		| /		jumps over
		/ \		|/		the lazy

		user		display	buffer
</pre>

<p>In this view, the user sees the text on a display. Now let us
redraw this picture more abstractly:</p>

<pre>
		 o		------	The quick
		---		|ed f|	red fox
		 |		|umps|	jumps over
		/ \		------	the lazy

		user		window	buffer
</pre>

<p>In this view, the user is &quot;looking through&quot; a window onto
the text.  The user sees only that part of the text that can be seen
through the window.  Now the question &quot;when the user gives the
`move down one line' command, does the command move the window or the
text?&quot; makes sense.</p>

<a name="c9.13.2"></a><h3>9.13.2 Scrolling vs. Paging</h3>

<p>Closely related to the previous point is whether to scroll or page
the screen.  Again, there are two choices, and again, we are
considering the case where the user is giving &quot;move down one
line&quot; commands.  In all cases, the <i>point</i> is moving down
one line at a time.  The question relates to how the <i>cursor</i>
moves on the screen.</p>

<p>First, the cursor can move down one line at a time until it reaches
the bottom of the screen (possibly with a line or so of &quot;guard
zone&quot;).  Once there, the whole screen moves up one
&quot;page&quot; and the cursor is re-centered.</p>

<p>Second, the cursor could stay in the same place on the screen and
the text could move up by one line.</p>

<p>The second method offers the advantage that the maximum amount of
surrounding text is always visible.  However, it offers the much more
severe disadvantage that &quot;just moving around&quot; appears to be
constantly changing the text.  That is quite distracting to users.  It
also ties what the user sees with where the user is making changes.
Thus, if the display has a 24-line screen and the preferred row is
line 10, the user is out of luck if he or she wants to make changes
while looking at text that is more than 10 lines before the point or
14 lines after it.</p>

<p>A third method would be to have the cursor move down to a guard
zone, then scroll the screen instead of paging it.  This method offers
better continuity than does just paging.  It is especially nice if you
repeatedly give the &quot;move down line&quot; command.  Personally, I
find it exasperating because your context gradually reduces to the
size of the guard zone, then <i>stays there</i>.  With paging, the
context is automatically restored to about one-half of the window.
When using editors that select this method, I have to give the
&quot;recenter window&quot; command much more often than I like
to.</p>

<a name="c9.13.3"></a><h3>9.13.3 Page Breaks</h3>

<p>This is more of an issue with word processors than text editors,
but it is worth mentioning anyway.  The problem arises when the
program is displaying the buffer in its &quot;printed form,&quot;
including page breaks.  It is very tempting for the implementor to
always position the page break at the top of the display.  However, it
is important that users be able to see the text just before and after
the page break at the same time.</p>

<a name="c9.13.4"></a><h3>9.13.4 How Many Ways Can You Move by a Word?</h3>

<p>When writing commands that operate on words, the first question
that arises is &quot;what is a word?&quot; We need a definition that
is both possible and easy to implement.  We will approach a definition
in a series of refinements.</p>

<p>The first step is to consider all of the characters between white
space to be one word.  With this definition, the sequence:</p>

<pre>
	This is a very-strange test sentence, isn't it?
</pre>

<p>would be considered to be eight words.  While a good start, it is
not sufficient, as the following sequence would be considered only two
words:</p>

<pre>
	here--a phrase
</pre>

<p>But this sequence would be considered four words:</p>

<pre>
	here -- a phrase
</pre>

<p>Thus, the next step is to define a word as a string of letters and
digits.  With this definition, the three examples would be considered
to have ten, three, and three words, respectively.  This definition
has the advantage that for something to be considered a word, there
should be something &quot;word-like&quot; about it (<i>i.e.</i>, the
characters &quot;--&quot; are not considered to be a word.  In
addition, the presence or absence of extra spaces around the
&quot;--&quot; does not change the number of words: a good sign that
we are on the right track.</p>

<p>Our refinement can stop right here and be considered acceptable.
There are some changes that we can make, but these changes are not
uniformly considered improvements.</p>

<p>The first change is to add some characters to the &quot;word&quot;
characters in language modes.  For example, when writing C programs,
the underscore character (&quot;_&quot;) is legal within a token.  By
adding this character to the letters and digits, a &quot;move by
word&quot; command will now properly move by tokens.</p>

<p>The second change is to add other characters, such as dash
(&quot;-&quot;) and quote (&quot; ' &quot;).  But these are added in a
special way: they must be surrounded by letters or digits in order to
be considered as part of a word.  This change allows the
&quot;very-strange&quot; and &quot;isn't&quot; parts of the sequence
to be considered as single words.</p>

<p>However, suppose that you had a very-long-hyphenated-phrase.  It
probably makes sense to consider this phrase as four separate words.
In particular, it is better to err on the side of dividing one
&quot;word&quot; into two rather than combining two &quot;words&quot;
into one.  For example, in our very-long-hyphenated-phrase, it would
be difficult to change the &quot;hyphenated&quot; to
&quot;dashed&quot; if word motion commands considered the whole thing
as one word.</p>

<a name="c9.13.4.1"></a><h4>9.13.4.1 Moving by Words</h4>

<p>As with many of the other topics here, there are two popular ways
of moving forward by words.  Oddly, though, there is only one popular
way of moving backwards.</p>

<p>One way to move forward is to move to the end of the word.  For
example, if we had the text:</p>

<pre>
	one two three four
	     ^
</pre>

<p>and the cursor was at the &quot;w&quot; (which means that the point
is between the &quot;t&quot; and the &quot;w&quot;), and a &quot;move
forward word&quot; command were given, this move would leave the point
here:</p>

<pre>
	one two three four
	       ^
</pre>

<p><i>i.e.</i>, just before the white space after the word.  The other
method would move the point to the start of the next word:</p>

<pre>
	one two three four
	        ^
</pre>

<p>When moving backwards, both methods leave the point at the start of
the word:</p>

<pre>
	one two three four
	    ^
</pre>

<p>The difference may become slightly more clear if we look at the
code that might be used to implement these commands.  Assuming that
the constant <i>WORDSTRING</i> contains the characters that comprise a
word, the code to move backward a word is this:</p>

<pre>
	Find_First_In_Backward(WORDSTRING);
	Find_First_Not_In_Backward(WORDSTRING);
</pre>

<p>The code to move forward to the end of the word is the same code,
with &quot;Backward&quot; changed to &quot;Forward&quot;:</p>

<pre>
	Find_First_In_Forward(WORDSTRING);
	Find_First_Not_In_Forward(WORDSTRING);
</pre>

<p>Finally, the code to move forward to the start of the next word is
this:</p>

<pre>
	Find_First_In_Forward(WORDSTRING);
	Find_First_Not_In_Forward(WORDSTRING);
	Find_First_In_Forward(WORDSTRING);
</pre>

<p>The first method, to leave the point at the end of the current
word, has the property that it is symmetric with respect to backward
motion.  The second method, to leave the point at the start of the
following word, lacks that symmetry.  On the other hand, it makes it
easier to move to the beginning of the following word.</p>

<p>The choice is up to you.  I strongly prefer the first method.</p>

<a name="c9.13.4.2"></a><h4>9.13.4.2 Deleting by Words</h4>

<p>This question is &quot;okay, so I have decided what happens when I
<i>move</i> by words.  What should happen when I <i>delete</i> by
words?&quot;</p>

<p>The first answer, which works very well, is simply that you should
delete whatever the corresponding move command would move over.  Thus,
if the motion command were to move to the start of the next word, the
deletion command should delete that same text.</p>

<p>However, consider this case:</p>

<pre>
	This is some text.
			   ^

	--------------------

	And, three lines later, more text.
</pre>

<p>The &quot;move forward word&quot; command would move to just before
the &quot;A&quot;.  However, is it really desirable that the
&quot;delete forward word&quot; command delete the lines in between,
including the row of dashes?  Well, yes, if you want to be consistent
(and predictable).  This is one of the reasons why this style of word
motion is not the best one to use.</p>

<p>The second answer would be to be &quot;intelligent.&quot; This view
is used by Apple Computer (see Apple 1987).  In it, you would change
exactly what was deleted based on circumstances.  For example, with
the text:</p>

<pre>
	Here is some text.
		   ^
</pre>

<p>a &quot;delete forward word&quot; command would delete the word
&quot;some&quot; and the following space, thus leaving this:</p>

<pre>
	Here is text.
	        ^
</pre>

<p>instead of this:</p>

<pre>
	Here is  text.
	        ^
</pre>

<p>This definition has the advantage that deleting a word deletes the
&quot;supporting structure&quot; for the word as well and thus makes
the text as if the word was never there.  It also means that
&quot;sloppy&quot; users don't leave stray extra spaces around.  It
has the disadvantage that if you wanted to replace one word with a new
one -- a very common operation -- you now have to re-type the space.
This definition also loses predictability in that only white space is
so treated: commas, periods, and other punctuation marks are not.  So,
to replace &quot;old&quot; with new in the following text:</p>

<pre>
	This is an old word.
	           ^
</pre>

<p>you give the &quot;delete forward word&quot; command then type
&quot;new &quot;, but to do the same replacement with the text:</p>

<pre>
	This is an old, word.
	           ^
</pre>

<p>you give the &quot;delete forward word&quot; command, then simply
type &quot;new&quot;.  Now explain that to a user quickly and
painlessly.  (Note that Apple Human Interface Guidelines do not
provide for word-level operations other than selection.)</p>

<p>In all fairness to Apple -- and I believe that their guidelines are
excellent -- their guidelines are build around a keyboard/mouse
combination for user input.  This book assumes that only a keyboard is
available.  Changing such a basic assumption will result in changing
some of its conclusions: that is why you should make your choices
based on a full understanding of the options and assumptions that
apply in your situation.</p>

<p>These examples have all operated on full words.  The Apple
guidelines do not have guidelines for how to handle deleting parts of
words because the guidelines only support whole words as objects.
However, you are free to invent your own semantics for handling
partial words in an &quot;intelligent&quot; manner.</p>

<a name="c9.13.5"></a><h3>9.13.5 Where Do Sentences and Paragraphs End?</h3>

<p>I will start with the cheery statement that there is no way to
correctly determine the ends of all possible valid English sentences
by analyzing syntax alone.  Why not?</p>

<p>Consider these text sequences:</p>

<pre>
	This is a sentence.
	The value 3.14159 is close to the value of pi.
	The value 3. is close to the value of pi.
	Dr. Martin is a medical doctor.
	I hate typing long words and prefer to abbrev. them.
</pre>

<p>We all know that a period is used to end a sentence.  The second
example shows that periods can occur within a sentence.  The third
shows that periods can end a token and yet not end a sentence.  The
fourth shows that the token can be a word.  The last shows that you
can't just work off a list of known abbreviations.  When considering
these examples, remember that we are applying semantic knowledge to
the statements, something that is beyond the ability of most computer
programs.  From the program's point of view, the sequences might as
well be:</p>

<pre>
	Xxxx xx x xxxxxxxx.
	Xxx xxxxx 0.00000 xx xxxxx xx xxx xxxxx xx xx.
	Xxx xxxxx 0. xx xxxxx xx xxx xxxxx xx xx.
	Xx. Xxxxxx xx x xxxxxxx xxxxxx.
	X xxxx xxxxxx xxxx xxxxx xxx xxxxxx xx xxxxxx. xxxx.
</pre>

<p>All that said, what is a way out?  The definition that I have found
that works best was worked out by trial-and-error and refined over a
period of years is this:</p>

<pre>
	Find_First_In_Forward(&quot;.?!:&quot;);
	Point_Move(1);
	Find_First_Not_In_Forward(&quot;\&quot;')]}&quot;);
	if (xiswhite(Get_Char())) &lt;you are at a sentence end&gt;;
</pre>

<p>This definition looks for any of the sentence-ending characters
(colons are considered to end sentences here).  It then skips over any
of the characters that tend to follow sentence ends.  Finally, it
checks for white space.</p>

<p>This definition has the unfortunate property that the last three
examples are considered to be two sentences each.  On the other hand,
it has the advantage that it works fairly well on non-contrived
examples.  And, as with words, it is better to count one sentence as
two than to treat two sentences as one.</p>

<p>Note that only one white-space character (any character of Space,
Tab, newline, or whatever else you wish to include) is required to end
a sentence.  Depending upon which style manual you follow, either one
or two spaces should be included after the end of a sentence.
However, even if your style manual requires two spaces, your users may
not use that manual or may simply forget to type the extra space.
Hence, you should not penalize them for the omission.</p>

<p>I know of one implementation that makes life difficult for its
users.  Its end-of-sentence definition requires two spaces.  Yet, when
you refill a paragraph, it removes the second space.  Thus, you can
move by sentences until you first refill the paragraph, after which
the entire paragraph is treated as one sentence...</p>

<p>Paragraph ends are much easier than sentence ends.  If you are
using word wrap, each paragraph will be one line long.  Thus, a
newline character will end a paragraph.  Otherwise, a newline followed
by any white-space character (Space, Tab, newline, etc.) will mark the
end of the paragraph.</p>

<p>If you are fortunate (or unfortunate, it depends on your outlook)
enough to use a text formatter, you will want to include your
formatter-command characters as paragraph-break characters.  For
example, if you are using the nroff formatter, you will want a
paragraph break here:</p>

<pre>
	This is some text.
	.LP
	This is some more text.
</pre>

<p>So just look for a newline followed by either white space or a
dot.</p>

<p>Moving and deleting by sentences and paragraphs involves all of the
same problems as moving and deleting by words.  See the earlier
discussion. </p>

<a name="c9.13.6"></a><h3>9.13.6 How to Search</h3>

<p>This topic supplies lots of choices, all of them good.  The
question is more one of how much work you want to put into your
implementation than which is the correct approach.</p>

<p>The first choice is between buffered searching and incremental
searching.  <i>Buffered searching</i> means that your implementation
prompts for a search string, waits for the user to enter the complete
string, then performs the search.  It works and is easy to implement,
but not as good as incremental search.</p>

<p><i>Incremental search</i> means that the implementation searches as
the user types.  Here is an example:</p>

<table border="0" width="100%">
<colgroup>
<col width="10%">
<col width="90%">
</colgroup>

<tr><td valign="top"><b>user types</b></td><td valign="top"><b>what is done</b></td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top"><b>^S</b></td><td valign="top">start incremental search</td></tr>
<tr><td valign="top"><b>a</b></td><td valign="top">find the first &quot;a&quot;</td></tr>
<tr><td valign="top"><b>b</b></td><td valign="top">(1) find the first &quot;ab&quot;</td></tr>
<tr><td valign="top"><b>c</b></td><td valign="top">find the first &quot;abc&quot;</td></tr>
<tr><td valign="top"><b>^H</b></td><td valign="top">erase the &quot;c&quot; from the string; go back to where you were after (1)</td></tr>
<tr><td valign="top"><b>d</b></td><td valign="top">find the first &quot;abd&quot;</td></tr>
<tr><td valign="top"><b>^S</b></td><td valign="top">(2) search again for &quot;abd&quot;: you are now at the second one</td></tr>
<tr><td valign="top"><b>^S</b></td><td valign="top">search again, you are now at the third one</td></tr>
<tr><td valign="top"><b>^H</b></td><td valign="top">get rid of the last ^S; go back to where you were after (2)</td></tr>
</table>

<p>You get the idea.  The commands available can be as powerful as you
like.  This is clearly a much nicer way to search than buffered
searching.  Just as clearly, it is more work to implement.</p>

<p>The next question is what the search string should be.  The most
simple case is that the editor should search for the string exactly as
typed.  Thus, this string:</p>

<pre>
	Some text.
</pre>

<p>would match only the string &quot;Some text.&quot; in the buffer.
While simple, it is not necessarily useful.</p>

<p>The first alternate way to search would be to simply ignore upper
and lower case.  Thus, the string would also match &quot;some
text.&quot; and &quot;SOME TEXT.&quot; and &quot;SoMe TeXt.&quot;</p>

<p>Another way to search would be to have lower-case characters in the
search string match either upper or lower case in the buffer, but an
upper-case character in the search string match only upper-case
characters in the buffer.  The search string would then match
&quot;SOME TEXT.&quot; and &quot;SoMe TeXt.&quot; but not &quot;some
text.&quot; This way is more useful than one might think, because you
can enter &quot;ROM&quot; in order to find &quot;ROM&quot; but not the
&quot;rom&quot; in &quot;from&quot;, yet you can still find both
&quot;the&quot; and &quot;The&quot; with one search string.</p>

<p>Another search variation is whole-word match.  Thus, one could
search for &quot;the&quot; without finding &quot;then&quot;.  In
addition, it would be handy to be able to allow varying amounts of
white space to match.  Thus, our &quot;Some text.&quot; string would
match</p>

<pre>
	Some
	text.
</pre>

<p>and</p>

<pre>
	Some      text.
</pre>

<p>You can get as complex as you like with all of this, up to wild
cards and UNIX-style regular expressions.  Just don't forget to
include a way to quote any special characters so that the user can
search for them exactly.</p>

<a name="c9.13.7"></a><h3>9.13.7 Commands to Handle Typos</h3>

<p>There are two very common forms of typographic errors for which
special commands can be helpful.</p>

<a name="c9.13.7.1"></a><h4>9.13.7.1 Capitalization Commands</h4>

<p>One typographic error is the incorrect upper/lower case of a
character, part of word, or word.  Two different forms of commands can
be defined to handle this task.</p>

<p>The first form operates as a &quot;move forward word&quot; command,
but forcing all characters moved over to UPPER, lower, or Capitalized
case (the latter is first character in upper case, and all others in
lower case).  Note that three separate commands are required.</p>

<p>The second form is a &quot;rotate case&quot; command.  The
definition that I use acts differently depending upon whether you are
within a word or between words.  In the former case, it affects all
characters between the point and the end of the word.  In the latter
case, it affects the entire previous word.  In either case, it
examines the current state of the word and rotates it among word -&gt;
Word -&gt; WORD -&gt; word, etc.  The point is not moved.  This
definition turns out to be very handy.</p>

<a name="c9.13.7.2"></a><h4>9.13.7.2 Twiddling</h4>

<p>Another typographic error is interchanging two characters.  For
example, &quot;teh&quot; instead of &quot;the&quot;.  There are three
forms of the command to fix this.</p>

<p>The first form interchanges the two preceding characters.
Thus:</p>

<pre>
	abcd
	  ^
</pre>

<p>becomes</p>

<pre>
	bacd
	  ^
</pre>

<p>The second form interchanges the two surrounding characters.  Thus
our original becomes:</p>

<pre>
	acbd
	  ^
</pre>

<p>Neither of the first two forms moves the point.  The third form
moves the point and our original becomes</p>

<pre>
	acbd
	   ^
</pre>

<p>The advantage to this form is that repeated executions of the
command serve to &quot;drag&quot; a character along.</p>

<a name="c9.q"></a><h2>Questions to Probe Your Understanding</h2>

<p>Consider how your favorite editor's command set and implementation
meet the design guidelines.  (Medium)</p>

<p>Define a command that you would like to see in an
editor. (Easy)</p>

<p>What are some different ways to handle moving down a line (hint:
consider how to handle variable-width characters)?  (Easy)</p>

<p>How do the word, sentence, and paragraph problems change when
languages other than English are considered? (Medium)</p>

<p>Define a complete command set. (Hard)</p>

<p>Define a good structure-editor command set. (Hard)</p>

<p><a href="#contents">Back to Contents</a>.</p>
<hr>
<a name="c10"></a><h1>Ten: Emacs-Type Editors</h1>

<blockquote><i>
Oh frabjous day!  Callooh!  Callay!&quot;<br>
&nbsp;&nbsp;He chortled in his joy.
</i></blockquote>

<p>With a thesis subtitle of &quot;A Cookbook for an Emacs&quot; and
this book's subtitle of &quot;Emacs for Modern Times,&quot; it is a
safe bet that I would get around to discussing Emacs-type editors at
some point.  And so I have.</p>

<p>First, I will admit to being biased.  I have used Emacs-type
editors exclusively for going on fifteen years now (except for a brief
stint in durance vile on a Macintosh).  In addition, I have
implemented or worked on implementations of a half-dozen Emacs-type
editors.  This chapter will describe what it is about an Emacs-type
editor that makes it special.</p>

<a name="c10.1"></a><h2>10.1 &quot;What Do You Mean, 'Emacs-type?' &quot;</h2>

<p>This chapter discusses &quot;Emacs-type&quot; editors and not a
particular &quot;Emacs&quot; editor because, due to its very nature,
there isn't one definitive &quot;Emacs&quot; editor.  The closest that
you can come to such a thing is either the original Emacs-on-TECO or
Gnu-Emacs.</p>

<a name="c10.2"></a><h2>10.2 The Command Set</h2>

<p>The specifics of the Emacs command set will always be shifting and
changing.  Even details on how the basic commands operate will change.
However, the broad outlines of the basic commands are pretty constant,
which is to say that an editor that does not implement them is not
considered to be an Emacs-type editor.  Appendix C lists one Emacs
command set and a set of changes to it.</p>

<p>By and large, the Emacs command set follows the design guidelines
presented in the previous chapter.  Those places where it falls short
are usually either physical constraints (there are only a limited
number of keys available), design compromises (to achieve A one must
trade off B), or the ever-present &quot;historical reasons&quot; (it
was a good idea at the time and, while we know better now, it is too
ingrained to change).  All things considered, the Emacs command set
meets the design guidelines better than any other editor that I am
aware of.</p>

<p>Some editors never get beyond providing the command set.  These
editors are neither extensible nor provide an extended environment.
These limitations may be due to the implementation environment or
merely the amount of effort that is available to devote to the
project.  There is a place for such editors (they are listed in
Appendix B as &quot;command set&quot;).  After all, an implementor
should be able to decide to create a small editor without feeling
obligated to spend years on the project.  Given that this decision has
been made, it is better to use the Emacs command set than any other
(at least in my opinion).</p>

<a name="c10.3"></a><h2>10.3 The Extended Environment</h2>

<p>Emacs-type editors have been and continue to be used for many
things besides editing text.  Here are some examples.</p>

<p><b>Emulation</b>: If you or another user likes a different editor's
command set for some reason, you can just emulate it in an Emacs-type
editor.  Thus, you can still have all of the power of an Emacs and
your favorite command set as well.</p>

<p><b>Electronic mail</b>: A text editor can be the primary interface
to a mail system. Messages can be composed by editing a buffer and can
be sent with a command.  Mail can be read and managed by reading it
into a buffer and having commands to perform such operations as
&quot;move to the next message&quot; and &quot;summarize all
messages.&quot; Having the full power of an editor available makes it
easy to un-delete an accidentally deleted message or to copy part of
the text of a message into one's reply.  In addition, you have only
minimal additional learning in order to use the system very
effectively.</p>

<p><b>Command shell</b>: A text editor can be the primary interface to
the operating system.  Command lines can be edited with the full power
of the editor before being evaluated.  The past record of interaction
can be kept and parts of it examined or re-used in new command lines.
If the operating system does not have support for advanced terminals,
a display editor can offer its interface for use by other programs.
Other programs would then take advantage of the terminal independence
of the editor.  Alternatively, other programs would insert their
output into a buffer and the editor would become an entire
terminal-management system.  This function has been somewhat
superseded by a window system.  But again, why learn two systems when
you only need to learn one?</p>

<p><b>Compilation</b>: A text editor can work closely with a compiler
to speed turnaround when developing software.</p>

<p><b>Debugging</b>: A text editor can be used by a debugger.
Multiple buffers and multiple windows can be used to examine (perhaps
multiple) source files, interact with the debugger, and see the
output/input of the program as it runs.  In addition, a debugger might
use a window or two to do such things as constantly show the values of
selected variables.</p>

<p><b>File interface</b>: A text editor can be an interface to a
complicated file.  For example, an indexed sequential file can be
updated by providing editor commands to read and write entries (adding
or deleting them can be managed as well).  The full power of the
editor is available for editing the contents of the entry.</p>

<p><b>File system interface</b>: A text editor can provide a smooth
interface to the file system. A directory can be read by the editor
and &quot;edited&quot; by the user. Files can be deleted or otherwise
changed in a smooth manner by merely moving to the file name and
giving a command (<i>e.g.</i>, &quot;delete&quot;).</p>

<p><b>Binary files</b>: A text editor can be used to examine and --
when absolutely necessary -- modify binary files.  It can thus replace
various patching programs.</p>

<p>Again, all of these functions are currently performed by one or
more Emacs-type editors.  The main advantage to building them off of
the editor is that, even in the absence of such features, most users
spend the bulk of their time using the text editor (or word processor,
etc.).  By extending that environment, only minimal learning is
required to use those features.  Users are thus free to get work done
instead of having to spend their time reading manuals.  This extended
environment is one of the hallmarks of an Emacs-type editor.</p>

<a name="c10.4"></a><h2>10.4 Extensibility</h2>

<p>The final hallmark of an Emacs-type editor is extensibility.  Emacs
was born because of the extensibility of its predecessor, TECO.  TECO
was extensible and many of its users took advantage of that
extensibility to write their own command or change the existing ones.
Eventually, one person (Richard Stallman) took a large number of those
extension packages and created a &quot;standard&quot; package of
Editor MACroS: EMACS.  With extensibility in its heritage and even in
its name, an Emacs-type editor is expected to be extensible.</p>

<p>Extensibility means, quite simply, that end users can change any of
the features of the editor.  There should be <i>no</i> feature that a
sufficiently dedicated end user cannot change.  This implies that the
full source code of the implementation is available to all end users
(and that is why GNU-Emacs is distributed under its
&quot;CopyLeft&quot; policy).</p>

<p>Now, not every end user will want to recode redisplay.  However,
the principle remains.  Most end users will only want to tweak a few
parameters and maybe &quot;fix&quot; a command or two.  That's great
and you should encourage such changes by making it easy to make
them.</p>

<p>Now that the importance of extensibility has been explained, it is
easy to see why the Emacs command set cannot be standardized: each
user will want to change it.  In a way, the Emacs command set can be
compared to a ball of mud.  You can add more to it, or take some away,
and you will still have a ball of mud.  (Actually, this property is
true of most extensible systems.)  That is also why any comparison
between an implementation of an Emacs-type editor and any other editor
is pointless: the Emacs-type editor can be changed (and may already
have been) to overcome any shortcoming.</p>

<a name="c10.q"></a><h2>Questions to Probe Your Understanding</h2>

<p>Identify those ways in which the Emacs command set does not meet
the design guidelines listed in the previous chapter.  (Easy to
Medium)</p>

<p>Identify other editors or similar programs that offer extended
environments. (Easy)</p>

<p>Identify other editors or similar programs that are
extensible. (Easy)</p>

<p>What other programs would you like to be extensible that aren't?
(Easy)</p>

<p><a href="#contents">Back to Contents</a>.</p>
<hr>
<a name="epilogue"></a><h1>Epilogue</h1>

<blockquote><i>
'Twas brillig, and the slithy toves<br>
&nbsp;&nbsp;Did gyre and gimble in the wabe:<br>
All mimsy were the borogoves,<br>
&nbsp;&nbsp;And the mome raths outgrabe.
</i></blockquote>

<p>And so concludes the verse &quot;Jabberwocky&quot; by Lewis
Carroll.  A piece of nonsense verse embedded in a nonsense work, it
resembles the &quot;real world&quot; about as much as a computer
program does.  Which is perhaps why Lewis Carroll is so popular among
computer programmers.</p>

<p>And, before you ask, the chapter structure of this book was worked
out well before the fit of the verse was noticed. Right.</p>

<a name="epilogue.q"></a><h2>Questions to Probe Your Understanding</h2>

<p>What parts of &quot;Jabberwocky&quot; fit particularly well with
the chapters that they lead off?  Particularly poorly?  (Easy -- or is
it?)</p>

<p><a href="#contents">Back to Contents</a>.</p>
<hr>
<a name="aA"></a><h1>Appendix A: A Five-Minute Introduction to C</h1>

<p>This Appendix provides a brief introduction to that part of the C
programming language as used in the examples presented in this book.
This appendix is not a reference manual, nor does it describe all of
C.  Rather, it assumes that you are familiar with other programming
languages in general and just need a nudge or two to follow the
examples presented in this book.  If you want to learn more about the
C language, consult ANSI (1990) or Kernighan (1978).  If you are
interested in C, you should also look into the C++ language.</p>

<p>The best way to think of the C programming language is to consider
it as providing the programmer with a mechanism for allocating and
naming memory, control structure, and an extension mechanism.  Many
people consider it barely a high-level language.  Perhaps for that
very reason, it is ideally suited for systems and utilities such as
text editors.</p>

<p>The <i>declaration mechanism</i> provides the programmer a way to
allocate and name memory.  Data types are oriented around what is best
suited to the hardware.</p>

<p>The <i>language statements</i> provide a control structure
mechanism.  All of the usual control structures are available.  In
addition, a full suite of arithmetic and bit operators is available,
again focusing around what is best suited to the hardware.</p>

<p>The <i>procedure definition and call mechanism</i> provide the
extension mechanism.  Many &quot;standard&quot; C operations such as
string copy and input/output are implemented in terms of this
mechanism.</p>

<p>Comments are enclosed in &quot;/* ... */&quot;.</p>

<a name="aA.1"></a><h2>A.1 Case Conventions</h2>

<p>The names in this book follow the convention that <i>UPPERCASE</i>
names are pre-defined constants, <i>MixedCase</i> names are
procedures, and <i>lowercase</i> names are variables. Again, these are
conventions, not requirements.</p>

<a name="aA.2"></a><h2>A.2 Data Types and Declarations</h2>

<p>All variables and procedures used are declared.  Declarations are
of the following form:</p>

<blockquote><i>type variable</i>;</blockquote>

<p>The language supports the following data types:</p>

<table border="0" width="100%">
<colgroup>
<col width="10%">
<col width="90%">
</colgroup>

<tr><td valign="top"><b>char</b></td><td valign="top">The variable holds one character.
Characters are typically 8 bits wide.  They may either be signed
(range -128 to +127) or unsigned (range 0 to 255) at the
implementation's discretion.</td></tr>

<tr><td valign="top"><b>int</b></td><td valign="top">The variable holds an integer of a size
convenient to the hardware.  This size is typically 16 or 32
bits.</td></tr>

<tr><td valign="top"><b>float</b></td><td valign="top">The variable holds a floating point
number.</td></tr>

<tr><td valign="top"><b>FILE *</b></td><td valign="top">The variable holds a file
descriptor.</td></tr>

<tr><td valign="top"><b>struct <i>name</i> { &lt;list of declarations&gt;
};</b></td><td valign="top">the declarations are combined into a single, larger
data type named <i>name</i>.</td></tr>

<tr><td valign="top"><b><i>type</i> (*<i>name</i>)();</b></td><td valign="top">The <i>name</i>
is the address of a procedure that returns a value of type
<i>type</i>.</td></tr>

<tr><td valign="top"><b>void</b></td><td valign="top">No value.  Used to indicate that a
procedure does not return anything or accepts no arguments.</td></tr>

</table>

<p>A declaration of the form</p>

<blockquote>
<i>type</i> *
</blockquote>

<p>means that the variable holds the address of an object of the
specified type.  The variable is called a <i>pointer</i> to the
specified type.  A declaration of the form</p>

<blockquote>
<i>type name</i>[<i>constant</i>]
</blockquote>

<p>means that the variable holds an array of objects of the specified
data type.  The array is <i>constant</i> object long. The form</p>

<blockquote>
<i>type name</i>[<i>constant1</i>][<i>constant2</i>]
</blockquote>

<p>is used for a two-dimensional array.</p>

<p>The following data types are not part of the language, but
represent types used in examples.  An implementation would define
these in terms of existing-language data types.</p>

<table border="0" width="100%">
<colgroup>
<col width="10%">
<col width="90%">
</colgroup>

<tr><td valign="top"><b>FLAG</b></td><td valign="top">The variable holds a True or False value.
(In C any value is considered to be False and any non-zero value
is considered to be True.)</td></tr>

<tr><td valign="top"><b>status</b></td><td valign="top">The variable holds a success or failure status
value.  This value may include warning or error information.</td></tr>

<tr><td valign="top"><b>location</b></td><td valign="top">The variable holds a value that represents a
point or mark location within a buffer.</td></tr>

<tr><td valign="top"><b>time</b></td><td valign="top">The variable holds a value that represents the time
date and time.</td></tr>

<tr><td valign="top"><b>private</b></td><td valign="top">You get to define this.</td></tr>
</table>

<a name="aA.3"></a><h2>A.3 Constants</h2>

<p>Integers are written as themselves (<i>e.g.</i>, &quot;56&quot;
means the value fifty-six).</p>

<p>Hexadecimal constants are written in the form &quot;0x##&quot;,
where the ##s are hexadecimal digits.</p>

<p>Character strings are enclosed in double quotes (&quot; &quot;).  A
NUL-terminator (a byte of decimal value 0) is automatically appended
to the string by the compiler.  Character strings are considered to
have the type &quot;array of char.&quot;</p>

<p>Character constants are enclosed in single quotes ('&nbsp;').  They are
automatically converted to integers whose value is that of the
character.  For example:</p>

<table border="0" width="100%">
<colgroup>
<col width="10%">
<col width="90%">
</colgroup>

<tr><td valign="top"><b>&quot;a&quot;</b></td><td valign="top">is an array of two characters,
consisting of the characters 'a' and NUL (values 97 and 0 decimal,
assuming ASCII).</td></tr>

<tr><td valign="top"><b>'a'</b></td><td valign="top">is an integer whose value is 97, assuming
ASCII.</td></tr>
</table>

<p>while:</p>

<p>&quot;abc&quot; is an array of four characters, consisting of the
characters 'a', 'b', 'c', and NUL (values 97, 98, 99, and 0 decimal,
assuming ASCII).</p>

<p>The form 'abc' is officialy undefined (some compilers might
consider this as an integer whose value is 97 * 65536 + 98 * 256 + 99,
but don't count on it).</p>

<p>The character '\b' refers to the ASCII Back Space character
(8 decimal).</p>

<p>Note: the &quot;&quot; / '' syntax is used in all code excerpts.
However, the normal English typographical conventions of using
&quot;&quot; are followed in the body of the text.</p>

<a name="aA.4"></a><h2>A.4 Pre-defined Constants</h2>

<table border="0" width="100%">
<colgroup>
<col width="10%">
<col width="90%">
</colgroup>

<tr><td valign="top"><b>NEWLINE</b></td><td valign="top">The character string that represents a
system-specific newline, written &quot;\n&quot;.</td></tr>

<tr><td valign="top"><b>NL</b></td><td valign="top">The character that represents a newline, 10 decimal.</td></tr>

<tr><td valign="top"><b>SP</b></td><td valign="top">The space character, 32 decimal.</td></tr>

<tr><td valign="top"><b>TAB</b></td><td valign="top">The horizontal tab character, 9 decimal.</td></tr>

<tr><td valign="top"><b>NUL</b></td><td valign="top">The nul character, 0 decimal.  Character
strings are terminated by this character.</td></tr>

<tr><td valign="top"><b>NULL</b></td><td valign="top">The null pointer: no data object can be at
this address.</td></tr>

<tr><td valign="top"><b>BUFFERNAMEMAX</b></td><td valign="top">The size of the longest possible
buffer name plus 1 for the trailing NUL.  Possibly 33.</td></tr>

<tr><td valign="top"><b>FILENAMEMAX</b></td><td valign="top">The size of the longest possible
file name plus 1 for the trailing NUL.  Typically 1,025.</td></tr>

</table>

<a name="aA.5"></a><h2>A.5 Procedure Structure</h2>

<p>Procedures have the following structure:</p>

<pre>
<i>type Name</i>(&lt;arguments&gt;)
		{
		&lt;local variables&gt;

		&lt;statements&gt;
		}
</pre>

<p>The procedure is named <i>Name</i> and returns data of type
<i>type</i> (<i>type</i> can be a structure or pointer as well as a
basic type).  The argument list contains a list of declarations or the
keyword <b>void</b> if the procedure takes no arguments.  The local
variables are then declared (and may be initialized at each procedure
invocation).  Last are the procedure statements.</p>

<a name="aA.6"></a><h2>A.6 Statements</h2>

<p>The statements are the usual ones.  A semi-colon (&quot;;&quot;)
terminates a statement.  Comments start with &quot;/*&quot; and end
with &quot;*/&quot;.  Statements can be grouped with &quot;{&quot; and
&quot;}&quot; characters, so the sequence</p>

<pre>
	{
	&lt;statement 1&gt;
	&lt;statement 1&gt;
		...
	&lt;statement n&gt;
	}
</pre>

is equivalent to one statement.  White space and columns are not significant.

<pre>
<b>if (</b><i>condition</i><b>) </b><i>then-statement</i>

<b>if (</b><i>condition</i><b>) </b><i>then-statement</i><b>
else </b><i>else-statement</i>

<b>for (</b><i>initializer</i><b>; </b><i>end-test</i><b>; </b><i>increment</i><b>)

	</b><i>statements</i>
			execute the initializer, then the end test, then
			repeat the statements, the increment, and end test
			until the end test becomes True

	<b>break;</b>	exit a loop immediately

	<b>continue;</b>	skip the rest of the loop body, but don't
			 exit the loop

<b>while (</b><i>end-test</i><b>) </b><i>statements</i>
			repeat the end test and statements until the end
			test becomes True

<b>for (;;) </b><i>statements</i>
			repeat the statements forever: a break, continue,
			or return statement is used to exit the loop

<b>switch (</b><i>expression</i><b>) {

case</b> LABEL1:
	<i>statements</i>
	<b>break;

case</b> LABEL2:
	<i>statements</i>
	<b>break;

	...

default:</b>
	<i>statements</i>
	<b>break;
	}</b>
			execute the statements after the label whose value
			matches the expression, or the statements after
			&quot;default&quot; if present and no label matches

<b>return(</b><i>expression</i><b>);</b>
				return a value from a procedure
</pre>

<a name="aA.7"></a><h2>A.7 Operators</h2>

<p>The (possibly unusual) language operators are these:</p>

<table border="0" width="100%">
<colgroup>
<col width="10%">
<col width="90%">
</colgroup>

<tr><td valign="top"><b>=</b></td><td valign="top">assignment; not test for equality</td></tr>

<tr><td valign="top"><b>==</b></td><td valign="top">test for equality; not assignment</td></tr>

<tr><td valign="top"><b>!=</b></td><td valign="top">test for not equal</td></tr>

<tr><td valign="top"><b>!</b></td><td valign="top">logical negation: !FALSE becomes TRUE</td></tr>

<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>a+b</b></td><td valign="top">returns the sum of a and b</td></tr>

<tr><td valign="top"><b>a-b</b></td><td valign="top">returns the difference of a and b</td></tr>

<tr><td valign="top"><b>a*b</b></td><td valign="top">returns the product of a and b</td></tr>

<tr><td valign="top"><b>a/b</b></td><td valign="top">returns a divided by b</td></tr>

<tr><td valign="top"><b>a%b</b></td><td valign="top">returns a modulo b</td></tr>

<tr><td valign="top"><b>a&amp;b</b></td><td valign="top">returns the bitwise and of a and b</td></tr>

<tr><td valign="top"><b>a|b</b></td><td valign="top">returns the bitwise or of a and b</td></tr>

<tr><td valign="top"><b>a^b</b></td><td valign="top">returns the bitwise exclusive or of a and
b</td></tr>
</table>

<p>The construct &quot;a @= b&quot; where &quot;@&quot; is any of the
operators &quot;+&quot; through &quot;^&quot; does the same as &quot;a
= a @ b&quot;, except that &quot;a&quot; is only evaluated once.</p>

<p>Operators that return True / False results return 1 for True and 0
for False.  However, when a True / False value is required (say, in an
if-condition), any non-zero value means True and zero means False.</p>

<table border="0" width="100%">
<colgroup>
<col width="10%">
<col width="90%">
</colgroup>

<tr><td valign="top"><b>&amp;v</b></td><td valign="top">returns the address of v</td></tr>

<tr><td valign="top"><b>s.m</b></td><td valign="top">selects member m of the structure s (s is
of type &quot;struct&quot;)</td></tr>

<tr><td valign="top"><b>p-&gt;m</b></td><td valign="top">selects member m of the structure
pointed to by p (p is of type &quot;struct *&quot;)</td></tr>

<tr><td valign="top"><b>++v</b></td><td valign="top">increment the value in v and return the new
value</td></tr>

<tr><td valign="top"><b>v++</b></td><td valign="top">increment the value in v and return the
pre-increment value</td></tr>

<tr><td valign="top"><b>--v</b></td><td valign="top">decrement the value in v and return the new
value</td></tr>

<tr><td valign="top"><b>v--</b></td><td valign="top">decrement the value in v and return the
pre-decrement value</td></tr>
</table>

<p>The construct <b>(</b><i>type</i><b>)</b><i>expression</i> (called
a &quot;cast&quot;) converts the value returned by the expression to
the specified type.</p>

<a name="aA.8"></a><h2>A.8 Standard Library Functions Used in This Book</h2>

<p><i>fclose(&lt;fileptr&gt;)</i> closes a file opened earlier with
fopen.</p>

<p><i>fgets(&lt;buffer&gt;, &lt;length&gt;, &lt;fileptr&gt;)</i> reads
one line from a file opened earlier with fopen.</p>

<p><i>fopen(&lt;name&gt;, &lt;mode&gt;)</i> opens a file for reading.
A &lt;mode&gt; of &quot;r&quot; means &quot;read-only.&quot;</p>

<p><i>free(&lt;ptr&gt;)</i> frees memory previously allocated by
malloc.</p>

<p><i>isprint(&lt;key&gt;)</i> returns True if &lt;key&gt; is a
printing character or False if not.</p>

<p><i>malloc(&lt;size&gt;)</i> allocates a block of memory at least
&lt;size&gt; characters long.</p>

<p><i>memmove(&lt;to&gt;, &lt;from&gt;, &lt;length&gt;)</i> moves
&lt;length&gt; characters from &lt;from&gt; to &lt;to&gt;, working
properly if the areas overlap.</p>

<p><i>memset(&lt;start&gt;, &lt;char&gt;, &lt;length&gt;)</i> sets
&lt;length&gt; characters starting from &lt;start&gt; to the character
&lt;char&gt;.</p>

<p><i>printf(&lt;format&gt;)</i> or <i>printf(&lt;format&gt;,
&lt;arg&gt;)</i> copies the characters from the format string to the
screen &quot;as is&quot; until a '%' character is encountered.  The
sequence &quot;%s&quot; means to take the next argument and send it as
a string to the screen.  The sequence &quot;%c&quot; means to take the
next argument and send it as a single character to the screen.  (The
routine does a lot more, but the examples in this book don't use the
extra functionality.)</p>

<p><i>strcpy(&lt;to&gt;, &lt;from&gt;)</i> copy the from string to the
to string.</p>

<p><i>strlen(&lt;sting&gt;)</i> returns the number of characters in
the string, not counting the terminating NUL.</p>

<a name="aA.9"></a><h2>A.9 Non-Standard Library Functions Used in This Book</h2>

<p><i>Fatal(&lt;message&gt;)</i> handles a fatal error.</p>

<p><i>xiswhite(&lt;c&gt;)</i> returns True if the supplies character
is a white-space character (space or tab) or False if not.</p>

<p><i>xstrcpy(&lt;to&gt;, &lt;from&gt;)</i> works like the C
<i>strcpy</i> routine to copy one string to another, but is defined to
work properly if the strings overlap.</p>

<p><a href="#contents">Back to Contents</a>.</p>
<hr>
<a name="aB"></a><h1>Appendix B: Emacs Implementations</h1>

<p>This appendix has not been converted.  The <a
href=&quot;http://www.finseth.com/emacs.html">current Emacs
Implementations list</a> is maintained online.  Its URL for citation
purposes is:</p>

<blockquote><a href="http://www.finseth.com/emacs.html">
http://www.finseth.com/emacs.html</a></blockquote>

<p><a href="#contents">Back to Contents</a>.</p>
<hr>
<a name="aC"></a><h1>Appendix C: The Emacs Command Set</h1>

<p>First, there is no such thing as an &quot;official&quot; Emacs
command set.  One of the main reasons why Emacs-type text editors
exist is that each user is free to change the commands to suit his or
her own tastes.  Another reason is that there are many different
implementations of Emacs editors and each will have a slightly
different command set.  You should consult the documentation that
comes with your implementation (or the documentation that you write
for your own implementation) for specifics.</p>

<p>That said, this appendix will list most of the default command set
that comes with GNU-Emacs.  It will also list my own alterations to
these defaults.</p>

<p>Emacs-type text editors implement the &quot;one-dimensional array
of bytes&quot; editing model.  Line breaks are represented as single
Newline characters, regardless of the representation used by the
operating system.</p>

<a name="aC.1"></a><h2>C.1 Notation</h2>

<p>The first Emacs took advantage of a particular keyboard's features.
This keyboard allowed you to type all of the normal characters.  In
addition, both <b>Control</b> and <b>Meta</b> keys were available.
These keys acted as full Shift keys, allowing the user to specify
Control- and/or Meta-shifts to any key.  For example, one could
type:</p>

<table border="0" width="100%">
<colgroup>
<col width="10%">
<col width="90%">
</colgroup>

<tr><td valign="top"><b>notation</b></td><td valign="top"><b>key combinations</b></td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top"><b>5</b></td><td valign="top">5</td></tr>
<tr><td valign="top"><b>%</b></td><td valign="top">Shift-5</td></tr>
<tr><td valign="top"><b>C-5</b></td><td valign="top">Control-5</td></tr>
<tr><td valign="top"><b>C-%</b></td><td valign="top">Control-Shift-5</td></tr>
<tr><td valign="top"><b>M-5</b></td><td valign="top">Meta-5</td></tr>
<tr><td valign="top"><b>M-%</b></td><td valign="top">Meta-Shift-5</td></tr>
<tr><td valign="top"><b>M-C-5</b></td><td valign="top">Meta-Control-5</td></tr>
<tr><td valign="top"><b>M-C-%</b></td><td valign="top">Meta-Control-Shift-5</td></tr>
</table>

<p>The last two could also be written C-M-5 and C-M-%.  Most current
keyboards can only send the usual ASCII characters.  That limitation
removes the possibility of typing the multiply shifted characters and
hence the need for the unusual notation.  The command sets presented
here will thus use the familiar caret notation, a copy of which is
listed in Appendix E.  There are still some systems that use extended
keyboards like these.  The documentation for those systems will use
the original notation.</p>

<p>The Escape key (usually labelled &quot;Esc&quot;) which sends the
escape character is used as a prefix to make up for the missing Meta
shift key.  By convention, those keyboards that have an extra shift
key (perhaps labelled Meta or Alt) can specify meta commands by
setting bit 2^7 in characters sent from the keyboard.</p>

<p>Emacs commands are, by convention, always upper/lower
case-independent.  Thus, ^X B and ^X b both refer to the same command.
The only exception is the &quot;self-insert&quot; command, where B
inserts a &quot;B&quot; and b inserts a &quot;b&quot;.  Only the
uppercase versions will be listed.</p>

<p>The terms &quot;S-exp&quot; and &quot;defun,&quot; while familiar
to Lisp programmers, are probably not familiar to others.
&quot;S-exp&quot; refers to a parenthesized list and &quot;defun&quot;
refers to a function definition.  Most Emacs language modes remap
these Lisp-specific commands to comparable commands for other
programming languages.</p>

<a name="aC.2"></a><h2>C.2 Default GNU-Emacs Command List</h2>

<a name="aC.2.1"></a><h3>C.2.1 Base Commands</h3>

<table border="0" width="100%">
<colgroup>
<col width="10%">
<col width="90%">
</colgroup>

<tr><td valign="top"><b>^@</b></td><td valign="top">Place the mark at the point.</td></tr>
<tr><td valign="top"><b>^A</b></td><td valign="top">Move to the beginning of the current line.</td></tr>
<tr><td valign="top"><b>^B</b></td><td valign="top">Move backward one character.</td></tr>
<tr><td valign="top"><b>^C</b></td><td valign="top">Prefix for mode-specific commands.</td></tr>
<tr><td valign="top"><b>^D</b></td><td valign="top">Delete the following character.</td></tr>
<tr><td valign="top"><b>^E</b></td><td valign="top">Move to the end of the current line.</td></tr>
<tr><td valign="top"><b>^F</b></td><td valign="top">Move forward one character.</td></tr>
<tr><td valign="top"><b>^G</b></td><td valign="top">Abort execution and return to the edit loop.</td></tr>
<tr><td valign="top"><b>^H</b></td><td valign="top">Help</td></tr>
<tr><td valign="top"><b>^I</b></td><td valign="top">Tab to indentation in a language-specific manner.</td></tr>
<tr><td valign="top"><b>^J</b></td><td valign="top">Insert a line break and indent in a language-specific manner.</td></tr>
<tr><td valign="top"><b>^K</b></td><td valign="top">Delete the text to the end of the current line; if at the end of the line, delete the line break.  With an argument, delete that many complete lines.</td></tr>
<tr><td valign="top"><b>^L</b></td><td valign="top">Rebuild the display from scratch, centering the point.</td></tr>
<tr><td valign="top"><b>^M</b></td><td valign="top">Insert a line break, leaving the point after the break.</td></tr>
<tr><td valign="top"><b>^N</b></td><td valign="top">Move down one line, staying in as nearly the same column as possible.  If at the end of the buffer, grow the buffer.</td></tr>
<tr><td valign="top"><b>^O</b></td><td valign="top">Insert a line break, leaving the point before the break.</td></tr>
<tr><td valign="top"><b>^P</b></td><td valign="top">Move up one line, staying in as nearly the same column as possible.</td></tr>
<tr><td valign="top"><b>^Q</b></td><td valign="top">Quote: Insert the following character as typed.</td></tr>
<tr><td valign="top"><b>^R</b></td><td valign="top">Reverse search (see ^S).</td></tr>
<tr><td valign="top"><b>^S</b></td><td valign="top">Search incrementally for a string after the:

<table border="0">
<colgroup>
<col width="10%">
<col width="90%">
</colgroup>

<tr><td valign="top"><b>^R</b></td><td valign="top">Search for the previous occurrence.</td></tr>
<tr><td valign="top"><b>^S</b></td><td valign="top">Search for the next (2nd, 3rd...) occurrence.</td></tr>
<tr><td valign="top"><b>^?</b></td><td valign="top">&quot;Untypes&quot; the last character (including ^R, ^S, etc.)</td></tr>
<tr><td valign="top"><b>^G</b></td><td valign="top">Abort search: return to starting place.</td></tr>
<tr><td valign="top"><b>^[</b></td><td valign="top">Complete the search.</td></tr>
<tr><td valign="top"><b>^Q</b></td><td valign="top">Quote a search command.</td></tr>
<tr><td valign="top"><b>ctrl-XX</b></td><td valign="top">Complete the search and execute the XX command.</td></tr>
<tr><td valign="top"><b>other</b></td><td valign="top">Add the character to the search string.</td></tr>
</table>
</td></tr>

<tr><td valign="top"><b>^T</b></td><td valign="top">Interchange the characters on each side of the point, leaving the point after the second one.</td></tr>
<tr><td valign="top"><b>^U</b></td><td valign="top">Universal argument. There are two:

<table border="0">
<colgroup>
<col width="25%">
<col width="75%">
</colgroup>

<tr><td valign="top"><b><i>^U ^U .... &lt;cmd&gt;</i></b></td><td valign="top">does &lt;cmd&gt; 4, 16, 64, 256, ... times depending upon the number of ^Us (each ^U is a multiplier by 4).</td></tr>
<tr><td valign="top"><b><i>^U &lt;integer&gt; &lt;cmd&gt;</i></b></td><td valign="top">does &lt;cmd&gt; &lt;integer&gt; times. (<i>e.g.</i>, ^U 3 5 ^F means to ^F 35 times).</td></tr>
</table>
</td></tr>

<tr><td valign="top"><b>^V</b></td><td valign="top">Move the bottom of the current screen to the top of the screen: <i>i.e.</i>, move down one screen.</td></tr>
<tr><td valign="top"><b>^W</b></td><td valign="top">Delete the text between the point and the mark (&quot;cut&quot;).</td></tr>
<tr><td valign="top"><b>^X</b></td><td valign="top">Prefix for the ^X commands listed below.</td></tr>
<tr><td valign="top"><b>^Y</b></td><td valign="top">Copy the top item from the kill ring to the point; place the mark at the beginning of the block and the point at the end (&quot;paste&quot;).</td></tr>
<tr><td valign="top"><b>^Z</b></td><td valign="top">Suspend the program's execution and return to whatever invoked the editor.</td></tr>
<tr><td valign="top"><b>^[</b></td><td valign="top">Prefix for the Meta commands listed below.</td></tr>
<tr><td valign="top"><b>^\</b></td><td valign="top">Undefined.</td></tr>
<tr><td valign="top"><b>^]</b></td><td valign="top">Aborts a recursive edit.</td></tr>
<tr><td valign="top"><b>^^</b></td><td valign="top">Undefined.</td></tr>
<tr><td valign="top"><b>^_</b></td><td valign="top">Undo.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top"><b>SP ... ~</b></td><td valign="top">Insert themselves.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top"><b>^?</b></td><td valign="top">Delete the preceding character.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top"><b>BS</b></td><td valign="top">Same as ^H, also BACK SPACE.</td></tr>
<tr><td valign="top"><b>TAB</b></td><td valign="top">Same as ^I.</td></tr>
<tr><td valign="top"><b>LF</b></td><td valign="top">Same as ^J, also LINE FEED.</td></tr>
<tr><td valign="top"><b>CR</b></td><td valign="top">Same as ^M, also CARRIAGE RETURN or RETURN.</td></tr>
<tr><td valign="top"><b>ESC</b></td><td valign="top">Same as ^[, also ESCAPE.</td></tr>
<tr><td valign="top"><b>DEL</b></td><td valign="top">Same as ^?, also DELETE or RUBOUT (obsolete).</td></tr>
</table>

<a name="aC.2.2"></a><h3>C.2.2 Help Commands</h3>

<table border="0" width="100%">
<colgroup>
<col width="10%">
<col width="90%">
</colgroup>

<tr><td valign="top"><b>^H ^C</b></td><td valign="top">Describe the copying policy.</td></tr>
<tr><td valign="top"><b>^H ^D</b></td><td valign="top">Describe the distribution policy.</td></tr>
<tr><td valign="top"><b>^H ^H</b></td><td valign="top">Help on help.</td></tr>
<tr><td valign="top"><b>^H ^N</b></td><td valign="top">View Emacs news.</td></tr>
<tr><td valign="top"><b>^H ^W</b></td><td valign="top">Describe the (lack of) warranty.</td></tr>
<tr><td valign="top"><b>^H ?</b></td><td valign="top">Help on help.</td></tr>
<tr><td valign="top"><b>^H A</b></td><td valign="top">Apropos (which commands deal with ...?).</td></tr>
<tr><td valign="top"><b>^H B</b></td><td valign="top">Describe the current key bindings.</td></tr>
<tr><td valign="top"><b>^H C</b></td><td valign="top">Briefly describe a key.</td></tr>
<tr><td valign="top"><b>^H D</b></td><td valign="top">Describe a function.</td></tr>
<tr><td valign="top"><b>^H F</b></td><td valign="top">Describe a function.</td></tr>
<tr><td valign="top"><b>^H I</b></td><td valign="top">Invoke the &quot;info&quot; subsystem.</td></tr>
<tr><td valign="top"><b>^H K</b></td><td valign="top">Describe a key.</td></tr>
<tr><td valign="top"><b>^H L</b></td><td valign="top">Describe problems with the (current) version (&quot;lossage&quot;).</td></tr>
<tr><td valign="top"><b>^H M</b></td><td valign="top">Describe a mode.</td></tr>
<tr><td valign="top"><b>^H N</b></td><td valign="top">View Emacs news.</td></tr>
<tr><td valign="top"><b>^H S</b></td><td valign="top">Describe syntax.</td></tr>
<tr><td valign="top"><b>^H T</b></td><td valign="top">Tutorial.</td></tr>
<tr><td valign="top"><b>^H V</b></td><td valign="top">Describe a variable.</td></tr>
<tr><td valign="top"><b>^H W</b></td><td valign="top">Where is ...?</td></tr>
</table>

<a name="aC.2.3"></a><h3>C.2.3 Control-X (^X) Commands</h3>

<table border="0" width="100%">
<colgroup>
<col width="10%">
<col width="90%">
</colgroup>

<tr><td valign="top"><b>^X ^@</b></td><td valign="top">Flush mouse queue.</td></tr>
<tr><td valign="top"><b>^X ^A</b></td><td valign="top">Add mode abbreviation.</td></tr>
<tr><td valign="top"><b>^X ^B</b></td><td valign="top">Display a list of all buffers and associated information.</td></tr>
<tr><td valign="top"><b>^X ^C</b></td><td valign="top">Exit editor.</td></tr>
<tr><td valign="top"><b>^X ^D</b></td><td valign="top">Display the current directory.</td></tr>
<tr><td valign="top"><b>^X ^E</b></td><td valign="top">Evaluate the last S-exp.</td></tr>
<tr><td valign="top"><b>^X ^F</b></td><td valign="top">Ask for the name of a file and read it into a new buffer whose name is derived from the file name.</td></tr>
<tr><td valign="top"><b>^X ^G</b></td><td valign="top">Cancel ^X prefix.</td></tr>
<tr><td valign="top"><b>^X ^H</b></td><td valign="top">Remove mode abbreviation.</td></tr>
<tr><td valign="top"><b>^X ^I</b></td><td valign="top">Indent rigidly</td></tr>
<tr><td valign="top"><b>^X ^L</b></td><td valign="top">Convert the region to lower case.</td></tr>
<tr><td valign="top"><b>^X ^N</b></td><td valign="top">Set the goal column.</td></tr>
<tr><td valign="top"><b>^X ^O</b></td><td valign="top">Delete the blank lines around the point.</td></tr>
<tr><td valign="top"><b>^X ^P</b></td><td valign="top">Place the point and the mark around the current page.</td></tr>
<tr><td valign="top"><b>^X ^Q</b></td><td valign="top">Toggle the &quot;read only&quot; marker.</td></tr>
<tr><td valign="top"><b>^X ^R</b></td><td valign="top">As ^X ^F, but mark the file &quot;read only.&quot;</td></tr>
<tr><td valign="top"><b>^X ^S</b></td><td valign="top">Save the current buffer if it has been modified.</td></tr>
<tr><td valign="top"><b>^X ^T</b></td><td valign="top">Transpose lines.</td></tr>
<tr><td valign="top"><b>^X ^U</b></td><td valign="top">Convert the region to upper case.</td></tr>
<tr><td valign="top"><b>^X ^V</b></td><td valign="top">Find alternate file.</td></tr>
<tr><td valign="top"><b>^X ^W</b></td><td valign="top">Ask for the name of a file and write the buffer to that file.</td></tr>
<tr><td valign="top"><b>^X ^X</b></td><td valign="top">Exchange the point and mark.</td></tr>
<tr><td valign="top"><b>^X ^[</b></td><td valign="top">Repeat a complex command.</td></tr>
<tr><td valign="top"><b>^X $</b></td><td valign="top">Set selective display.</td></tr>
<tr><td valign="top"><b>^X '</b></td><td valign="top">Expand an abbreviation.</td></tr>
<tr><td valign="top"><b>^X (</b></td><td valign="top">Start collecting a keyboard macro.</td></tr>
<tr><td valign="top"><b>^X )</b></td><td valign="top">End collecting a keyboard macro.</td></tr>
<tr><td valign="top"><b>^X +</b></td><td valign="top">Add global abbreviation.</td></tr>
<tr><td valign="top"><b>^X -</b></td><td valign="top">Remove global abbreviation.</td></tr>
<tr><td valign="top"><b>^X .</b></td><td valign="top">Set the fill prefix.</td></tr>
<tr><td valign="top"><b>^X /</b></td><td valign="top">Point to register.</td></tr>
<tr><td valign="top"><b>^X 0</b></td><td valign="top">Delete window.</td></tr>
<tr><td valign="top"><b>^X 1</b></td><td valign="top">Delete other windows.</td></tr>
<tr><td valign="top"><b>^X 2</b></td><td valign="top">Split window vertically (one above the other).</td></tr>
<tr><td valign="top"><b>^X 3</b></td><td valign="top">Split window vertically (one above the other), but stay in the first.</td></tr>
<tr><td valign="top"><b>^X 4</b></td><td valign="top">Prefix for the Control-X 4 commands listed below.</td></tr>
<tr><td valign="top"><b>^X 5</b></td><td valign="top">Split window horizontally (one beside the other).</td></tr>
<tr><td valign="top"><b>^X ;</b></td><td valign="top">Set the comment column.</td></tr>
<tr><td valign="top"><b>^X &lt;</b></td><td valign="top">Scroll the window left.</td></tr>
<tr><td valign="top"><b>^X =</b></td><td valign="top">Display the current cursor position.</td></tr>
<tr><td valign="top"><b>^X &gt;</b></td><td valign="top">Scroll the window right.</td></tr>
<tr><td valign="top"><b>^X A</b></td><td valign="top">Append the region to a buffer.</td></tr>
<tr><td valign="top"><b>^X B</b></td><td valign="top">Switch to a buffer.</td></tr>
<tr><td valign="top"><b>^X D</b></td><td valign="top">Edit directory (&quot;DIRED&quot;).</td></tr>
<tr><td valign="top"><b>^X E</b></td><td valign="top">Invoke the last keyboard macro.</td></tr>
<tr><td valign="top"><b>^X F</b></td><td valign="top">Set the fill column to the horizontal position.</td></tr>
<tr><td valign="top"><b>^X G</b></td><td valign="top">Insert a register.</td></tr>
<tr><td valign="top"><b>^X H</b></td><td valign="top">Place the point and the mark around the entire buffer.</td></tr>
<tr><td valign="top"><b>^X I</b></td><td valign="top">Insert a file.</td></tr>
<tr><td valign="top"><b>^X J</b></td><td valign="top">Register to point.</td></tr>
<tr><td valign="top"><b>^X K</b></td><td valign="top">Kill a buffer.</td></tr>
<tr><td valign="top"><b>^X L</b></td><td valign="top">Count the number of lines in the page.</td></tr>
<tr><td valign="top"><b>^X M</b></td><td valign="top">Send electronic mail.</td></tr>
<tr><td valign="top"><b>^X N</b></td><td valign="top">Narrow the editing bounds to the region.</td></tr>
<tr><td valign="top"><b>^X O</b></td><td valign="top">Switch to the other window.</td></tr>
<tr><td valign="top"><b>^X P</b></td><td valign="top">Narrow the editing bounds to the page.</td></tr>
<tr><td valign="top"><b>^X Q</b></td><td valign="top">Keyboard macro query.</td></tr>
<tr><td valign="top"><b>^X R</b></td><td valign="top">Copy a rectangle to a register.</td></tr>
<tr><td valign="top"><b>^X S</b></td><td valign="top">Save some buffers.</td></tr>
<tr><td valign="top"><b>^X U</b></td><td valign="top">Advertised undo.</td></tr>
<tr><td valign="top"><b>^X W</b></td><td valign="top">Widen the editing bounds.</td></tr>
<tr><td valign="top"><b>^X X</b></td><td valign="top">Copy to a register.</td></tr>
<tr><td valign="top"><b>^X [</b></td><td valign="top">Move backward one page.</td></tr>
<tr><td valign="top"><b>^X ]</b></td><td valign="top">Move forward one page.</td></tr>
<tr><td valign="top"><b>^X ^</b></td><td valign="top">Grow the current window.</td></tr>
<tr><td valign="top"><b>^X `</b></td><td valign="top">Move to the location implied by the next error message.</td></tr>
<tr><td valign="top"><b>^X {</b></td><td valign="top">Shrink a window horizontally.</td></tr>
<tr><td valign="top"><b>^X }</b></td><td valign="top">Grow a window horizontally.</td></tr>
<tr><td valign="top"><b>^X ^?</b></td><td valign="top">Delete to the beginning of the current sentence.</td></tr>
</table>

<a name="aC.2.4"></a><h3>C.2.4 Control-X 4 Commands</h3>

<table border="0" width="100%">
<colgroup>
<col width="10%">
<col width="90%">
</colgroup>

<tr><td valign="top"><b>^X 4 ^F</b></td><td valign="top">Find file other window.</td></tr>
<tr><td valign="top"><b>^X 4 .</b></td><td valign="top">Find tag other window.</td></tr>
<tr><td valign="top"><b>^X 4 A</b></td><td valign="top">Add change log entry other window.</td></tr>
<tr><td valign="top"><b>^X 4 B</b></td><td valign="top">Switch buffer other window.</td></tr>
<tr><td valign="top"><b>^X 4 D</b></td><td valign="top">DIRED other window.</td></tr>
<tr><td valign="top"><b>^X 4 F</b></td><td valign="top">Find file other window.</td></tr>
<tr><td valign="top"><b>^X 4 M</b></td><td valign="top">Mail other window.</td></tr>
</table>

<a name="aC.2.5"></a><h3>C.2.5 Meta (^[) Commands</h3>

<table border="0" width="100%">
<colgroup>
<col width="10%">
<col width="90%">
</colgroup>

<tr><td valign="top"><b>^[ ^@</b></td><td valign="top">Place the point and the mark around the S-exp.</td></tr>
<tr><td valign="top"><b>^[ ^A</b></td><td valign="top">Move to the beginning of the current defun.</td></tr>
<tr><td valign="top"><b>^[ ^B</b></td><td valign="top">Move backward one S-exp.</td></tr>
<tr><td valign="top"><b>^[ ^C</b></td><td valign="top">Exit recursive edit.</td></tr>
<tr><td valign="top"><b>^[ ^D</b></td><td valign="top">Move down one level of list structure.</td></tr>
<tr><td valign="top"><b>^[ ^E</b></td><td valign="top">Move to the end of the current defun.</td></tr>
<tr><td valign="top"><b>^[ ^F</b></td><td valign="top">Move forward one S-exp.</td></tr>
<tr><td valign="top"><b>^[ ^G</b></td><td valign="top">Format (&quot;grind&quot;) the current S-exp.</td></tr>
<tr><td valign="top"><b>^[ ^H</b></td><td valign="top">Place the point and the mark around the S-exp.</td></tr>
<tr><td valign="top"><b>^[ ^I</b></td><td valign="top">Complete a Lisp symbol.</td></tr>
<tr><td valign="top"><b>^[ ^J</b></td><td valign="top">Indent a new comment line.</td></tr>
<tr><td valign="top"><b>^[ ^K</b></td><td valign="top">Delete the following S-exp.</td></tr>
<tr><td valign="top"><b>^[ ^N</b></td><td valign="top">Move forward one list.</td></tr>
<tr><td valign="top"><b>^[ ^O</b></td><td valign="top">Split line: move the rest of this line vertically down.</td></tr>
<tr><td valign="top"><b>^[ ^P</b></td><td valign="top">Move backward one list.</td></tr>
<tr><td valign="top"><b>^[ ^Q</b></td><td valign="top">Indent an S-exp.</td></tr>
<tr><td valign="top"><b>^[ ^S</b></td><td valign="top">Incremental search forward using regular expressions.</td></tr>
<tr><td valign="top"><b>^[ ^T</b></td><td valign="top">Transpose the adjoining S-exp.</td></tr>
<tr><td valign="top"><b>^[ ^V</b></td><td valign="top">Scroll the other window.</td></tr>
<tr><td valign="top"><b>^[ ^W</b></td><td valign="top">Append the next delete to the top item on the kill ring.</td></tr>
<tr><td valign="top"><b>^[ ^X</b></td><td valign="top">Evaluate a defun.</td></tr>
<tr><td valign="top"><b>^[ ^[</b></td><td valign="top">Evaluate an expression.</td></tr>
<tr><td valign="top"><b>^[ ^\</b></td><td valign="top">Indent the region.</td></tr>
<tr><td valign="top"><b>^[ SP</b></td><td valign="top">Insert exactly one space.</td></tr>
<tr><td valign="top"><b>^[ !</b></td><td valign="top">Ask for and execute a shell command.</td></tr>
<tr><td valign="top"><b>^[ $</b></td><td valign="top">Invoke the spelling checker on a word.</td></tr>
<tr><td valign="top"><b>^[ %</b></td><td valign="top">Query replace: ask for an old string and a new string. At each occurrence of the old string, display it and ask for a:

<table border="0" width="100%">
<colgroup>
<col width="10%">
<col width="90%">
</colgroup>

<tr><td valign="top"><b>^L</b></td><td valign="top">Redisplay the screen.</td></tr>
<tr><td valign="top"><b>^R</b></td><td valign="top">Invoke the editor recursively.</td></tr>
<tr><td valign="top"><b>^W</b></td><td valign="top">Delete the old string and invoke the editor recursively.</td></tr>
<tr><td valign="top"><b>^[</b></td><td valign="top">Exit.</td></tr>
<tr><td valign="top"><b>SP</b></td><td valign="top">Replace the old with the new and continue.</td></tr>
<tr><td valign="top"><b>,</b></td><td valign="top">Replace and wait for confirmation.</td></tr>
<tr><td valign="top"><b>.</b></td><td valign="top">Replace and exit.</td></tr>
<tr><td valign="top"><b>!</b></td><td valign="top">Replace the rest without asking.</td></tr>
<tr><td valign="top"><b>^</b></td><td valign="top">Return to previous old string (jump to mark).</td></tr>
<tr><td valign="top"><b>^?</b></td><td valign="top">Don't replace but continue.</td></tr>
</table>
</td></tr>

<tr><td valign="top"><b>^[ '</b></td><td valign="top">Set abbreviation prefix mark.</td></tr>
<tr><td valign="top"><b>^[ (</b></td><td valign="top">Insert paired parentheses.</td></tr>
<tr><td valign="top"><b>^[ )</b></td><td valign="top">Move past the closing parenthesis.</td></tr>
<tr><td valign="top"><b>^[ ,</b></td><td valign="top">Tags loop continue.</td></tr>
<tr><td valign="top"><b>^[ -</b></td><td valign="top">Make the argument negative.</td></tr>
<tr><td valign="top"><b>^[ .</b></td><td valign="top">Find a tag.</td></tr>
<tr><td valign="top"><b>^[ /</b></td><td valign="top">Abbreviation expand.</td></tr>
<tr><td valign="top"><b>^[ 0 .. 9</b></td><td valign="top">Use digits as argument (similar to ^U).</td></tr>
<tr><td valign="top"><b>^[ ;</b></td><td valign="top">Indent for comment.</td></tr>
<tr><td valign="top"><b>^[ &lt;</b></td><td valign="top">Move to the beginning of the current buffer.</td></tr>
<tr><td valign="top"><b>^[ =</b></td><td valign="top">Count the lines within the region.</td></tr>
<tr><td valign="top"><b>^[ &gt;</b></td><td valign="top">Move to the end of the current buffer.</td></tr>
<tr><td valign="top"><b>^[ @</b></td><td valign="top">Place the point and mark around the current word.</td></tr>
<tr><td valign="top"><b>^[ A</b></td><td valign="top">Move to the beginning of the current sentence.</td></tr>
<tr><td valign="top"><b>^[ B</b></td><td valign="top">Move backward one word.</td></tr>
<tr><td valign="top"><b>^[ C</b></td><td valign="top">Capitalize the following word.</td></tr>
<tr><td valign="top"><b>^[ D</b></td><td valign="top">Delete the following word.</td></tr>
<tr><td valign="top"><b>^[ E</b></td><td valign="top">Move to the end of the current sentence.</td></tr>
<tr><td valign="top"><b>^[ F</b></td><td valign="top">Move forward one word.</td></tr>
<tr><td valign="top"><b>^[ G</b></td><td valign="top">Fill text in the region.</td></tr>
<tr><td valign="top"><b>^[ H</b></td><td valign="top">Place the point and the mark around the current paragraph.</td></tr>
<tr><td valign="top"><b>^[ I</b></td><td valign="top">Tab to tab stop.</td></tr>
<tr><td valign="top"><b>^[ J</b></td><td valign="top">Indent new comment line.</td></tr>
<tr><td valign="top"><b>^[ K</b></td><td valign="top">Delete the remainder of the current sentence.</td></tr>
<tr><td valign="top"><b>^[ L</b></td><td valign="top">Convert the following word to lower case.</td></tr>
<tr><td valign="top"><b>^[ M</b></td><td valign="top">Move back to indentation.</td></tr>
<tr><td valign="top"><b>^[ Q</b></td><td valign="top">Fill the current paragraph.  ^U ^[ Q means to justify the paragraph.</td></tr>
<tr><td valign="top"><b>^[ R</b></td><td valign="top">Move to window line.</td></tr>
<tr><td valign="top"><b>^[ T</b></td><td valign="top">Transpose the adjoining words.</td></tr>
<tr><td valign="top"><b>^[ U</b></td><td valign="top">Convert the following word to upper case.</td></tr>
<tr><td valign="top"><b>^[ V</b></td><td valign="top">Move the top of the current screen to the bottom of the screen: <i>i.e.</i>, move up one screen.</td></tr>
<tr><td valign="top"><b>^[ W</b></td><td valign="top">Copy the region to the kill buffer.</td></tr>
<tr><td valign="top"><b>^[ X</b></td><td valign="top">Execute extended command.</td></tr>
<tr><td valign="top"><b>^[ Y</b></td><td valign="top">After ^Y: Delete the just-yanked text and yank the previously killed text.</td></tr>
<tr><td valign="top"><b>^[ Z</b></td><td valign="top">Zap to character.</td></tr>
<tr><td valign="top"><b>^[ [</b></td><td valign="top">Move to the beginning of the current paragraph.</td></tr>
<tr><td valign="top"><b>^[ \</b></td><td valign="top">Delete the spaces and tabs around the point.</td></tr>
<tr><td valign="top"><b>^[ ]</b></td><td valign="top">Move to the end of the current paragraph.</td></tr>
<tr><td valign="top"><b>^[ ^</b></td><td valign="top">Delete the indentation on the current line.</td></tr>
<tr><td valign="top"><b>^[ |</b></td><td valign="top">Execute a shell command on the region (&quot;pipe the region through a shell command&quot;).</td></tr>
<tr><td valign="top"><b>^[ ~</b></td><td valign="top">Clear the buffer modified flag.</td></tr>
<tr><td valign="top"><b>^[ ^?</b></td><td valign="top">Delete the previous word.</td></tr>
</table>

<a name="aC.3"></a><h2>C.3 The Author's Command Set</h2>

<p>This section lists the changes the author makes to the
just-presented default command set.</p>

<table border="0" width="100%">
<colgroup>
<col width="10%">
<col width="90%">
</colgroup>

<tr><td valign="top"><b>^C</b></td><td valign="top">Rotate case of word: foo -&gt; Foo -&gt; FOO -&gt; foo ...</td></tr>
<tr><td valign="top"><b>^H</b></td><td valign="top">Delete the previous character.</td></tr>
<tr><td valign="top"><b>^I</b></td><td valign="top">Just insert a TAB: no special indentation.</td></tr>
<tr><td valign="top"><b>^J</b></td><td valign="top">Insert a line break and indent the new line the same as the current one.</td></tr>
<tr><td valign="top"><b>^K</b></td><td valign="top">Delete lines as usual, but don't treat an argument specially.</td></tr>
<tr><td valign="top"><b>^M</b></td><td valign="top">Just insert a line break: no special actions.</td></tr>
<tr><td valign="top"><b>^N</b></td><td valign="top">Move to the next line: don't extend the buffer.</td></tr>
<tr><td valign="top"><b>^T</b></td><td valign="top">Always transpose the two preceding characters.</td></tr>
<tr><td valign="top"><b>^V</b></td><td valign="top">A slightly different move down screen.</td></tr>
<tr><td valign="top"><b>^Z</b></td><td valign="top">Move up screen.</td></tr>
<tr><td valign="top"><b>^\</b></td><td valign="top">Delete all white space (indentation) on the current line.</td></tr>
<tr><td valign="top"><b>^]</b></td><td valign="top">Invoke keyboard macro.</td></tr>
<tr><td valign="top"><b>^_</b></td><td valign="top">Suspend the program's execution and return to whatever invoked the editor.</td></tr>
<tr><td valign="top"><b>^?</b></td><td valign="top">Delete the previous character with no special actions.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top"><b>^X ^E</b></td><td valign="top">Execute one shell command.</td></tr>
<tr><td valign="top"><b>^X ^I</b></td><td valign="top">Insert a file.</td></tr>
<tr><td valign="top"><b>^X ^M</b></td><td valign="top">Invoke a subshell.</td></tr>
<tr><td valign="top"><b>^X ^N</b></td><td valign="top">Null (to prevent typing by accident).</td></tr>
<tr><td valign="top"><b>^X ^P</b></td><td valign="top">Null (to prevent typing by accident).</td></tr>
<tr><td valign="top"><b>^X ^R</b></td><td valign="top">Re-read file.</td></tr>
<tr><td valign="top"><b>^X ^T</b></td><td valign="top">Return to top-level editing (exit all recursive editors).</td></tr>
<tr><td valign="top"><b>^X \</b></td><td valign="top">Get rid of all &quot;^H_&quot; strings in the buffer (used to make UNIX man pages more readable after doing &quot;^X ^E man <i>title</i>&quot;).</td></tr>
<tr><td valign="top"><b>^X C</b></td><td valign="top">Invoke compiler.</td></tr>
<tr><td valign="top"><b>^X ^H</b></td><td valign="top">Help.</td></tr>
<tr><td valign="top"><b>^X N</b></td><td valign="top">Null (to prevent typing by accident).</td></tr>
<tr><td valign="top"><b>^X P</b></td><td valign="top">Null (to prevent typing by accident).</td></tr>
<tr><td valign="top"><b>^X R</b></td><td valign="top">Read electronic mail.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top"><b>^[ ^H</b></td><td valign="top">Delete previous word.</td></tr>
<tr><td valign="top"><b>^[ ^R</b></td><td valign="top">Query replace.</td></tr>
<tr><td valign="top"><b>^[ ^[</b></td><td valign="top">Null (to prevent typing by accident).</td></tr>
<tr><td valign="top"><b>^[ SP</b></td><td valign="top">Set the mark.</td></tr>
<tr><td valign="top"><b>^[ &lt;</b></td><td valign="top">Move to the beginning of the buffer.  With an argument, move to the specified line number.</td></tr>
<tr><td valign="top"><b>^[ =</b></td><td valign="top">Display the number of lines in the buffer and the number of the line that the point is on.</td></tr>
<tr><td valign="top"><b>^[ &gt;</b></td><td valign="top">Move to the end of the buffer.  With an argument, move to the specified line number.</td></tr>
<tr><td valign="top"><b>^[ G</b></td><td valign="top">Ask for a line number and go to the specified line.</td></tr>
<tr><td valign="top"><b>^[ I</b></td><td valign="top">Null (to prevent typing by accident).</td></tr>
<tr><td valign="top"><b>^[ J</b></td><td valign="top">Null (to prevent typing by accident).</td></tr>
<tr><td valign="top"><b>^[ M</b></td><td valign="top">Null (to prevent typing by accident).</td></tr>
<tr><td valign="top"><b>^[ N</b></td><td valign="top">Null (to prevent typing by accident).</td></tr>
<tr><td valign="top"><b>^[ O</b></td><td valign="top">Null (to prevent typing by accident).</td></tr>
<tr><td valign="top"><b>^[ P</b></td><td valign="top">Null (to prevent typing by accident).</td></tr>
<tr><td valign="top"><b>^[ R</b></td><td valign="top">Replace string (as ^[ ^R, but don't ask).</td></tr>
<tr><td valign="top"><b>^[ S</b></td><td valign="top">Center the current line.</td></tr>
<tr><td valign="top"><b>^[ Z</b></td><td valign="top">Null (to prevent typing by accident).</td></tr>
<tr><td valign="top"><b>^[ \</b></td><td valign="top">Delete all surrounding spaces, tabs, and line breaks and re-insert one space.</td></tr>
</table>

<p><a href="#contents">Back to Contents</a>.</p>
<hr>
<a name="aD"></a><h1>Appendix D: The TECO Command Set</h1>

<p>This appendix presents a summary of the MIT TECO editor's command
set.  Should you actually find an ITS or TOPS-20 system and wish to
run TECO on it, this appendix will be useful but not completely
replace the full manual.</p>

<p>TECO implements the &quot;one-dimensional array of bytes&quot;
editing model.  Line breaks are stored as single newline characters.
Large files are divided into <i>pages</i>.  Pages within a file must
be edited in order (<i>i.e.</i>, all editing on the first page is
done, then the second page is read in and edited, etc.).  The only way
to go backwards is to finish editing the file and to start over.  On
the other hand, on most systems, only very large files (over 64
Kilobytes) are split into pages.</p>

<p>Commands are single or double characters.  Upper/lower case is
ignored.  The basic forms of commands are &quot;C&quot;,
&quot;nC&quot; and &quot;n,mC&quot;.  The first form executes command
&quot;C&quot; with the default arguments, the second supplies one
argument of &quot;n&quot;, and the third supplies two arguments of
&quot;n&quot; and &quot;m&quot;.</p>

<p>Some commands take string arguments.  The string consists of all
characters after the command up to the terminator character.  This
character, called <i>altmode</i>, is the Escape character, and is
written as &quot;$&quot; (for historical reasons, of course).</p>

<p>Commands are accumulated into a <i>command string</i>, until a
double altmode terminator is entered, at which time the commands are
executed.  One of the altmodes may serve to delimit a string.  For
example:</p>

<blockquote>
<tt>5C$$</tt>
</blockquote>

<p>moves forward five characters, and the command string:</p>

<blockquote>
<tt>Ithen$$</tt>
</blockquote>

<p>inserts the string &quot;then&quot;, and the string:</p>

<blockquote>
<tt>5CIthen$8R$$</tt>
</blockquote>

<p>moves forward five characters, then inserts the string
&quot;then&quot;, then moves backward eight characters.</p>

<p>TECO also supports the concept of <i>Q-registers</i>.  These are
variables that can either hold arbitrarily large strings of text or
numbers.  Each Q-register can either hold a string or a number and may
change back and forth as desired.  However, it may only hold one or
the other at any given time.  Q-registers are named by single
characters.  When holding strings, Q-registers act just like buffers:
you can switch to, insert into, delete from, move around in, display,
and search in them.  Q-register names are either</p>

<ul>
<li>one alphanumeric character preceded by zero, one, or two periods
(names with two periods are reserved for system variables), a
&quot;variable name&quot; of the form $name$ (these are dollar signs,
not altmodes),
`
<li>a subscripting expression such as :Q(index),

<li>a * (for certain commands, it causes them to return their data
instead of storing it),

<li>an expression in parentheses (for certain commands), or

<li>up to 3 periods followed by a ^R or ^^ and any ASCII character.
</ul>

<p>TECO was first written for PDP-10s running ITS (the Incompatible
Timesharing System) and its command set incorporates some knowledge of
that system's file name syntax.  Briefly, an ITS file name has these
four parts:</p>

<blockquote>
<tt>DEV;DIR:PRTONE PRTTWO</tt>
</blockquote>

<p>Each part can be up to 6 characters long and is stored in one
36-bit word.  Within that word, each character is squeezed into a
6-bit character set, so lower-case characters are folded into their
upper-case equivalents.  The operating system and applications
programs maintain a default value for each of the four parts.  For
example, if a user specifies a name of &quot;foo&quot;, the default
device, directory, and second part of the file name are automatically
filled in.  Multiple versions of a file are kept by setting the second
part of the file name to a number.  Successive versions are maintained
by incrementing the number.  A second part of &quot;&lt;&quot; refers
to the earliest version around.  A second part of &quot;&gt;&quot;
refers to the latest version around (for reading) or one past the
latest version around (for writing).</p>

<a name="aD.1"></a><h2>D.1 General notation:</h2>

<table border="0" width="100%">
<colgroup>
<col width="10%">
<col width="90%">
</colgroup>

<tr><td valign="top"><b>^X</b></td><td valign="top">Denotes the specified control character (see Appendix E for a listing of all ASCII characters).</td></tr>
<tr><td valign="top"><b>$</b></td><td valign="top">Denotes the altmode character unless otherwise specified.</td></tr>
<tr><td valign="top"><b>|</b></td><td valign="top">Denotes a choice (either the form on the left or the form on the right are acceptable).</td></tr>
<tr><td valign="top"><b>m | n | arg</b></td><td valign="top">Denote integer arguments.</td></tr>
<tr><td valign="top"><b>cmd</b></td><td valign="top">An arbitrary command string.</td></tr>
<tr><td valign="top"><b>dir</b></td><td valign="top">Denotes a directory.</td></tr>
<tr><td valign="top"><b>file</b></td><td valign="top">Denotes a file name.</td></tr>
<tr><td valign="top"><b>k</b></td><td valign="top">Denotes either &quot;m,n&quot; or &quot;n&quot;: either a text range of characters m through n or n successive lines.</td></tr>
<tr><td valign="top"><b>string</b></td><td valign="top">Denotes a string argument.</td></tr>
<tr><td valign="top"><b>: | @</b></td><td valign="top">Modify the operation of certain commands.</td></tr>
</table>

<a name="aD.2"></a><h2>D.2 Commands</h2>

<table border="0" width="100%">
<colgroup>
<col width="10%">
<col width="90%">
</colgroup>

<tr><td valign="top"><b>n^@</b></td><td valign="top">Argument: if n &gt; 0, same as &quot;.,.+n&quot;.  If n &lt;= 0, the same as &quot;.+n,.&quot;</td></tr>
<tr><td valign="top"><b>m,n^@</b></td><td valign="top">Returns the value n - m.</td></tr>
<tr><td valign="top"><b>m,n:^@</b></td><td valign="top">Returns the value n,m.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>^A</b></td><td valign="top">Logical xor operator.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>^B</b></td><td valign="top">Used for cleaning up after failed searches.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>^C</b></td><td valign="top">When typed from the console, it terminates the command string and starts execution.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>^Fstring$</b></td><td valign="top">Inserts its string argument, after deleting the last string found or inserted.  Same as &quot;FKDIstring$&quot;.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>^G</b></td><td valign="top">Executes immediately.  Erase's the command string as typed so far.  Also aborts current command if one is executing.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>^H</b></td><td valign="top">Inserts a Back Space character.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>^I</b></td><td valign="top">Inserts a Tab character.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>^J</b></td><td valign="top">Flushes any pending values.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>^Kstring$</b></td><td valign="top">Executes string as a system command.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>^M</b></td><td valign="top">Flushes any pending values.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>n^N</b></td><td valign="top">Sets FS LINES$ to n.</td></tr>
<tr><td valign="top"><b>:^N</b></td><td valign="top">Toggle the FS TTMODE$ flag.</td></tr>
<tr><td valign="top"><b>:n^N</b></td><td valign="top">Does n^N:^N.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>^Ofilename$</b></td><td valign="top">Bigprints filename on the device open for output.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>^Pcmd0$cmd1$cmd2$</b></td><td valign="top">ASCII sort command.  Assuming the point is at the start of a record, cmd0 should move the point to the start of the key, cmd1 should move the point to the end of the key, and cmd2 should move the point to the end of the record (= start of the next record).  If FS ^P CASE $ is non-zero, then this command ignores case.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>^Q</b></td><td valign="top">Quotes the next character.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>^R</b></td><td valign="top">Invokes Real time (Emacs-like) mode.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>n^S</b></td><td valign="top">If n &gt; 0, sleeps for n 30ths of a second.  Otherwise, sleeps until system uptime is &gt;= -n.</td></tr>
<tr><td valign="top"><b>n:^S</b></td><td valign="top">Sleeps for at most n 30ths of a second, returning immediately when input becomes available.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>^U</b></td><td valign="top">Displays the current directory in a user supplied manner.  Executes immediately if it is the first character in a command string.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>^V</b></td><td valign="top">Pops the next position off of the ring buffer of positions.  Successive ^Vs move through the 8-item ring.</td></tr>
<tr><td valign="top"><b>:^V</b></td><td valign="top">Returns the value on the top of the ring.</td></tr>
<tr><td valign="top"><b>n^V</b></td><td valign="top">Pushes n onto the ring buffer unless n is the same as the value on the top of the ring.</td></tr>
<tr><td valign="top"><b>n:^V</b></td><td valign="top">Pushes n onto the ring buffer.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>^W</b></td><td valign="top">Returns to the top level.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>^X</b></td><td valign="top">Its value is m, the first argument to m,nMq.  It is only valid inside macros.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>^Y</b></td><td valign="top">Its value is n, the second argument to m,nMq.  It is only valid inside macros.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>^Z</b></td><td valign="top">Suspends the editing process.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>$ (^[)</b></td><td valign="top">Terminates text argument; two successive altmodes terminates a command string.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>^\</b></td><td valign="top">Exits from the innermost macro invocation.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>^]x</b></td><td valign="top">Specially processes character x.</td></tr>
<tr><td valign="top"><b>^]^X</b></td><td valign="top">Reads and returns the string argument which follows kMq.  It is only valid inside macros.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>^^x</b></td><td valign="top">Returns the ASCII value of &quot;x&quot;.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>SP</b></td><td valign="top">Same as &quot;+&quot;, except that just a space is not an argument.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>!label!</b></td><td valign="top">Defines a label or a comment.  It is a comment if no command attempts to go there.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>arg&quot;x then-cmd '</b></td><td valign="top">Conditional.  It checks the arg according to condition x.  Executes the command string then-cmd if the condition is true. Arg is discarded.  Conditionals:

<table border="0">
<colgroup>
<col width="10%">
<col width="90%">
</colgroup>

<tr><td valign="top"><b>B</b></td><td valign="top">is arg the ASCII value of a delimiter (..D)?</td></tr>
<tr><td valign="top"><b>C</b></td><td valign="top">is arg the ASCII value of a non-delimiter?</td></tr>
<tr><td valign="top"><b>D</b></td><td valign="top">is arg the ASCII value of a digit?</td></tr>
<tr><td valign="top"><b>E</b></td><td valign="top">is arg == 0?</td></tr>
<tr><td valign="top"><b>G</b></td><td valign="top">is arg &gt; 0?</td></tr>
<tr><td valign="top"><b>L</b></td><td valign="top">is arg &lt; 0?</td></tr>
<tr><td valign="top"><b>N</b></td><td valign="top">is arg != 0?</td></tr>
<tr><td valign="top"><b>U</b></td><td valign="top">is arg the ASCII value of an upper-case character?</td></tr>
<tr><td valign="top"><b>:x</b></td><td valign="top">Reverses the meaning of condition x</td></tr>
</table>
</td></tr>

<tr><td valign="top"><b>arg&quot;x then-cmd '&quot;# else-cmd'</b></td><td valign="top">Conditional with else.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>#</b></td><td valign="top">Logical or operator.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>%q</b></td><td valign="top">Increments the numeric contents of q and returns the result.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top"><b>&amp;</b></td><td valign="top">Logical and operator.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>'</b></td><td valign="top">Terminates a conditional.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>( | )</b></td><td valign="top">Specify precedence for argument operators.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>*</b></td><td valign="top">Multiplication operator (no precedence).</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>+</b></td><td valign="top">Addition operator.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>,</b></td><td valign="top">Separates numeric arguments.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>-</b></td><td valign="top">Subtraction operator.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>.</b></td><td valign="top">(by itself) Specifies the position (number) of the point.  See also the special .. Q-register names listed below.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>/</b></td><td valign="top">Division operator (no precedence).</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>0-9, .</b></td><td valign="top">Digits.  XXX is interpreted in base FS IBASE$ (usually 10); XXX. is interpreted in base FS I.BASE$ (usually 8).</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>:</b></td><td valign="top">Modifies the action of certain commands.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>n;</b></td><td valign="top">Does nothing if n &lt; 0.  Otherwise, it passes control to the character after the next &gt;.  In other words, it is used to terminate iteration.  If n is null, it uses the value of the last search.</td></tr>
<tr><td valign="top"><b>:;</b></td><td valign="top">Like ;, but reverses the condition.</td></tr>
<tr><td valign="top"><b>@@;</b></td><td valign="top">Like ;, but exit if arg == 0.</td></tr>
<tr><td valign="top"><b>:@@;</b></td><td valign="top">Like ;, but exit if arg != 0.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>n&lt;cmd&gt;</b></td><td valign="top">Does command cmd n times, or indefinitely if n is null.</td></tr>
<tr><td valign="top"><b>:&lt;cmd&gt;</b></td><td valign="top">Begins errset.  If an error occurs inside &lt;&gt;, execution will resume after the &gt;.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>k=</b></td><td valign="top">Types k.</td></tr>
<tr><td valign="top"><b>k:=</b></td><td valign="top">Types k, omits CR/LF.</td></tr>
<tr><td valign="top"><b>k@=</b></td><td valign="top">Types k in the echo area.</td></tr>
<tr><td valign="top"><b>k@:=</b></td><td valign="top">Types k in the echo area, omitting CR/LF.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>?</b></td><td valign="top">If first character after an error message, displays the last several command characters.  Otherwise, enters trace mode.</td></tr>
<tr><td valign="top"><b>:?</b></td><td valign="top">Leaves trace mode.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>@</b></td><td valign="top">Modifies the action of certain commands.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>A</b></td><td valign="top">Appends the next page of the input file to the buffer.</td></tr>
<tr><td valign="top"><b>n:A</b></td><td valign="top">Appends the next n lines (up to a page marker)  from the input file to the buffer.</td></tr>
<tr><td valign="top"><b>@A</b></td><td valign="top">Appends all of the input file to the buffer and closes the input file.</td></tr>
<tr><td valign="top"><b>mA</b></td><td valign="top">Returns the ASCII value of the character m characters to the right of the point.</td></tr>
<tr><td valign="top"><b>0A</b></td><td valign="top">Returns the ASCII value of the character at the point.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>B</b></td><td valign="top">Argument; equivalent to 0 (<i>i.e.</i>, the beginning of the buffer).  However, its value is modified by the virtual buffer boundaries.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>nC</b></td><td valign="top">Moves forwards n characters.</td></tr>
<tr><td valign="top"><b>n:C</b></td><td valign="top">Same as moving, but returns -1 if the move succeeds or 0 if the move would fail.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>mD</b></td><td valign="top">Deletes forward m characters.</td></tr>
<tr><td valign="top"><b>-mD</b></td><td valign="top">Deletes backward m characters (there is no equivalent to R).</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>E...</b></td><td valign="top">See E-Commands listed below.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>F...</b></td><td valign="top">See F-Commands listed below.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>Gq</b></td><td valign="top">Inserts the contents of Q-register q into the buffer.  If q has a number, its string representation is inserted.  FS INSLEN$ is set to the length of the inserted text.</td></tr>
<tr><td valign="top"><b>m,nGq</b></td><td valign="top">Inserts the range m to n from Q-register q.</td></tr>
<tr><td valign="top"><b>:Gq</b></td><td valign="top">Returns a copy of the string in Q-register q.</td></tr>
<tr><td valign="top"><b>n:Gq</b></td><td valign="top">Returns the value of the character at position n in Q-register q.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>H</b></td><td valign="top">Argument: wHole buffer: equivalent to &quot;B,Z&quot;.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>Istring$</b></td><td valign="top">Inserts the string at the point.</td></tr>
<tr><td valign="top"><b>@Ixstringx</b></td><td valign="top">Inserts the string delimited by the &quot;x&quot; characters at the point (lets you insert a string that contains an altmode).</td></tr>
<tr><td valign="top"><b>nI</b></td><td valign="top">Inserts the character with ASCII value n.</td></tr>
<tr><td valign="top"><b>m,nI</b></td><td valign="top">Inserts m copies of character n.</td></tr>
<tr><td valign="top"><b>:Iq</b></td><td valign="top">Inserts the Q-register q into the buffer.</td></tr>
<tr><td valign="top"><b>n:Iq</b></td><td valign="top">Inserts the character with ASCII value n into Q-register q.</td></tr>
<tr><td valign="top"><b>m,n:Iq</b></td><td valign="top">Inserts m copies of character n into Q-register q.</td></tr>
<tr><td valign="top"><b>:Iqstring$</b></td><td valign="top">Inserts the string into Q-register q, replacing any prior contents.</td></tr>
<tr><td valign="top"><b>@n:Iq</b></td><td valign="top">Inserts the character whose ASCII value is n into Q-register q, replacing any prior contents.</td></tr>
<tr><td valign="top"><b>@m,n:Iq</b></td><td valign="top">Same as n:Iq, but inserts m copies.</td></tr>
<tr><td valign="top"><b>@:Iqxstringx</b></td><td valign="top">Same as :Iqstring$, except that string is delimited by the characters x.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>nJ</b></td><td valign="top">Sets the point to the specified position (BJ or just J is move to start; ZJ is move to end).</td></tr>
<tr><td valign="top"><b>n:J</b></td><td valign="top">Does the set and returns -1 if successful and 0 if not.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>m,nK</b></td><td valign="top">Kills (deletes and saves the deleted text) the characters in the range; moves the point there.</td></tr>
<tr><td valign="top"><b>nK</b></td><td valign="top">Kills what L would move over.</td></tr>
<tr><td valign="top"><b>n:K</b></td><td valign="top">Kills what :L would move over.</td></tr>
<tr><td valign="top"><b>@K</b></td><td valign="top">Like K, but only LFs preceded by CRs are recognized.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>mL</b></td><td valign="top">Moves to start of mth line after the point.</td></tr>
<tr><td valign="top"><b>0L</b></td><td valign="top">Moves to the start of the current line.</td></tr>
<tr><td valign="top"><b>m,nL</b></td><td valign="top">Same as m+n-.J, used by some other commands.</td></tr>
<tr><td valign="top"><b>m:L</b></td><td valign="top">Moves to the end of the m-1th line.</td></tr>
<tr><td valign="top"><b>0:L</b></td><td valign="top">Moves to the end of the <i>previous</i> line.</td></tr>
<tr><td valign="top"><b>@L</b></td><td valign="top">Like L, but only LFs preceded by CRs are recognized.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>m,nMqstring$</b></td><td valign="top">Executes the contents of Q-register q as TECO commands.  If the Q-register contains a number, it executes the corresponding ^R mode command.</td></tr>
<tr><td valign="top"><b>:M</b></td><td valign="top">Tail-recursive form of M.  Like M then ^\, but the current function is removed from the stack before the new one is called.</td></tr>
<tr><td valign="top"><b>@M</b></td><td valign="top">Fools the called macro into thinking it was called from ^R mode.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>nNstring$</b></td><td valign="top">Same as nSstring$, but it does P and continues the search if the end of the buffer is reached.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>Olabel$</b></td><td valign="top">Goes to the specified label.  Generates an error if the label is not found.</td></tr>
<tr><td valign="top"><b>:Olabel$</b></td><td valign="top">Returns if the label is not found.</td></tr>
<tr><td valign="top"><b>@Olabel$</b></td><td valign="top">Allows the label to be abbreviated.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>nP</b></td><td valign="top">Writes out the buffer and a ^L (page mark), kills the buffer, and reads one page from the input file.  All of this is repeated n times.</td></tr>
<tr><td valign="top"><b>m,nP</b></td><td valign="top">Writes out the specified range of the buffer, but does not kill it or append input.</td></tr>
<tr><td valign="top"><b>nPW</b></td><td valign="top">Writes out the buffer and a ^L (page mark), no killing or reading.  All of this is repeated n times.</td></tr>
<tr><td valign="top"><b>@P</b></td><td valign="top">As P, except that the low-order bit of each word written should be preserved and not cleared.  Used for writing binary files.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>Qq</b></td><td valign="top">Returns the value in Q-register q as a number.  If the Q-register holds text, this returns the pointer to that text.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>nR</b></td><td valign="top">Moves backwards n characters (same as -nC).</td></tr>
<tr><td valign="top"><b>n:R</b></td><td valign="top">Same as moving, but returns -1 if the move succeeds or 0 if the move would fail.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>nSstring$</b></td><td valign="top">Searches forward for the nth occurrence of the string and places the point after the string.  If the argument is null, the last non-null argument is used.  Special characters in search:

<table border="0">
<colgroup>
<col width="10%">
<col width="90%">
</colgroup>

<tr><td valign="top"><b>^B</b></td><td valign="top">Matches any delimiter (see ..D).</td></tr>
<tr><td valign="top"><b>^O</b></td><td valign="top">Divides string into alternate patterns.  Thus, Sfoo^Obar$ will find the first of &quot;foo&quot; or &quot;bar&quot;.</td></tr>
<tr><td valign="top"><b>^Qx</b></td><td valign="top">Quotes x.</td></tr>
<tr><td valign="top"><b>^X</b></td><td valign="top">Matches any character.</td></tr>
<tr><td valign="top"><b>^Nx</b></td><td valign="top">Matches any character except for x, where x is any character.</td></tr>
<tr><td valign="top"><b>^N^B</b></td><td valign="top">Matches any non-delimiter.</td></tr>
<tr><td valign="top"><b>^N^X</b></td><td valign="top">Matches nothing.</td></tr>
</table>

Note that Sfoo^O$ will always succeed and will move the point over
the next three characters if and only if they are &quot;foo&quot;.
-2-(:Sfoo^O$) will do that and return non-zero if they were
&quot;foo&quot;.</td></tr>

<tr><td valign="top"><b>-nSstring$</b></td><td valign="top">Same as nSstring$, but searches backwards and leaves the point before the string.</td></tr>
<tr><td valign="top"><b>n@Sxstringx</b></td><td valign="top">Same as nSstring$, but the string is delimited by the character specified by the &quot;x&quot;s.  If the argument is null, searches for the null string.</td></tr>
<tr><td valign="top"><b>n:Sstring$</b></td><td valign="top">Same as nSstring$, but returns the value -1 if successful or 0 if not.  If a ^O is used within -n is returned if the nth subpart is found.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>kT</b></td><td valign="top">Types out the text in the range (n lines or m,n characters).</td></tr>
<tr><td valign="top"><b>@T</b></td><td valign="top">Types out in the echo area.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>nUq</b></td><td valign="top">Inserts number n into Q-register q, returns no value.</td></tr>
<tr><td valign="top"><b>m,nUq</b></td><td valign="top">Inserts number n into Q-register q, returns m. </td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>kV</b></td><td valign="top">Displays what T would type.  Puts &quot;/\&quot; where point is and does &quot;--MORE--&quot; processing.</td></tr>
<tr><td valign="top"><b>@V</b></td><td valign="top">Does standard buffer redisplay.</td></tr>
<tr><td valign="top"><b>kVW</b></td><td valign="top">Does V, then waits for one character and returns its ASCII code as a value.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>W</b></td><td valign="top">Flushes current value except when part of PW or VW.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>kXq</b></td><td valign="top">Inserts text range k into Q-register q, replacing any prior contents.</td></tr>
<tr><td valign="top"><b>k@Xq</b></td><td valign="top">Same as kXq, but appends to q.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>Y</b></td><td valign="top">Kills the buffer and reads one page from the input file into the buffer.</td></tr>
<tr><td valign="top"><b>@Y</b></td><td valign="top">Kills the buffer and reads the rest of the input file into the buffer.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>Z</b></td><td valign="top">Argument: specifies the length of the buffer in characters.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>[q</b></td><td valign="top">Push the text or number from Q-register q onto the Q-register push down list.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>\</b></td><td valign="top">Moves past number, returns its value.</td></tr>
<tr><td valign="top"><b>n\</b></td><td valign="top">Inserts a printed representation of character n (in base ..E).</td></tr>
<tr><td valign="top"><b>m,n\</b></td><td valign="top">Is like n\, but pads with spaces to m columns.</td></tr>
<tr><td valign="top"><b>:\</b></td><td valign="top">Returns the representation of n as a string instead of inserting it.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>]q</b></td><td valign="top">Pop the text or number from the Q-register push down list into Q-register q.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>^</b></td><td valign="top">Replaced by @.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>n_string$</b></td><td valign="top">Same as nSstring$, but it does Y if the end of the buffer is reached.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>^?</b></td><td valign="top">Erases the last character of command string.</td></tr>
</table>

<a name="aD.3"></a><h2>D.3 E-Commands (most file commands are here)</h2>

<table border="0" width="100%">
<colgroup>
<col width="10%">
<col width="90%">
</colgroup>

<tr><td valign="top"><b>E^Udir$</b></td><td valign="top">Displays the specified directory in a user-defined manner.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>E?file$</b></td><td valign="top">Tries to open file.  Returns 0 if successful or an error code if not.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>EC</b></td><td valign="top">Closes the input file.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>EDfile$</b></td><td valign="top">Deletes the specified file.</td></tr>
<tr><td valign="top"><b>:ED</b></td><td valign="top">Deletes the currently open file.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>EEfile$</b></td><td valign="top">Same as the sequence infinityPEFfile$EC.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>EFfile$</b></td><td valign="top">Closes the output file and changes its name to file.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>EG</b></td><td valign="top">Inserts various information into the buffer on successive lines:  the date as YYMMDD, the time as HHMMSS, the current username, the default file names, the real names of the files open for input and output, the date in text form, a 3-digit value (day of week, day of week of 1st of this year, leap year status), and the phase of the moon.  There are better ways of getting most of this information.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>EI</b></td><td valign="top">Opens a file &quot;_TECO_ OUTPUT&quot; for writing on the default device.</td></tr>
<tr><td valign="top"><b>:EI</b></td><td valign="top">Same as EI, but uses the current default file name.</td></tr>
<tr><td valign="top"><b>@EI</b></td><td valign="top">Same as EI, but sets the default device to DSK:</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>EJfile$</b></td><td valign="top">Restores the complete state from the file, which must have been saved with @EJ.</td></tr>
<tr><td valign="top"><b>@EJfile$</b></td><td valign="top">Saves TECO's complete state to the file.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>EL</b></td><td valign="top">Types out a listing of the default directory.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>EM</b></td><td valign="top">Inserts a listing of the default directory into the buffer.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>ENold$new$</b></td><td valign="top">Renames file old to file new.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>EPfile$</b></td><td valign="top">Does ERfile$, then bigprints the file name twice on the device open for writing.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>EQfrom$to$</b></td><td valign="top">Creates a link from the file &quot;from&quot; to the file &quot;to&quot;.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>ERfile$</b></td><td valign="top">Opens a file for input.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>ETfile$</b></td><td valign="top">Sets the default file name to the specified file name.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>EWdir$</b></td><td valign="top">Same as EI, but with the specified directory.</td></tr>
<tr><td valign="top"><b>:EWdir file$</b></td><td valign="top">Same as EW, but with the specified file name.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>EYdir$</b></td><td valign="top">Types out a listing of the specified directory.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>EZdir$</b></td><td valign="top">Inserts a listing of the specified directory into the buffer.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>E[</b></td><td valign="top">Push the input channel.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>E\</b></td><td valign="top">Push the output channel.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>E]</b></td><td valign="top">Pop the input channel.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>E^</b></td><td valign="top">Pop the output channel.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>E_old$new$</b></td><td valign="top">Copies file old to file new.</td></tr>
<tr><td valign="top"><b>:E_old$new$</b></td><td valign="top">Copies file old to file new, preserving the old file's date.</td></tr>
</table>

<a name="aD.4"></a><h2>D.4 F-Commands</h2>

<table border="0" width="100%">
<colgroup>
<col width="10%">
<col width="90%">
</colgroup>

<tr><td valign="top"><b>m,nF^@</b></td><td valign="top">Returns m and n in numerical order, such that the new m will be &gt; n.</td></tr>
<tr><td valign="top"><b>nF^@</b></td><td valign="top">Returns 2 arguments that specify the range from the point to the location n lines away.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>F^A</b></td><td valign="top">Runs every character in the buffer through a dispatch table.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>nF^Bstring$</b></td><td valign="top">Searches in string for the character whose ASCII value is N.</td></tr>
<tr><td valign="top"><b>@F^Bstring$</b></td><td valign="top">Searches the buffer forward for a character not in string.</td></tr>
<tr><td valign="top"><b>-@F^Bstring$</b></td><td valign="top">Searches the buffer backward for a character not in string.</td></tr>
<tr><td valign="top"><b>m,n@F^Bstring$</b></td><td valign="top">Searches the buffer in the range for a character not in string.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>F^Estring$</b></td><td valign="top">Overwrites the next length-of-string characters with string.  Same as deleting and inserting, but the gap does not need to move.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>F^K</b></td><td valign="top">Reads a string argument from within a macro.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>m,nF^Sq</b></td><td valign="top">Searches Q-register q for a word that contains n, starting at m.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>F^X</b></td><td valign="top">Its value is k, all arguments to m,nMq.  It is only valid inside macros.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>F^Y</b></td><td valign="top">Its value is the number of arguments to m,nMq.  It is only valid inside macros.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>string:F^^</b></td><td valign="top">Determines whether string is a short Q-register name.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>argF&quot;x</b></td><td valign="top">Same as regular conditional, but passes the arg to the then or else command string.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>F$ (dollar)</b></td><td valign="top">Returns FS CASE$ and inserts in the buffer the case shift and lock characters, if any.  If FS CASE$ is non-zero, all characters are converted to uppercase (if &gt; 0) or lower case (if &lt; 0) on input.  The case-shift character causes the next character to be read in the other case.  The case-lock character temporarily complements the preferred case.  On output, if FS CASE$ is odd, characters in the non-standard case will be preceded by case-shifts.  If even, no translation is done.</td></tr>
<tr><td valign="top"><b>nF$string$</b></td><td valign="top">Sets FS CASE$ to n and sets the case shift and lock characters to the first two characters in string.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>F(</b></td><td valign="top">Is like (, except that F( returns its arguments, making it easy to use a value twice without using a Q-register.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>F)</b></td><td valign="top">Is like ), except that F) returns its arguments exactly, discarding the data saved by (.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>F*string$</b></td><td valign="top">Reads and discards a string argument.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>F+</b></td><td valign="top">Clears the screen.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>F6string$</b></td><td valign="top">Returns string with the first six characters packed into a word (this TECO is running on a 36 bit machine).</td></tr>
<tr><td valign="top"><b>nF6</b></td><td valign="top">Expands n into an ASCII string and inserts it into the buffer.</td></tr>
<tr><td valign="top"><b>n:F6</b></td><td valign="top">Expands n into a string.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>F;tag$</b></td><td valign="top">Throws to the tag.  This is a &quot;long jump.&quot;</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>F&lt;!tag!cmds&gt;</b></td><td valign="top">Catches a throw and executes the commands.</td></tr>
<tr><td valign="top"><b>:F&lt;!tag!cmds&gt;</b></td><td valign="top">Is an errset and a catch at the same time.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>F=qstring$</b></td><td valign="top">Compares the Q-register q to string.  Returns 0 if ==, positive if q is &gt; string, or negative if q is &lt; string.  If value is not zero, the value's absolute value is 1 + location of the difference.</td></tr>
<tr><td valign="top"><b>@F=qxstringx</b></td><td valign="top">Compares the Q-register q to string delimited by x.</td></tr>
<tr><td valign="top"><b>m,nF=string$</b></td><td valign="top">Compares the buffer in the range m to n to string.</td></tr>
<tr><td valign="top"><b>m,n@Fxstringx</b></td><td valign="top">Compares the buffer in the range m to n to string delimited by x.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>F?</b></td><td valign="top">Same as 30F?</td></tr>
<tr><td valign="top"><b>0F?</b></td><td valign="top">Same as 30F?</td></tr>
<tr><td valign="top"><b>nF?</b></td><td valign="top">Mbox control.  Argument is a bit string,:

<table border="0" width="100%">
<colgroup>
<col width="10%">
<col width="90%">
</colgroup>

<tr><td valign="top"><b>bit 2^0</b></td><td valign="top">close the gap</td></tr>
<tr><td valign="top"><b>bit 2^1</b></td><td valign="top">run garbage collect</td></tr>
<tr><td valign="top"><b>bit 2^2</b></td><td valign="top">clear the jump cache</td></tr>
<tr><td valign="top"><b>bit 2^3</b></td><td valign="top">flush unused core</td></tr>
<tr><td valign="top"><b>bit 2^4</b></td><td valign="top">close the gap if it is &gt;5000</td></tr>
</table>
</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>m,nFA</b></td><td valign="top">Justifies text within the range.</td></tr>
<tr><td valign="top"><b>nFA</b></td><td valign="top">Justifies n lines of text.</td></tr>
<tr><td valign="top"><b>@FA</b></td><td valign="top">Fills without justification.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>kFBstring$</b></td><td valign="top">Same as Sstring$ in the domain defined by k.  If k is of the form m,n and m &gt; n, search backwards.  &quot;:&quot; and &quot;@&quot; modifiers work.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>kFC</b></td><td valign="top">Converts text range k to lower case.</td></tr>
<tr><td valign="top"><b>k@FC</b></td><td valign="top">Converts text range k to upper case.</td></tr>
<tr><td valign="top"><b>n:FC</b></td><td valign="top">Returns the upper-case version of the character whose ASCII value is n.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>nFD</b></td><td valign="top">Returns the range &quot;.,x&quot;, where &quot;x&quot; is the position just after the nth level down in parenthesis after the point.</td></tr>
<tr><td valign="top"><b>-nFD</b></td><td valign="top">Goes backward.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>FE</b></td><td valign="top">Inserts a list of all TECO error messages into the buffer.</td></tr>
<tr><td valign="top"><b>nFE</b></td><td valign="top">Inserts only the message whose error code is n.</td></tr>
<tr><td valign="top"><b>@FEstring$</b></td><td valign="top">Returns the code of the error whose message is string.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>FG</b></td><td valign="top">Process an error.</td></tr>
<tr><td valign="top"><b>@FG</b></td><td valign="top">Process an error and throw away type ahead.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>FI</b></td><td valign="top">Reads one character and returns its ASCII value.</td></tr>
<tr><td valign="top"><b>:FI</b></td><td valign="top">As FI, but don't flush the character (it will be re-used).</td></tr>
<tr><td valign="top"><b>@FI</b></td><td valign="top">As FI, but returns the value in the 9-bit TV character set.</td></tr>
<tr><td valign="top"><b>@:FI</b></td><td valign="top">As @FI, but don't flush the character (it will be re-used).</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>FJ</b></td><td valign="top">Insert the command line used to invoke TECO into the buffer.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>FK</b></td><td valign="top">Returns the value - FS INSLEN$, <i>i.e.</i>, length of the last string inserted or found by a search or FW.  FK is always &lt; 0 except for a backwards search or FW.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>nFL</b></td><td valign="top">Returns the range &quot;.,x&quot;, where &quot;x&quot; is the position just after the nth list after the point.</td></tr>
<tr><td valign="top"><b>-nFL</b></td><td valign="top">Goes backward.</td></tr>
<tr><td valign="top"><b>n@FL</b></td><td valign="top">As nFW, but does S-expressions.</td></tr>
<tr><td valign="top"><b>nFLD</b></td><td valign="top">Same as nFLK.</td></tr>
<tr><td valign="top"><b>nFLK</b></td><td valign="top">Kills what nFL implies.</td></tr>
<tr><td valign="top"><b>nFLL</b></td><td valign="top">Does the move implied by the nFL.</td></tr>
<tr><td valign="top"><b>nFLR</b></td><td valign="top">Same as nFLL.</td></tr>
<tr><td valign="top"><b>nFLXq</b></td><td valign="top">Combines nFL with Xq.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>m,nFM</b></td><td valign="top">Attempts to move the point so that the cursor will appear at column n, m lines below where you started.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>FN</b></td><td valign="top">Is the same as &quot;[..n:I..N&quot;.  It is needed to eliminate the possibility of a ^G within the string.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>FOqname$</b></td><td valign="top">Performs a binary search of a table of fixed-length entries.  It is intended for symbol tables.  Q-register q contains the table and &quot;name&quot; is what should be searched for.  The first word of the table contains the number of words for each entry in the table.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>objectFP</b></td><td valign="top">Returns a number describing object:

<table border="0">
<colgroup>
<col width="10%">
<col width="90%">
</colgroup>

<tr><td valign="top"><b>-4</b></td><td valign="top">A number, none of the below.</td></tr>
<tr><td valign="top"><b>-3</b></td><td valign="top">A number that could be in pure string space.</td></tr>
<tr><td valign="top"><b>-2</b></td><td valign="top">A number that could be in impure string space.</td></tr>
<tr><td valign="top"><b>-1</b></td><td valign="top">A dead buffer.</td></tr>
<tr><td valign="top"><b>0</b></td><td valign="top">A living buffer.</td></tr>
<tr><td valign="top"><b>1</b></td><td valign="top">A Q-vector.</td></tr>
<tr><td valign="top"><b>100</b></td><td valign="top">A pure string.</td></tr>
<tr><td valign="top"><b>101</b></td><td valign="top">An impure string.</td></tr>
</table>
</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>FQq</b></td><td valign="top">Its value is the number of characters in Q-register q or -1 if the Q-register holds a number.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>FR</b></td><td valign="top">Updates the display.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>FSname$</b></td><td valign="top">Returns the value of the specified variable (listed below).</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>FTstring$</b></td><td valign="top">Types its string argument.</td></tr>
<tr><td valign="top"><b>:FTstring$</b></td><td valign="top">Types its string argument at the top of the screen.</td></tr>
<tr><td valign="top"><b>@FTstring$</b></td><td valign="top">Types its string argument in the echo area.</td></tr>
<tr><td valign="top"><b>@:FTstring$</b></td><td valign="top">Types its string argument in the echo area but only if no input is available.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>nFU</b></td><td valign="top">Returns the range &quot;.,x&quot;, where &quot;x&quot; is the position just after the nth level up in parenthesis after the point.</td></tr>
<tr><td valign="top"><b>-nFU</b></td><td valign="top">Goes backward.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>FVstring$</b></td><td valign="top">Displays its string argument.</td></tr>
<tr><td valign="top"><b>:FVstring$</b></td><td valign="top">Displays its string argument, then clears the rest of the screen.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>nFW</b></td><td valign="top">Returns the range &quot;.,x&quot;, where &quot;x&quot; is the position just after the nth word after the point.</td></tr>
<tr><td valign="top"><b>-nFW</b></td><td valign="top">Goes backward.</td></tr>
<tr><td valign="top"><b>n:FW</b></td><td valign="top">As nFW, but only does n-1 words.</td></tr>
<tr><td valign="top"><b>n@FW</b></td><td valign="top">As nFW, but does Lisp atoms and not words.</td></tr>
<tr><td valign="top"><b>nFWD</b></td><td valign="top">Same as nFWK.</td></tr>
<tr><td valign="top"><b>nFWK</b></td><td valign="top">Kills what nFW implies.</td></tr>
<tr><td valign="top"><b>nFWL</b></td><td valign="top">Does the move implied by the nFW.</td></tr>
<tr><td valign="top"><b>nFWR</b></td><td valign="top">Same as nFWL.</td></tr>
<tr><td valign="top"><b>nFWXq</b></td><td valign="top">Combines nFW with Xq.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>kFXq</b></td><td valign="top">Same as X and K combined: kXqkK.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>FY</b></td><td valign="top">Inserts all that remains of the input file before the point.</td></tr>
<tr><td valign="top"><b>nFY</b></td><td valign="top">Inserts at most n characters.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>FZfile string$</b></td><td valign="top">Creates and starts a non-exec fork.</td></tr>
<tr><td valign="top"><b>FZ$</b></td><td valign="top">Resumes the inferior fork.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>F[flag$</b></td><td valign="top">Pushes the value of FS flag on the Q-register PDL.</td></tr>
<tr><td valign="top"><b>nF[flag$</b></td><td valign="top">Pushes and sets the flag to the new value.</td></tr>
<tr><td valign="top"><b>nF[^R CMACRO$</b></td><td valign="top">Pushes the definition of the character whose number is n.</td></tr>
<tr><td valign="top"><b>m,nF[^R CMACRO$</b></td><td valign="top">Pushes and sets.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>F_</b></td><td valign="top">Mostly the same as _, but keeps working regardless of the setting of FS _DISABLE$.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>F]flag$</b></td><td valign="top">Pops the value of FS flag from the Q-register PDL.</td></tr>
<tr><td valign="top"><b>nF]^R CMACRO$</b></td><td valign="top">Pops the definition of the character whose number is n.</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>

<tr><td valign="top"><b>F~</b></td><td valign="top">Like F=, but both strings are compared as if converted to upper case.</td></tr>
</table>

<a name="aD.5"></a><h2>D.5 Special Q-registers, names are of the form &quot;..x&quot;</h2>

<table border="0" width="100%">
<colgroup>
<col width="10%">
<col width="90%">
</colgroup>

<tr><td valign="top"><b>..0</b></td><td valign="top">^P puts its three arguments into these.</td></tr>
<tr><td valign="top"><b>..1</b></td><td valign="top"></td></tr>
<tr><td valign="top"><b>..2</b></td><td valign="top"></td></tr>
<tr><td valign="top"><b>..A</b></td><td valign="top">Holds the string to represent the cursor (default is &quot;/\&quot;).</td></tr>
<tr><td valign="top"><b>..B</b></td><td valign="top">Holds the macro to display the user buffer.</td></tr>
<tr><td valign="top"><b>..D</b></td><td valign="top">Holds the delimiter dispatch table, which tells several commands (FW, FL, &quot;B, &quot;C and search ^B) how to treat ASCII characters.</td></tr>
<tr><td valign="top"><b>..E</b></td><td valign="top">Holds the output radix for = and \.</td></tr>
<tr><td valign="top"><b>..F</b></td><td valign="top">Holds the ^R secretary macro.  Can be used for auto save.</td></tr>
<tr><td valign="top"><b>..G</b></td><td valign="top">Holds the user-specified directory display macro.</td></tr>
<tr><td valign="top"><b>..H</b></td><td valign="top">Is the &quot;suppress-display&quot; flag.</td></tr>
<tr><td valign="top"><b>..I</b></td><td valign="top">Holds the value of . at the start of the command.</td></tr>
<tr><td valign="top"><b>..J</b></td><td valign="top">Holds user-specified label for --MORE-- processing.</td></tr>
<tr><td valign="top"><b>..K</b></td><td valign="top">Holds deleted text.</td></tr>
<tr><td valign="top"><b>..L</b></td><td valign="top">Executes when TECO first starts.</td></tr>
<tr><td valign="top"><b>..N</b></td><td valign="top">Macro that to be executed when another macro exits.</td></tr>
<tr><td valign="top"><b>..O</b></td><td valign="top">The current buffer.</td></tr>
<tr><td valign="top"><b>..P</b></td><td valign="top">Holds the user-defined error-handler macro.</td></tr>
<tr><td valign="top"><b>..Q</b></td><td valign="top">Holds the symbol table used to define TECO variables.</td></tr>
<tr><td valign="top"><b>..Z</b></td><td valign="top">Safety backup copy of ..O.</td></tr>
</table>

<a name="aD.6"></a><h2>D.6 FS Variables</h2>

<p>Names can be up to six characters long.  Spaces in names are
ignored. Only as much of a name as is required to make it unique is
required, although programs should include the entire name. Saying
FSname$ returns the value of the flag.  Saying nFSname$ or m,nFSname$
sets the value.  If a flag can be set and you want to use the flag as
the second operand of an arithmetic operator (<i>e.g.</i>,
.+FSname$C), enclose the FS in parentheses (.+(FSname$)C).</p>

<p>These names can never include control characters.  The
&quot;^&quot; in some of the names is a leading caret.  However, the
combination usually relates to the implied control character.</p>

<table border="0" width="100%">
<colgroup>
<col width="10%">
<col width="90%">
</colgroup>

<tr><td valign="top"><b>% BOTTOM</b></td><td valign="top">Size of the bottom margin as a percentage of the number of lines being displayed.</td></tr>
<tr><td valign="top"><b>% CENTER</b></td><td valign="top">Where TECO should prefer to put the cursor.</td></tr>
<tr><td valign="top"><b>% END</b></td><td valign="top">Size of the area at the bottom of the screen, such that TECO should never choose to put the cursor there.</td></tr>
<tr><td valign="top"><b>% OPLSP</b></td><td valign="top">(Read only) Non-zero if the input is coming from a Lisp job</td></tr>
<tr><td valign="top"><b>% TOP</b></td><td valign="top">Size of the top margin (analogous to %BOTTOM).</td></tr>
<tr><td valign="top"><b>% TOCID</b></td><td valign="top">(Read only) Non-zero if the terminal can insert and delete characters.</td></tr>
<tr><td valign="top"><b>% TOFCI</b></td><td valign="top">(Read only) Non-zero if the terminal can generate 9-bit characters.</td></tr>
<tr><td valign="top"><b>% TOHDX</b></td><td valign="top">(Read only) Non-zero if the terminal is half-duplex.</td></tr>
<tr><td valign="top"><b>% TOLID</b></td><td valign="top">(Read only) Non-zero if the terminal can insert and delete lines.</td></tr>
<tr><td valign="top"><b>% TOLWR</b></td><td valign="top">(Read only) Non-zero if the terminal can generate lower case characters.</td></tr>
<tr><td valign="top"><b>% TOMOR</b></td><td valign="top">(Read only) Non-zero if the use wants --MORE-- processing.</td></tr>
<tr><td valign="top"><b>% TOOVR</b></td><td valign="top">(Read only) Non-zero if the terminal can overprint.</td></tr>
<tr><td valign="top"><b>% TOROL</b></td><td valign="top">(Read only) Non-zero if the user has selected scroll mode.</td></tr>
<tr><td valign="top"><b>% TOSAI</b></td><td valign="top">(Read only) Non-zero if the terminal can print the SAIL character set.</td></tr>
<tr><td valign="top"><b>*RSET</b></td><td valign="top">Initially 0. If set to non-zero, trace information is not cleared automatically.</td></tr>
<tr><td valign="top"><b>.CLRMOD</b></td><td valign="top">Normally -1.  If negative, screen is normally cleared automatically.  If 0, automatic screen clears are not done (used for debugging).  If positive, the screen is never cleared.</td></tr>
<tr><td valign="top"><b>.KILMOD</b></td><td valign="top">Normally -1.  If 0, FS BKILL$ doesn't actually do the kill.</td></tr>
<tr><td valign="top"><b>.TYI BACK</b></td><td valign="top">Backs up the point FS .TYI PT$ by one step.  After backing up n steps, you can use FS .TYI NXT$ to re-get those n input characters.</td></tr>
<tr><td valign="top"><b>.TYI NXT</b></td><td valign="top">Extracts one character from the ring buffer of past input characters.</td></tr>
<tr><td valign="top"><b>.TYI PT</b></td><td valign="top">Pointer into the ring buffer that contains the last 60 input characters.</td></tr>
<tr><td valign="top"><b>:EJ PAGE</b></td><td valign="top">Is the number of the lowest page used by :EJ'd shared pure files.</td></tr>
<tr><td valign="top"><b>ADLINE</b></td><td valign="top">Is the line size used by the FA command.</td></tr>
<tr><td valign="top"><b>ALTCOUNT</b></td><td valign="top">Is the number of $$s that TECO has seen at interrupt level.</td></tr>
<tr><td valign="top"><b>BACK ARGS</b></td><td valign="top">(Read only) Returns the arguments to a macro in a different stack frame (<i>i.e.</i>, one of the macros that was called that eventually called you).  Returns 0, 1, or 2 values in the same ways that F^X does.  If the argument to this is 0 or positive, it returns the arguments for the specified frame number (0 is outermost).  If negative, returns the arguments for the relative frame number (-1 is your caller).</td></tr>
<tr><td valign="top"><b>BACK DEPTH</b></td><td valign="top">(Read only) Returns the number of stack frames, not counting you.</td></tr>
<tr><td valign="top"><b>BACK PC</b></td><td valign="top">Returns the PC of the stack frame that is specified in the same way as FS BACK ARGS$.  m,nFS BACK PC$ sets the PC to m.</td></tr>
<tr><td valign="top"><b>BACK QP PTR</b></td><td valign="top">(Read only) Specifies where a ^\ will return to.  Arguments are as for FS BACK ARGS$.</td></tr>
<tr><td valign="top"><b>BACK RETURN</b></td><td valign="top">(Write only) Returns from the specified stack frame.  Arguments are as for FS BACK ARGS$.  -1 FS BACK RETURN$ is equivalent to ^\.</td></tr>
<tr><td valign="top"><b>BACK STRING</b></td><td valign="top">(Read only) Returns a pointer to the string or buffer being executed.  Arguments are as for FS BACK ARGS$.</td></tr>
<tr><td valign="top"><b>BACKTRACE</b></td><td valign="top">Returns a copy of the program being run by the stack frame.  Arguments are as for FS BACK ARGS$.</td></tr>
<tr><td valign="top"><b>BBIND</b></td><td valign="top">is useless, but F[B BIND$ and F]B BIND$ are useful for pushing to and popping from a temporary buffer.</td></tr>
<tr><td valign="top"><b>BCONS</b></td><td valign="top">(as in n FS BCONS$) returns a new buffer n characters long.  It is initially filled with 0's (NULs).</td></tr>
<tr><td valign="top"><b>BCREATE</b></td><td valign="top">is like FS BCONS$ U..0.  In other words, the buffer is selected instead of returned.</td></tr>
<tr><td valign="top"><b>BKILL</b></td><td valign="top">Kills the specified buffer.</td></tr>
<tr><td valign="top"><b>BOTHCASE</b></td><td valign="top">Initially 0.  If == 0, case is significant during searches. If &gt; 0, case is ignored.  If &lt; 0, case of special characters (@[\]^_ and `{|}~^?) is also ignored.</td></tr>
<tr><td valign="top"><b>BOUNDARIES</b></td><td valign="top">Reads or sets the virtual buffer boundaries.</td></tr>
<tr><td valign="top"><b>BS NO LF</b></td><td valign="top">If non-zero, suppresses the LF that follows any backward motion or rubbing out in ^R mode on printing terminals.</td></tr>
<tr><td valign="top"><b>CASE</b></td><td valign="top">Like F$, but neither gets nor sets the case-shift or case-lock characters.</td></tr>
<tr><td valign="top"><b>CLK INTERVAL</b></td><td valign="top">Is the interval between real time clock ticks in 1/60 seconds.  Only active during user input.</td></tr>
<tr><td valign="top"><b>CLK MACRO</b></td><td valign="top">Is the real-time interrupt handler macro.  If the macro types anything out, it must not leave ..H set.</td></tr>
<tr><td valign="top"><b>CTL MTA</b></td><td valign="top">If negative, it suppresses the ^R mode definitions for all control-meta characters.  This makes it easy to edit TECO commands.</td></tr>
<tr><td valign="top"><b>DATA SWITCHES</b></td><td valign="top">(Read only) The contents of the PDP-10 console switches.</td></tr>
<tr><td valign="top"><b>DATE</b></td><td valign="top">(Read only) The current date and time as a number in file-date format.  It can be fed to FS FD CONVERT$ or FS IF CDATE$.</td></tr>
<tr><td valign="top"><b>D DEVICE</b></td><td valign="top">Is the default device name.</td></tr>
<tr><td valign="top"><b>DD FAST</b></td><td valign="top">(Read only) Is non-zero if the current device is fast (<i>i.e.</i>, local disk).</td></tr>
<tr><td valign="top"><b>D FILE</b></td><td valign="top">Is the default file name.</td></tr>
<tr><td valign="top"><b>D FN1</b></td><td valign="top">Is the default file name first part.</td></tr>
<tr><td valign="top"><b>D FN2</b></td><td valign="top">Is the default file name second part.</td></tr>
<tr><td valign="top"><b>D FORCE</b></td><td valign="top">Setting this to non-zero forces a complete redisplay of everything except the mode line.  It is used for putting up temporary displays.</td></tr>
<tr><td valign="top"><b>D SNAME</b></td><td valign="top">Is the default sname.</td></tr>
<tr><td valign="top"><b>D VERSION</b></td><td valign="top">Is the default versions number, a reflection of FD D FN2$.  If the latter is numeric, reading this value returns the corresponding number.  If it is &quot;&gt;&quot; or &quot;&lt;&quot;, this value is 0 or -2, respectively.  If it is not numeric, this returns -1.  if FD D FN2$ is numeric, setting this value sets the file name.  Otherwise, the setting is ignored.</td></tr>
<tr><td valign="top"><b>D WAIT</b></td><td valign="top">When set to non-zero, causes the display to pause slightly between lines of output.</td></tr>
<tr><td valign="top"><b>ECHO ACTIVE</b></td><td valign="top">When set to non-zero, indicates that output has been written to the echo area, so the echo area needs to be cleaned up.</td></tr>
<tr><td valign="top"><b>ECHO CHAR</b></td><td valign="top">When a ^R mode character is being executed, this value holds the character that caused the invocation.</td></tr>
<tr><td valign="top"><b>ECHO DISPLAY</b></td><td valign="top">(Write only) As for FS ECHO OUT$, but outputs in display mode.</td></tr>
<tr><td valign="top"><b>ECHO ERRORS</b></td><td valign="top">When set to non-zero, error messages are printed in the echo area.</td></tr>
<tr><td valign="top"><b>ECHO FLUSH</b></td><td valign="top">When set to non-zero, automatic clearing of the echo area in ^R mode is enabled.</td></tr>
<tr><td valign="top"><b>ECHO LINES</b></td><td valign="top">Then number of lines at the screen bottom that can be used for command echoing.</td></tr>
<tr><td valign="top"><b>ECHO OUT</b></td><td valign="top">(Write only) Used for outputs to the echo area.  If it has a numeric argument, the argument is the ASCII code of a character to echo.  With a string argument, the string is echoed.</td></tr>
<tr><td valign="top"><b>ERR</b></td><td valign="top">Same as FS ERROR$ if read.  If written to, creates an error with the specified error code.</td></tr>
<tr><td valign="top"><b>ERRFLAG</b></td><td valign="top">When negative, signals to redisplay that the first -n lines of the display contain an error message and should not be overwritten.</td></tr>
<tr><td valign="top"><b>ERROR</b></td><td valign="top">The error code of the most recent error.</td></tr>
<tr><td valign="top"><b>ERR THROW</b></td><td valign="top">(Write only) Return to the innermost error catcher.</td></tr>
<tr><td valign="top"><b>EXIT</b></td><td valign="top">(Write only) Does a .break 16.</td></tr>
<tr><td valign="top"><b>FDCONVERT</b></td><td valign="top">With a numeric argument, converts it from an ITS file date to a string of the form &quot;dd/mm/yy hh:mm:ss&quot; and inserts the string into the buffer.  The form n:FS FDCONVERT$ returns the string.  With no argument, reads the string from the buffer and converts it to numeric form.</td></tr>
<tr><td valign="top"><b>FILE PAD</b></td><td valign="top">Is the character used to pad the last word of files.  Usually 3 (^C).</td></tr>
<tr><td valign="top"><b>FLUSHED</b></td><td valign="top">Is set to non-zero if a --MORE-- has been flushed, and thus output is being discarded.</td></tr>
<tr><td valign="top"><b>FNAM SYNTAX</b></td><td valign="top">Controls what happens when only one file name is present.  If this is 0, the file name is used as part two.  If &gt; 0, the file name is used as part one.  If &lt; 0, the file name is used as part one and &quot;&gt;&quot; is used for part two.</td></tr>
<tr><td valign="top"><b>GAP LENGTH</b></td><td valign="top">(Read only) The length of the gap.</td></tr>
<tr><td valign="top"><b>GAP LOCATION</b></td><td valign="top">(Read only) The buffer position of the gap.</td></tr>
<tr><td valign="top"><b>HEIGHT</b></td><td valign="top">(Read only) The number of lines on the screen.</td></tr>
<tr><td valign="top"><b>HELP CHAR</b></td><td valign="top">Contains the character used for the help character.  Normally, ^_.  If set to -1, help is not recognized (<i>e.g.</i>, useful for ^Q).</td></tr>
<tr><td valign="top"><b>HELP MAC</b></td><td valign="top">Is the macro to execute when the help character is typed.</td></tr>
<tr><td valign="top"><b>H POSITION</b></td><td valign="top">(Read only) Returns the column that the point is in.</td></tr>
<tr><td valign="top"><b>HSNAME</b></td><td valign="top">The user's home directory.</td></tr>
<tr><td valign="top"><b>I&amp;D CHR</b></td><td valign="top">When set to non-zero, TECO tries to use the terminal's insert and delete character functions.</td></tr>
<tr><td valign="top"><b>I&amp;D LINE</b></td><td valign="top">When set to non-zero, TECO tries to use the terminal's insert and delete line functions.</td></tr>
<tr><td valign="top"><b>IBASE</b></td><td valign="top">The input radix for numbers not ended by &quot;.&quot;.  Initially 8 + 2.</td></tr>
<tr><td valign="top"><b>I.BASE</b></td><td valign="top">The input radix for numbers ended by &quot;.&quot;.  Initially 8.</td></tr>
<tr><td valign="top"><b>IF ACCESS</b></td><td valign="top">(Write only) Sets the access pointer for the input file.</td></tr>
<tr><td valign="top"><b>IF CDATE</b></td><td valign="top">The creation data for the input file.</td></tr>
<tr><td valign="top"><b>IF DEVICE</b></td><td valign="top">(Read only). The device for the input file.</td></tr>
<tr><td valign="top"><b>IF DUMP</b></td><td valign="top">The dumped bit for the input file.</td></tr>
<tr><td valign="top"><b>I FILE</b></td><td valign="top">(Read only) The name of the input file.</td></tr>
<tr><td valign="top"><b>IF FN1</b></td><td valign="top">(Read only) The first name of the input file.</td></tr>
<tr><td valign="top"><b>IF FN2</b></td><td valign="top">(Read only) The second name of the input file.</td></tr>
<tr><td valign="top"><b>IF LENGTH</b></td><td valign="top">(Read only) The length of the input file.</td></tr>
<tr><td valign="top"><b>IF REAP</b></td><td valign="top">The reap bit for the input file.</td></tr>
<tr><td valign="top"><b>IF SNAME</b></td><td valign="top">(Read only) The sname of the input file.</td></tr>
<tr><td valign="top"><b>IF VERSION</b></td><td valign="top">(Read only) The version number of the input file or FS IF FN2$.</td></tr>
<tr><td valign="top"><b>IMAGE OUT</b></td><td valign="top">Outputs its argument in super-image mode (no translations at all).</td></tr>
<tr><td valign="top"><b>IN COUNT</b></td><td valign="top">Is an old name for FS TYI COUNT$</td></tr>
<tr><td valign="top"><b>INSLEN</b></td><td valign="top">Is the length of the last string inserted with &quot;I&quot;, &quot;G&quot;, or &quot;\&quot;, or found with &quot;S&quot; or &quot;FW&quot;.  It will be negative after a backward search.</td></tr>
<tr><td valign="top"><b>JNAME</b></td><td valign="top">(Read only) Returns the jobname.</td></tr>
<tr><td valign="top"><b>JRN EXECUTE</b></td><td valign="top">(Write only) Opens a journal file for playing back.  The form :FS JRN EXECUTE$ closes the file.  The default file names are used.</td></tr>
<tr><td valign="top"><b>JRN IN</b></td><td valign="top">(Read only) Is non-zero when a journal file is being replayed.</td></tr>
<tr><td valign="top"><b>JRN INHIBIT</b></td><td valign="top">When set to non-zero, input is taken from the terminal even though a journal file is being replayed.  This is how FS JRN MACRO$ can work.</td></tr>
<tr><td valign="top"><b>JRN INTERVAL</b></td><td valign="top">Specifies how often a journal file being recorded is updated on disk.  The interval is in units of commands.</td></tr>
<tr><td valign="top"><b>JRN MACRO</b></td><td valign="top">This macro is called when a journal file is being replayed and TECO encounters a colon or ^G in the file.  The character is passed as an argument.  In the case of a ^G, the macro should execute a ^R and then quit by doing -1 FS QUIT$.  In the case of a colon, this macro should read more characters from the file by doing FS JRN READ$ and acting upon them.</td></tr>
<tr><td valign="top"><b>JRN OPEN</b></td><td valign="top">(Write only) Opens a journal file for writing (recording).  The default file names are used.  The form :FS JRN OPEN$ closes the file.</td></tr>
<tr><td valign="top"><b>JRN OUT</b></td><td valign="top">(Read only) Is non-zero when a journal file is being recorded.</td></tr>
<tr><td valign="top"><b>JRN READ</b></td><td valign="top">(Read only) Reads a character from the journal file being replayed.  If there is no such file, it returns a random value.</td></tr>
<tr><td valign="top"><b>JRN WRITE</b></td><td valign="top">(Write only) Outputs its argument, either a character or a string, to the journal file being written.  If there is no such file, it does nothing.</td></tr>
<tr><td valign="top"><b>LAST PAGE</b></td><td valign="top">(Read only) Set to -1 when a file is opened and set to 0 when the last character has been read.</td></tr>
<tr><td valign="top"><b>LINES</b></td><td valign="top">Is the number of lines used by a standard buffer redisplay.  0 means to use the whole screen.</td></tr>
<tr><td valign="top"><b>LISPT</b></td><td valign="top">When set to non-zero, it means that text is supposed to be passed between TECO and its superior.</td></tr>
<tr><td valign="top"><b>LISTEN</b></td><td valign="top">Returns non-zero if input is available to be read by FI.  If it is given an argument and no input is available, the argument is typed out.</td></tr>
<tr><td valign="top"><b>MACHINE</b></td><td valign="top">(Read only) Returns the name of the machine that TECO is running on.</td></tr>
<tr><td valign="top"><b>MODE CHANGE</b></td><td valign="top">When set to non-zero, the FS MODE MACRO$ needs to be run eventually.</td></tr>
<tr><td valign="top"><b>MODE MACRO</b></td><td valign="top">The macro to update Q-register ..J and the mode line.</td></tr>
<tr><td valign="top"><b>MODIFIED</b></td><td valign="top">When set to non-zero, the buffer has been changed since last read or written.</td></tr>
<tr><td valign="top"><b>MP DISPLAY</b></td><td valign="top">(Write only) Outputs text to the main program display.</td></tr>
<tr><td valign="top"><b>MSNAME</b></td><td valign="top">The name of the working directory.</td></tr>
<tr><td valign="top"><b>NOOP ALTMODE</b></td><td valign="top">When set to a negative number, an altmode is considered a no-op. When set to 0, an altmode is considered an error.  When set to a positive number, altmode ends execution as ^_ does.</td></tr>
<tr><td valign="top"><b>NOQUIT</b></td><td valign="top">Gives the user control over ^G.</td></tr>
<tr><td valign="top"><b>OF ACCESS</b></td><td valign="top">(Write only) Sets the access pointer for the output file.</td></tr>
<tr><td valign="top"><b>OF CDATE</b></td><td valign="top">The creation data for the output file.</td></tr>
<tr><td valign="top"><b>O FILE</b></td><td valign="top">(Read only) The name of the output file.</td></tr>
<tr><td valign="top"><b>OF LENGTH</b></td><td valign="top">(Read only) The length of the output file.</td></tr>
<tr><td valign="top"><b>OF VERSION</b></td><td valign="top">(Read only) The version number of the output file or FS OF FN2$.</td></tr>
<tr><td valign="top"><b>OLD FLUSHED</b></td><td valign="top">Saves the value of FS FLUSHED$ when that is set to zero upon returning to ^R.</td></tr>
<tr><td valign="top"><b>OLD MODE</b></td><td valign="top">Is the last Q-register ..J actually displayed.</td></tr>
<tr><td valign="top"><b>OSPEED</b></td><td valign="top">The terminal's output speed in baud or 0 if the speed is not known.</td></tr>
<tr><td valign="top"><b>OUTPUT</b></td><td valign="top">When set to non-zero, suppresses output to the EW'd file.</td></tr>
<tr><td valign="top"><b>PAGENUM</b></td><td valign="top">The number of form feeds read from the input file.</td></tr>
<tr><td valign="top"><b>PJATTY</b></td><td valign="top">Set to a negative value whenever TECO detects that the terminal has been taken away. This negative value means that a complete redisplay must be done.</td></tr>
<tr><td valign="top"><b>PROMPT</b></td><td valign="top">The ASCII value of the prompt character.</td></tr>
<tr><td valign="top"><b>PUSHPT</b></td><td valign="top">(Write only) Same as n^V.</td></tr>
<tr><td valign="top"><b>QP HOME</b></td><td valign="top">Returns a string that says where the Q-register PDL (Push Down List == stack) slot n was pushed from.  The form :FS QP HOME$ returns a pointer to the Q-register.  The form n@FS QP HOME$ converts the pointer returned by :FS QP HOME$ into the string form.</td></tr>
<tr><td valign="top"><b>QP PTR</b></td><td valign="top">The Q-register PDL pointer.</td></tr>
<tr><td valign="top"><b>QP SLOT</b></td><td valign="top">Read the specified PDL slot.</td></tr>
<tr><td valign="top"><b>QP UNWIND</b></td><td valign="top">(Write only) Like FS QP PTR$ but pops slots back into the Q-registers they came from.</td></tr>
<tr><td valign="top"><b>QUIT</b></td><td valign="top">When set to a negative value, execution will quit at the next opportunity.</td></tr>
<tr><td valign="top"><b>Q VECTOR</b></td><td valign="top">Returns an n character long newly-consed up Q-register vector.</td></tr>
<tr><td valign="top"><b>RANDOM</b></td><td valign="top">Reads or sets the random number generator seed.</td></tr>
<tr><td valign="top"><b>READ ONLY</b></td><td valign="top">When set to non-zero.  Attempt to modify the buffer become an error.</td></tr>
<tr><td valign="top"><b>REAL ADDRESS</b></td><td valign="top">Returns the value of the machine address of the start of the buffer.</td></tr>
<tr><td valign="top"><b>REFRESH</b></td><td valign="top">When set to non-zero, this macro is executed whenever TECO really clears the whole screen.  It is executed after the screen has been cleared.</td></tr>
<tr><td valign="top"><b>REREAD</b></td><td valign="top">When set to non-negative, the 9-bit TV code will be read by the next invocation of FI.</td></tr>
<tr><td valign="top"><b>RGETTY</b></td><td valign="top">0 if printing terminal, or contains the tctyp word of a display terminal.</td></tr>
<tr><td valign="top"><b>RUB CRLF</b></td><td valign="top">When set to non-zero, both characters of a CR/LF pair are erased together.</td></tr>
<tr><td valign="top"><b>RUB MACRO</b></td><td valign="top">The macro called by ^R mode when it wants to do a ^? or ^D.</td></tr>
<tr><td valign="top"><b>RUNTIME</b></td><td valign="top">(Read only) TECO's runtime in milliseconds.</td></tr>
<tr><td valign="top"><b>SAIL</b></td><td valign="top">When set to non-zero, the terminal is assumed to support the SAIL character set.</td></tr>
<tr><td valign="top"><b>S ERROR</b></td><td valign="top">When set to non-zero, a failing search within an iteration or a ^P sort will generate an error.</td></tr>
<tr><td valign="top"><b>SHOW MODE</b></td><td valign="top">When set to non-zero, FR will type on the mode line on a printing terminal.  Has no effect on displays.</td></tr>
<tr><td valign="top"><b>S HPOS</b></td><td valign="top">Is the horizontal position of the point when everything is taken into account, but assuming an infinitely wide line.</td></tr>
<tr><td valign="top"><b>S STRING</b></td><td valign="top">Is the default search string.</td></tr>
<tr><td valign="top"><b>STEP MACRO</b></td><td valign="top">When set to non-zero and numeric, TECO displays the buffer and waits at the start of every line in a program.  When set to non-zero and a string, TECO executes this macro at the beginning of every line in a program.  Macros that start with W are never stepped.</td></tr>
<tr><td valign="top"><b>STEP DEPTH</b></td><td valign="top">When set to -1, stepping occurs always.  Otherwise, it is the number of the stack level at which to cut off stepping.</td></tr>
<tr><td valign="top"><b>SUPERIOR</b></td><td valign="top">Is the macro invoked when superiors want to put text into TECO.</td></tr>
<tr><td valign="top"><b>S VALUE</b></td><td valign="top">Is the value returned by last search command.</td></tr>
<tr><td valign="top"><b>TOP LINE</b></td><td valign="top">The number of the first line of the screen that TECO should use.</td></tr>
<tr><td valign="top"><b>TRACE</b></td><td valign="top">When set to non-zero, TECO is in trace mode.  See ?.</td></tr>
<tr><td valign="top"><b>TRUNCATE</b></td><td valign="top">If negative, long lines should be truncated.  If 0 or positive, long lines are wrapped to the next line.</td></tr>
<tr><td valign="top"><b>TTMODE</b></td><td valign="top">When set to non-zero, tells TECO that normal buffer display should display on printing terminals.</td></tr>
<tr><td valign="top"><b>TTY INIT</b></td><td valign="top">(Re)initializes TECO's TTY information.</td></tr>
<tr><td valign="top"><b>TTY MACRO</b></td><td valign="top">Performs user-specified TTY initialization.</td></tr>
<tr><td valign="top"><b>TTYOPT</b></td><td valign="top">(Read only) The TTYOPT word for the terminal.  Use the %TOxxx values instead.</td></tr>
<tr><td valign="top"><b>TTYSMT</b></td><td valign="top">(Read only) The TTYSMT word for the terminal.</td></tr>
<tr><td valign="top"><b>TYI BEG</b></td><td valign="top">The value of FS TYI COUNT$ the last time through the main ^R command loop.</td></tr>
<tr><td valign="top"><b>TYI COUNT</b></td><td valign="top">The number of characters read so far.</td></tr>
<tr><td valign="top"><b>TYI SINK</b></td><td valign="top">When set to non-zero, is a macro that is executed every time a character is actually read from the terminal.</td></tr>
<tr><td valign="top"><b>TYI SOURCE</b></td><td valign="top">When set to non-zero, it a macro that is called to obtain &quot;terminal input.&quot;</td></tr>
<tr><td valign="top"><b>TYO HASH</b></td><td valign="top">Returns the hash code of screen line n.  Doing -1,n FS TYO HASH$ forces line n to be redisplayed.</td></tr>
<tr><td valign="top"><b>TYO HPOS</b></td><td valign="top">(Read only) Holds the horizontal position at which type out will next appear.</td></tr>
<tr><td valign="top"><b>TYO VPOS</b></td><td valign="top">(Read only) Holds the vertical position at which type out will next appear.</td></tr>
<tr><td valign="top"><b>TYPEOUT</b></td><td valign="top">Tells where type out will next appear.  If -1, the next type out will appear at the top of the screen.  Otherwise, type out will appear just after the last type out.</td></tr>
<tr><td valign="top"><b>U HSNAME</b></td><td valign="top">Determines a user's hsname.</td></tr>
<tr><td valign="top"><b>UINDEX</b></td><td valign="top">(Read only) The user index of the TECO job.</td></tr>
<tr><td valign="top"><b>U MAIL FILE</b></td><td valign="top">The complete file name of the user's mail file.</td></tr>
<tr><td valign="top"><b>UNAME</b></td><td valign="top">(Read only) The user name of the TECO job.</td></tr>
<tr><td valign="top"><b>UPTIME</b></td><td valign="top">(Read only) Returns the time that the system has been up in units of 1/30 second.</td></tr>
<tr><td valign="top"><b>UREAD</b></td><td valign="top">(Read only) Is -1 if an input file is open, otherwise it is zero.</td></tr>
<tr><td valign="top"><b>UWRITE</b></td><td valign="top">(Read only) Is -1 if an output file is open, otherwise it is zero.</td></tr>
<tr><td valign="top"><b>VAR MACRO</b></td><td valign="top">When set to non-zero, a macro can be run whenever a variable is set.</td></tr>
<tr><td valign="top"><b>V B</b></td><td valign="top">Is the distance between the real beginning of the buffer and the virtual beginning.</td></tr>
<tr><td valign="top"><b>VERBOSE</b></td><td valign="top">When set to non-zero, TECO prints long error messages.  Otherwise, TECO prints only short messages and ^X must be typed to see the long version.</td></tr>
<tr><td valign="top"><b>VERSION</b></td><td valign="top">(Read only) The TECO version number.</td></tr>
<tr><td valign="top"><b>V Z</b></td><td valign="top">Is the distance between the real end of the buffer and the virtual end.</td></tr>
<tr><td valign="top"><b>WIDTH</b></td><td valign="top">Width of the terminal in characters.</td></tr>
<tr><td valign="top"><b>WINDOW</b></td><td valign="top">The position of the first character in the display window, relative to the virtual beginning of the buffer.</td></tr>
<tr><td valign="top"><b>WORD</b></td><td valign="top">Gets or sets words in the current buffer.</td></tr>
<tr><td valign="top"><b>XJNAME</b></td><td valign="top">(Read only) Returns the xjname of the TECO job.</td></tr>
<tr><td valign="top"><b>X MODIFIED</b></td><td valign="top">Just like FS MODIFIED$, only it doesn't affect the display of the modified flag in the mode line.  Thus, the user can track whether changes were made by intervening commands.</td></tr>
<tr><td valign="top"><b>X PROMPT</b></td><td valign="top">Printed and zeroed with each printing terminal prompt.</td></tr>
<tr><td valign="top"><b>XUNAME</b></td><td valign="top">(Read only) Returns the xjname of the TECO job.</td></tr>
<tr><td valign="top"><b>Y DISABLE</b></td><td valign="top">When set to 0, the Y command is legal.  When set to 1, the Y command is always illegal.  When set to -1, the Y command is treated as @Y.</td></tr>
<tr><td valign="top"><b>Z</b></td><td valign="top">(Read only) The number of characters in the buffer.</td></tr>
<tr><td valign="top"><b>^H PRINT</b></td><td valign="top">When set to negative, a ^H on output will backspace and overprint.  Otherwise, ^H will type as a ^ and H.</td></tr>
<tr><td valign="top"><b>^I DISABLE</b></td><td valign="top">When set to 0, ^I is an insert command.  When set to 1, ^I is illegal.   When set to -1, ^I is a no-op.</td></tr>
<tr><td valign="top"><b>^L INSERT</b></td><td valign="top">When set to non-zero, form feeds read from files always go into the buffer and P and PW never output anything except what is in the buffer.</td></tr>
<tr><td valign="top"><b>^M PRINT</b></td><td valign="top">When set to negative, a ^M on output will output as a CR/LF.  Otherwise, ^M will type as a ^ and M.</td></tr>
<tr><td valign="top"><b>^P CASE</b></td><td valign="top">When set to non-zero, ^P ignores case.</td></tr>
<tr><td valign="top"><b>^R ARG</b></td><td valign="top">Is the explicit numeric argument and is 0 (not 1!) if no argument was entered</td></tr>
<tr><td valign="top"><b>^R ARGP</b></td><td valign="top">Describes the ^R command's td.

<table border="0" width="100%">
<colgroup>
<col width="10%">
<col width="90%">
</colgroup>

<tr><td valign="top"><b>bit 2^0</b></td><td valign="top">set if any argument was specified</td></tr>
<tr><td valign="top"><b>bit 2^1</b></td><td valign="top">set if a number was typed</td></tr>
<tr><td valign="top"><b>bit 2^2</b></td><td valign="top">set if the argument is negative</td></tr>
</table>
</td></tr>

<tr><td valign="top"><b>^R CCOL</b></td><td valign="top">The comment column.</td></tr>
<tr><td valign="top"><b>^R CMACRO</b></td><td valign="top">Converts the ASCII value n to a form required for ^R command dispatch.</td></tr>
<tr><td valign="top"><b>^R DISPLAY</b></td><td valign="top">When set to non-zero, this macro is executed whenever ^R is about to do a non-trivial redisplay.</td></tr>
<tr><td valign="top"><b>^R EXIT</b></td><td valign="top">(Write only) Exits from the innermost ^R invocation.</td></tr>
<tr><td valign="top"><b>^R ECHO</b></td><td valign="top">When set to 1, the characters read in by ^R should not be echoed.  When set to 0, they should be echoed only on printing terminals.  When set to -1, they should be echoed on all terminals.</td></tr>
<tr><td valign="top"><b>^R EC SD</b></td><td valign="top">When set to non-zero, this macro is executed whenever a space command is typed.  Used for auto-filling and such.</td></tr>
<tr><td valign="top"><b>^R ENTERED</b></td><td valign="top">When set to non-zero, this macro is executed whenever ^R is invoked.</td></tr>
<tr><td valign="top"><b>^R EXPT</b></td><td valign="top">Is the ^U count for the next ^R mode command.</td></tr>
<tr><td valign="top"><b>^R H MIN</b></td><td valign="top">(Read only) Is the leftmost horizontal position requiring redisplay.</td></tr>
<tr><td valign="top"><b>^R HPOS</b></td><td valign="top">The current horizontal position of the cursor.</td></tr>
<tr><td valign="top"><b>^R INDIRECT</b></td><td valign="top">Given a 9-bit character, follows the alias definitions to find what it is equivalent to.</td></tr>
<tr><td valign="top"><b>^R INHIBIT</b></td><td valign="top">When set to non-zero, ^R will not update the display.</td></tr>
<tr><td valign="top"><b>When set back to zero, ^R will catch up.
^R INIT</b></td><td valign="top">Returns the initial definition of the character whose ASCII value is n.</td></tr>
<tr><td valign="top"><b>^R INSERT</b></td><td valign="top">Inserts its argument.</td></tr>
<tr><td valign="top"><b>^R LAST</b></td><td valign="top">Holds the most recent character read by any ^R.</td></tr>
<tr><td valign="top"><b>^R LEAVE</b></td><td valign="top">When set to non-zero, this macro is executed whenever ^R returns.</td></tr>
<tr><td valign="top"><b>^R MARK</b></td><td valign="top">Records the position of the mark.</td></tr>
<tr><td valign="top"><b>^R MAX</b></td><td valign="top">The maximum number of characters of insertions or deletions printed out by ^R on a printing terminal before it switches to printing a description of the change.  Default is 50.</td></tr>
<tr><td valign="top"><b>^R MCNT</b></td><td valign="top">The secretary mode counter.</td></tr>
<tr><td valign="top"><b>^R MDLY</b></td><td valign="top">The secretary mode limit value.</td></tr>
<tr><td valign="top"><b>^R MODE</b></td><td valign="top">(Read only) Non-zero while in ^R mode.</td></tr>
<tr><td valign="top"><b>^R MORE</b></td><td valign="top">When positive, --MORE-- is used for the ^R mode line instead of --TOP--, --BOT--, and --nn%--.  This is used when in an environment where Space means &quot;show me the next screenful.&quot;  When negative, no --XXX-- is displayed.</td></tr>
<tr><td valign="top"><b>^R NORMAL</b></td><td valign="top">When set to non-zero, this macro is executed for all normally self-insert characters.</td></tr>
<tr><td valign="top"><b>^R PAREN</b></td><td valign="top">When set to non-zero, this macro is executed for every &quot;)&quot; character.</td></tr>
<tr><td valign="top"><b>^R PREVIOUS</b></td><td valign="top">Holds the previous (second most recent) command.</td></tr>
<tr><td valign="top"><b>^R REPLACE</b></td><td valign="top">When set to non-zero, ^R runs in &quot;replace&quot; mode instead of &quot;insert&quot; mode.</td></tr>
<tr><td valign="top"><b>^R RUBOUT</b></td><td valign="top">The internal ^R rubout routine.</td></tr>
<tr><td valign="top"><b>^R SCAN</b></td><td valign="top">When set to non-zero and a printing terminal is in use, displays characters that are being moved past.</td></tr>
<tr><td valign="top"><b>^R STAR</b></td><td valign="top">When set to non-zero, a star appears in the mode line if the buffer has been modified.</td></tr>
<tr><td valign="top"><b>^R SUPPRESS</b></td><td valign="top">When set to 0 or positive, built-in ^R mode commands are suppressed and characters insert.</td></tr>
<tr><td valign="top"><b>^R THROW</b></td><td valign="top">Returns control to the innermost invocation of ^R.</td></tr>
<tr><td valign="top"><b>^R UNSUPP</b></td><td valign="top">When set to -1, one character will be unsuppressed.</td></tr>
<tr><td valign="top"><b>^R V MIN</b></td><td valign="top">(Read only) Is the topmost line requiring redisplay.</td></tr>
<tr><td valign="top"><b>^R VPOS</b></td><td valign="top">The current vertical position of the cursor.</td></tr>
<tr><td valign="top"><b>_ DISABLE</b></td><td valign="top">When 0, _ is &quot;search and yank.&quot;  When 1, _ is illegal.  When -1, _ is treated like -.</td></tr>
</table>

<p><a href="#contents">Back to Contents</a>.</p>
<hr>
<a name="aE"></a><h1>Appendix E: ASCII Chart</h1>

<p>This character set is as specified in ANS standards, and is known
as the ASCII character set.  It has been extended to include Meta
characters (characters with their top, or eighth, bit turned on).</p>

<table border="0" width="100%">
<colgroup>
<col width="10%">
<col width="10%">
<col width="10%">
<col width="10%">
<col width="60%">
</colgroup>

<tr><td valign="top">Decimal</td><td valign="top">Octal</td><td valign="top">Hex</td><td valign="top">Graphic</td><td valign="top">Name (Meaning)</td></tr>
<tr><td valign="top" colspan="5">&nbsp;</td></tr>
<tr><td valign="top">0.</td><td valign="top">000</td><td valign="top">00</td><td valign="top">^@</td><td valign="top">NUL (used for padding)</td></tr>
<tr><td valign="top">1.</td><td valign="top">001</td><td valign="top">01</td><td valign="top">^A</td><td valign="top">SOH (start of header)</td></tr>
<tr><td valign="top">2.</td><td valign="top">002</td><td valign="top">02</td><td valign="top">^B</td><td valign="top">STX (start of text)</td></tr>
<tr><td valign="top">3.</td><td valign="top">003</td><td valign="top">03</td><td valign="top">^C</td><td valign="top">ETX (end of text)</td></tr>
<tr><td valign="top">4.</td><td valign="top">004</td><td valign="top">04</td><td valign="top">^D</td><td valign="top">EOT (end of transmission)</td></tr>
<tr><td valign="top">5.</td><td valign="top">005</td><td valign="top">05</td><td valign="top">^E</td><td valign="top">ENQ (enquiry)</td></tr>
<tr><td valign="top">6.</td><td valign="top">006</td><td valign="top">06</td><td valign="top">^F</td><td valign="top">ACK (acknowledge)</td></tr>
<tr><td valign="top">7.</td><td valign="top">007</td><td valign="top">07</td><td valign="top">^G</td><td valign="top">BEL (bell or alarm)</td></tr>
<tr><td valign="top">8.</td><td valign="top">010</td><td valign="top">08</td><td valign="top">^H</td><td valign="top">BS  (backspace)</td></tr>
<tr><td valign="top">9.</td><td valign="top">011</td><td valign="top">09</td><td valign="top">^I</td><td valign="top">HT, TAB  (horizontal tab)</td></tr>
<tr><td valign="top">10.</td><td valign="top">012</td><td valign="top">0A</td><td valign="top">^J</td><td valign="top">LF  (line feed)</td></tr>
<tr><td valign="top">11.</td><td valign="top">013</td><td valign="top">0B</td><td valign="top">^K</td><td valign="top">VT  (vertical tab)</td></tr>
<tr><td valign="top">12.</td><td valign="top">014</td><td valign="top">0C</td><td valign="top">^L</td><td valign="top">FF  (form feed, new page)</td></tr>
<tr><td valign="top">13.</td><td valign="top">015</td><td valign="top">0D</td><td valign="top">^M</td><td valign="top">CR  (carriage return)</td></tr>
<tr><td valign="top">14.</td><td valign="top">016</td><td valign="top">0E</td><td valign="top">^N</td><td valign="top">SO  (shift out)</td></tr>
<tr><td valign="top">15.</td><td valign="top">017</td><td valign="top">0F</td><td valign="top">^O</td><td valign="top">SI  (shift in)</td></tr>

<tr><td valign="top" colspan="5">&nbsp;</td></tr>

<tr><td valign="top">16.</td><td valign="top">020</td><td valign="top">10</td><td valign="top">^P</td><td valign="top">DLE (data link escape)</td></tr>
<tr><td valign="top">17.</td><td valign="top">021</td><td valign="top">11</td><td valign="top">^Q</td><td valign="top">DC1, XON (device control 1)</td></tr>
<tr><td valign="top">18.</td><td valign="top">022</td><td valign="top">12</td><td valign="top">^R</td><td valign="top">DC2 (device control 2)</td></tr>
<tr><td valign="top">19.</td><td valign="top">023</td><td valign="top">13</td><td valign="top">^S</td><td valign="top">DC3, XOFF (device control 3)</td></tr>
<tr><td valign="top">20.</td><td valign="top">024</td><td valign="top">14</td><td valign="top">^T</td><td valign="top">DC4 (device control 4)</td></tr>
<tr><td valign="top">21.</td><td valign="top">025</td><td valign="top">15</td><td valign="top">^U</td><td valign="top">NAK (negative acknowledge)</td></tr>
<tr><td valign="top">22.</td><td valign="top">026</td><td valign="top">16</td><td valign="top">^V</td><td valign="top">SYN (synchronous idle)</td></tr>
<tr><td valign="top">23.</td><td valign="top">027</td><td valign="top">17</td><td valign="top">^W</td><td valign="top">ETB (end transmission block)</td></tr>
<tr><td valign="top">24.</td><td valign="top">030</td><td valign="top">18</td><td valign="top">^X</td><td valign="top">CAN (cancel)</td></tr>
<tr><td valign="top">25.</td><td valign="top">031</td><td valign="top">19</td><td valign="top">^Y</td><td valign="top">EM  (end of medium)</td></tr>
<tr><td valign="top">26.</td><td valign="top">032</td><td valign="top">1A</td><td valign="top">^Z</td><td valign="top">SUB (substitute)</td></tr>
<tr><td valign="top">27.</td><td valign="top">033</td><td valign="top">1B</td><td valign="top">^[</td><td valign="top">ESC (escape, alter mode, SEL)</td></tr>
<tr><td valign="top">28.</td><td valign="top">034</td><td valign="top">1C</td><td valign="top">^\</td><td valign="top">FS  (file separator)</td></tr>
<tr><td valign="top">29.</td><td valign="top">035</td><td valign="top">1D</td><td valign="top">^]</td><td valign="top">GS  (group separator)</td></tr>
<tr><td valign="top">30.</td><td valign="top">036</td><td valign="top">1E</td><td valign="top">^^</td><td valign="top">RS  (record separator)</td></tr>
<tr><td valign="top">31.</td><td valign="top">037</td><td valign="top">1F</td><td valign="top">^_</td><td valign="top">US  (unit separator)</td></tr>

<tr><td valign="top" colspan="5">&nbsp;</td></tr>

<tr><td valign="top">32.</td><td valign="top">040</td><td valign="top">20</td><td valign="top">&nbsp;</td><td valign="top">space or blank</td></tr>
<tr><td valign="top">33.</td><td valign="top">041</td><td valign="top">21</td><td valign="top">!</td><td valign="top">exclamation mark</td></tr>
<tr><td valign="top">34.</td><td valign="top">042</td><td valign="top">22</td><td valign="top">&quot;</td><td valign="top">double quote</td></tr>
<tr><td valign="top">35.</td><td valign="top">043</td><td valign="top">23</td><td valign="top">#</td><td valign="top">number sign (hash mark)</td></tr>
<tr><td valign="top">36.</td><td valign="top">044</td><td valign="top">24</td><td valign="top">$</td><td valign="top">dollar sign</td></tr>
<tr><td valign="top">37.</td><td valign="top">045</td><td valign="top">25</td><td valign="top">%</td><td valign="top">percent sign</td></tr>
<tr><td valign="top">38.</td><td valign="top">046</td><td valign="top">26</td><td valign="top">&amp;</td><td valign="top">ampersand sign</td></tr>
<tr><td valign="top">39.</td><td valign="top">047</td><td valign="top">27</td><td valign="top">'</td><td valign="top">single quote (apostrophe)</td></tr>
<tr><td valign="top">40.</td><td valign="top">050</td><td valign="top">28</td><td valign="top">(</td><td valign="top">left parenthesis</td></tr>
<tr><td valign="top">41.</td><td valign="top">051</td><td valign="top">29</td><td valign="top">)</td><td valign="top">right parenthesis</td></tr>
<tr><td valign="top">42.</td><td valign="top">052</td><td valign="top">2A</td><td valign="top">*</td><td valign="top">asterisk (star)</td></tr>
<tr><td valign="top">43.</td><td valign="top">053</td><td valign="top">2B</td><td valign="top">+</td><td valign="top">plus sign</td></tr>
<tr><td valign="top">44.</td><td valign="top">054</td><td valign="top">2C</td><td valign="top">,</td><td valign="top">comma</td></tr>
<tr><td valign="top">45.</td><td valign="top">055</td><td valign="top">2D</td><td valign="top">-</td><td valign="top">minus sign (dash)</td></tr>
<tr><td valign="top">46.</td><td valign="top">056</td><td valign="top">2E</td><td valign="top">.</td><td valign="top">period (decimal point, dot)</td></tr>
<tr><td valign="top">47.</td><td valign="top">057</td><td valign="top">2F</td><td valign="top">/</td><td valign="top">(right) slash</td></tr>

<tr><td valign="top">&nbsp;</td></tr>

<tr><td valign="top">48.</td><td valign="top">060</td><td valign="top">30</td><td valign="top">0</td><td valign="top">numeral zero</td></tr>
<tr><td valign="top">49.</td><td valign="top">061</td><td valign="top">31</td><td valign="top">1</td><td valign="top">numeral one</td></tr>
<tr><td valign="top">50.</td><td valign="top">062</td><td valign="top">32</td><td valign="top">2</td><td valign="top">numeral two</td></tr>
<tr><td valign="top">51.</td><td valign="top">063</td><td valign="top">33</td><td valign="top">3</td><td valign="top">numeral three</td></tr>
<tr><td valign="top">52.</td><td valign="top">064</td><td valign="top">34</td><td valign="top">4</td><td valign="top">numeral four</td></tr>
<tr><td valign="top">53.</td><td valign="top">065</td><td valign="top">35</td><td valign="top">5</td><td valign="top">numeral five</td></tr>
<tr><td valign="top">54.</td><td valign="top">066</td><td valign="top">36</td><td valign="top">6</td><td valign="top">numeral six</td></tr>
<tr><td valign="top">55.</td><td valign="top">067</td><td valign="top">37</td><td valign="top">7</td><td valign="top">numeral seven</td></tr>
<tr><td valign="top">56.</td><td valign="top">070</td><td valign="top">38</td><td valign="top">8</td><td valign="top">numeral eight</td></tr>
<tr><td valign="top">57.</td><td valign="top">071</td><td valign="top">39</td><td valign="top">9</td><td valign="top">numeral nine</td></tr>
<tr><td valign="top">58.</td><td valign="top">072</td><td valign="top">3A</td><td valign="top">:</td><td valign="top">colon</td></tr>
<tr><td valign="top">59.</td><td valign="top">073</td><td valign="top">3B</td><td valign="top">;</td><td valign="top">semi-colon</td></tr>
<tr><td valign="top">60.</td><td valign="top">074</td><td valign="top">3C</td><td valign="top">&lt;</td><td valign="top">less-than sign</td></tr>
<tr><td valign="top">61.</td><td valign="top">075</td><td valign="top">3D</td><td valign="top">=</td><td valign="top">equal sign</td></tr>
<tr><td valign="top">62.</td><td valign="top">076</td><td valign="top">3E</td><td valign="top">&gt;</td><td valign="top">greater-than sign</td></tr>
<tr><td valign="top">63.</td><td valign="top">077</td><td valign="top">3F</td><td valign="top">?</td><td valign="top">question mark</td></tr>

<tr><td valign="top" colspan="5">&nbsp;</td></tr>

<tr><td valign="top">64.</td><td valign="top">100</td><td valign="top">40</td><td valign="top">@</td><td valign="top">atsign</td></tr>
<tr><td valign="top">65.</td><td valign="top">101</td><td valign="top">41</td><td valign="top">A</td><td valign="top">upper-case letter ALPHA</td></tr>
<tr><td valign="top">66.</td><td valign="top">102</td><td valign="top">42</td><td valign="top">B</td><td valign="top">upper-case letter BRAVO</td></tr>
<tr><td valign="top">67.</td><td valign="top">103</td><td valign="top">43</td><td valign="top">C</td><td valign="top">upper-case letter CHARLIE</td></tr>
<tr><td valign="top">68.</td><td valign="top">104</td><td valign="top">44</td><td valign="top">D</td><td valign="top">upper-case letter DELTA</td></tr>
<tr><td valign="top">69.</td><td valign="top">105</td><td valign="top">45</td><td valign="top">E</td><td valign="top">upper-case letter ECHO</td></tr>
<tr><td valign="top">70.</td><td valign="top">106</td><td valign="top">46</td><td valign="top">F</td><td valign="top">upper-case letter FOXTROT</td></tr>
<tr><td valign="top">71.</td><td valign="top">107</td><td valign="top">47</td><td valign="top">G</td><td valign="top">upper-case letter GOLF</td></tr>
<tr><td valign="top">72.</td><td valign="top">110</td><td valign="top">48</td><td valign="top">H</td><td valign="top">upper-case letter HOTEL</td></tr>
<tr><td valign="top">73.</td><td valign="top">111</td><td valign="top">49</td><td valign="top">I</td><td valign="top">upper-case letter INDIA</td></tr>
<tr><td valign="top">74.</td><td valign="top">112</td><td valign="top">4A</td><td valign="top">J</td><td valign="top">upper-case letter JERICHO</td></tr>
<tr><td valign="top">75.</td><td valign="top">113</td><td valign="top">4B</td><td valign="top">K</td><td valign="top">upper-case letter KAPPA</td></tr>
<tr><td valign="top">76.</td><td valign="top">114</td><td valign="top">4C</td><td valign="top">L</td><td valign="top">upper-case letter LIMA</td></tr>
<tr><td valign="top">77.</td><td valign="top">115</td><td valign="top">4D</td><td valign="top">M</td><td valign="top">upper-case letter MIKE</td></tr>
<tr><td valign="top">78.</td><td valign="top">116</td><td valign="top">4E</td><td valign="top">N</td><td valign="top">upper-case letter NOVEMBER</td></tr>
<tr><td valign="top">79.</td><td valign="top">117</td><td valign="top">4F</td><td valign="top">O</td><td valign="top">upper-case letter OSCAR</td></tr>

<tr><td valign="top" colspan="5">&nbsp;</td></tr>

<tr><td valign="top">80.</td><td valign="top">120</td><td valign="top">50</td><td valign="top">P</td><td valign="top">upper-case letter PAPPA</td></tr>
<tr><td valign="top">81.</td><td valign="top">121</td><td valign="top">51</td><td valign="top">Q</td><td valign="top">upper-case letter QUEBEC</td></tr>
<tr><td valign="top">82.</td><td valign="top">122</td><td valign="top">52</td><td valign="top">R</td><td valign="top">upper-case letter ROMEO</td></tr>
<tr><td valign="top">83.</td><td valign="top">123</td><td valign="top">53</td><td valign="top">S</td><td valign="top">upper-case letter SIERRA</td></tr>
<tr><td valign="top">84.</td><td valign="top">124</td><td valign="top">54</td><td valign="top">T</td><td valign="top">upper-case letter TANGO</td></tr>
<tr><td valign="top">85.</td><td valign="top">125</td><td valign="top">55</td><td valign="top">U</td><td valign="top">upper-case letter UNICORN</td></tr>
<tr><td valign="top">86.</td><td valign="top">126</td><td valign="top">56</td><td valign="top">V</td><td valign="top">upper-case letter VICTOR</td></tr>
<tr><td valign="top">87.</td><td valign="top">127</td><td valign="top">57</td><td valign="top">W</td><td valign="top">upper-case letter WHISKEY</td></tr>
<tr><td valign="top">88.</td><td valign="top">130</td><td valign="top">58</td><td valign="top">X</td><td valign="top">upper-case letter XRAY</td></tr>
<tr><td valign="top">89.</td><td valign="top">131</td><td valign="top">59</td><td valign="top">Y</td><td valign="top">upper-case letter YANKEE</td></tr>
<tr><td valign="top">90.</td><td valign="top">132</td><td valign="top">5A</td><td valign="top">Z</td><td valign="top">upper-case letter ZEBRA</td></tr>
<tr><td valign="top">91.</td><td valign="top">133</td><td valign="top">5B</td><td valign="top">[</td><td valign="top">left square bracket</td></tr>
<tr><td valign="top">92.</td><td valign="top">134</td><td valign="top">5C</td><td valign="top">\</td><td valign="top">left slash (backslash)</td></tr>
<tr><td valign="top">93.</td><td valign="top">135</td><td valign="top">5D</td><td valign="top">]</td><td valign="top">right square bracket</td></tr>
<tr><td valign="top">94.</td><td valign="top">136</td><td valign="top">5E</td><td valign="top">^</td><td valign="top">uparrow (caret)</td></tr>
<tr><td valign="top">95.</td><td valign="top">137</td><td valign="top">5F</td><td valign="top">_</td><td valign="top">underscore</td></tr>

<tr><td valign="top" colspan="5">&nbsp;</td></tr>

<tr><td valign="top">96.</td><td valign="top">140</td><td valign="top">60</td><td valign="top">`</td><td valign="top">(single) back quote (grave accent)</td></tr>
<tr><td valign="top">97.</td><td valign="top">141</td><td valign="top">61</td><td valign="top">a</td><td valign="top">lower-case letter alpha</td></tr>
<tr><td valign="top">98.</td><td valign="top">142</td><td valign="top">62</td><td valign="top">b</td><td valign="top">lower-case letter bravo</td></tr>
<tr><td valign="top">99.</td><td valign="top">143</td><td valign="top">63</td><td valign="top">c</td><td valign="top">lower-case letter charlie</td></tr>
<tr><td valign="top">100.</td><td valign="top">144</td><td valign="top">64</td><td valign="top">d</td><td valign="top">lower-case letter delta</td></tr>
<tr><td valign="top">101.</td><td valign="top">145</td><td valign="top">65</td><td valign="top">e</td><td valign="top">lower-case letter echo</td></tr>
<tr><td valign="top">102.</td><td valign="top">146</td><td valign="top">66</td><td valign="top">f</td><td valign="top">lower-case letter foxtrot</td></tr>
<tr><td valign="top">103.</td><td valign="top">147</td><td valign="top">67</td><td valign="top">g</td><td valign="top">lower-case letter golf</td></tr>
<tr><td valign="top">104.</td><td valign="top">150</td><td valign="top">68</td><td valign="top">h</td><td valign="top">lower-case letter hotel</td></tr>
<tr><td valign="top">105.</td><td valign="top">151</td><td valign="top">69</td><td valign="top">i</td><td valign="top">lower-case letter india</td></tr>
<tr><td valign="top">106.</td><td valign="top">152</td><td valign="top">6A</td><td valign="top">j</td><td valign="top">lower-case letter jericho</td></tr>
<tr><td valign="top">107.</td><td valign="top">153</td><td valign="top">6B</td><td valign="top">k</td><td valign="top">lower-case letter kappa</td></tr>
<tr><td valign="top">108.</td><td valign="top">154</td><td valign="top">6C</td><td valign="top">l</td><td valign="top">lower-case letter lima</td></tr>
<tr><td valign="top">109.</td><td valign="top">155</td><td valign="top">6D</td><td valign="top">m</td><td valign="top">lower-case letter mike</td></tr>
<tr><td valign="top">110.</td><td valign="top">156</td><td valign="top">6E</td><td valign="top">n</td><td valign="top">lower-case letter november</td></tr>
<tr><td valign="top">111.</td><td valign="top">157</td><td valign="top">6F</td><td valign="top">o</td><td valign="top">lower-case letter oscar</td></tr>

<tr><td valign="top" colspan="5">&nbsp;</td></tr>

<tr><td valign="top">112.</td><td valign="top">160</td><td valign="top">70</td><td valign="top">p</td><td valign="top">lower-case letter pappa</td></tr>
<tr><td valign="top">113.</td><td valign="top">161</td><td valign="top">71</td><td valign="top">q</td><td valign="top">lower-case letter quebec</td></tr>
<tr><td valign="top">114.</td><td valign="top">162</td><td valign="top">72</td><td valign="top">r</td><td valign="top">lower-case letter romeo</td></tr>
<tr><td valign="top">115.</td><td valign="top">163</td><td valign="top">73</td><td valign="top">s</td><td valign="top">lower-case letter sierra</td></tr>
<tr><td valign="top">116.</td><td valign="top">164</td><td valign="top">74</td><td valign="top">t</td><td valign="top">lower-case letter tango</td></tr>
<tr><td valign="top">117.</td><td valign="top">165</td><td valign="top">75</td><td valign="top">u</td><td valign="top">lower-case letter unicorn</td></tr>
<tr><td valign="top">118.</td><td valign="top">166</td><td valign="top">76</td><td valign="top">v</td><td valign="top">lower-case letter victor</td></tr>
<tr><td valign="top">119.</td><td valign="top">167</td><td valign="top">77</td><td valign="top">w</td><td valign="top">lower-case letter whiskey</td></tr>
<tr><td valign="top">120.</td><td valign="top">170</td><td valign="top">78</td><td valign="top">x</td><td valign="top">lower-case letter xray</td></tr>
<tr><td valign="top">121.</td><td valign="top">171</td><td valign="top">79</td><td valign="top">y</td><td valign="top">lower-case letter yankee</td></tr>
<tr><td valign="top">122.</td><td valign="top">172</td><td valign="top">7A</td><td valign="top">z</td><td valign="top">lower-case letter zebra</td></tr>
<tr><td valign="top">123.</td><td valign="top">173</td><td valign="top">7B</td><td valign="top">{</td><td valign="top">left curly brace</td></tr>
<tr><td valign="top">124.</td><td valign="top">174</td><td valign="top">7C</td><td valign="top">|</td><td valign="top">vertical bar</td></tr>
<tr><td valign="top">125.</td><td valign="top">175</td><td valign="top">7D</td><td valign="top">}</td><td valign="top">right curly brace</td></tr>
<tr><td valign="top">126.</td><td valign="top">176</td><td valign="top">7E</td><td valign="top">~</td><td valign="top">tilde</td></tr>
<tr><td valign="top">127.</td><td valign="top">177</td><td valign="top">7F</td><td valign="top">^?</td><td valign="top">DEL (delete, rub out)</td></tr>

<tr><td valign="top" colspan="5">&nbsp;</td></tr>

<tr><td valign="top">128.</td><td valign="top">200</td><td valign="top">80</td><td valign="top">~^@</td><td valign="top">Meta NUL (used for padding)</td></tr>
<tr><td valign="top">129.</td><td valign="top">201</td><td valign="top">81</td><td valign="top">~^A</td><td valign="top">Meta SOH (start of header)</td></tr>
<tr><td valign="top">130.</td><td valign="top">202</td><td valign="top">82</td><td valign="top">~^B</td><td valign="top">Meta STX (start of text)</td></tr>
<tr><td valign="top">131.</td><td valign="top">203</td><td valign="top">83</td><td valign="top">~^C</td><td valign="top">Meta ETX (end of text)</td></tr>
<tr><td valign="top">132.</td><td valign="top">204</td><td valign="top">84</td><td valign="top">~^D</td><td valign="top">Meta EOT (end of transmission)</td></tr>
<tr><td valign="top">133.</td><td valign="top">205</td><td valign="top">85</td><td valign="top">~^E</td><td valign="top">Meta ENQ (enquiry)</td></tr>
<tr><td valign="top">134.</td><td valign="top">206</td><td valign="top">86</td><td valign="top">~^F</td><td valign="top">Meta ACK (ackowledge)</td></tr>
<tr><td valign="top">135.</td><td valign="top">207</td><td valign="top">87</td><td valign="top">~^G</td><td valign="top">Meta BEL (bell or alarm)</td></tr>
<tr><td valign="top">136.</td><td valign="top">210</td><td valign="top">88</td><td valign="top">~^H</td><td valign="top">Meta BS  (backspace)</td></tr>
<tr><td valign="top">137.</td><td valign="top">211</td><td valign="top">89</td><td valign="top">~^I</td><td valign="top">Meta HT, TAB  (horizontal tab)</td></tr>
<tr><td valign="top">138.</td><td valign="top">212</td><td valign="top">8A</td><td valign="top">~^J</td><td valign="top">Meta LF  (line feed)</td></tr>
<tr><td valign="top">139.</td><td valign="top">213</td><td valign="top">8B</td><td valign="top">~^K</td><td valign="top">Meta VT  (vertical tab)</td></tr>
<tr><td valign="top">140.</td><td valign="top">214</td><td valign="top">8C</td><td valign="top">~^L</td><td valign="top">Meta FF  (form feed, new page)</td></tr>
<tr><td valign="top">141.</td><td valign="top">215</td><td valign="top">8D</td><td valign="top">~^M</td><td valign="top">Meta CR  (carriage return)</td></tr>
<tr><td valign="top">142.</td><td valign="top">216</td><td valign="top">8E</td><td valign="top">~^N</td><td valign="top">Meta SO  (shift out)</td></tr>
<tr><td valign="top">143.</td><td valign="top">217</td><td valign="top">8F</td><td valign="top">~^O</td><td valign="top">Meta SI  (shift in)</td></tr>

<tr><td valign="top" colspan="5">&nbsp;</td></tr>

<tr><td valign="top">144.</td><td valign="top">220</td><td valign="top">90</td><td valign="top">~^P</td><td valign="top">Meta DLE (data link escape)</td></tr>
<tr><td valign="top">145.</td><td valign="top">221</td><td valign="top">91</td><td valign="top">~^Q</td><td valign="top">Meta DC1, XON (device control 1)</td></tr>
<tr><td valign="top">146.</td><td valign="top">222</td><td valign="top">92</td><td valign="top">~^R</td><td valign="top">Meta DC2 (device control 2)</td></tr>
<tr><td valign="top">147.</td><td valign="top">223</td><td valign="top">93</td><td valign="top">~^S</td><td valign="top">Meta DC3, XOFF (device control 3)</td></tr>
<tr><td valign="top">148.</td><td valign="top">224</td><td valign="top">94</td><td valign="top">~^T</td><td valign="top">Meta DC4 (device control 4)</td></tr>
<tr><td valign="top">149.</td><td valign="top">225</td><td valign="top">95</td><td valign="top">~^U</td><td valign="top">Meta NAK (negative acknowledge)</td></tr>
<tr><td valign="top">150.</td><td valign="top">226</td><td valign="top">96</td><td valign="top">~^V</td><td valign="top">Meta SYN (synchronous idle)</td></tr>
<tr><td valign="top">151.</td><td valign="top">227</td><td valign="top">97</td><td valign="top">~^W</td><td valign="top">Meta ETB (end transmission block)</td></tr>
<tr><td valign="top">152.</td><td valign="top">230</td><td valign="top">98</td><td valign="top">~^X</td><td valign="top">Meta CAN (cancel)</td></tr>
<tr><td valign="top">153.</td><td valign="top">231</td><td valign="top">99</td><td valign="top">~^Y</td><td valign="top">Meta EM  (end of medium)</td></tr>
<tr><td valign="top">154.</td><td valign="top">232</td><td valign="top">9A</td><td valign="top">~^Z</td><td valign="top">Meta SUB (substitute)</td></tr>
<tr><td valign="top">155.</td><td valign="top">233</td><td valign="top">9B</td><td valign="top">~^[</td><td valign="top">Meta ESC (escape, alter mode, SEL)</td></tr>
<tr><td valign="top">156.</td><td valign="top">234</td><td valign="top">9C</td><td valign="top">~^\</td><td valign="top">Meta FS  (file separator)</td></tr>
<tr><td valign="top">157.</td><td valign="top">235</td><td valign="top">9D</td><td valign="top">~^]</td><td valign="top">Meta GS  (group separator)</td></tr>
<tr><td valign="top">158.</td><td valign="top">236</td><td valign="top">9E</td><td valign="top">~^^</td><td valign="top">Meta RS  (record separator)</td></tr>
<tr><td valign="top">159.</td><td valign="top">237</td><td valign="top">9F</td><td valign="top">~^_</td><td valign="top">Meta US  (unit separator)</td></tr>

<tr><td valign="top" colspan="5">&nbsp;</td></tr>

<tr><td valign="top">160.</td><td valign="top">240</td><td valign="top">A0</td><td valign="top">~&nbsp;</td><td valign="top">Meta space</td></tr>
<tr><td valign="top">161.</td><td valign="top">241</td><td valign="top">A1</td><td valign="top">~!</td><td valign="top">Meta exclamation mark</td></tr>
<tr><td valign="top">162.</td><td valign="top">242</td><td valign="top">A2</td><td valign="top">~&quot;</td><td valign="top">Meta double quote</td></tr>
<tr><td valign="top">163.</td><td valign="top">243</td><td valign="top">A3</td><td valign="top">~#</td><td valign="top">Meta number sign (hash mark)</td></tr>
<tr><td valign="top">164.</td><td valign="top">244</td><td valign="top">A4</td><td valign="top">~$</td><td valign="top">Meta dollar sign</td></tr>
<tr><td valign="top">165.</td><td valign="top">245</td><td valign="top">A5</td><td valign="top">~%</td><td valign="top">Meta percent sign</td></tr>
<tr><td valign="top">166.</td><td valign="top">246</td><td valign="top">A6</td><td valign="top">~&amp;</td><td valign="top">Meta ampersand sign</td></tr>
<tr><td valign="top">167.</td><td valign="top">247</td><td valign="top">A7</td><td valign="top">~'</td><td valign="top">Meta single quote (apostrophe)</td></tr>
<tr><td valign="top">168.</td><td valign="top">250</td><td valign="top">A8</td><td valign="top">~(</td><td valign="top">Meta left parenthesis</td></tr>
<tr><td valign="top">169.</td><td valign="top">251</td><td valign="top">A9</td><td valign="top">~)</td><td valign="top">Meta right parenthesis</td></tr>
<tr><td valign="top">170.</td><td valign="top">252</td><td valign="top">AA</td><td valign="top">~*</td><td valign="top">Meta asterisk (star)</td></tr>
<tr><td valign="top">171.</td><td valign="top">253</td><td valign="top">AB</td><td valign="top">~+</td><td valign="top">Meta plus sign</td></tr>
<tr><td valign="top">172.</td><td valign="top">254</td><td valign="top">AC</td><td valign="top">~,</td><td valign="top">Meta comma</td></tr>
<tr><td valign="top">173.</td><td valign="top">255</td><td valign="top">AD</td><td valign="top">~-</td><td valign="top">Meta minus sign (dash)</td></tr>
<tr><td valign="top">174.</td><td valign="top">256</td><td valign="top">AE</td><td valign="top">~.</td><td valign="top">Meta period (decimal point, dot)</td></tr>
<tr><td valign="top">175.</td><td valign="top">257</td><td valign="top">AF</td><td valign="top">~/</td><td valign="top">Meta (right) slash</td></tr>

<tr><td valign="top" colspan="5">&nbsp;</td></tr>

<tr><td valign="top">176.</td><td valign="top">260</td><td valign="top">B0</td><td valign="top">~0</td><td valign="top">Meta numeral zero</td></tr>
<tr><td valign="top">177.</td><td valign="top">261</td><td valign="top">B1</td><td valign="top">~1</td><td valign="top">Meta numeral one</td></tr>
<tr><td valign="top">178.</td><td valign="top">262</td><td valign="top">B2</td><td valign="top">~2</td><td valign="top">Meta numeral two</td></tr>
<tr><td valign="top">179.</td><td valign="top">263</td><td valign="top">B3</td><td valign="top">~3</td><td valign="top">Meta numeral three</td></tr>
<tr><td valign="top">180.</td><td valign="top">264</td><td valign="top">B4</td><td valign="top">~4</td><td valign="top">Meta numeral four</td></tr>
<tr><td valign="top">181.</td><td valign="top">265</td><td valign="top">B5</td><td valign="top">~5</td><td valign="top">Meta numeral five</td></tr>
<tr><td valign="top">182.</td><td valign="top">266</td><td valign="top">B6</td><td valign="top">~6</td><td valign="top">Meta numeral six</td></tr>
<tr><td valign="top">183.</td><td valign="top">267</td><td valign="top">B7</td><td valign="top">~7</td><td valign="top">Meta numeral seven</td></tr>
<tr><td valign="top">184.</td><td valign="top">270</td><td valign="top">B8</td><td valign="top">~8</td><td valign="top">Meta numeral eight</td></tr>
<tr><td valign="top">185.</td><td valign="top">271</td><td valign="top">B9</td><td valign="top">~9</td><td valign="top">Meta numeral nine</td></tr>
<tr><td valign="top">186.</td><td valign="top">272</td><td valign="top">BA</td><td valign="top">~:</td><td valign="top">Meta colon</td></tr>
<tr><td valign="top">187.</td><td valign="top">273</td><td valign="top">BB</td><td valign="top">~;</td><td valign="top">Meta semi-colon</td></tr>
<tr><td valign="top">188.</td><td valign="top">274</td><td valign="top">BC</td><td valign="top">~&lt;</td><td valign="top">Meta less-than sign</td></tr>
<tr><td valign="top">189.</td><td valign="top">275</td><td valign="top">BD</td><td valign="top">~=</td><td valign="top">Meta equal sign</td></tr>
<tr><td valign="top">190.</td><td valign="top">276</td><td valign="top">BE</td><td valign="top">~&gt;</td><td valign="top">Meta greater-than sign</td></tr>
<tr><td valign="top">191.</td><td valign="top">277</td><td valign="top">BF</td><td valign="top">~?</td><td valign="top">Meta question mark</td></tr>

<tr><td valign="top" colspan="5">&nbsp;</td></tr>

<tr><td valign="top">192.</td><td valign="top">300</td><td valign="top">C0</td><td valign="top">~@</td><td valign="top">Meta atsign</td></tr>
<tr><td valign="top">193.</td><td valign="top">301</td><td valign="top">C1</td><td valign="top">~A</td><td valign="top">Meta upper-case letter ALPHA</td></tr>
<tr><td valign="top">194.</td><td valign="top">302</td><td valign="top">C2</td><td valign="top">~B</td><td valign="top">Meta upper-case letter BRAVO</td></tr>
<tr><td valign="top">195.</td><td valign="top">303</td><td valign="top">C3</td><td valign="top">~C</td><td valign="top">Meta upper-case letter CHARLIE</td></tr>
<tr><td valign="top">196.</td><td valign="top">304</td><td valign="top">C4</td><td valign="top">~D</td><td valign="top">Meta upper-case letter DELTA</td></tr>
<tr><td valign="top">197.</td><td valign="top">305</td><td valign="top">C5</td><td valign="top">~E</td><td valign="top">Meta upper-case letter ECHO</td></tr>
<tr><td valign="top">198.</td><td valign="top">306</td><td valign="top">C6</td><td valign="top">~F</td><td valign="top">Meta upper-case letter FOXTROT</td></tr>
<tr><td valign="top">199.</td><td valign="top">307</td><td valign="top">C7</td><td valign="top">~G</td><td valign="top">Meta upper-case letter GOLF</td></tr>
<tr><td valign="top">200.</td><td valign="top">310</td><td valign="top">C8</td><td valign="top">~H</td><td valign="top">Meta upper-case letter HOTEL</td></tr>
<tr><td valign="top">201.</td><td valign="top">311</td><td valign="top">C9</td><td valign="top">~I</td><td valign="top">Meta upper-case letter INDIA</td></tr>
<tr><td valign="top">202.</td><td valign="top">312</td><td valign="top">CA</td><td valign="top">~J</td><td valign="top">Meta upper-case letter JEHRICHO</td></tr>
<tr><td valign="top">203.</td><td valign="top">313</td><td valign="top">CB</td><td valign="top">~K</td><td valign="top">Meta upper-case letter KAPPA</td></tr>
<tr><td valign="top">204.</td><td valign="top">314</td><td valign="top">CC</td><td valign="top">~L</td><td valign="top">Meta upper-case letter LIMA</td></tr>
<tr><td valign="top">205.</td><td valign="top">315</td><td valign="top">CD</td><td valign="top">~M</td><td valign="top">Meta upper-case letter MIKE</td></tr>
<tr><td valign="top">206.</td><td valign="top">316</td><td valign="top">CE</td><td valign="top">~N</td><td valign="top">Meta upper-case letter NOVEMBER</td></tr>
<tr><td valign="top">207.</td><td valign="top">317</td><td valign="top">CF</td><td valign="top">~O</td><td valign="top">Meta upper-case letter OSCAR</td></tr>

<tr><td valign="top" colspan="5">&nbsp;</td></tr>

<tr><td valign="top">208.</td><td valign="top">320</td><td valign="top">D0</td><td valign="top">~P</td><td valign="top">Meta upper-case letter PAPPA</td></tr>
<tr><td valign="top">209.</td><td valign="top">321</td><td valign="top">D1</td><td valign="top">~Q</td><td valign="top">Meta upper-case letter QUEBEC</td></tr>
<tr><td valign="top">210.</td><td valign="top">322</td><td valign="top">D2</td><td valign="top">~R</td><td valign="top">Meta upper-case letter ROMEO</td></tr>
<tr><td valign="top">211.</td><td valign="top">323</td><td valign="top">D3</td><td valign="top">~S</td><td valign="top">Meta upper-case letter SIERRA</td></tr>
<tr><td valign="top">212.</td><td valign="top">324</td><td valign="top">D4</td><td valign="top">~T</td><td valign="top">Meta upper-case letter TANGO</td></tr>
<tr><td valign="top">213.</td><td valign="top">325</td><td valign="top">D5</td><td valign="top">~U</td><td valign="top">Meta upper-case letter UNICORN</td></tr>
<tr><td valign="top">214.</td><td valign="top">326</td><td valign="top">D6</td><td valign="top">~V</td><td valign="top">Meta upper-case letter VICTOR</td></tr>
<tr><td valign="top">215.</td><td valign="top">327</td><td valign="top">D7</td><td valign="top">~W</td><td valign="top">Meta upper-case letter WHISKEY</td></tr>
<tr><td valign="top">216.</td><td valign="top">330</td><td valign="top">D8</td><td valign="top">~X</td><td valign="top">Meta upper-case letter XRAY</td></tr>
<tr><td valign="top">217.</td><td valign="top">331</td><td valign="top">D9</td><td valign="top">~Y</td><td valign="top">Meta upper-case letter YANKEE</td></tr>
<tr><td valign="top">218.</td><td valign="top">332</td><td valign="top">DA</td><td valign="top">~Z</td><td valign="top">Meta upper-case letter ZEBRA</td></tr>
<tr><td valign="top">219.</td><td valign="top">333</td><td valign="top">DB</td><td valign="top">~[</td><td valign="top">Meta left square bracket</td></tr>
<tr><td valign="top">220.</td><td valign="top">334</td><td valign="top">DC</td><td valign="top">~\</td><td valign="top">Meta left slash (backslash)</td></tr>
<tr><td valign="top">221.</td><td valign="top">335</td><td valign="top">DD</td><td valign="top">~]</td><td valign="top">Meta right square bracket</td></tr>
<tr><td valign="top">222.</td><td valign="top">336</td><td valign="top">DE</td><td valign="top">~^</td><td valign="top">Meta uparrow (caret)</td></tr>
<tr><td valign="top">223.</td><td valign="top">337</td><td valign="top">DF</td><td valign="top">~_</td><td valign="top">Meta underscore</td></tr>

<tr><td valign="top" colspan="5">&nbsp;</td></tr>

<tr><td valign="top">224.</td><td valign="top">340</td><td valign="top">E0</td><td valign="top">~`</td><td valign="top">Meta (single) back quote (grave acent)</td></tr>
<tr><td valign="top">225.</td><td valign="top">341</td><td valign="top">E1</td><td valign="top">~a</td><td valign="top">Meta lower-case letter alpha</td></tr>
<tr><td valign="top">226.</td><td valign="top">342</td><td valign="top">E2</td><td valign="top">~b</td><td valign="top">Meta lower-case letter bravo</td></tr>
<tr><td valign="top">227.</td><td valign="top">343</td><td valign="top">E3</td><td valign="top">~c</td><td valign="top">Meta lower-case letter charlie</td></tr>
<tr><td valign="top">228.</td><td valign="top">344</td><td valign="top">E4</td><td valign="top">~d</td><td valign="top">Meta lower-case letter delta</td></tr>
<tr><td valign="top">229.</td><td valign="top">345</td><td valign="top">E5</td><td valign="top">~e</td><td valign="top">Meta lower-case letter echo</td></tr>
<tr><td valign="top">230.</td><td valign="top">346</td><td valign="top">E6</td><td valign="top">~f</td><td valign="top">Meta lower-case letter foxtrot</td></tr>
<tr><td valign="top">231.</td><td valign="top">347</td><td valign="top">E7</td><td valign="top">~g</td><td valign="top">Meta lower-case letter golf</td></tr>
<tr><td valign="top">232.</td><td valign="top">350</td><td valign="top">E8</td><td valign="top">~h</td><td valign="top">Meta lower-case letter hotel</td></tr>
<tr><td valign="top">233.</td><td valign="top">351</td><td valign="top">E9</td><td valign="top">~i</td><td valign="top">Meta lower-case letter india</td></tr>
<tr><td valign="top">234.</td><td valign="top">352</td><td valign="top">EA</td><td valign="top">~j</td><td valign="top">Meta lower-case letter jericho</td></tr>
<tr><td valign="top">235.</td><td valign="top">353</td><td valign="top">EB</td><td valign="top">~k</td><td valign="top">Meta lower-case letter kappa</td></tr>
<tr><td valign="top">236.</td><td valign="top">354</td><td valign="top">EC</td><td valign="top">~l</td><td valign="top">Meta lower-case letter lima</td></tr>
<tr><td valign="top">237.</td><td valign="top">355</td><td valign="top">ED</td><td valign="top">~m</td><td valign="top">Meta lower-case letter mike</td></tr>
<tr><td valign="top">238.</td><td valign="top">356</td><td valign="top">EE</td><td valign="top">~n</td><td valign="top">Meta lower-case letter november</td></tr>
<tr><td valign="top">239.</td><td valign="top">357</td><td valign="top">EF</td><td valign="top">~o</td><td valign="top">Meta lower-case letter oscar</td></tr>

<tr><td valign="top" colspan="5">&nbsp;</td></tr>

<tr><td valign="top">240.</td><td valign="top">360</td><td valign="top">F0</td><td valign="top">~p</td><td valign="top">Meta lower-case letter pappa</td></tr>
<tr><td valign="top">241.</td><td valign="top">361</td><td valign="top">F1</td><td valign="top">~q</td><td valign="top">Meta lower-case letter quebec</td></tr>
<tr><td valign="top">242.</td><td valign="top">362</td><td valign="top">F2</td><td valign="top">~r</td><td valign="top">Meta lower-case letter romeo</td></tr>
<tr><td valign="top">243.</td><td valign="top">363</td><td valign="top">F3</td><td valign="top">~s</td><td valign="top">Meta lower-case letter sierra</td></tr>
<tr><td valign="top">244.</td><td valign="top">364</td><td valign="top">F4</td><td valign="top">~t</td><td valign="top">Meta lower-case letter tango</td></tr>
<tr><td valign="top">245.</td><td valign="top">365</td><td valign="top">F5</td><td valign="top">~u</td><td valign="top">Meta lower-case letter unicorn</td></tr>
<tr><td valign="top">246.</td><td valign="top">366</td><td valign="top">F6</td><td valign="top">~v</td><td valign="top">Meta lower-case letter victor</td></tr>
<tr><td valign="top">247.</td><td valign="top">367</td><td valign="top">F7</td><td valign="top">~w</td><td valign="top">Meta lower-case letter whiskey</td></tr>
<tr><td valign="top">248.</td><td valign="top">370</td><td valign="top">F8</td><td valign="top">~x</td><td valign="top">Meta lower-case letter xray</td></tr>
<tr><td valign="top">249.</td><td valign="top">371</td><td valign="top">F9</td><td valign="top">~y</td><td valign="top">Meta lower-case letter yankee</td></tr>
<tr><td valign="top">250.</td><td valign="top">372</td><td valign="top">FA</td><td valign="top">~z</td><td valign="top">Meta lower-case letter zebra</td></tr>
<tr><td valign="top">251.</td><td valign="top">373</td><td valign="top">FB</td><td valign="top">~{</td><td valign="top">Meta left curly brace</td></tr>
<tr><td valign="top">252.</td><td valign="top">374</td><td valign="top">FC</td><td valign="top">~|</td><td valign="top">Meta vertical bar</td></tr>
<tr><td valign="top">253.</td><td valign="top">375</td><td valign="top">FD</td><td valign="top">~}</td><td valign="top">Meta right curly brace</td></tr>
<tr><td valign="top">254.</td><td valign="top">376</td><td valign="top">FE</td><td valign="top">~~</td><td valign="top">Meta tilde</td></tr>
<tr><td valign="top">255.</td><td valign="top">377</td><td valign="top">FF</td><td valign="top">~^?</td><td valign="top">Meta DEL (delete, rub out)</td></tr>
</table>

<p>These forms can be used to prevent ambiguity:</p>

<table border="0" width="100%">
<colgroup>
<col width="10%">
<col width="10%">
<col width="10%">
<col width="10%">
<col width="60%">
</colgroup>

<tr><td valign="top">Decimal</td><td valign="top">Octal</td><td valign="top">Hex</td><td valign="top">Graphic</td><td valign="top">can be printed as...</td></tr>

<tr><td valign="top" colspan="5">&nbsp;</td></tr>

<tr><td valign="top">94.</td><td valign="top">136</td><td valign="top">5E</td><td valign="top">^</td><td valign="top">^=</td></tr>
<tr><td valign="top">126.</td><td valign="top">176</td><td valign="top">7E</td><td valign="top">~</td><td valign="top">^~</td></tr>
<tr><td valign="top">222.</td><td valign="top">336</td><td valign="top">DE</td><td valign="top">~^</td><td valign="top">~^=</td></tr>
<tr><td valign="top">254.</td><td valign="top">376</td><td valign="top">FE</td><td valign="top">~~</td><td valign="top">~^~</td></tr>
</table>

<p>List of all 94 basic characters:<p>

<table border="0" width="100%">
<tr><td valign="top">!&quot;#$%&amp;'()*+,-./0123456789:;&lt;=&gt;?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`abcdefghijklmnopqrstuvwxyz{|}~</td></tr>
</table>
	
<p><a href="#contents">Back to Contents</a>.</p>
<hr>
<a name="bibliog"></a><h1>Bibliography</h1>

<p>This bibliography is in two parts.  The first part is the list of
publications used in the preparation of this book.  The second part is
the annotated bibliography from the thesis.  Documents that are marked
with "*" are especially valuable or interesting.</p>

<a name="bibliog.1"></a><h2>1 Current</h2>

<p>American National Standards Institute (1990) X3J11 Programming
Language C.  New York: ANSI.</p>

<p>American National Standards Institute (1983)
ANSI/MIL-STD-1815A-1983 Reference Manual for the Ada Programming
Language. New York: Springer-Verlag.  ISBN 0-387-90887-0.</p>

<p>*Apple Computer Corp. (1987) Human Interface Guidelines: the Apple
Desktop Interface.  Reading, Massachusetts: Addison-Wesley.  ISBN
0-201-17753-6.</p>

<p><i>ibid.</i> (1989) Release 7.0 Macintosh Script Management System
(unreleased preliminary).  Cuptertino, California: Apple Computer
Corp.</p>

<p>*Brooks, Frederick P. (1982) The Mythical Man-Month.  Reading,
Massachusetts: Addison-Wesley.  ISBN 0-201-00650-2.</p>

<p>*Caplan, Ralph (1982) By Design: Why There Are No Locks on the
Bathroom Doors in the Hotel Louis XIV and Other Object Lessons.  New
York: McGraw-Hill.  ISBN 0-07-009777-1.</p>

<p>Carroll, Lewis (1865) Alice's Adventures in Wonderland.  London:
Macmillian and Co.</p>

<p><i>ibid.</i> (1871) Through the Looking-Glass and What Alice Found
There.  London: Macmillian and Co.</p>

<p>Crowley, Terrence; Forsdick, Harry; Landau, Matt; Travers, Virginia
(1987) The Diamond Multimedia Editor.  USENIX Proceedings, Summer
1987.</p>

<p>Finseth, Craig A. (June 1980) Theory and Practise of Text Editing
-- or -- A Cookbook for an Emacs.  Cambridge, Massachusetts:
M.I.T. Laboratory for Computer Science.  Technical Memo TM-165.</p>

<p>Hammer, Michael; Ilson, Richard; Anderson, Timothy; Gilbert, Edward
J.; Good, Michael; Niamir, Bahram; Rosenstein, Larry; Schoichet,
Sandor (February 1981) Etude: An Integrated Document Processing
System.  Cambridge, Massachusetts: M.I.T. Laboratory for Computer
Science.  Office Automation Group Memo OAM-028.</p>

<p>Ilson, Richard; Good, Michael (March 1981) Etude: An Interactive
Editor and Formatter.  Cambridge, Massachusetts: M.I.T. Laboratory for
Computer Science.  Office Automation Group Memo OAM-029.</p>

<p>Jensen, Kathleen & Wirth, Nikalus (1974) Pascal User Manual and
Report.  New York: Springer-Verlag.  ISBN 0-387-90144-2.</p>

<p>Kemeny, John G. & Kurtz, Thomas E. (1985) Back to Basic.  Reading,
Massachusetts: Addison-Wesley.  ISBN 0-201-13433-0.</p>

<p>Kernighan, Brian W. & Ritchie, Dennis M. (1978) The C Programming
Language.  Englewood Cliffs, New Jersey: Prentice-Hall.  ISBN
0-13-110163-3.</p>

<p>*Knuth, Donald E. (1971) An Empirical Study of Fortran Programs.
Software Practise and Experience, vol 1, April/May, p 105-133.</p>

<p>Miller, Webb (1987) A Software Tools Sampler.  Englewood Cliffs,
New Jersey: Prentice-Hall.  ISBN 0-13-822305-X.</p>

<p>Myers, Eugene W. (December 1986) A Simple Row-Replacement Method.
Tucson, Arizona: Department of Computer Science, University of
Arizona.  Technical Report TR 86-28.</p>

<p>*Norman, Donald A. (1990) The Design of Everyday Things.  New York:
Doubleday.  ISBN 0-385-26774-6.</p>

<p>Oman, Paul W. & Cook, Curtis R. (1990) Typographic Style is More
than Cosmetic.  Communications of the ACM, vol. 33 #5, January, p
506.</p>

<p>Phelps, Hermann (1982) The Craft of Log Building.  (Translation of
Holzbaukunst : der Blockbau.)  Ottawa, Ontario: Lee Valley Tools.
ISBN 0-9691019-2-9 (bound), 0-9691019-1-0 (pbk).</p>

<p>Qiao, Jinan; Qiao, Yizheng; Qiao, Sanzheng. (1990) Six-Digit Coding
Method.  Communications of the ACM, vol. 33 #5, January, p 491.</p>

<p>Quarterman, John S. (1989) The Matrix: Computer Networks and
Conferencing Systems Worldwide.  Bedford, Massachusetts: Digital
Press.  ISBN 1-55558-033-5.</p>

<p>Reid, Brian K. & Walker, Janet H. (1980) Scribe Introductory User's
Manual.  Pittsburgh, Pennsylvania: Unilogic Ltd.</p>

<p>Stallman, Richard (1987) GNU Emacs Manual.  Cambridge,
Massachusetts: Free Software Foundation.  Sixth edition, version
18.</p>

<p>Tayli, Murat & Al-Salamah, Abdulla I. (1990) Building Bilingual
Microcomputer Systems.  Communications of the ACM, vol. 33 #5,
January, p 495.</p>

<p>Thorell, L.G. & Smith, W.J. (1990) Using Computer Color
Effectively, An Illustrated Reference.  Englewood Cliffs, New Jersey:
Prentice-Hall.  ISBN 0-13-939878-3.</p>

<p>*Tufte, Edward R. (1990) Envisioning Information. Cheshire,
Connecticut: Graphics Press.</p>

<p><i>ibid</i>. (1983) The Visual Display of Quantitative Information.
Cheshire, Connecticut: Graphics Press.</p>

<p>The USENET News groups <i>Comp.editors</i>, <i>Comp.emacs</i>, and
<i>Gnu.emacs</i> carry editor-related material.</p>

<a name="bibliog.2"></a><h2>2 Thesis</h2>

<p>This bibliography includes many different types of documents. Some
of the documents are user manuals for various editors. Others of them
describe the implementation of specific editors. Still others discuss
language tradeoffs or input/output system interfaces.</p>

<p>They are grouped by the type of editor that they refer to.  Each
entry is annotated to help place it in perspective.</p>

<a name="bibliog.2.1"></a><h3>2.1 Emacs-Type Editors</h3>

<p>There are four principal implementations of Emacs-type editors, and
there are enough documents to justify their separate listing.</p>

<a name="bibliog.2.1.1"></a><h4>2.1.1 ITS EMACS</h4>

<p>Ciccarelli, Eugene (1978) An Introduction to the Emacs
Editor. Cambridge, Massachusetts: MIT Artificial Intelligence
Laboratory, MIT AI Lab Memo #447, January 1978.  -- A primer on the
editor's user interface.</p>

<p>*Stallman, Richard M. (1979) Emacs: The Extensible, Customizable,
Self-Documenting, Display Editor. Cambridge, Massachusetts: MIT
Artificial Intelligence Laboratory, AI Memo #519, June 1979. --
Provides arguments for the Emacs philosophy.</p>

<p><i>ibid.</i> (1978) Structured Editing with a Lisp.  Computing
Surveys, vol 10 #4, December, p 505. -- This is a response to the
Sanderwall paper (referenced later).</p>

<p>On-line Documentation:</p>

<blockquote>
MIT-AI: .TECO.; TECORD &gt; -- A more detailed command list for TECO<br>
MIT-AI: .TECO.; TECO PRIMER -- A primer for TECO<br>
MIT-AI: EMACS; EMACS CHART -- A four-page command list for Emacs<br>
MIT-AI: EMACS; EMACS GUIDE -- A detailed user interface manual<br>
MIT-AI: EMACS; EMACS ORDER -- A more detailed command list for Emacs<br>
</blockquote>

<a name="bibliog.2.1.2"></a><h4>2.1.2 Lisp Machine Zwei</h4>

*Weinreb, Daniel L. & Moon, David (January 1979) The Lisp Machine
Manual.  <p>Cambridge, Massachusetts: MIT Artificial Intelligence
Laboratory. -- The user interface for Zwei.</p>

<p><i>ibid.</i> (January 1979) A Real-Time Display-Oriented Editor for
the Lisp Machine. Cambridge, Massachusetts: S.B. Thesis, MIT
Electrical Engineering and Computer Science Department. -- How Zwei
works internally.</p>

<a name="bibliog.2.1.3"></a><h4>2.1.3 Multics Emacs</h4>

<p>Greenberg, Bernard S. (in publication in 1980) Emacs Extension
Writer's Guide. Honeywell Information Systems, Inc., order #CJ52. --
How to write extensions.</p>

<p><i>ibid.</i> (December 1979) Emacs Text Editor User's
Guide. Honeywell Information Systems, Inc., order #CH27. -- The user
interface.</p>

<p>*<i>ibid.</i> (March 1980) Multics Emacs: An Experiment in Computer
Interaction. Honeywell Information Systems, Proceedings, Fourth Annual
Honeywell Software Conference. -- A summary of MEPAP (referenced
below, also, MIT-AI: BSG; NMEPAP >)</p>

<p><i>ibid.</i> (April 1978) Real-Time Editing on Multics. Cambridge,
Massachusetts: Honeywell Information Systems, Inc., Multics Technical
Bulletin #373</p>

<p><i>ibid.</i>, On-Line Documentation:</p>

<blockquote>
MIT-AI: BSG; LMEPAP &gt; -- Why Lisp was chosen for the implementation language<br>
*MIT-AI: BSG; MEPAP &gt; -- A detailed history of Emacs in general and the Multics implementation in specific. Very valuable.<br>
MIT-AI: BSG; R4V &gt; -- A proposal for a terminal independent video terminal support package.<br>
MIT-AI: BSG; TTYWIN &gt; -- A look at the good and bad features of video terminals.<br>
</blockquote>

<a name="bibliog.2.1.4"></a><h4>2.1.4 MagicSix TVMacs</h4>

<p>*Anderson, Owen Ted (January 1979) The Design and Implementation of
a Display-Oriented Editor Writing System.  Cambridge, Massachusetts:
S.B. Thesis, MIT Physics Department. -- How TVMacs works internally.
It concentrates on describing not the editor itself but rather the
implementations language: SINE.</p>

<p>Linhart, Jason T. (June 1980) Dynamic Multi-Window Terminal
Management for the MagicSix Operating System. Cambridge,
Massachusetts: S.B. Thesis, MIT Electrical Engineering and Computer
Science Department. -- A video terminal management system.  Contains
many useful comments on terminal independence and redisplay
problems.</p>

<a name="bibliog.2.1.5"></a><h4>2.1.5 Other Emacs-Type Text Editors</h4>

<p>This section covers editors which have the same general user
interface as an Emacs (<i>e.g.</i>, screen-oriented, similar key
bindings) but are not extensible or otherwise fall noticeably short of
the Emacs philosophy.</p>

<p>Finseth, Craig A. (August 1979) VINE Primer. Dallas, Texas: Texas
Instruments, Inc., Central Research Laboratories, Systems and
Information Sciences Laboratory. -- User interface manual for the
complete novice.</p>

<p>Schiller, Jeffrey I. (June 1979) TORES: the Text ORiented Editing
System Cambridge, Massachusetts: revised from S.B. Thesis, MIT
Electrical Engineering and Computer Science Department.</p>

<p>On-Line Documentation:</p>

<blockquote>
Kazar, Mike. User manual for FINE, running at Carnegie-Mellon University.  At CMU-10A: fine.{mss prt}[s200mk50]
</blockquote>

<a name="bibliog.2.2"></a><h3>2.2 Non-Emacs Display Editors</h3>

<p>Bilofsky, Walter (December 1977) The CRT Text Editor NED --
Introduction and Reference Manual. Rand Corporation, R-2176-ARPA.</p>

<p>Irons, E. T. & Djorup, F. M. (1972) A CRT Editing System.
Communications of the ACM, vol. 15 #1, January, p 16.</p>

<p>Joy, William (April 1979) Ex Reference Manual; Version
2.0. Berkeley, California; Computer Science Division, Dept of
Electrical Engineering and Computer Science, University of California
at Berkeley.</p>

<p><i>ibid.</i> (April 1979) An Introduction to Display Editing With
vi. Berkeley, California: Computer Science Division, Dept of
Electrical Engineering and Computer Science, University of California
at Berkeley.</p>

<p>Kanerva, Pentti (1973) TVGUID: a User's Guide to TEC/DATAMEDIA
TV-Edit.  Palo Alto, California: Stanford University, Institute for
Mathematical Studies in the Social Sciences.</p>

<p>Kelly, Jeanne (July 1977) A Guide to NED: a New On-Line Computer
Editor. The Rand Corporation, R-2000-ARPA.</p>

<p>Kernighan, Brian W. (1978) A Tutorial Introduction to the ED Text
Editor. Murray Hill, New Jersey: Bell Laboratories Technical
Report.</p>

<p>MacLeod, I. A. (November 1977) Design and Implementation of a
Display-Oriented Text Editor. Software Practice and Experience, vol. 7
#6, November, p 771.</p>

<p>Weiner, P., et. al. (April 1973) The Yale Editor "E": a CRT-Based
Editing System.  Yale Computer Science Research Report 19</p>

<p>Seybold, Patricia B. (October 1978) TYMSHARE's AUGMENT -- Heralding
a New Era. The Seybold Report on Word Processing, vol. 1 #9. ISSN:
0160-9572, Seybold Publications, Inc., Box 644, Media, Pennsylvania
19063</p>

<p>On-Line Documentation:</p>

<blockquote>
SAIL: E.ALS[UP,DOC] -- User manual again.  Stanford University.
</blockquote>

<a name="bibliog.2.3"></a><h3>2.3 Structure Editors</h3>

<p>Ackland, Gillian M., et al (?) UCSD Pascal Version 1.5 (Reference
Manual). San Diego, California: Institute for Information Systems,
University of California at San Diego.</p>

<p>Donzeau-Gouge, V.; Huet, G.; Kahn, G.; Lang, B.; & Levy,
J.J. (April 1975) A Structure Oriented Program Editor: a First Step
Towards Computer Assisted Programming. Paris: IRIA, Res. Rep. 114.</p>

<p>Teitelbaum, R. T. (?) The Cornell Program Synthesizer: a
Microcomputer Implementation of PL/CS. Ithaca, New York: Department of
Computer Science, Cornell University, Technical Report TR 79-370,.</p>

<a name="bibliog.2.4"></a><h3>2.4 Other Editors</h3>

<p>Benjamin, Arthur J. (August 1972) An Extensible Editor for a Small
Machine With Disk Storage. Communications of the ACM, vol. 15 #8 p
742. -- Talks about an editor for the IBM 1130 written in Fortran. Not
extensible at all.</p>

<p>Bourne, S. R. (January 1971) A Design for a Text Editor. Software
Practice and Experience, vol 1 p 73. -- User manual.</p>

<p>Cecil, Moll & Rinde (March 1977) TRIX AC: a Set of General Purpose
Text Editing Commands. Lawrence Livermore Laboratory UCID 30040.</p>

<p>Deutsch, L. Peter & Lampson, Butler W. (1967) An On-line
Editor. Communications of the ACM, vol 10 #12, December, p 793. -- QED
user manual.</p>

<p>Fraser, Christopher W. (1970) A Compact, Portable CRT-Based
Editor. Software Practice and Experience, vol. 9 #2, February, p
121. -- Front end to a line editor.</p>

<p><i>ibid.</i> (1980) A Generalized Text Editor. Communications of
the ACM, vol. 23 #3, March, p 154. -- Applying text editors to
non-text objects,</p>

<p>Hansen, W. J. (June 1971) Creation of Hierarchic Text With a
Computer Display.  Palo Alto, California: Ph.D. Thesis, Stanford
University.</p>

<p>Kai, Joyce Moore (July 1974) A Text Editor Design. Urbana,
Illinois: Department of Computer Science, University of Illinois at
Urbana-Champaign. -- Describes both internals and externals on the
editor.  However, the design is a poor one.</p>

<p>Kernighan, Brian W. & Plauger, P. J. (1976) Software
Tools. Reading, Massachusetts: Addison-Wesley. -- This book has a
chapter which leads you by the hand in implementing a simple line
editor in RatFor.</p>

<p>*Roberts, Teresa L. (November 1979) Evaluation of Computer Text
Editors. Systems Sciences Laboratory, Xerox PARC. -- A comparative
evaluation of four text editors.  Quite well done. Unfortunately, it
does not include Emacs (it uses DEC TECO instead).</p>

<p>Sanderwall, Erik (1978) Programming in the Interactive Environment:
the Lisp Experience. Computing Surveys, vol. 10 #1, March, p 35. --
Talks about the editor for InterLisp.</p>

<p>Sneeringer, James (1978) User-Interface Design for Text Editing: a
Case Study. Software Practice and Experience, vol 8, p 543. -- User
manual and a discussion of user interface concepts.</p>

<p>Teitelman, Warren (October 1978) InterLisp Reference Manual. Palo
Alto, California: Xerox Palo Alto Research Center. -- How to use the
InterLisp (non-display) structure editor.</p>

<p>van Dam, Andries & Rice, David E. (1971) On-line Text Editing: a
Survey. Computing Surveys, vol #3, September, p 93. -- Contains a
general introduction to the problems of text editing.  Out-dated
technology, however.</p>

<p><a href="#contents">Back to Contents</a>.</p>
<hr>
<a name="index"></a><h1>Book Index</h1>

<p>This is the index to the book and the numbers, of course, reflect
the page numbers in the book.  How quaint.</p>

<table border="0" width="100%">
<colgroup>
<col width="20%">
<col width="80%">
</colgroup>

<tr><td valign="top">$</td><td valign="top">180</td></tr>
<tr><td valign="top">/etc/termcap</td><td valign="top">26</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">Ada</td><td valign="top">41</td></tr>
<tr><td valign="top">add_proc</td><td valign="top">58</td></tr>
<tr><td valign="top">advanced</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">&nbsp;&nbsp;algorithm</td><td valign="top">102</td></tr>
<tr><td valign="top">&nbsp;&nbsp;display</td><td valign="top">22, 89</td></tr>
<tr><td valign="top">after the point</td><td valign="top">55</td></tr>
<tr><td valign="top">again</td><td valign="top">123</td></tr>
<tr><td valign="top">allocation</td><td valign="top">68, 78</td></tr>
<tr><td valign="top">altmode</td><td valign="top">180</td></tr>
<tr><td valign="top">amount of experience</td><td valign="top">11</td></tr>
<tr><td valign="top">Annex</td><td valign="top">34</td></tr>
<tr><td valign="top">ANSI</td><td valign="top">87</td></tr>
<tr><td valign="top">APL</td><td valign="top">39</td></tr>
<tr><td valign="top">Apple</td><td valign="top">26, 28, 47, 139</td></tr>
<tr><td valign="top">approaches to redisplay</td><td valign="top">96</td></tr>
<tr><td valign="top">Argument</td><td valign="top">108</td></tr>
<tr><td valign="top">arguments</td><td valign="top">112</td></tr>
<tr><td valign="top">ASCII</td><td valign="top">202</td></tr>
<tr><td valign="top">asynchronous communications</td><td valign="top">31</td></tr>
<tr><td valign="top">attributes</td><td valign="top">52, 95</td></tr>
<tr><td valign="top">auto-repeat</td><td valign="top">24</td></tr>
<tr><td valign="top">availability</td><td valign="top">36</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">Back Space</td><td valign="top">4</td></tr>
<tr><td valign="top">backward from the point</td><td valign="top">55</td></tr>
<tr><td valign="top">Basic</td><td valign="top">41</td></tr>
<tr><td valign="top">basic</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">&nbsp;&nbsp;display</td><td valign="top">22</td></tr>
<tr><td valign="top">&nbsp;&nbsp;redisplay algorithm</td><td valign="top">100</td></tr>
<tr><td valign="top">&nbsp;&nbsp;users</td><td valign="top">12</td></tr>
<tr><td valign="top">Beep</td><td valign="top">88</td></tr>
<tr><td valign="top">before the point</td><td valign="top">55</td></tr>
<tr><td valign="top">between</td><td valign="top">55</td></tr>
<tr><td valign="top">biases</td><td valign="top">52</td></tr>
<tr><td valign="top">binary files</td><td valign="top">49, 147</td></tr>
<tr><td valign="top">binding</td><td valign="top">109, 115</td></tr>
<tr><td valign="top">breaking out of redisplay</td><td valign="top">95</td></tr>
<tr><td valign="top">buffer</td><td valign="top">54, 56</td></tr>
<tr><td valign="top">&nbsp;&nbsp;gap</td><td valign="top">68, 72</td></tr>
<tr><td valign="top">&nbsp;&nbsp;management</td><td valign="top">65, 72</td></tr>
<tr><td valign="top">BUFFERNAMEMAX</td><td valign="top">152</td></tr>
<tr><td valign="top">buffer_chain</td><td valign="top">56</td></tr>
<tr><td valign="top">Buffer_Clear</td><td valign="top">59</td></tr>
<tr><td valign="top">Buffer_Create</td><td valign="top">59</td></tr>
<tr><td valign="top">Buffer_Delete</td><td valign="top">59</td></tr>
<tr><td valign="top">Buffer_End</td><td valign="top">60</td></tr>
<tr><td valign="top">Buffer_Get_Name</td><td valign="top">59</td></tr>
<tr><td valign="top">Buffer_Insert</td><td valign="top">62</td></tr>
<tr><td valign="top">buffer_name</td><td valign="top">57</td></tr>
<tr><td valign="top">Buffer_Read</td><td valign="top">62</td></tr>
<tr><td valign="top">Buffer_Set_Current</td><td valign="top">59</td></tr>
<tr><td valign="top">Buffer_Set_Name</td><td valign="top">59</td></tr>
<tr><td valign="top">Buffer_Set_Next</td><td valign="top">59</td></tr>
<tr><td valign="top">Buffer_Start</td><td valign="top">60</td></tr>
<tr><td valign="top">Buffer_Write</td><td valign="top">62</td></tr>
<tr><td valign="top">button press</td><td valign="top">18</td></tr>
<tr><td valign="top">byte</td><td valign="top">56</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">C</td><td valign="top">39, 150</td></tr>
<tr><td valign="top">capitalization</td><td valign="top">143</td></tr>
<tr><td valign="top">Caps Lock</td><td valign="top">25</td></tr>
<tr><td valign="top">card images</td><td valign="top">47</td></tr>
<tr><td valign="top">cards, baseball</td><td valign="top">13</td></tr>
<tr><td valign="top">caret notation</td><td valign="top">49, 94, 202</td></tr>
<tr><td valign="top">categories of users</td><td valign="top">11</td></tr>
<tr><td valign="top">center tabs</td><td valign="top">93</td></tr>
<tr><td valign="top">changing your mind</td><td valign="top">119</td></tr>
<tr><td valign="top">character</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">&nbsp;&nbsp;definition</td><td valign="top">56</td></tr>
<tr><td valign="top">&nbsp;&nbsp;format</td><td valign="top">31</td></tr>
<tr><td valign="top">&nbsp;&nbsp;set</td><td valign="top">48</td></tr>
<tr><td valign="top">chunking</td><td valign="top">80</td></tr>
<tr><td valign="top">Clear_Line</td><td valign="top">88</td></tr>
<tr><td valign="top">Clear_Screen</td><td valign="top">88</td></tr>
<tr><td valign="top">CLEOL</td><td valign="top">88</td></tr>
<tr><td valign="top">CLEOS</td><td valign="top">88</td></tr>
<tr><td valign="top">clipboard</td><td valign="top">120</td></tr>
<tr><td valign="top">command</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">&nbsp;&nbsp;set design</td><td valign="top">125</td></tr>
<tr><td valign="top">&nbsp;&nbsp;shell</td><td valign="top">146</td></tr>
<tr><td valign="top">&nbsp;&nbsp;user-oriented</td><td valign="top">106</td></tr>
<tr><td valign="top">Command_Procedure</td><td valign="top">107</td></tr>
<tr><td valign="top">communications path</td><td valign="top">31</td></tr>
<tr><td valign="top">Compare_Locations</td><td valign="top">60</td></tr>
<tr><td valign="top">compilation</td><td valign="top">146</td></tr>
<tr><td valign="top">compiler</td><td valign="top">134</td></tr>
<tr><td valign="top">completion</td><td valign="top">115</td></tr>
<tr><td valign="top">considerations</td><td valign="top">36, 83, 90</td></tr>
<tr><td valign="top">consistency</td><td valign="top">126</td></tr>
<tr><td valign="top">contents, of line</td><td valign="top">48, 57</td></tr>
<tr><td valign="top">Control</td><td valign="top">172</td></tr>
<tr><td valign="top">control characters</td><td valign="top">93</td></tr>
<tr><td valign="top">constraints</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">&nbsp;&nbsp;physiological</td><td valign="top">14</td></tr>
<tr><td valign="top">&nbsp;&nbsp;redisplay</td><td valign="top">82</td></tr>
<tr><td valign="top">Copy_Region</td><td valign="top">63</td></tr>
<tr><td valign="top">core loop</td><td valign="top">106</td></tr>
<tr><td valign="top">counts</td><td valign="top">48</td></tr>
<tr><td valign="top">Count_To_Location</td><td valign="top">60</td></tr>
<tr><td valign="top">CP/M</td><td valign="top">47, 49, 73</td></tr>
<tr><td valign="top">crash recovery</td><td valign="top">74, 75</td></tr>
<tr><td valign="top">Ctrl_X_Dispatch</td><td valign="top">108</td></tr>
<tr><td valign="top">current_buffer</td><td valign="top">56</td></tr>
<tr><td valign="top">curses</td><td valign="top">87</td></tr>
<tr><td valign="top">cursor, left edge of</td><td valign="top">55</td></tr>
<tr><td valign="top">cur_line</td><td valign="top">57</td></tr>
<tr><td valign="top">custom editor languages</td><td valign="top">41</td></tr>
<tr><td valign="top">customers</td><td valign="top">11</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">data structures</td><td valign="top">56</td></tr>
<tr><td valign="top">debugging</td><td valign="top">146</td></tr>
<tr><td valign="top">DEC</td><td valign="top">47</td></tr>
<tr><td valign="top">decimal tabs</td><td valign="top">93</td></tr>
<tr><td valign="top">decomposition</td><td valign="top">54</td></tr>
<tr><td valign="top">defun</td><td valign="top">173</td></tr>
<tr><td valign="top">delay</td><td valign="top">70</td></tr>
<tr><td valign="top">Delayed_Display</td><td valign="top">108</td></tr>
<tr><td valign="top">Delete</td><td valign="top">4, 63</td></tr>
<tr><td valign="top">delete line</td><td valign="top">22</td></tr>
<tr><td valign="top">Delete_Chars</td><td valign="top">89</td></tr>
<tr><td valign="top">Delete_Lines</td><td valign="top">89</td></tr>
<tr><td valign="top">Delete_Region</td><td valign="top">63</td></tr>
<tr><td valign="top">deleting words</td><td valign="top">138</td></tr>
<tr><td valign="top">design</td><td valign="top">119, 125</td></tr>
<tr><td valign="top">dialog box</td><td valign="top">18</td></tr>
<tr><td valign="top">difference files</td><td valign="top">80</td></tr>
<tr><td valign="top">dispatch</td><td valign="top">107</td></tr>
<tr><td valign="top">display</td><td valign="top">21, 84</td></tr>
<tr><td valign="top">display independent procedures</td><td valign="top">86</td></tr>
<tr><td valign="top">Dvorak keyboard</td><td valign="top">27</td></tr>
<tr><td valign="top">dynamic linking</td><td valign="top">116</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">echo negotiation</td><td valign="top">33</td></tr>
<tr><td valign="top">editor procedures</td><td valign="top">84</td></tr>
<tr><td valign="top">efficiency</td><td valign="top">38</td></tr>
<tr><td valign="top">&nbsp;&nbsp;of editing</td><td valign="top">75</td></tr>
<tr><td valign="top">&nbsp;&nbsp;of input/output</td><td valign="top">76</td></tr>
<tr><td valign="top">&nbsp;&nbsp;of searching</td><td valign="top">77</td></tr>
<tr><td valign="top">electronic mail</td><td valign="top">146</td></tr>
<tr><td valign="top">Emacs</td><td valign="top">39</td></tr>
<tr><td valign="top">Emacs-type</td><td valign="top">4, 16, 41, 109, 122, 128, 145, 156, 172</td></tr>
<tr><td valign="top">empty lines</td><td valign="top">48</td></tr>
<tr><td valign="top">emulation</td><td valign="top">146</td></tr>
<tr><td valign="top">end</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">&nbsp;&nbsp;of file</td><td valign="top">49</td></tr>
<tr><td valign="top">&nbsp;&nbsp;of buffer</td><td valign="top">55, 91</td></tr>
<tr><td valign="top">error</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">&nbsp;&nbsp;checking</td><td valign="top">126</td></tr>
<tr><td valign="top">&nbsp;&nbsp;handling</td><td valign="top">110</td></tr>
<tr><td valign="top">&nbsp;&nbsp;messages</td><td valign="top">131</td></tr>
<tr><td valign="top">ETX/ACK</td><td valign="top">35</td></tr>
<tr><td valign="top">Evaluate</td><td valign="top">107</td></tr>
<tr><td valign="top">exiting</td><td valign="top">111</td></tr>
<tr><td valign="top">experience</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">&nbsp;&nbsp;amount of</td><td valign="top">11</td></tr>
<tr><td valign="top">&nbsp;&nbsp;type of</td><td valign="top">13</td></tr>
<tr><td valign="top">extended character sets</td><td valign="top">50</td></tr>
<tr><td valign="top">extensibility</td><td valign="top">37, 128, 147</td></tr>
<tr><td valign="top">external errors</td><td valign="top">111</td></tr>
<tr><td valign="top">extra shift keys</td><td valign="top">26</td></tr>
<tr><td valign="top">extra space</td><td valign="top">67</td></tr>
<tr><td valign="top">extremely large files</td><td valign="top">79</td></tr>
<tr><td valign="top">eyes</td><td valign="top">15</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">Fatal</td><td valign="top">155</td></tr>
<tr><td valign="top">fclose</td><td valign="top">155</td></tr>
<tr><td valign="top">fgets</td><td valign="top">155</td></tr>
<tr><td valign="top">file</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">&nbsp;&nbsp;formats</td><td valign="top">47</td></tr>
<tr><td valign="top">&nbsp;&nbsp;interface</td><td valign="top">147</td></tr>
<tr><td valign="top">&nbsp;&nbsp;name</td><td valign="top">57</td></tr>
<tr><td valign="top">FILENAMEMAX</td><td valign="top">152</td></tr>
<tr><td valign="top">file_time</td><td valign="top">57</td></tr>
<tr><td valign="top">FinalWord</td><td valign="top">74</td></tr>
<tr><td valign="top">Find_First_In_Backward</td><td valign="top">64</td></tr>
<tr><td valign="top">Find_First_In_Forward</td><td valign="top">64</td></tr>
<tr><td valign="top">Find_First_Not_In_Backward</td><td valign="top">64</td></tr>
<tr><td valign="top">Find_First_Not_In_Forward</td><td valign="top">64</td></tr>
<tr><td valign="top">fixed marks</td><td valign="top">55</td></tr>
<tr><td valign="top">FLAG</td><td valign="top">151</td></tr>
<tr><td valign="top">flow control</td><td valign="top">32</td></tr>
<tr><td valign="top">fonts</td><td valign="top">52, 95</td></tr>
<tr><td valign="top">fopen</td><td valign="top">155</td></tr>
<tr><td valign="top">forest</td><td valign="top">9</td></tr>
<tr><td valign="top">format, character</td><td valign="top">31</td></tr>
<tr><td valign="top">formats</td><td valign="top">52</td></tr>
<tr><td valign="top">Fortran</td><td valign="top">40</td></tr>
<tr><td valign="top">forward from the point</td><td valign="top">55</td></tr>
<tr><td valign="top">fragmentation</td><td valign="top">68, 78</td></tr>
<tr><td valign="top">framer</td><td valign="top">99</td></tr>
<tr><td valign="top">free</td><td valign="top">155</td></tr>
<tr><td valign="top">function keys</td><td valign="top">25</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">gap</td><td valign="top">68, 72</td></tr>
<tr><td valign="top">Get_Attr</td><td valign="top">88</td></tr>
<tr><td valign="top">Get_Char</td><td valign="top">62</td></tr>
<tr><td valign="top">Get_Column</td><td valign="top">65, 88</td></tr>
<tr><td valign="top">Get_File_Name</td><td valign="top">62</td></tr>
<tr><td valign="top">Get_Line</td><td valign="top">2</td></tr>
<tr><td valign="top">Get_Modified</td><td valign="top">62</td></tr>
<tr><td valign="top">Get_Num_Chars</td><td valign="top">62</td></tr>
<tr><td valign="top">Get_Num_Lines</td><td valign="top">62</td></tr>
<tr><td valign="top">Get_Point_Col</td><td valign="top">85</td></tr>
<tr><td valign="top">Get_Point_Row</td><td valign="top">85</td></tr>
<tr><td valign="top">Get_Row</td><td valign="top">88</td></tr>
<tr><td valign="top">Get_String</td><td valign="top">62</td></tr>
<tr><td valign="top">Get_Window_Bot</td><td valign="top">86</td></tr>
<tr><td valign="top">Get_Window_Bot_Line</td><td valign="top">86</td></tr>
<tr><td valign="top">Get_Window_Top</td><td valign="top">86</td></tr>
<tr><td valign="top">Get_Window_Top_Line</td><td valign="top">86</td></tr>
<tr><td valign="top">glass TTY</td><td valign="top">21</td></tr>
<tr><td valign="top">GNU-Emacs</td><td valign="top">147, 173</td></tr>
<tr><td valign="top">goals, user</td><td valign="top">14</td></tr>
<tr><td valign="top">grahical input</td><td valign="top">18, 29</td></tr>
<tr><td valign="top">graphics display</td><td valign="top">23</td></tr>
<tr><td valign="top">guidelines</td><td valign="top">18, 19, 131</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">handicaps</td><td valign="top">19</td></tr>
<tr><td valign="top">hands</td><td valign="top">14</td></tr>
<tr><td valign="top">hardware</td><td valign="top">21</td></tr>
<tr><td valign="top">hidden second gap</td><td valign="top">71</td></tr>
<tr><td valign="top">horizontal scrolling</td><td valign="top">91</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">IBM PC</td><td valign="top">23, 26, 28, 35</td></tr>
<tr><td valign="top">image, card and print</td><td valign="top">47</td></tr>
<tr><td valign="top">implementation</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">&nbsp;&nbsp;languages</td><td valign="top">36</td></tr>
<tr><td valign="top">&nbsp;&nbsp;methods</td><td valign="top">65, 71</td></tr>
<tr><td valign="top">implementations</td><td valign="top">156</td></tr>
<tr><td valign="top">in-band</td><td valign="top">32, 50</td></tr>
<tr><td valign="top">incremental</td><td valign="top">115</td></tr>
<tr><td valign="top">&nbsp;&nbsp;redisplay</td><td valign="top">82</td></tr>
<tr><td valign="top">&nbsp;&nbsp;search</td><td valign="top">142</td></tr>
<tr><td valign="top">input/output</td><td valign="top">76, 87</td></tr>
<tr><td valign="top">insert</td><td valign="top">6, 54</td></tr>
<tr><td valign="top">insert line</td><td valign="top">22</td></tr>
<tr><td valign="top">Insert_A_Character</td><td valign="top">08</td></tr>
<tr><td valign="top">Insert_Char</td><td valign="top">63</td></tr>
<tr><td valign="top">Insert_Lines</td><td valign="top">89</td></tr>
<tr><td valign="top">Insert_String</td><td valign="top">63, 89</td></tr>
<tr><td valign="top">interface</td><td valign="top">147</td></tr>
<tr><td valign="top">internal</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">&nbsp;&nbsp;editor</td><td valign="top">54</td></tr>
<tr><td valign="top">&nbsp;&nbsp;errors</td><td valign="top">110</td></tr>
<tr><td valign="top">internationalization</td><td valign="top">52</td></tr>
<tr><td valign="top">interrupting redisplay</td><td valign="top">95</td></tr>
<tr><td valign="top">isprint</td><td valign="top">155</td></tr>
<tr><td valign="top">Is_A_Match</td><td valign="top">64</td></tr>
<tr><td valign="top">Is_File_Changed</td><td valign="top">62</td></tr>
<tr><td valign="top">is_fixed</td><td valign="top">57</td></tr>
<tr><td valign="top">is_modified</td><td valign="top">57</td></tr>
<tr><td valign="top">Is_Point_After_Mark</td><td valign="top">60</td></tr>
<tr><td valign="top">Is_Point_At_Mark</td><td valign="top">60</td></tr>
<tr><td valign="top">Is_Point_Before_Mark</td><td valign="top">60</td></tr>
<tr><td valign="top">ITS</td><td valign="top">180</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">Jabberwocky</td><td valign="top">149</td></tr>
<tr><td valign="top">job control</td><td valign="top">32</td></tr>
<tr><td valign="top">joystick</td><td valign="top">30</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">kerning</td><td valign="top">95</td></tr>
<tr><td valign="top">keyboards</td><td valign="top">23</td></tr>
<tr><td valign="top">keyboard procedures</td><td valign="top">87</td></tr>
<tr><td valign="top">key placement</td><td valign="top">27</td></tr>
<tr><td valign="top">keystroke recording</td><td valign="top">124</td></tr>
<tr><td valign="top">Key_Fini</td><td valign="top">87</td></tr>
<tr><td valign="top">Key_Function_Keys</td><td valign="top">87</td></tr>
<tr><td valign="top">Key_Get</td><td valign="top">87</td></tr>
<tr><td valign="top">Key_Init</td><td valign="top">87</td></tr>
<tr><td valign="top">Key_Is_Input</td><td valign="top">87</td></tr>
<tr><td valign="top">kill</td><td valign="top">119</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">languages, implementation</td><td valign="top">36</td></tr>
<tr><td valign="top">language</td><td valign="top">130</td></tr>
<tr><td valign="top">lap-top computer</td><td valign="top">81</td></tr>
<tr><td valign="top">large</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">&nbsp;&nbsp;files</td><td valign="top">79</td></tr>
<tr><td valign="top">&nbsp;&nbsp;project upport</td><td valign="top">38</td></tr>
<tr><td valign="top">layout of text</td><td valign="top">45</td></tr>
<tr><td valign="top">LEAP</td><td valign="top">34</td></tr>
<tr><td valign="top">left tabs</td><td valign="top">93</td></tr>
<tr><td valign="top">line</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">&nbsp;&nbsp;boundaries</td><td valign="top">47</td></tr>
<tr><td valign="top">&nbsp;&nbsp;contents</td><td valign="top">48</td></tr>
<tr><td valign="top">&nbsp;&nbsp;wrap</td><td valign="top">91</td></tr>
<tr><td valign="top">linked line</td><td valign="top">72</td></tr>
<tr><td valign="top">Lisp</td><td valign="top">39, 72, 173</td></tr>
<tr><td valign="top">list of lines</td><td valign="top">44</td></tr>
<tr><td valign="top">location</td><td valign="top">151</td></tr>
<tr><td valign="top">Location_To_Count</td><td valign="top">60</td></tr>
<tr><td valign="top">long lines</td><td valign="top">48</td></tr>
<tr><td valign="top">loop</td><td valign="top">106</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">Macintosh</td><td valign="top">see Apple</td></tr>
<tr><td valign="top">macros</td><td valign="top">123</td></tr>
<tr><td valign="top">mail</td><td valign="top">146</td></tr>
<tr><td valign="top">malloc</td><td valign="top">155</td></tr>
<tr><td valign="top">management</td><td valign="top">65, 72</td></tr>
<tr><td valign="top">mark</td><td valign="top">55, 57</td></tr>
<tr><td valign="top">marker</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">&nbsp;&nbsp;bytes</td><td valign="top">75</td></tr>
<tr><td valign="top">&nbsp;&nbsp;record</td><td valign="top">48</td></tr>
<tr><td valign="top">Mark_Create</td><td valign="top">60</td></tr>
<tr><td valign="top">Mark_Delete</td><td valign="top">60</td></tr>
<tr><td valign="top">Mark_Get</td><td valign="top">60</td></tr>
<tr><td valign="top">mark_list</td><td valign="top">57</td></tr>
<tr><td valign="top">Mark_Set</td><td valign="top">60</td></tr>
<tr><td valign="top">Mark_To_Point</td><td valign="top">60</td></tr>
<tr><td valign="top">meaning of text</td><td valign="top">45</td></tr>
<tr><td valign="top">memmove</td><td valign="top">155</td></tr>
<tr><td valign="top">memory</td><td valign="top">74</td></tr>
<tr><td valign="top">memory management</td><td valign="top">65, 72</td></tr>
<tr><td valign="top">memory-mapped display</td><td valign="top">23, 105</td></tr>
<tr><td valign="top">memset</td><td valign="top">155</td></tr>
<tr><td valign="top">messages</td><td valign="top">130</td></tr>
<tr><td valign="top">meta</td><td valign="top">27, 172, 202</td></tr>
<tr><td valign="top">methods</td><td valign="top">65, 71</td></tr>
<tr><td valign="top">mind</td><td valign="top">15</td></tr>
<tr><td valign="top">Mince</td><td valign="top">73</td></tr>
<tr><td valign="top">model</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">&nbsp;&nbsp;editing</td><td valign="top">43</td></tr>
<tr><td valign="top">&nbsp;&nbsp;user's</td><td valign="top">11</td></tr>
<tr><td valign="top">modems</td><td valign="top">34</td></tr>
<tr><td valign="top">modes</td><td valign="top">56, 58, 114, 117, 129, 134</td></tr>
<tr><td valign="top">Mode_Append</td><td valign="top">63</td></tr>
<tr><td valign="top">Mode_Delete</td><td valign="top">63</td></tr>
<tr><td valign="top">Mode_Invoke</td><td valign="top">63</td></tr>
<tr><td valign="top">mode_list</td><td valign="top">57</td></tr>
<tr><td valign="top">modification flag</td><td valign="top">101</td></tr>
<tr><td valign="top">Modula</td><td valign="top">40</td></tr>
<tr><td valign="top">mouse</td><td valign="top">30</td></tr>
<tr><td valign="top">mouse ahead</td><td valign="top">18</td></tr>
<tr><td valign="top">Move_By_Character</td><td valign="top">107</td></tr>
<tr><td valign="top">moving</td><td valign="top">64, 135</td></tr>
<tr><td valign="top">MS/DOS</td><td valign="top">47, 49</td></tr>
<tr><td valign="top">Multics</td><td valign="top">33, 71</td></tr>
<tr><td valign="top">multiple</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">&nbsp;&nbsp;buffers</td><td valign="top">77</td></tr>
<tr><td valign="top">&nbsp;&nbsp;gaps</td><td valign="top">70</td></tr>
<tr><td valign="top">&nbsp;&nbsp;windows</td><td valign="top">96</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">n-key rollover</td><td valign="top">24</td></tr>
<tr><td valign="top">name</td><td valign="top">57</td></tr>
<tr><td valign="top">neophyte users</td><td valign="top">11</td></tr>
<tr><td valign="top">NEWLINE</td><td valign="top">152</td></tr>
<tr><td valign="top">newline</td><td valign="top">47, 55</td></tr>
<tr><td valign="top">next_chain_entry</td><td valign="top">57</td></tr>
<tr><td valign="top">next_mark</td><td valign="top">57</td></tr>
<tr><td valign="top">next_mode</td><td valign="top">58</td></tr>
<tr><td valign="top">NL</td><td valign="top">152</td></tr>
<tr><td valign="top">node_name</td><td valign="top">58</td></tr>
<tr><td valign="top">no management</td><td valign="top">66</td></tr>
<tr><td valign="top">non-printing characters</td><td valign="top">48</td></tr>
<tr><td valign="top">non-text files</td><td valign="top">see binary files</td></tr>
<tr><td valign="top">normal marks</td><td valign="top">55</td></tr>
<tr><td valign="top">novice users</td><td valign="top">12</td></tr>
<tr><td valign="top">NUL</td><td valign="top">152</td></tr>
<tr><td valign="top">NULL</td><td valign="top">152</td></tr>
<tr><td valign="top">numeric arguments</td><td valign="top">112</td></tr>
<tr><td valign="top">num_chars</td><td valign="top">57</td></tr>
<tr><td valign="top">num_lines</td><td valign="top">57</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">object models</td><td valign="top">45</td></tr>
<tr><td valign="top">objects</td><td valign="top">52</td></tr>
<tr><td valign="top">one-dimensional array</td><td valign="top">43, 55</td></tr>
<tr><td valign="top">out-of-band</td><td valign="top">32, 51</td></tr>
<tr><td valign="top">output</td><td valign="top">87</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">packaging, keyboard</td><td valign="top">25</td></tr>
<tr><td valign="top">padding</td><td valign="top">32</td></tr>
<tr><td valign="top">page breaks</td><td valign="top">136</td></tr>
<tr><td valign="top">paged</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">&nbsp;&nbsp;buffer gap</td><td valign="top">72, 73</td></tr>
<tr><td valign="top">&nbsp;&nbsp;model</td><td valign="top">44</td></tr>
<tr><td valign="top">&nbsp;&nbsp;virtual memory</td><td valign="top">78</td></tr>
<tr><td valign="top">paging</td><td valign="top">136</td></tr>
<tr><td valign="top">paragraphs</td><td valign="top">140</td></tr>
<tr><td valign="top">parsing</td><td valign="top">51</td></tr>
<tr><td valign="top">partial lines</td><td valign="top">48</td></tr>
<tr><td valign="top">Pascal</td><td valign="top">40</td></tr>
<tr><td valign="top">pen</td><td valign="top">31</td></tr>
<tr><td valign="top">permissiveness</td><td valign="top">126</td></tr>
<tr><td valign="top">philosophy</td><td valign="top">109, 125</td></tr>
<tr><td valign="top">physiological constraints</td><td valign="top">14</td></tr>
<tr><td valign="top">piano</td><td valign="top">129</td></tr>
<tr><td valign="top">PL/1</td><td valign="top">40</td></tr>
<tr><td valign="top">placement, key</td><td valign="top">27</td></tr>
<tr><td valign="top">point</td><td valign="top">55, 57</td></tr>
<tr><td valign="top">Point_Get</td><td valign="top">60</td></tr>
<tr><td valign="top">Point_Get_Line</td><td valign="top">60</td></tr>
<tr><td valign="top">Point_Move</td><td valign="top">60</td></tr>
<tr><td valign="top">Point_Set</td><td valign="top">60</td></tr>
<tr><td valign="top">Point_To_Mark</td><td valign="top">60</td></tr>
<tr><td valign="top">positional arguments</td><td valign="top">115</td></tr>
<tr><td valign="top">power users</td><td valign="top">12</td></tr>
<tr><td valign="top">prefix arguments</td><td valign="top">112</td></tr>
<tr><td valign="top">print images</td><td valign="top">47</td></tr>
<tr><td valign="top">printf</td><td valign="top">155</td></tr>
<tr><td valign="top">private</td><td valign="top">151</td></tr>
<tr><td valign="top">procedures</td><td valign="top">58-65, 84-89</td></tr>
<tr><td valign="top">programmer-level users</td><td valign="top">13</td></tr>
<tr><td valign="top">progress</td><td valign="top">127</td></tr>
<tr><td valign="top">prompts</td><td valign="top">113, 130</td></tr>
<tr><td valign="top">proportionally spaced text</td><td valign="top">94</td></tr>
<tr><td valign="top">Put_Char</td><td valign="top">88</td></tr>
<tr><td valign="top">Put_String</td><td valign="top">88</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">quality</td><td valign="top">36</td></tr>
<tr><td valign="top">quote</td><td valign="top">113</td></tr>
<tr><td valign="top">QWERTY</td><td valign="top">27</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">rat</td><td valign="top">30</td></tr>
<tr><td valign="top">raw</td><td valign="top">87</td></tr>
<tr><td valign="top">read</td><td valign="top">54</td></tr>
<tr><td valign="top">real text</td><td valign="top">45</td></tr>
<tr><td valign="top">rebinding</td><td valign="top">115</td></tr>
<tr><td valign="top">Recenter</td><td valign="top">85</td></tr>
<tr><td valign="top">record markers</td><td valign="top">48</td></tr>
<tr><td valign="top">recording</td><td valign="top">124</td></tr>
<tr><td valign="top">recovery</td><td valign="top">74, 75</td></tr>
<tr><td valign="top">Redisplay</td><td valign="top">85</td></tr>
<tr><td valign="top">redisplay</td><td valign="top">51, 82</td></tr>
<tr><td valign="top">&nbsp;&nbsp;algorithms</td><td valign="top">99</td></tr>
<tr><td valign="top">Redo</td><td valign="top">123</td></tr>
<tr><td valign="top">redo</td><td valign="top">122</td></tr>
<tr><td valign="top">Refresh_Screen</td><td valign="top">85</td></tr>
<tr><td valign="top">region</td><td valign="top">55, 61, 115</td></tr>
<tr><td valign="top">regular expressions</td><td valign="top">143</td></tr>
<tr><td valign="top">&quot;religion&quot;</td><td valign="top">13</td></tr>
<tr><td valign="top">repeat</td><td valign="top">24, 112</td></tr>
<tr><td valign="top">replace</td><td valign="top">6</td></tr>
<tr><td valign="top">Replace_Char</td><td valign="top">63</td></tr>
<tr><td valign="top">Replace_String</td><td valign="top">63</td></tr>
<tr><td valign="top">responsiveness</td><td valign="top">125</td></tr>
<tr><td valign="top">right tabs</td><td valign="top">93</td></tr>
<tr><td valign="top">rollover</td><td valign="top">24</td></tr>
<tr><td valign="top">ruler lines</td><td valign="top">92</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">S-exp</td><td valign="top">173</td></tr>
<tr><td valign="top">screen</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">&nbsp;&nbsp;definition</td><td valign="top">84</td></tr>
<tr><td valign="top">&nbsp;&nbsp;procedures</td><td valign="top">87</td></tr>
<tr><td valign="top">Screen_Attributes</td><td valign="top">87</td></tr>
<tr><td valign="top">Screen_Columns</td><td valign="top">87</td></tr>
<tr><td valign="top">Screen_Fini</td><td valign="top">87</td></tr>
<tr><td valign="top">Screen_Init</td><td valign="top">87</td></tr>
<tr><td valign="top">Screen_Rows</td><td valign="top">87</td></tr>
<tr><td valign="top">Screen_Timings</td><td valign="top">89</td></tr>
<tr><td valign="top">scripts</td><td valign="top">95</td></tr>
<tr><td valign="top">scroll window</td><td valign="top">22</td></tr>
<tr><td valign="top">scrolling</td><td valign="top">136</td></tr>
<tr><td valign="top">Scroll_Lines</td><td valign="top">89</td></tr>
<tr><td valign="top">searching</td><td valign="top">77, 141</td></tr>
<tr><td valign="top">Search_Backward</td><td valign="top">64</td></tr>
<tr><td valign="top">Search_Forward</td><td valign="top">64</td></tr>
<tr><td valign="top">second</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">&nbsp;&nbsp;gap</td><td valign="top">71</td></tr>
<tr><td valign="top">&nbsp;&nbsp;level dispatch</td><td valign="top">108</td></tr>
<tr><td valign="top">&nbsp;&nbsp;system effect</td><td valign="top">14</td></tr>
<tr><td valign="top">selection arguments</td><td valign="top">115</td></tr>
<tr><td valign="top">sentences</td><td valign="top">140</td></tr>
<tr><td valign="top">serial</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">&nbsp;&nbsp;chunking</td><td valign="top">80</td></tr>
<tr><td valign="top">&nbsp;&nbsp;communications</td><td valign="top">31</td></tr>
<tr><td valign="top">Set_Attr</td><td valign="top">88</td></tr>
<tr><td valign="top">Set_Column</td><td valign="top">65</td></tr>
<tr><td valign="top">Set_Column</td><td valign="top">88</td></tr>
<tr><td valign="top">Set_File_Name</td><td valign="top">62</td></tr>
<tr><td valign="top">Set_Modified</td><td valign="top">62</td></tr>
<tr><td valign="top">Set_Pref_Pct</td><td valign="top">85</td></tr>
<tr><td valign="top">Set_Row</td><td valign="top">88</td></tr>
<tr><td valign="top">shell</td><td valign="top">146</td></tr>
<tr><td valign="top">shift keys</td><td valign="top">26</td></tr>
<tr><td valign="top">Shift Lock</td><td valign="top">25</td></tr>
<tr><td valign="top">short lines</td><td valign="top">48</td></tr>
<tr><td valign="top">simplicity</td><td valign="top">127</td></tr>
<tr><td valign="top">Sine</td><td valign="top">41</td></tr>
<tr><td valign="top">SNOBOL</td><td valign="top">42</td></tr>
<tr><td valign="top">SP</td><td valign="top">152</td></tr>
<tr><td valign="top">special function keys</td><td valign="top">25</td></tr>
<tr><td valign="top">speed</td><td valign="top">31, 83</td></tr>
<tr><td valign="top">spinal cord</td><td valign="top">16</td></tr>
<tr><td valign="top">standard system text files</td><td valign="top">47</td></tr>
<tr><td valign="top">start of the buffer</td><td valign="top">55</td></tr>
<tr><td valign="top">state save</td><td valign="top">56, 58</td></tr>
<tr><td valign="top">status</td><td valign="top">151</td></tr>
<tr><td valign="top">status line</td><td valign="top">90</td></tr>
<tr><td valign="top">storage</td><td valign="top">74</td></tr>
<tr><td valign="top">strcpy</td><td valign="top">155</td></tr>
<tr><td valign="top">string arguments</td><td valign="top">113</td></tr>
<tr><td valign="top">strlen</td><td valign="top">155</td></tr>
<tr><td valign="top">structure editors</td><td valign="top">132</td></tr>
<tr><td valign="top">structured files</td><td valign="top">50</td></tr>
<tr><td valign="top">sub-editor</td><td valign="top">54, 101, 101</td></tr>
<tr><td valign="top">suffix arguments</td><td valign="top">113</td></tr>
<tr><td valign="top">Sun workstations</td><td valign="top">23, 29</td></tr>
<tr><td valign="top">suspend process</td><td valign="top">32</td></tr>
<tr><td valign="top">Swap_Point_And_Mark</td><td valign="top">60</td></tr>
<tr><td valign="top">system text files</td><td valign="top">47</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">TAB</td><td valign="top">152</td></tr>
<tr><td valign="top">tablet</td><td valign="top">30</td></tr>
<tr><td valign="top">tabs</td><td valign="top">93</td></tr>
<tr><td valign="top">TECO</td><td valign="top">39, 72, 80, 81, 145, 180</td></tr>
<tr><td valign="top">terminfo</td><td valign="top">26</td></tr>
<tr><td valign="top">text</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">&nbsp;&nbsp;files</td><td valign="top">45, 47</td></tr>
<tr><td valign="top">&nbsp;&nbsp;handling</td><td valign="top">37</td></tr>
<tr><td valign="top">&nbsp;&nbsp;structure of</td><td valign="top">45</td></tr>
<tr><td valign="top">three-file sysstem</td><td valign="top">80</td></tr>
<tr><td valign="top">time</td><td valign="top">151</td></tr>
<tr><td valign="top">toaster</td><td valign="top">59</td></tr>
<tr><td valign="top">top-level</td><td valign="top">106</td></tr>
<tr><td valign="top">Tops-20</td><td valign="top">180</td></tr>
<tr><td valign="top">touch sensitive display</td><td valign="top">29</td></tr>
<tr><td valign="top">trackball</td><td valign="top">30</td></tr>
<tr><td valign="top">trees</td><td valign="top">9</td></tr>
<tr><td valign="top">TTY</td><td valign="top">21</td></tr>
<tr><td valign="top">twiddling</td><td valign="top">143</td></tr>
<tr><td valign="top">two-dimensional array</td><td valign="top">43</td></tr>
<tr><td valign="top">&quot;typeability&quot;</td><td valign="top">24</td></tr>
<tr><td valign="top">type of experience</td><td valign="top">13</td></tr>
<tr><td valign="top">typing aids</td><td valign="top">133</td></tr>
<tr><td valign="top">typos</td><td valign="top">143</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">Undo</td><td valign="top">122</td></tr>
<tr><td valign="top">undo</td><td valign="top">120</td></tr>
<tr><td valign="top">UNICODE</td><td valign="top">50</td></tr>
<tr><td valign="top">unicorn</td><td valign="top">98</td></tr>
<tr><td valign="top">uniformity</td><td valign="top">128</td></tr>
<tr><td valign="top">unique identifier</td><td valign="top">101</td></tr>
<tr><td valign="top">universal argument</td><td valign="top">112</td></tr>
<tr><td valign="top">UNIX</td><td valign="top">47</td></tr>
<tr><td valign="top">Unix stream</td><td valign="top">22</td></tr>
<tr><td valign="top">up/down</td><td valign="top">135</td></tr>
<tr><td valign="top">upper-case</td><td valign="top">130</td></tr>
<tr><td valign="top">user</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">&nbsp;&nbsp;categories</td><td valign="top">11</td></tr>
<tr><td valign="top">&nbsp;&nbsp;goals</td><td valign="top">14</td></tr>
<tr><td valign="top">user-oriented commands</td><td valign="top">106</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">vi</td><td valign="top">109</td></tr>
<tr><td valign="top">virtual memory</td><td valign="top">78</td></tr>
<tr><td valign="top">visible effect</td><td valign="top">125</td></tr>
<tr><td valign="top">VT100</td><td valign="top">22, 28, 87</td></tr>
<tr><td valign="top">VT200</td><td valign="top">28</td></tr>
<tr><td valign="top">VT52</td><td valign="top">22</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">whale</td><td valign="top">83</td></tr>
<tr><td valign="top">where_it_is</td><td valign="top">57</td></tr>
<tr><td valign="top">whirlpool</td><td valign="top">36</td></tr>
<tr><td valign="top">window</td><td valign="top">84, 135</td></tr>
<tr><td valign="top">window mark</td><td valign="top">101</td></tr>
<tr><td valign="top">Window_Create</td><td valign="top">86</td></tr>
<tr><td valign="top">Window_Destroy</td><td valign="top">86</td></tr>
<tr><td valign="top">Window_Fini</td><td valign="top">84, 87</td></tr>
<tr><td valign="top">Window_Grow</td><td valign="top">86</td></tr>
<tr><td valign="top">Window_Init</td><td valign="top">84, 87</td></tr>
<tr><td valign="top">Window_Load</td><td valign="top">85</td></tr>
<tr><td valign="top">Window_Save</td><td valign="top">85</td></tr>
<tr><td valign="top">words</td><td valign="top">65, 136</td></tr>
<tr><td valign="top">word wrap</td><td valign="top">92</td></tr>
<tr><td valign="top">world</td><td valign="top">56</td></tr>
<tr><td valign="top">World_Fini</td><td valign="top">58</td></tr>
<tr><td valign="top">World_Init</td><td valign="top">58</td></tr>
<tr><td valign="top">World_Load</td><td valign="top">58</td></tr>
<tr><td valign="top">World_Save</td><td valign="top">58</td></tr>
<tr><td valign="top">World_Save</td><td valign="top">85</td></tr>
<tr><td valign="top">wrap</td><td valign="top">91</td></tr>
<tr><td valign="top">write</td><td valign="top">54</td></tr>
<tr><td valign="top">WYSIWYG</td><td valign="top">15</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">xiswhite</td><td valign="top">155</td></tr>
<tr><td valign="top">XON/XOFF</td><td valign="top">32</td></tr>
<tr><td valign="top">xstrcpy</td><td valign="top">155</td></tr>
<tr><td valign="top">Xylogics</td><td valign="top">34</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">zero-length lines</td><td valign="top">48</td></tr>
<tr><td valign="top">&nbsp;</td><td valign="top">&nbsp;</td></tr>
<tr><td valign="top">^</td><td valign="top">94, 202</td></tr>
</table>

<?PHP
include("../include/fin-bot.inc");
?>
